AddComponentPostInit("sleepingbag", function(self)
	function self:CanSleep(target)
		if target:HasTag("tp_insomniac")
		and not target:HasTag("tp_good_stomach") then
			return false
		end
		return true
	end
	local old_scene = self.CollectSceneActions
	function self:CollectSceneActions(doer, actions)
		if self:CanSleep(doer) then
			if doer and doer:HasTag("player") and not doer:HasTag("insomniac") then
				if self.inst:HasTag("tp_sea_sleep") 
				and WARGON.on_water(self.inst) then
					table.insert(actions, ACTIONS.TP_SEA_SLEEP)
				else
					old_scene(self, doer, actions)
				end
			end
		end
	end
	local CollectUseActions = self.CollectUseActions
	function self:CollectUseActions(doer, ...)
		if self:CanSleep(doer) then
			CollectUseActions(doer, ...)
		end
	end
	local CollectInventoryActions = self.CollectInventoryActions
	function self:CollectInventoryActions(doer, ...)
		if self:CanSleep(doer) then
			CollectInventoryActions(doer, ...)
		end
	end
end)

AddComponentPostInit("dryable", function(self)
	local old_use = self.CollectUseActions
	function self:CollectUseActions(doer, target, actions)
		if not target:HasTag("burnt") then
	        if target.components.dryer and target.components.dryer:CanDry(self.inst) then
	            if target:HasTag("tp_sea_dryer") 
	            and WARGON.on_water(target) then
		            table.insert(actions, ACTIONS.TP_SEA_DRY)
		        else
		        	old_use(self, doer, target, actions)
		        end
	        end
	    end
	end
end)













	            







































































AddComponentPostInit("hunter", function(self)
	table.insert(self.alternate_beast_prefab, "tp_blue_warg")
	table.insert(self.alternate_beast_prefab, "tp_red_warg")
end)

local health_meta = false


AddComponentPostInit("health", function(self)




	rawset(self, "maxhealth", nil)
	rawset(self, "absorb", nil)
	self.tp_max_health = 100
	self.tp_max_health_buff = 0
	self.max_health_modifiers = {}

	self.tp_absorb = 0
	self.tp_absorb_buff = 0
	self.absorb_modifiers = {}
	self.magic_absorb_modifiers = {}
	self.tp_absorb = 0

	
	self.penalty_modifiers = {}





	function self:AddMaxHealthModifier(key, mod, save_p)
		local p = self:GetPercent()

		self.max_health_modifiers[key] = mod
		self.tp_max_health_buff = self:GetMaxHealthModifier()


		if save_p then
			self:SetPercent(p)
		else
			self:DoDelta(0, true)
		end
	end
	function self:RemoveMaxHealthModifier(key, save_p, no_delta)
		if self.max_health_modifiers[key] then
			local p = self:GetPercent()

			self.max_health_modifiers[key] = nil
			self.tp_max_health_buff = self:GetMaxHealthModifier()

			if save_p then
				self:SetPercent(p)
			elseif not no_delta then
				self:DoDelta(0, true)
			end
		end
	end
	function self:GetMaxHealthModifier()
		local mod = 0
		for k, v in pairs(self.max_health_modifiers) do
			mod = mod + v
		end
		return mod
	end

	local set_absorb = self.SetAbsorptionAmount
	function self:SetAbsorptionAmount(amount)
		self:AddAbsorbModifier("health", amount)
	end
	function self:AddAbsorbModifier(key, mod)
		self.absorb_modifiers[key] = mod

		self.tp_absorb_buff = self:GetAbsorbModifier()
	end
	function self:RemoveAbsorbModifier(key, mod)
		self.absorb_modifiers[key] = nil

		self.tp_absorb_buff = self:GetAbsorbModifier()
	end
	function self:GetAbsorbModifier()
		local mod = 0
		for k, v in pairs(self.absorb_modifiers) do
			mod = mod + v
		end
		if mod > 1 then
			mod = 1
		end




		return mod
	end

	local old_delta = self.DoDelta
	function self:DoDelta(amount, overtime, cause, ignore_invincible, skipredirect)

		if amount > 0 and self.inst:HasTag("tp_wound") then
			amount = amount - amount * .5
		end





		if cause == "hot" and (self.inst:HasTag("tp_not_hot_damage")
		) then
			return
		end

		if cause == "cold" and (self.inst:HasTag("tp_not_cold_damage")
		) then
			return
		end

		if cause == "fire" and (self.inst:HasTag("tp_not_fire_damage")

		) then
			return
		end

		if cause == "poison" and (self.inst:HasTag("tp_not_poison_damage")
		) then
			return
		end

		if cause == "gas" and (self.inst:HasTag("tp_not_gas_damage")
		) then
			return
		end
		old_delta(self, amount, overtime, cause, ignore_invincible, skipredirect)
	end

	local old_kill = self.Kill
	function self:Kill(cause)
		if self.inst:HasTag("ironlord") == false
		and not self.invincible then
			old_kill(self, cause)
		end
	end

	local old_fire = self.DoFireDamage
	function self:DoFireDamage(amount, doer, instant)
		if self.inst:HasTag("tp_not_fire_damage")

		then
			return
		end
		if self.inst.components.tpbody then
			amount = amount * self.inst.components.tpbody.fire
		end

		old_fire(self, amount, doer, instant)
	end

	function self:AddHealthPenaltyModifier(key, mod)
		self:RemoveHealthPenaltyModifier(key)
		self.penalty_modifiers[key] = mod

	end
	function self:RemoveHealthPenaltyModifier(key)
		if self.penalty_modifiers[key] then

			self.penalty_modifiers[key] = nil
		end
	end
	function self:GetHealthPenaltyModifier()
		local mod = 0
		for k, v in pairs(self.penalty_modifiers) do
			mod = mod + v
		end
		return mod
	end
	local old_penalty = self.RecalculatePenalty
	function self:RecalculatePenalty(...)
		old_penalty(self, ...)
		self.penalty = self.penalty + self:GetHealthPenaltyModifier()
		self:DoDelta(0, nil, "resurrection_penalty")






	end

	self.invincible_cause = {}
	local old_invincible = self.SetInvincible
	function self:SetInvincible(val, cause)
		cause = cause or "health"
		self.invincible_cause[cause] = val
		local is_invincible = false
		if val then
			is_invincible = true
		else
			for k, v in pairs(self.invincible_cause) do
				if v then 
					is_invincible = true 
				end
			end
		end
		old_invincible(self, is_invincible)
	end

	function self:DoTrueDelta(amount, overtime, cause, ignore_invincible, skipredirect)
		if self.redirect and not skipredirect then
			self.redirect(self.inst, amount, overtime, cause, ignore_invincible)
			return
		end

		if not ignore_invincible and (self.invincible or self.inst.is_teleporting == true) then
			return
		end

		local old_percent = self:GetPercent()
		self:SetVal(self.currenthealth + amount, cause)
		local new_percent = self:GetPercent()

		self.inst:PushEvent("healthdelta", {oldpercent = old_percent, newpercent = self:GetPercent(), overtime=overtime, cause=cause})

		if METRICS_ENABLED and self.inst == GetPlayer() and cause and cause ~= "debug_key" then
			if amount > 0 then
				ProfileStatsAdd("healby_" .. cause, math.floor(amount))
				FightStat_Heal(math.floor(amount))
			end
		end

		if self.ondelta then
			self.ondelta(self.inst, old_percent, self:GetPercent())
		end
	end

	function self:ChangeMaxHealth(amount)
		self.maxhealth = amount
		self:DoDelta(0)
	end

	self.birth_year = nil
	self.birthed = nil
	function self:CalculateMaxHealthRate()
		local mult = 1
		local year = WARGON.get_years()
		if self.birth_year then
			year = self.birth_year
		else
			self.birth_year = year
		end
		if year > 1 then
			if year <= 3 then
				mult = mult + 1-1/year
			else
				mult = mult + 3/2*(1-1/year)
			end
		end
		return mult
	end
	
	local set_max_health = self.SetMaxHealth

	function self:SetMaxHealth(amount)
		set_max_health(self, amount)
		if WARGON.CONFIG.maxhp and not self.inst:HasTag("player") then
			local mult = self:CalculateMaxHealthRate()

			local mod = math.ceil(amount*(mult-1))
			self:AddMaxHealthModifier("nature_power", mod)
		end

		if self.equip_hp then

			self:AddMaxHealthModifier("equip_hp", self.equip_hp)
		end
		if self.sec_equip_hp then

			self:AddMaxHealthModifier("sec_equip_hp", self.sec_equip_hp)
		end
		self:SetPercent(1)

	end

































	local on_save = self.OnSave
	function self:OnSave()



		local data = on_save(self)

		data.birthed = self.birthed
		data.birth_year = self.birth_year
		data.equip_hp = self.equip_hp
		data.sec_equip_hp = self.sec_equip_hp

		return data
	end
	local on_load = self.OnLoad
	function self:OnLoad(data)
		on_load(self, data)
		self.birthed = data.birthed
		self.birth_year = data.birth_year
		self.equip_hp = data.equip_hp
		self.sec_equip_hp = data.sec_equip_hp

	end

	if health_meta then
		return 
	end
	health_meta = true
	local c = getmetatable(self)
	local c_index = c.__index
	local c_newindex = c.__newindex
	c.__newindex = function(t, k, val)
		if k == "maxhealth" then
			return rawset(t, "tp_max_health", val)
		elseif k == "absorb" then
			return rawset(t, "tp_absorb", val)
		else
			return (c_newindex or rawset)(t, k, val)
		end
	end
	c.__index = function(t, k)
		if k == "maxhealth" then
			return (rawget(t, "tp_max_health") or 0) +
				(rawget(t, "tp_max_health_buff") or 0)
		elseif k == "absorb" then
			local absorb = (rawget(t, "tp_absorb") or 0) +
				(rawget(t, "tp_absorb_buff") or 0)
			if t.inst and t.inst:HasTag("tp_absorb_ripped") then
				absorb = absorb/2
			end
			return absorb
		else
			if type(c_index) == "table" then
				return c_index[k]
			else
				return (c_index or rawget)(t, k)
			end
		end
	end



end)

AddComponentPostInit("armor", function(self)

	self.inst:ListenForEvent("percentusedchange", function(inst, data)
		if data and data.percent and data.percent <= 0 then
			inst:PushEvent("armorbroke")
		end
	end)
	local old_take = self.TakeDamage
	function self:TakeDamage(damage_amount, attacker, weapon)
		local invitem = self.inst.components.inventoryitem
		local owner = invitem and invitem.owner
		if owner and owner:HasTag("tp_armor_broken")
		and not self.inst:HasTag("tp_not_armor_broken") then
			if self:CanResist(attacker, weapon) then
		        local leftover = damage_amount
		        
		        local max_absorbed = damage_amount * self.absorb_percent/2;
		        local absorbed = math.floor(math.min(max_absorbed, self.condition))

		        if absorbed < 1 then
		            absorbed = 1
		        end
		        leftover = damage_amount - absorbed
		        ProfileStatsAdd("armor_absorb", absorbed)
		        
		        if METRICS_ENABLED then
					FightStat_Absorb(absorbed)
				end

		        if self.bonussanitydamage then
		            local sanitydamage = absorbed * self.bonussanitydamage
		            if self.inst.components.equippable and self.inst.components.equippable:IsEquipped() and self.inst.components.equippable.equipper then
		                self.inst.components.equippable.equipper.components.sanity:DoDelta(-sanitydamage)
		            end                
		        end

		        self:SetCondition(self.condition - absorbed)
				if self.ontakedamage then
					self.ontakedamage(self.inst, damage_amount, absorbed, leftover)
				end

		        self.inst:PushEvent("armorhit")

		        if self.absorb_percent >= 1 then
		            return 0
		        end

		        return leftover
		    else
		        return damage_amount
		    end
		else
			return old_take(self, damage_amount, attacker, weapon)
		end
	end
	function self:DoDelta(amount)
		local old_val = self.condition
		local new_val = math.min(self.maxcondition, self.condition+amount)
		self:SetCondition(new_val)
	end
end)

AddComponentPostInit("projectile", function(self)
	local old_throw = self.Throw
	function self:Throw(owner, target, attacker)
		if self.speed_z then
			self.owner = owner
		    self.target = target
		    self.start = Vector3(owner.Transform:GetWorldPosition() )
		    self.dest = Vector3(target.Transform:GetWorldPosition() )

		    local offset = self.launchoffset
		    print('throwing '..tostring(attacker)..", "..tostring(offset))
		    if attacker and offset then
		        local pos = self.inst:GetPosition()
		        local facing_angle = attacker.Transform:GetRotation()*DEGREES
		        local offset_vec = Vector3(offset.x * math.cos( facing_angle ), offset.y, -offset.x * math.sin( facing_angle ))
		        print("facing", facing_angle)
		        print("offset", offset)
		        print("vec", offset_vec)
		        pos = pos + offset_vec
		        self.inst.Transform:SetPosition( pos:Get() )
		    elseif target and offset then
		        local pos = self.inst:GetPosition()
		        local facing_angle = target.Transform:GetRotation()*DEGREES
		        local offset_vec = Vector3(offset.x * math.cos( facing_angle ), offset.y, -offset.x * math.sin( facing_angle ))
		        print("facing", facing_angle)
		        print("offset", offset)
		        print("vec", offset_vec)
		        pos = pos + offset_vec
		        self.inst.Transform:SetPosition( pos:Get() )
		    end
		    if self.vertical then 
		         self.inst.Physics:SetVel(0, self.speed, self.speed_z)
		    else 
		        self:RotateToTarget(self.dest)
		        self.inst.Physics:SetMotorVel(self.speed,0,self.speed_z)
		    end 
		    self.inst:StartUpdatingComponent(self)
		    self.inst:PushEvent("onthrown", {thrower = owner, target = target})
		    target:PushEvent("hostileprojectile",{thrower = owner, attacker = attacker, target = target})
		    if self.onthrown then
		        self.onthrown(self.inst, owner, target)
		    end
		    if self.cancatch and target.components.catcher then
		        target.components.catcher:StartWatching(self.inst)
		    end
		else
			old_throw(self, owner, target, attacker)
		end
	end
end)

AddComponentPostInit("lootdropper", function(self)
	local old_loot = self.GenerateLoot
	local chance_fix = GetPlayer().components.tpbody and GetPlayer().components.tpbody:GetLucky() or 0
	function self:GenerateLoot()
		local loots = {}
		
		if self.numrandomloot and math.random() <= (self.chancerandomloot or 1) then
			for k = 1, self.numrandomloot do
				local loot = self:PickRandomLoot()
				if loot then
					table.insert(loots, loot)
				end
			end
		end
		
		if self.chanceloot then
			for k,v in pairs(self.chanceloot) do
				if math.random() < v.chance + chance_fix then
					table.insert(loots, v.prefab)
					self.droppingchanceloot = true
				end
			end
		end

		if self.chanceloottable then
			local loot_table = LootTables[self.chanceloottable]
			if loot_table then
				for i, entry in ipairs(loot_table) do
					local prefab = entry[1]
					local chance = entry[2]
					if math.random() <= chance + chance_fix then
						table.insert(loots, prefab)
						self.droppingchanceloot = true
					end
				end
			end
		end

		if not self.droppingchanceloot and self.ifnotchanceloot then
			self.inst:PushEvent("ifnotchanceloot")
			for k,v in pairs(self.ifnotchanceloot) do
				table.insert(loots, v.prefab)
			end
		end

		if self.loot then
			for k,v in ipairs(self.loot) do
				table.insert(loots, v)
			end
		end
		
		local recipename = self.inst.prefab
		if self.inst.recipeproxy then
			recipename = self.inst.recipeproxy
		end

		local recipe = GetRecipe(recipename)

		if recipe then
			local percent = 1

			if self.lootpercentoverride then
				percent = self.lootpercentoverride(self.inst)
			elseif self.inst.components.finiteuses then
				percent = self.inst.components.finiteuses:GetPercent()
			end

			for k,v in ipairs(recipe.ingredients) do
				local amt = math.ceil( (v.amount * TUNING.HAMMER_LOOT_PERCENT) * percent)
				if self.inst:HasTag("burnt") then
					amt = math.ceil( (v.amount * TUNING.BURNT_HAMMER_LOOT_PERCENT) * percent)
				end
				for n = 1, amt do
					table.insert(loots, v.type)
				end
			end

			if self.inst:HasTag("burnt") and math.random() < .4 then
				table.insert(loots, "charcoal")
			end
		end
		
		return loots
	end
	local old_drop_loot = self.DropLoot
	function self:DropLoot(...)
		if self.inst:HasTag("tp_no_drop_loot") then
		else
			old_drop_loot(self, ...)
		end
	end

	function self:DropSingleLoot(pt, loots)
		local prefabs = loots
		if prefabs == nil then
			prefabs = self:GenerateLoot()
		end
		if prefabs and #prefabs>0 then

			local loot = prefabs[math.random(#prefabs)]
			if loot ~= "tp_boss_loot" then
				self:SpawnLootPrefab(loot, pt)
			end
		end






	end

	function self:GetPotentialLoot()
		local total_loot = {}

		if self.loot then
			for i,v in ipairs(self.loot) do
				table.insert(total_loot, v)
			end
		end

		if self.externalloot then
			for i,v in ipairs(self.externalloot) do
				table.insert(total_loot, v)
			end
		end

		if self.randomloot then
			for i,v in ipairs(self.randomloot) do
				if v.weight >=  4 * (self.totalrandomweight/10) then
					table.insert(total_loot, v.prefab)
				end
			end
		end

		if self.chanceloot then
			for i,v in ipairs(self.chanceloot) do
				if v.chance >= 1 then
					table.insert(total_loot, v.prefab)
				end
			end
		end

		if self.chanceloottable and LootTables[self.chanceloottable] then		
			for k,v in pairs(LootTables[self.chanceloottable]) do


				if type(v) == "table" and v[2] >= 0.8 then 
					table.insert(total_loot, v[1])
				end
			end
		end	

		return total_loot
	end

	function self:GiveLoot(target)
		local inv = target.components.inventory or target.components.container
		if inv then
			local loots = self:GenerateLoot()
			for k, v in pairs(loots) do
				local loot = SpawnPrefab(v)
				if loot.components.inventoryitem
				and loot.components.inventoryitem.cangoincontainer then
					inv:GiveItem(loot)
				else
					self:DropLootPrefab(loot, nil, self.lootdropangle, self.lootdroparc, self.alwaysinfront, self.dropdir)
				end
			end
		end
	end
end)

AddComponentPostInit("locomotor", function(self)
	local old_push_action = self.PushAction
	function self:PushAction(bufferedaction, run, try_instant)
		if not bufferedaction then return end

		local vehicle = self.inst.components.tpvehicleowner and self.inst.components.tpvehicleowner.vehicle

		if bufferedaction.action.vehicle then
			if vehicle == nil or vehicle.components.locomotor == nil then
				return
			end
		    self.throttle = 1
		    local success, reason = bufferedaction:TestForStart()
		    if not success then
		        self.inst:PushEvent("actionfailed", {action = bufferedaction, reason = reason})
		        return
		    end
		    
		    self:Clear()
		    if bufferedaction.action == ACTIONS.WALKTO then

		        if bufferedaction.target then
		            vehicle.components.locomotor:GoToEntity(bufferedaction.target, bufferedaction, run)
		        elseif bufferedaction.pos then
		            vehicle.components.locomotor:GoToPoint(bufferedaction.pos, bufferedaction, run)
		        end
		    elseif bufferedaction.action.instant then
		        vehicle:PushBufferedAction(bufferedaction)
		    else
		        if bufferedaction.target then

		            vehicle.components.locomotor:GoToEntity(bufferedaction.target, bufferedaction, run)
		        elseif bufferedaction.pos then

		            vehicle.components.locomotor:GoToPoint(bufferedaction.pos, bufferedaction, run)
		        else

		            vehicle:PushBufferedAction(bufferedaction)
		        end
		    end
		elseif self.inst:HasTag("tp_fast_builder")
		and bufferedaction.action == ACTIONS.BUILD then
			self.throttle = 1
		    local success, reason = bufferedaction:TestForStart()
		    if not success then
		        self.inst:PushEvent("actionfailed", {action = bufferedaction, reason = reason})
		        return
		    end
		    self:Clear()
	        self.inst:PushBufferedAction(bufferedaction)
		else
			old_push_action(self, bufferedaction, run, try_instant)
		end
	end
	local update_ground_speed_mult = self.UpdateGroundSpeedMultiplier
	function self:UpdateGroundSpeedMultiplier()
		update_ground_speed_mult(self)
		if self.inst:HasTag("tp_spear_road") and self.groundspeedmultiplier > 1 then
			local dt = self.groundspeedmultiplier - 1
			self.groundspeedmultiplier = self.groundspeedmultiplier + dt+dt
		end
	end
end)

AddComponentPostInit("freezable", function(self)
	local old_add_coldness = self.AddColdness
	function self:AddColdness(coldness, freezetime)
		if self.inst:HasTag("tp_not_freezable")


		or self.inst:HasTag("riding_vehicle") then
			return
		end



		if coldness < 0 then
			self.coldness = self.coldness + coldness
		    if self.coldness < 0 then 
		    	self.coldness = 0 
		    end
	        self:StartWearingOff()
		    self:UpdateTint()






		else
			old_add_coldness(self, coldness, freezetime)
		end
	end
	local unfreeze = self.Unfreeze
	function self:Unfreeze()

		if self.state == "FROZEN" then
			if (not self.inst.components.health 
			or not self.inst.components.health:IsDead()) 
			and self:IsFrozen() then

				unfreeze(self)
				local inst = self.inst
				inst.SoundEmitter:KillSound("thawing")
		        inst.AnimState:ClearOverrideSymbol("swap_frozen")
		        if inst.sg and inst.sg.sg and inst.sg.sg.states
		        and inst.sg.sg.states.hit then
		            inst.sg:GoToState("hit")
		        elseif inst.sg then
		            inst.sg:GoToState("idle")
		        end
			end
		else
			unfreeze(self)
		end











	end
end)

AddComponentPostInit("groundpounder", function(self)
	table.insert(self.noTags, "tp_perseus")
end)

AddComponentPostInit("equippable", function(self)


	self.tp_load = nil
	self.max_health_mod = nil
	self.max_sanity_mod = nil
	self.max_hunger_mod = nil
	local old_get_dapperness = self.GetDapperness
	function self:GetDapperness(owner)
		local dapperness = old_get_dapperness(self, owner)
		local tpenchantment = self.inst.components.tpenchantment
		if tpenchantment then
			dapperness = dapperness + tpenchantment.attribute.purplegem*TUNING.DAPPERNESS_SMALL
		end
		return dapperness
	end
	local Equip = self.Equip
	function self:Equip(owner, slot, ...)
		Equip(self, owner, slot, ...)
		if self.max_health_mod then
			if owner.components.health then
				local k = "equipslot_"..self.equipslot
				owner.components.health:AddMaxHealthModifier(k, self.max_health_mod, not self.tp_load)
			end
		end
		if self.max_sanity_mod then
			if owner.components.sanity then
				local k = "equipslot_"..self.equipslot
				owner.components.sanity:AddMaxSanityModifier(k, self.max_sanity_mod, not self.tp_load)
			end
		end
		if self.max_hunger_mod then
			if owner.components.hunger then
				local k = "equipslot_"..self.equipslot
				owner.components.hunger:AddMaxHungerModifier(k, self.max_hunger_mod, not self.tp_load)
			end
		end
		if self.equip_fns then
			for k, v in pairs(self.equip_fns) do
				v(self.inst, owner)
			end
		end
	end
	local Unequip = self.Unequip
	function self:Unequip(owner, slot, ...)
		Unequip(self, owner, slot, ...)
		if self.max_health_mod then
			if owner.components.health then
				local k = "equipslot_"..self.equipslot
				owner.components.health:RemoveMaxHealthModifier(k, self.max_health_mod, true)
			end
		end
		if self.max_sanity_mod then
			if owner.components.sanity then
				local k = "equipslot_"..self.equipslot
				owner.components.sanity:RemoveMaxSanityModifier(k, self.max_sanity_mod, true)
			end
		end
		if self.max_hunger_mod then
			if owner.components.hunger then
				local k = "equipslot_"..self.equipslot
				owner.components.hunger:RemoveMaxHungerModifier(k, self.max_hunger_mod, true)
			end
		end
		if self.unequip_fns then
			for k, v in pairs(self.unequip_fns) do
				v(self.inst, owner)
			end
		end
	end
	function self:AddEquipFn(fn)
		if self.equip_fns == nil then
			self.equip_fns = {}
		end
		table.insert(self.equip_fns, fn)
	end
	function self:AddUnequipFn(fn)
		if self.unequip_fns == nil then
			self.unequip_fns = {}
		end
		table.insert(self.unequip_fns, fn)
	end
	local OnLoad = self.OnLoad
	function self:OnLoad(...)
		if OnLoad then
			OnLoad(...)
		end
		self.tp_load = true
	end
end)

AddComponentPostInit("insulator", function(self)
	local old_get_insulation = self.GetInsulation
	function self:GetInsulation()
		local insulation, typ = old_get_insulation(self)
		local tpenchantment = self.inst.components.tpenchantment
		if tpenchantment then
			insulation = insulation + (tpenchantment.attribute.bluegem+tpenchantment.attribute.redgem)*30
		end
		return insulation, typ
	end
end)

AddComponentPostInit("temperature", function(self)




























	local is_freezing = self.IsFreezing
	function self:IsFreezing()
		if self.inst:HasTag("tp_not_cold_damage") then
			return
		end
		return is_freezing(self)
	end
	local is_overheating = self.IsOverheating
	function self:IsOverheating()
		if self.inst:HasTag("tp_not_hot_damage") then
			return
		end
		return is_overheating(self)
	end
end)

AddComponentPostInit("edible", function(self)
	local old_get_sanity = self.GetSanity
	function self:GetSanity(...)
		local value = old_get_sanity(self, ...)
		if self.inst.components.tppowerfruit
		and self.inst.components.tppowerfruit.enable then
			if self.inst.components.tppowerfruit:IsDelicacy() then
				value = value+value*self.inst.components.tppowerfruit.rate
			end
			if self.inst.components.tppowerfruit:IsTerriable() then

				value = value-value*.2
			end
		end
		return value
	end
	local old_get_hunger = self.GetHunger
	function self:GetHunger(...)
		local value = old_get_hunger(self, ...)
		if self.inst.components.tppowerfruit
		and self.inst.components.tppowerfruit.enable then
			if self.inst.components.tppowerfruit:IsDelicacy() then
				value = value+value*self.inst.components.tppowerfruit.rate
			end
			if self.inst.components.tppowerfruit:IsTerriable() then

				value = value-value*.2
			end
		end
		return value
	end
	local old_get_health = self.GetHealth
	function self:GetHealth(...)
		local value = old_get_health(self, ...)
		if self.inst.components.tppowerfruit
		and self.inst.components.tppowerfruit.enable then
			if self.inst.components.tppowerfruit:IsDelicacy() then
				value = value+value*self.inst.components.tppowerfruit.rate
			end
			if self.inst.components.tppowerfruit:IsTerriable() then

				value = value-value*.2
			end
		end
		return value
	end
end)

AddComponentPostInit("stackable", function(self)
	local old_get = self.Get

	function self:Get(num)
		if self.inst.components.tppowerfruit then
			local power = self.inst.components.tppowerfruit.power
			local quality = self.inst.components.tppowerfruit.quality
			local instance = old_get(self, num)
			instance.components.tppowerfruit:Set(power, quality)
			return instance
		else
			return old_get(self, num)
		end
	end

	local old_put = self.Put
	function self:Put(item, source_pos)
		if self.inst.components.tppowerfruit
		and item.components.tppowerfruit then
			local quality = self.inst.components.tppowerfruit:GetQuality()
			local quality2 = item.components.tppowerfruit:GetQuality()
			if quality > quality2
			or (quality == quality2 and math.random() <.5) then
				local quality = item.components.tppowerfruit.quality
				local power = item.components.tppowerfruit.power
				self.inst.components.tppowerfruit:Set(power, quality)
			end


		end
		return old_put(self, item, source_pos)
	end
end)

local sanity_meta = false
AddComponentPostInit("sanity", function(self)
	rawset(self, "max", nil)
	self.tp_max = 100
	self.tp_max_buff = 0

	self.penalty_modifiers = {}
	self.max_sanity_modifiers = {}
	function self:AddMaxSanityModifier(key, mod, save_p)
		local p = self:GetPercent()

		self.max_sanity_modifiers[key] = mod

		self.tp_max_buff = self:GetMaxSanityModifier()
		if save_p then
			self:SetPercent(p)
		else
			self:DoDelta(0, true)
		end
	end
	function self:RemoveMaxSanityModifier(key, save_p, no_delta)
		if self.max_sanity_modifiers[key] then
			local p = self:GetPercent()

			self.max_sanity_modifiers[key] = nil
			self.tp_max_buff = self:GetMaxSanityModifier()
			if save_p then
				self:SetPercent(p)
			elseif not no_delta then
				self:DoDelta(0, true)
			end
		end
	end
	function self:GetMaxSanityModifier()
		local mod = 0
		for k, v in pairs(self.max_sanity_modifiers) do
			mod = mod + v
		end
		return mod
	end
	function self:AddSanityPenaltyModifier(key, mod)
		self:RemoveSanityPenaltyModifier(key)
		self.penalty_modifiers[key] = mod

	end
	function self:RemoveSanityPenaltyModifier(key)
		if self.penalty_modifiers[key] then

			self.penalty_modifiers[key] = nil
		end
	end
	function self:GetSanityPenaltyModifier()
		local mod = 0
		for k, v in pairs(self.penalty_modifiers) do
			mod = mod + v
		end
		return mod
	end
	local old_penalty = self.RecalculatePenalty
	function self:RecalculatePenalty(...)
		old_penalty(self, ...)
		self.penalty = self.penalty + self:GetSanityPenaltyModifier()
		self:DoDelta(0)






	end

	local do_delta = self.DoDelta
	function self:DoDelta(delta, ...)
		if self.inst:HasTag("blood_prince") then
			delta = -delta
		end
		do_delta(self, delta, ...)








	end

	self.night_drain_mult_mods = {}
	function self:GetNightDrainMultModifier()
		local mod = 0
		for k, v in pairs(self.night_drain_mult_mods) do
			mod = mod + v
		end
		return mod
	end
	function self:AddNightDrainMultModifier(key, mod)
		if self.default_night_drain_mult == nil then
			self.default_night_drain_mult = self.night_drain_mult
		end
		self.night_drain_mult_mods[key] = mod
		local modifier = self:GetNightDrainMultModifier()
		self.night_drain_mult = self.default_night_drain_mult + modifier
	end
	function self:RemoveNightDrainMultModifier(key)
		if self.default_night_drain_mult == nil then
			self.default_night_drain_mult = self.night_drain_mult
		end
		self.night_drain_mult_mods[key] = nil
		local modifier = self:GetNightDrainMultModifier()
		self.night_drain_mult = self.default_night_drain_mult + modifier
	end

	self.neg_aura_mult_mods = {}
	function self:GetNegAuraMultModifier()
		local mod = 0
		for k, v in pairs(self.neg_aura_mult_mods) do
			mod = mod + v
		end
		return mod
	end
	function self:AddNegAuraMultModifier(key, mod)
		if self.default_neg_aura_mult == nil then
			self.default_neg_aura_mult = self.neg_aura_mult
		end
		self.neg_aura_mult_mods[key] = mod
		local modifier = self:GetNegAuraMultModifier()
		self.neg_aura_mult = self.default_neg_aura_mult + modifier
	end
	function self:RemoveNegAuraMultModifier(key)
		if self.default_neg_aura_mult == nil then
			self.default_neg_aura_mult = self.neg_aura_mult
		end
		self.neg_aura_mult_mods[key] = nil
		local modifier = self:GetNegAuraMultModifier()
		self.neg_aura_mult = self.default_neg_aura_mult + modifier
	end

	if sanity_meta then
		return 
	end
	sanity_meta = true
	local c = getmetatable(self)
	local c_index = c.__index
	local c_newindex = c.__newindex
	c.__newindex = function(t, k, val)
		if k == "max" and val then
			return rawset(t, "tp_max", val)
		else
			return (c_newindex or rawset)(t, k, val)
		end
	end
	c.__index = function(t, k)
		if k == "max" then
			return (rawget(t, "tp_max") or 0) +
				(rawget(t, "tp_max_buff") or 0)
		else
			if type(c_index) == "table" then
				return c_index[k]
			else
				return (c_index or rawget)(t, k)
			end
		end
	end
end)

GLOBAL.PERISHABLE_UPDATE_SET = true
AddComponentPostInit("perishable", function(self)




	if GLOBAL.PERISHABLE_UPDATE_SET then
		GLOBAL.PERISHABLE_UPDATE_SET = false
		local fn_name, update = debug.getupvalue(self.StartPerishing, 1)

		if fn_name == "Update" then

			new_update = function(inst, dt)

				if inst.components.perishable then

					if inst.components.perishable.perishremainingtime > inst.components.perishable.perishtime then
						inst.components.perishable.perishremainingtime = inst.components.perishable.perishtime
					end
					if inst.components.tppowerfruit
					and inst.components.tppowerfruit.enable then
						if inst.components.tppowerfruit:IsFresh() then

							dt = dt/2
						elseif inst.components.tppowerfruit:IsPerish() then

							dt = dt*2
						elseif inst.components.tppowerfruit:IsForever() then
							dt = 0
						end
					end

					if not inst:HasTag("tp_must_spoilsh")
					and inst.components.inventoryitem
					and inst.components.perishable.perishremainingtime < inst.components.perishable.perishtime then
						local owner = inst.components.inventoryitem.owner
						if owner then
							if owner:HasTag("tp_pack_deerclops") then
								dt = -dt
							end
						end
					end
					update(inst, dt)
				end
			end
			debug.setupvalue(self.StartPerishing, 1, new_update)
		end
	end

	function self:DoDelta(amount)
		local old_val = self.perishremainingtime
		self.perishremainingtime = math.min(old_val + amount, self.perishtime)
		self.inst:PushEvent("perishchange", {percent = self:GetPercent()})
		if self.perishremainingtime <= 0 then
			self:Perish()
		end
	end
end)

AddComponentPostInit("keeponland", function(self)
	local on_update = self.OnUpdate
	function self:OnUpdate(dt)

		if self.inst:HasTag("tp_boat_driver")
		or self.inst:HasTag("tp_dragonfly_driver") then
			return
		end
		on_update(self, dt)
	end
end)

AddComponentPostInit("poisonable", function(self)
	local can_be_poisoned = self.CanBePoisoned
	function self:CanBePoisoned()
		if self.inst:HasTag("tp_perseus")
		or self.inst:HasTag("tp_spear_shell") then
			print("not poison")
			return 
		end
		return can_be_poisoned(self)
	end
	local Cure = self.Cure
	function self:Cure(...)
		Cure(self, ...)
		self.inst:PushEvent("tp_poison_cure")
	end
end)

AddComponentPostInit("combat", function(self)
	self.absorb_modifiers = {}
	local battle_cry = self.BattleCry
	function self:BattleCry()
		if not self.not_battle_cry then
			battle_cry(self)
		end
	end
	local get_attacked = self.GetAttacked
	function self:GetAttacked(attacker, damage, weapon, stimuli)




		damage = damage - damage*self:GetAbsorbModifier()
		if self.inst:HasTag("tp_armor_defense") then
			damage = damage - damage*.3
		end
		get_attacked(self, attacker, damage, weapon, stimuli)
	end
	function self:AddAbsorbModifier(key, mod)
		self.absorb_modifiers[key] = mod
	end
	function self:RemoveAbsorbModifier(key)
		self.absorb_modifiers[key] = nil
	end
	function self:GetAbsorbModifier()
		local mod = 0
		for k, v in pairs(self.absorb_modifiers) do
			mod = mod + v
		end
		return mod
	end
end)

AddComponentPostInit("weapon", function(self)
	local get_damage = self.GetDamage
	function self:GetDamage()
		local dmg = get_damage(self)
		if self.inst:HasTag("tp_forge_weapon") then
			local owner = self.inst.components.equippable and self.inst.components.equippable.owner
			if owner and owner.components.tplevel then
				local forge = owner.components.tplevel.attr.forge or 0
				dmg = dmg + forge
			end
		end
		if self.inst:HasTag("tp_witch_staff") then
			local owner = self.inst.components.equippable and self.inst.components.equippable.owner
			if owner and owner:HasTag("tp_hat_witch") then
				dmg = dmg + 34
			end
		end
		return dmg
	end
	local OnAttack = self.OnAttack
	function self:OnAttack(...)
		if self.pre_attack_fns then
			for k, v in pairs(self.pre_attack_fns) do
				v(self.inst, ...)
			end	
		end
		OnAttack(self, ...)
		if self.attack_fns then
			for k, v in pairs(self.attack_fns) do
				v(self.inst, ...)
			end	
		end
	end
	function self:AddAttackFn(fn)
		if self.attack_fns == nil then
			self.attack_fns = {}
		end
		table.insert(self.attack_fns, fn)
	end
	function self:AddPreAttackFn(fn)
		if self.pre_attack_fns == nil then
			self.pre_attack_fns = {}
		end
		table.insert(self.pre_attack_fns, fn)
	end
end)

AddComponentPostInit("crop", function(self)
	local plants = {
		["carrot"] = 1,
		["corn"] = 1,
		["radish"] = 1,
		["asparagus"] = 1,
		["aloe"] = 1,
		["pumpkin"] = 1,
		["eggplant"] = 1,
		["durian"] = 1,
		["pomegranate"] = 1,
		["dragonfruit"] = 1,
		["watermelon"] = 1,
		["sweet_potato"] = 1,
	}
	function self:SpawnPlantArmy()
		if self.matured or self.withered then
			local product = nil
			if self.grower and self.grower:HasTag("fire") or self.inst:HasTag("fire") then
				local temp = SpawnPrefab(self.product_prefab)
				if temp.components.cookable and temp.components.cookable.product then
					product = SpawnPrefab(temp.components.cookable.product)
				else
					product = SpawnPrefab("seeds_cooked")
				end
				temp:Remove()
			else
				product = SpawnPrefab(self.product_prefab)
			end
	
			if product then
				self.inst:ApplyInheritedMoisture(product)
				if plants[product.prefab] then
					local ents = self.inst:wg_finds(1, {"tp_plant_army"})
					if #ents <= 0 then
						WARGON.make_fx(self.inst, "statue_transition")
						WARGON.make_spawn(self.inst, "tp_army_"..product.prefab)
					end
				end
				product:Remove()
			end

			ProfileStatsAdd("grown_"..product.prefab) 
			
			self.matured = false
			self.withered = false
			self.inst:RemoveTag("withered")
			self.growthpercent = 0
			self.product_prefab = nil
	
			if self.grower and self.grower.components.grower then
				self.grower.components.grower:RemoveCrop(self.inst)
				self.grower = nil
			else
				self.inst:Remove()
			end
			
			return true
		end
	end
end)

AddComponentPostInit("finiteuses", function(self)
	function self:TpAddUses(dt)
		if not self.unlimited_uses then
			self:SetUses(math.min(self.total, self.current+dt))
		end
	end
	function self:DoDelta(amount)
		self:TpAddUses(amount)
	end
end)

AddComponentPostInit("harvestable", function(self)
	function self:TpDropProduct()
		if self:CanBeHarvested() then
			local produce = self.produce
			self.produce = 0
			if self.onharvestfn then
				self.onharvestfn(self.inst, nil, produce)
			end
			if self.product then
				for i = 1, produce, 1 do
					local loot = SpawnPrefab(self.product)
					if loot then
						WARGON.throw_item(self.inst, loot)
					end
				end
			end
			self:StartGrowing()
			return true
		end
	end
end)

AddComponentPostInit("pickable", function(self)
	function self:TpDropProduct()
		if self.canbepicked and self.caninteractwith then

			if self.transplanted then
				if self.cycles_left ~= nil then
					self.cycles_left = self.cycles_left - 1
				end
			end

			if self.shouldwither then
				if self.protected_cycles ~= nil then
					self.protected_cycles = self.protected_cycles - 1
				end
			end
			
			local loot = nil
			if self.product then        	

				loot = SpawnPrefab(self.product)

				if loot then
					if self.numtoharvest > 1 and loot.components.stackable then
						loot.components.stackable:SetStackSize(self.numtoharvest)	            	
					end

					self.inst:ApplyInheritedMoisture(loot)
					WARGON.throw_item(self.inst, loot)


				end
			end
			
			if self.onpickedfn then
				self.onpickedfn(self.inst, picker, loot)
			end
		
			self.canbepicked = false
			self.hasbeenpicked = true
			
			if not self.paused and not self.withered and self.baseregentime and (self.cycles_left == nil or self.cycles_left > 0) and self.inst:IsValid() then
				self.regentime = self.baseregentime * self:GetGrowthMod()
				self.task = self.inst:DoTaskInTime(self.regentime, OnRegen, "regen")
				self.targettime = GetTime() + self.regentime
			end
			

		end
	end
end)

AddComponentPostInit("dryer", function(self)
	function self:TpDropProduct()
		if self:IsDone() then
			if self.onharvest then
				self.onharvest(self.inst)
			end
			if self.product then

					local loot = SpawnPrefab(self.product)
					if loot then
						if loot and loot.components.perishable then
							if self.spoiltargettime then
								local spoilpercent = 1-((GetTime()-self.targettime)/(self.spoiltargettime-self.targettime))
								loot.components.perishable:SetPercent(spoilpercent)
							end
							loot.components.perishable:StartPerishing()
						end
	
						self.inst:ApplyInheritedMoisture(loot)
						WARGON.throw_item(self.inst, loot)

					end

				
				self.spoiltargettime = nil
				if self.spoiltask then
					self.spoiltask:Cancel()
					self.spoiltask = nil
				end
				
				self.product = nil
			end
			self.ingredient = nil
			return true		
		end
	end
end)

AddComponentPostInit("container", function(self)
	function self:TpCanGiveItem(item, _stack)
		if not self:CanTakeItemInSlot(item) then
			return 
		end
		local stack = 1
		if item.components.stackable then
			local can_give = 0
			local max_size = item.components.stackable.maxsize
			stack = _stack or item.components.stackable:StackSize()
			for k, v in pairs(self.slots) do
				if v.prefab == item.prefab then
					local delta = max_size - v.components.stackable:StackSize()
					can_give = can_give + delta
					if can_give >= stack then
						return true
					end
				end
			end



		end
		return not self:IsFull()
	end
end)

AddComponentPostInit("inventory", function(self)
	local apply_damage = self.ApplyDamage
	function self:ApplyDamage(damage, attacker, weapon)
		for k,v in pairs(self.equipslots) do
			if v.components.tpornament then
				damage = v.components.tpornament:TakeDamage(damage, attacker, weapon)
				if damage <= 0 then
					return 0
				end
			end
		end
		return apply_damage(self, damage, attacker, weapon)
	end
end)

AddComponentPostInit("inventoryitem", function(self)
	function self:SetImage(image)
		local atlas, img = nil, nil
		if type(image) == "table" then
            atlas = "images/inventoryimages/"..image[1]..".xml"
            img = image[2]
        else
            atlas, img = WARGON.resolve_img_path(image)
            img = string.sub(img, 1, -5)
        end
		self.atlasname = atlas
		self.imagename = img
	end
end)

local hunger_meta = false
AddComponentPostInit("hunger", function(self)
	rawset(self, "max", nil)
	self.tp_max = 100
	self.tp_max_buff = 0

	self.max_hunger_modifiers = {}
	function self:AddMaxHungerModifier(key, mod, save_p)
		local p = self:GetPercent()

		self.max_hunger_modifiers[key] = mod

		self.tp_max_buff = self:GetMaxHungerModifier()
		if save_p then
			self:SetPercent(p)
		else
			self:DoDelta(0, true)
		end
	end
	function self:RemoveMaxHungerModifier(key, save_p, no_delta)
		if self.max_hunger_modifiers[key] then
			local p = self:GetPercent()

			self.max_hunger_modifiers[key] = nil
			self.tp_max_buff = self:GetMaxHungerModifier()
			if save_p then
				self:SetPercent(p)
			elseif not no_delta then
				self:DoDelta(0, true)
			end
		end
	end
	function self:GetMaxHungerModifier()
		local mod = 0
		for k, v in pairs(self.max_hunger_modifiers) do
			mod = mod + v
		end
		return mod
	end

	if hunger_meta then
		return 
	end
	hunger_meta = true
	local c = getmetatable(self)
	local c_index = c.__index
	local c_newindex = c.__newindex
	c.__newindex = function(t, k, val)
		if k == "max" and val then
			return rawset(t, "tp_max", val)
		else
			return (c_newindex or rawset)(t, k, val)
		end
	end
	c.__index = function(t, k)
		if k == "max" then
			return (rawget(t, "tp_max") or 0) +
				(rawget(t, "tp_max_buff") or 0)
		else
			if type(c_index) == "table" then
				return c_index[k]
			else
				return (c_index or rawget)(t, k)
			end
		end
	end
end)

AddComponentPostInit("eater", function(self)
	local SetAbsorptionAmount = self.SetAbsorptionAmount
	function self:SetAbsorptionAmount(health, ...)
		SetAbsorptionAmount(self, health, ...)
		self.healthabsorption = math.sqrt(health)
	end
end)





















































































































































