

local shelfs = {

	{
		name = "tp_thumper_bp",
		img = "tp_thumper#",
		desc = "tp_thumper",
	},
	{
		name = "tp_egg_tool_bp",
		img = "tp_egg_tool#",
		desc = "tp_egg_tool",
	},
	{
		name = "tp_diving_mask",
		img = "gasmaskhat",
		desc = "tp_diving_mask",
	},
	{
		name = "tp_farm_pile_bp",
		img = "fertilizer",
		desc = "tp_farm_pile",
	},
	{
		name = "tp_dragon_cage_bp",
		img = "birdcage_curly#",
		desc = "tp_dragon_cage",
	},

	{
		name = "tp_many_scroll",
		img = "waxwelljournal",
		desc = "start_many_scroll",
	},
	{
		name = "tp_spear_conqueror",
		img = "tp_spear_conqueror#",
		desc = "tp_spear_conqueror",
	},
	{
		name = "tp_oak_armor",
		img = "armor_wood_haramaki#",
		desc = "tp_oak_armor",
	},
	{
		name = "tp_pack_crab",
		img = "backpack_crab#",
		desc = "tp_pack_crab",
	},
	{
		name = "tp_spear_road",
		img = "tp_spear_road#",
		desc = "tp_spear_road",
	},

	{
		name = "scroll_wind",
		img = "scroll_wind#",
		desc = "scroll_wind",
	},
	{
		name = "tp_spear_gold",
		img = "tp_spear_gold#",
		desc = "tp_spear_gold",
	},
	{
		name = "tp_spear_rose",
		img = "spear_rose#",
		desc =  "tp_spear_rose",
	},
	{
		name = "tp_bat_scythe",
		img = "batbat_scythe#",
		desc = "tp_bat_scythe",
	},
	{
		name = "tp_epic",
		img = "tp_epic#",
		desc = "tp_epic",
	},

	{

		name = "tp_many_gem",
		img = "greengem",
		desc = "start_greengem",
	},
	{
		name = "oinc100",
		img = "oinc100",
		desc = "start_oinc100",
	},
}

local goods_shelf = {}

local idx = #shelfs
if WARGON.CONFIG.diff == "dead" then
	idx = 5
elseif WARGON.CONFIG.diff == "hard" then
	idx = 10
elseif WARGON.CONFIG.diff == "normal" then
	idx = 15
end
for i = 1, idx do
	goods_shelf[i] = shelfs[i]
end



















































local BuySystem = Class(function(self)
end)

function BuySystem:GetBalance()




	return GetPlayer().components.inventory:Count("tp_gift")
end

function BuySystem:BuyGoods(goods)
	if self:GetBalance() > 0 then
		local item = SpawnPrefab(goods.name)
		if item.components.inventoryitem then
			GetPlayer().components.inventory:GiveItem(item)
			GetPlayer().components.inventory:ConsumeByName("tp_gift", 1)
		end
		return true
	else
		return false
	end











end

function BuySystem:__tostring()
	return string.format("BuySystem")
end

local GoodsData = Class(function(self, name, price, img)
	self.name = name
	self.price = price or 10
	self.img = img or ""
	self.book = ""
	self.limit = 19
end)

function GoodsData:SplitString(str)
	local len = string.len(str)/3
	local substr = nil
	if len > self.limit then
		substr = string.sub(str, self.limit*3+1, -1)
		str = string.sub(str, 1, self.limit*3)
	end
	return str, substr
end

function GoodsData:GetString()

	local str, substr = WARGON.split_string(self.book, self.limit)
	local sentence = str

	while substr do
		str, substr = WARGON.split_string(substr, self.limit)

		sentence = sentence.."\n"..str
	end
	return sentence
end

function GoodsData:__tostring()
	return string.format("GoodsData %s - %s", self.name, self.price)
end

local GiftPanelData = Class(ShelfData, function(self)
	ShelfData._ctor(self, "萌新礼包", 4)
	self.shopper = BuySystem()
	self.desc = ""
	self.tip = ""
	self.tip2 = ""
end)

local gift_panel_data = GiftPanelData()

for k, v in pairs(goods_shelf) do
	local goods = GoodsData(v.name, 1, v.img)
	goods.desc = v.desc
	goods.book = STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper(v.desc)]
	gift_panel_data:AddItem(goods)
end

WARGON.DATA.gift_panel_data = gift_panel_data