
local attrs = {
	{
		"生命上限",
		"提升你的最大生命值",
		"lightbulb",
		{"health", "health", "anim"},
	},
	{
		"理智上限",
		"提升你的最大理智值",
		"lightbulb",
		{"sanity", "sanity", "anim"},
	},
	{
		"饥饿上限",
		"提升你的最大饥饿值",
		"lightbulb",
		{"hunger", "hunger", "anim"},
	},
	{
		"伤害系数",
		"提升你造成的伤害",
		"spear",
	},
	{
		"速度系数",
		"提升你的移动速度",
		"cane",
	},
	{
		"食物回复",
		"提升食物的回复效果",
		"cookpot",
	},
	{
		"饥饿倍率",
		"降低饥饿的速度",
		"bonestew",
	},
	{
		"承受伤害",
		"降低攻击对你造成的伤害",
		"footballhat",
	},
	{
		"降智系数",
		"降低夜晚和遇到怪物时等造成的降低理智效果",
		"sanity_down",
	},
	{
		"异常减免",
		"降低烧伤，毒伤和流血时的扣血效果",
		"health_down",
	},
	{
		"武器强化",
		"提升强化核心钛金剑和电磁枪的额外伤害",
		"ruins_bat",
	},
	{
		"诅咒上限",
		"提升你的最大诅咒值，详见帮助说明>玩家>诅咒",
		"lightbulb",
		{"beaver_meter", "beaver_meter", "anim"},
	},
	{
		"攻速倍率",
		"提升攻击速度",
		"cutlass",
	},
	{
		"额外幸运",
		"提升部分战利品的掉落几率",
		"woodlegshat",
	},





	{
		"修复效果",
		"提升一些专属装备的维护效果",
		"tp_fix_powder#",
	},
	{
		"胃部调理",
		"食用饱食度较大的食物后当前阶段不会再失眠，详见帮助说明>玩家>饱腹",
		"tea",
	},
	{
		"抗毒血清",
		"中毒时不再受到额外伤害，详见帮助说明>玩家>抵抗力差",
		"antivenom",
	},
	{
		"勇气锻炼",
		"玩家理智崩溃时被影怪视为目标，不会再增加其攻击距离，详见帮助说明>玩家>梦魇",
		"trident",
	},
}

local fns = {
	{
		id = "health",
		cal = function(self, player, is_dec)
			local max = player.components.health.maxhealth
			local measure = max + self.buffer
			local threshold = 200
			local dt = (measure < threshold) and 5 or 1
			if is_dec then
				dt = (measure > threshold) and -1 or -5
			end
			self.buffer = self.buffer + dt
		end,
		show = function(self, player)
			return player.components.health.maxhealth + self.buffer
		end,
	},
	{
		id = "sanity",
		cal = function(self, player, is_dec)
			local max = player.components.sanity.max
			local measure = max + self.buffer
			local threshold = 200
			local dt = (measure < threshold) and 5 or 1
			if is_dec then
				dt = (measure > threshold) and -1 or -5
			end
			self.buffer = self.buffer + dt
		end,
		show = function(self, player)
			return player.components.sanity.max + self.buffer
		end,
	},
	{
		id = "hunger",
		cal = function(self, player, is_dec)
			local max = player.components.hunger.max
			local measure = max + self.buffer
			local threshold = 200
			local dt = (measure < threshold) and 5 or 1
			if is_dec then
				dt = (measure > threshold) and -1 or -5
			end
			self.buffer = self.buffer + dt
		end,
		show = function(self, player)
			return player.components.hunger.max + self.buffer
		end,
	},
	{
		id = "damage",
		cal = function(self, player, is_dec)
			local rate = player.components.combat.attack_damage_modifiers["tplevel"] or 0
			local measure = rate + self.buffer
			local threshold = 0
			local dt = (measure < threshold) and 5 or 1
			if is_dec then
				dt = (measure > threshold) and -1 or -5
			end
			self.buffer = (self.buffer*100+dt)/100
		end,
		show = function(self, player)
			local rate = player.components.combat.attack_damage_modifiers["tplevel"] or 0
			local number = rate + self.buffer
			local word = tostring(100+number*100).."%"
			return word
		end,
	},
	{
		id = "speed",
		cal = function(self, player, is_dec)
			local rate = player.components.locomotor.speed_modifiers_mult["tplevel"] or 0
			local measure = rate + self.buffer
			local threshold = 0
			local dt = (measure < threshold) and 5 or 1
			if is_dec then
				dt = (measure > threshold) and -1 or -5
			end
			self.buffer = (self.buffer*100 + dt)/100
		end,
		show = function(self, player)
			local rate = player.components.locomotor.speed_modifiers_mult["tplevel"] or 0
			local number = rate + self.buffer
			local word = tostring(100+number*100).."%"
			return word
		end,
	},
	{
		id = "eater",
		cal = function(self, player, is_dec)
			local rate = player.components.eater.hungerabsorption or 1
			local measure = rate + self.buffer
			local threshold = 1
			local dt = (measure < threshold) and 5 or 1
			if is_dec then
				dt = (measure > threshold) and -1 or -5
			end
			self.buffer = (self.buffer*100 + dt)/100
		end,
		show = function(self, player)
			local rate = player.components.eater.hungerabsorption or 1
			local number = rate + self.buffer
			local word = tostring(100*number).."%"
			return word
		end,
	},
	{
		id = "hungry",
		cal = function(self, player, is_dec)
			local rate = player.components.hunger.burn_rate_modifiers["tplevel"] or 0
			local measure = rate + self.buffer
			local threshold = 0
			local dt = (measure > threshold) and -5 or -1
			if is_dec then
				dt = (measure < threshold) and 1 or 5
			end
			self.buffer = (self.buffer*100 + dt)/100
		end,
		dom = function(self, player)
			local rate = player.components.hunger.burn_rate_modifiers["tplevel"] or 0
			return rate + self.buffer > -.9
		end,
		show = function(self, player)
			local rate = player.components.hunger.burn_rate_modifiers["tplevel"] or 0
			local number = rate + self.buffer
			local word = tostring(100+number*100).."%"
			return word
		end,
	},
	{
		id = "absorb",
		cal = function(self, player, is_dec)


			local rate = player.components.combat.absorb_modifiers["tplevel"]
			local measure = rate + self.buffer
			local threshold = 0
			local dt = (measure < threshold) and 5 or 1
			if is_dec then
				dt = (measure > threshold) and -1 or -5
			end
			self.buffer = (self.buffer*100 + dt)/100
		end,
		dom = function(self, player)


			local rate = player.components.combat.absorb_modifiers["tplevel"]
			return rate + self.buffer < 0.9
		end,
		show = function(self, player)


			local rate = player.components.combat.absorb_modifiers["tplevel"]
			local number = (rate+self.buffer)
			local word = tostring(100-number*100).."%"
			return word
		end,
	},
	{
		id = "horror",
		cal = function(self, player, is_dec)

			local rate = player.components.sanity.rate_modifiers["tplevel"] or 0
			local measure = rate + self.buffer
			local threshold = 0
			local dt = (measure > threshold) and -5 or -1
			if is_dec then
				dt = (measure < threshold) and 1 or 5
			end
			self.buffer = (self.buffer*100+dt)/100
		end,
		dom = function(self, player)

			local rate = player.components.sanity.rate_modifiers["tplevel"] or 0
			return rate + self.buffer > -.9
		end,
		show = function(self, player)

			local rate = player.components.sanity.rate_modifiers["tplevel"] or 0
			local number = rate + self.buffer
			local word = tostring(100+number*100).."%"
			return word
		end,
	},
	{
		id = "nature",
		cal = function(self, player, is_dec)
			local rate = player.components.health.poison_damage_scale or 1
			local measure = rate + self.buffer
			local threshold = 1
			local dt = (measure > threshold) and -5 or -1
			if is_dec then
				dt = (measure < threshold) and 1 or 5
			end
			self.buffer = (self.buffer*100+dt)/100
		end,
		dom = function(self, player)
			local rate = player.components.health.poison_damage_scale or 1
			return rate + self.buffer > .1
		end,
		show = function(self, player)
			local rate = player.components.health.poison_damage_scale or 1
			local number = rate + self.buffer
			local word = tostring(number*100).."%"
			return word
		end,
	},
	{
		id = "forge",
		cal = function(self, player, is_dec)
			local dmg = player.components.tplevel and player.components.tplevel.attr.forge or 0
			local measure = dmg + self.buffer
			local threshold = 20
			local dt = (measure < threshold) and 5 or 1
			if is_dec then
				dt = (measure > threshold) and -1 or -5
			end
			self.buffer = self.buffer + dt
		end,




		show = function(self, player)
			local dmg = player.components.tplevel and player.components.tplevel.attr.forge or 0
			return dmg + self.buffer
		end,
	},
	{
		id = "madval",
		cal = function(self, player, is_dec)
			local max = player.components.tpmadvalue and player.components.tpmadvalue.max or 100
			local measure = max + self.buffer
			local threshold = 200
			local dt = (measure < threshold) and 5 or 1
			if is_dec then
				dt = (measure > threshold) and -1 or -5
			end
			self.buffer = self.buffer + dt
		end,
		show = function(self, player)
			local max = player.components.tpmadvalue and player.components.tpmadvalue.max or 100
			return max + self.buffer
		end,
	},
	{
		id = "attack_period",
		cal = function(self, player, is_dec)

			local dt = is_dec and -1 or 1
			self.buffer = self.buffer + dt
		end,
		dom = function(self, player)
			local rate = player.components.combat.attack_period_modifiers["tplevel"] or 0
			return -rate*100 + self.buffer < 90
		end,
		show = function(self, player)
			local rate = player.components.combat.attack_period_modifiers["tplevel"] or 0
			local number = ( -rate*100 + self.buffer )
			local word = tostring(number).."%"
			return word
		end,
	},
	{
		id = "lucky",
		cal = function(self, player, is_dec)
			local rate =  player.components.tpbody and player.components.tpbody.lucky or 0
			local dt = is_dec and -1 or 1
			self.buffer = self.buffer + dt
		end,
		dom = function(self, player)
			local rate =  player.components.tpbody and player.components.tpbody.lucky or 0
			return rate + self.buffer < 90
		end,
		show = function(self, player)
			local rate =  player.components.tpbody and player.components.tpbody.lucky or 0
			local number = rate + self.buffer
			local word = tostring(number).."%"
			return word
		end,
	},



















	{
		id = "fixup",
		cal = function(self, player, is_dec)
			local num = player.components.tplevel and player.components.tplevel.attr.fixup or 0
			local measure = num + self.buffer
			local threshold = 10
			local dt = (measure < threshold) and 5 or 1
			if is_dec then
				dt = (measure > threshold) and -1 or -5
			end
			self.buffer = self.buffer + dt
		end,
		show = function(self, player)
			local num = player.components.tplevel and player.components.tplevel.attr.fixup or 0
			local number = num + self.buffer
			local word = tostring(number)
			return word
		end,
	},
	{
		id = "good_stomach",
		cal = function(self, player, is_dec)
			local num = player.components.tplevel and player.components.tplevel.attr.good_stomach or 0
			local dt = is_dec and -1 or 1
			self.buffer = self.buffer + dt
		end,
		dom = function(self, player)
			local num = player.components.tplevel and player.components.tplevel.attr.good_stomach or 0
			return num + self.buffer < 1
		end,
		show = function(self, player)
			local num = player.components.tplevel and player.components.tplevel.attr.good_stomach or 0
			num = num + self.buffer
			local word = "False"
			if num > 0 then
				word = "True"
			end
			return word
		end,
	},
	{
		id = "antivenom",
		cal = function(self, player, is_dec)
			local num = player.components.tplevel and player.components.tplevel.attr.antivenom or 0
			local dt = is_dec and -1 or 1
			self.buffer = self.buffer + dt
		end,
		dom = function(self, player)
			local num = player.components.tplevel and player.components.tplevel.attr.antivenom or 0
			return num + self.buffer < 1
		end,
		show = function(self, player)
			local num = player.components.tplevel and player.components.tplevel.attr.antivenom or 0
			num = num + self.buffer
			local word = "False"
			if num > 0 then
				word = "True"
			end
			return word
		end,
	},
	{
		id = "brave_nightmare",
		cal = function(self, player, is_dec)
			local num = player.components.tplevel and player.components.tplevel.attr.brave_nightmare or 0
			local dt = is_dec and -1 or 1
			self.buffer = self.buffer + dt
		end,
		dom = function(self, player)
			local num = player.components.tplevel and player.components.tplevel.attr.brave_nightmare or 0
			return num + self.buffer < 1
		end,
		show = function(self, player)
			local num = player.components.tplevel and player.components.tplevel.attr.brave_nightmare or 0
			num = num + self.buffer
			local word = "False"
			if num > 0 then
				word = "True"
			end
			return word
		end,
	},
}


















































local AttrData = Class(function(self)
	self.name = ""
	self.book = ""
	self.img = nil
	self.anim = nil
	self.id = ""
	self.cal = nil
	self.dom = nil
	self.show = nil
	self.buffer = 0
	self.limit = 19
	self.use = 0
end)

function AttrData:SplitString(str)
	local len = string.len(str)/3
	local substr = nil
	if len > self.limit then
		substr = string.sub(str, self.limit*3+1, -1)
		str = string.sub(str, 1, self.limit*3)
	end
	return str, substr
end

function AttrData:GetString()

	local str, substr = WARGON.split_string(self.book, self.limit)
	local sentence = str

	while substr do
		str, substr = WARGON.split_string(substr, self.limit)

		sentence = sentence.."\n"..str
	end
	return sentence
end

function AttrData:GetValue()
	return self:show(GetPlayer())
end

function AttrData:__tostring()
	return string.format("AttrData %s", self.name)
end

local LevelSystem = Class(ShelfData, function(self)
	ShelfData._ctor(self, "等级提升", 20)
	self.cost = 0
	self.essences = 0
	self.tip = "按下CTRL\n时点击可以\n返还未确认\n的升级点"
	self.tip2 = "确认升级"
end)

function LevelSystem:GetPlayerEssence()
	return GetPlayer().components.tplevel:GetEssence()
end

function LevelSystem:GetEssence()
	return self.essences
end

function LevelSystem:Init()
	self.essences = self:GetPlayerEssence()
	self.cost = 0
	for k, v in pairs(self:GetItems()) do
		v.buffer = 0
		v.use = 0
	end
end

function LevelSystem:GetCost()
	return self.cost
end

function LevelSystem:LevelDelta(attr, is_dec)
	local player = GetPlayer()
	if not is_dec then
		if self:GetEssence() > 0 then
			if (not attr.dom) or attr:dom(player) then
				attr:cal(player)
				attr.use = attr.use + 1
				self.cost = self.cost + 1
				self.essences = self.essences - 1
			end
		end
	else
		if self.cost > 0 and attr.use > 0 then

			attr:cal(player, true)
			attr.use = attr.use - 1
			self.cost = self.cost - 1
			self.essences = self.essences + 1
		end
	end
end

function LevelSystem:GetLevel()
	local level = GetPlayer().components.tplevel:GetLevel()
	return level + self.cost
end

function LevelSystem:Sure()
	if self.cost > 0 then
		local player = GetPlayer()
		if player.components.tplevel then
			for k, v in pairs(self:GetItems()) do
				local id = v.id
				player.components.tplevel.attr[id] = player.components.tplevel.attr[id] + v.buffer
			end
			player.components.tplevel:Apply(true)

			WARGON.make_fx2("multifirework_fx", player)
			player.components.inventory:ConsumeByName("tp_epic", self.cost)
			player.components.tplevel:LevelUp(self.cost)
		end
	end
end

local level_system = LevelSystem()

for k, v in pairs(attrs) do
	local attr = AttrData()
	attr.name = v[1]
	attr.book = v[2]
	attr.img = v[3]
	attr.anim = v[4]
	attr.id = fns[k].id
	attr.cal = fns[k].cal
	attr.dom = fns[k].dom
	attr.show = fns[k].show
	level_system:AddItem(attr)
end

GLOBAL.WARGON.DATA.level_panel_data = level_system