













































local GiftPool = Class(function(self, title)
	self.title = title
	self.pool = {}
	self.img = nil
	self.book = nil
	self.limit = 19
end)

function GiftPool:GiveGift()
	local name = weighted_random_choice(self.pool)
	local gift = SpawnPrefab(name)

	if gift.components.inventoryitem then
		WARGON.gift_throw(inst, {gift})
	else
		WARGON.spawn_creatures(inst, {gift})
	end
end

function GiftPool:__tostring()
	return string.format("GiftPool %s",self.title)
end

function GiftPool:SplitString(str)
	local len = string.len(str)/3
	local substr = nil
	if len > self.limit then
		substr = string.sub(str, self.limit*3+1, -1)
		str = string.sub(str, 1, self.limit*3)
	end
	return str, substr
end

function GiftPool:GetString()

	local str, substr = WARGON.split_string(self.book, self.limit)
	local sentence = str

	while substr do
		str, substr = WARGON.split_string(substr, self.limit)

		sentence = sentence.."\n"..str
	end
	return sentence
end

local BuySystem = Class(function(self)
end)

function BuySystem:GetBalance()
	local tpbuy = GetPlayer().components.tpbuy
	if tpbuy then
		return tpbuy:CountMoney() or 0
	end
end

function BuySystem:BuyGoods(gift, price)
	local tpbuy = GetPlayer().components.tpbuy
	if tpbuy and tpbuy:CanBuy(price) then
		GetPlayer().components.tpbuy:Buy(price)
		gift:GiveGift()





		return true
	else
		return false
	end
end

function BuySystem:__tostring()
	return string.format("BuySystem")
end

local LotteryData = Class(ShelfData, function(self)
	ShelfData._ctor("幸运抽奖", 4)
	self.buy_system = BuySystem()
end)

local pools = {
	{
		title = "标准奖池",
		book = "帮助新手更好的上路",
		img = "berries#",
		price = 10,
		pool = {
			tp_thumper_bp = 1,
			tp_egg_tool_bp = 1,
			tp_diving_mask = 1,
			tp_dragon_cage = 1,
			tp_farm_pile_bp = 1,
			tp_spear_conqueror = 2,
			tp_ballhat = 2,
			tp_oak_armor = 2,
			tp_spear_speed = 2,
			tp_spear_bag = 2,
			tp_spear_trap = 2,
			tp_spear_beefalo = 2,
			tp_spear_collect = 2,
			tp_spear_cooldown = 2,
			tp_spear_potion = 2,
			tp_spear_lance = 3,
			tp_spear_gungnir = 3,
			tp_spear_wrestle = 3,
			tp_armor_lamellar = 3,
			tp_hat_helm = 3,
			tp_woodarmor = 3,
			tp_fix_powder = 3,
			tp_wilson_v = 1,
			tp_wilson_m = 1,
			twigs = 100,
			log = 100,
			cutgrass = 100,
			flint = 50,
			rocks = 50,
			nitre = 20,
			goldnugget = 20,
			berries = 20,
			carrot = 20,
			gears = 5,
			silk = 5,
			seeds = 10,
			pinecone = 10,
		},
	},
	{
		title = "扩充奖池",
		book = "更丰富的奖励，但也可能招来不幸",
		img = "carrot",
		price = 20,
		pool = {

			tp_spear_ice = 1,
			tp_spear_hades = 1,
			tp_spear_lance = 1,
			tp_spear_fire_rose = 1,
			tp_spear_ice_rose = 1,
			tp_spear_anubis = 1,
			tp_spear_shadow = 1,
			tp_spear_combat = 1,
			tp_spear_gaea = 1,
			tp_spear_ice_thunder = 1,
			tp_spear_heracles = 1,
			tp_spear_shine = 1,
			tp_spear_lightning = 1,
			tp_spear_valkyrie = 1,
			tp_spear_potion = 1,
			tp_spear_blood = 1,
			tp_spear_thunder = 1,
			tp_spear_trap = 1,
			tp_spear_wind = 1,
			tp_spear_gold = 1,
			tp_spear_fire = 1,

			tp_armor_firm = 2,
			tp_armor_ancient = 1,
			tp_armor_thunder = 2,
			tp_armor_health = 2,
			tp_armor_cool = 2,

			tp_hat_cool = 2,
			tp_hat_helm = 2,
			tp_hat_health = 2,
			tp_hat_warm = 2,

			tp_potion_crazy = 3,
			tp_potion_warm = 3,
			tp_potion_killer = 3,
			tp_potion_health_small = 3,
			tp_potion_shine = 3,
			tp_potion_horror = 3,
			tp_potion_iron = 3,
			tp_plantable_grass_water = 3,

			scroll_sleep = 2,
			scroll_wind = 2,
			scroll_pig_armor = 2,
			scroll_tentacle = 2,
			scroll_pig_speed = 2,
			scroll_bunnyman = 2,
			scroll_lightning = 2,
			scroll_moose = 1,
			scroll_pigman = 2,
			scroll_volcano = 2,
			scroll_harvest = 2,
			scroll_pig_leader = 2,
			scroll_pig_damage = 2,
			scroll_dragonfly = 1,

			tp_wilson_m = 5,
			tp_wilson_v = 5,
			tp_wilson_s = 5,
			tp_wilson_f = 5,
			tp_wilson_i = 5,

			ash = 100,
			beefalowool = 100,
			boneshard = 100,
			charcoal = 100,
			cutreeds = 100,
			dug_grass = 100,
			dug_sapling = 100,
			ice = 100,
			lightbulb = 100,
			manrabbit_tail = 100,
			nightmarefuel = 100,
			papyrus = 100,
			pigskin = 100,
			poop = 100,
			silk = 100,
			spoiled_food = 100,

			monstermeat = 50,
			red_cap = 50,
			meat = 50,
			blue_cap = 50,
			bird_egg = 50,
			coffeebeans = 50,
			eggplant = 50,
			fish = 50,
			green_cap = 50,
			small_meat = 50,

			bat = 100,
			bee = 100,
			beefalo = 100,
			bunnyman = 100,
			firehound = 100,
			frog = 100,
			cocodog = 100,
			knight = 100,
			killerbee = 100,
			hound = 100,
			krampus = 100,
			leif = 100,
			merm = 100,
			mosquito = 100,
			pigguard = 100,
			rook = 100,
			spider = 100,
			snake = 100,
			tallbird = 100,
		},
	},
}

local lottery_panel_data = LotteryData()
for k, v in pairs(pools) do
	local pool = GiftPool(v.title)
	pool.img = v.img
	pool.book = v.book
	pool.price = v.price
	pool.pool = v.pool
	lottery_panel_data:AddItem(pool)
end