
local fruits = {
	{
		id = "delicacy",
		name = "美味",
		fn = function(self, eater)
		end,
		desc = "食用收益效果增加",
		quality = 1,
	},
	{
		id = "coffee",
		name = "咖啡因",
		fn = function(self, eater)
			eater:add_speed_rate("tp_coffee", .1, 60)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_coffee")
			end
		end,
		desc = "食用后增加移速",
		quality = 1,
	},
	{
		id = "incitant",
		name = "兴奋剂",
		fn = function(self, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_incitant", 60)
			end

		end,
		desc = "食用后增加攻击力",
		quality = 1,
	},
	{
		id = "hot",
		name = "麻辣",
		fn = function(self, eater)
			if eater.components.temperature then			
				eater.components.temperature:DeltaTemp(10)
			end
		end,
		desc = "食用后温度升高",
		quality = 1,
	},
	{
		id = "cool",
		name = "冰镇",
		fn = function(self, eater)
			if eater.components.temperature then			
				eater.components.temperature:DeltaTemp(-10)
			end
		end,
		desc = "食用后降低温度",
		quality = 1,
	},
	{
		id = "medicinal",
		name = "药材",
		fn = function(self, eater)
			if eater.components.poisonable then
				eater.components.poisonable:Cure()
			end
		end,
		desc = "食用后解毒",
		quality = 3,
	},
	{
		id = "vitamin",
		name = "维生素",
		fn = function(self, eater)
			if eater.components.health then
				eater.components.health:DoDelta(5)
			end
		end,
		desc = "食用后额外回复生命",
		quality = 1,
	},
	{
		id = "dessert",
		name = "甜点",
		fn = function(self, eater)
			if eater.components.sanity then
				eater.components.sanity:DoDelta(5)
			end
		end,
		desc = "食用后额外回复理智",
		quality = 1,
	},
	{
		id = "rice",
		name = "细粮",
		fn = function(self, eater)
			if eater.components.hunger then
				eater.components.hunger:DoDelta(5)
			end
		end,
		quality = 1,
		desc = "食用后额外回复饥饿",
	},
	{
		id = "box",
		name = "盒饭",
		fn = function(self, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_fast_work", 30)
			end
		end,
		desc = "食用后采集速度更快",
		quality = 2,
	},
	{
		id = "dry",
		name = "干粮",
		fn = function(self, eater)
			if eater.components.moisture then
				eater.components.moisture:DoDelta(-5)
			end
		end,
		desc = "食用后降低潮湿度",
		quality = 1,
	},
	{
		id = "mushroom",
		name = "昏睡菇",
		fn = function(self, eater)
			if eater:HasTag("player") then
				TheFrontEnd:Fade(true,1)
				GetClock():NextPhase()
			end
		end,
		desc = "食用后跳过当前阶段",
		quality = 3,
	},
	{
		id = "spice",
		name = "香料",
		fn = function(self, eater)
			local ents = eater:wg_finds(10, nil, {"NOCLICK", "FX", "BLOCK"})
			for k, v in pairs(ents) do
				if v.components.combat 
				and v.components.combat.target == eater
				and not v:HasTag("player") then
					v.components.combat:SetTarget(nil)
				end
			end
		end,
		desc = "食用后消除周围生物对自己的仇恨",
		quality = 2,
	},
	{
		id = "glow",
		name = "荧光",
		fn = function(self, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_glow", 90)
			end
		end,
		desc = "食用后身体发光",
		quality = 3,
	},
	{
		id = "fresh",
		name = "保鲜",
		fn = function(self, eater)
		end,
		desc = "腐烂速度减半",
		quality = 3,
	},
	{
		id = "tonic",
		name = "补药",
		fn = function(self, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_tonic")
			end
		end,
		desc = "增加最大生命上限",
		quality = 3,

	},
	{
		id = "dinner",
		name = "晚宴",
		fn = function(self, eater)
			if eater.components.tpbody
			and eater.components.tpbody.max_sanity_mods["tp_dinner"] == nil then
				if eater.components.sanity then
					eater.components.sanity:DoDelta(20)
				end
			end
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_dinner")
			end
		end,
		desc = "增加最大理智上限和理智值",
		quality = 3,

	},
	{
		id = "pickle",
		name = "泡菜",
		fn = function(self, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_pickle")
			end
		end,
		desc = "增加最大饥饿上限",
		quality = 3,

	},
	{
		id = "mine",
		name = "咯牙",
		fn = function(self, eater)
			if eater.components.hunger then
				eater.components.hunger:DoDelta(-3)
			end
			if eater.components.sanity then
				eater.components.sanity:DoDelta(-3)
			end
			local loots = {
				rocks = 10,
				flint = 10,
				goldnugget = 10,
				nitre = 10,
				obsidian = 5,
				yellowgem = 1,
				greengem = 1,
				orangegem = 1,
				redgem = 2,
				bluegem = 2,
				purplegem = 2,
				tp_alloy = 2,
				tp_alloy_red = 2,
				tp_alloy_great = 1,
			}
		end,
		desc = "额外降低一点饥饿和理智，并随机掉落一块矿物",
		quality = 2,
	},
	{
		id = "health_lord",
		name = "生命领主",
		fn = function(self, eater)
			if eater.components.health then
				eater.components.health:DoDelta(30)
			end
		end,
		desc = "食用后额外回复大量生命，不会腐烂",
		quality = 4,
	},
	{
		id = "sanity_lord",
		name = "精神领袖",
		fn = function(self, eater)
			if eater.components.sanity then
				eater.components.sanity:DoDelta(30)
			end
		end,
		desc = "食用后额外回复大量精神值，不会腐烂",
		quality = 4,
	},






	{
		id = "harvester_king",
		name = "收获之王",
		fn = function(inst, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_fast_work", 60)
				eater.components.tpbuff:AddBuff("tp_harvester_king")
			end
		end,
		desc = "食用后采集速度更快，且采集时会将周围的作物也采集起来",
		quality = 4,
	},
	{
		id = "combat_fruit",
		name = "战神之酒",
		fn = function(inst, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_combat_fruit")
			end
		end,
		desc = "食用后大幅增加攻击力",
		quality = 4,
	},
	{
		id = "wind_seed",
		name = "狂风之种",
		fn = function(inst, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_wind_seed")
			end
		end,
		desc = "食用后大幅增加移动速度，免疫春季之王和雨季之王飓风的伤害",
		quality = 4,
	},



	{
		id = "poison",
		name = "有毒",
		bad = true,
		quality = 0,
		fn = function(self, eater)
			WARGON.poison_prefab(eater)
		end,
		desc = "食用后会中毒",
	},
	{
		id = "terriable",
		name = "难吃",
		bad = true,
		quality = 0,
		fn = function(self, eater)
		end,
		desc = "食用收益降低",
	},
	{
		id = "grain",
		name = "粗粮",
		bad = true,
		quality = 0,
		fn = function(self, eater)
			if eater.components.hunger then
				eater.components.hunger:DoDelta(-5)
			end
		end,
		desc = "食用后降低饥饿值",
	},
	{
		id = "mildew",
		name = "发霉",
		bad = true,
		quality = 0,
		fn = function(self, eater)
			if eater.components.health then
				eater.components.health:DoDelta(-5)
			end
		end,
		desc = "食用后降低生命值",
	},
	{
		id = "bitter",
		name = "苦涩",
		bad = true,
		quality = 0,
		fn = function(self, eater)
			if eater.components.sanity then
				eater.components.sanity:DoDelta(-5)
			end
		end,
		desc = "食用后降低理智值",
	},
	{
		id = "wet",
		name = "浸水",
		bad = true,
		quality = 0,
		fn = function(self, eater)
			if eater.components.moisture then
				eater.components.moisture:DoDelta(5)
			end
		end,
		desc = "食用后增加潮湿度",
	},
	{
		id = "unhygienic",
		name = "不卫生",
		bad = true,
		quality = 0,
		fn = function(self, eater)


			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_unhygienic")
			end
		end,
		desc = "食用后降低攻击力",
	},
	{
		id = "junkfood",
		name = "垃圾食品",
		bad = true,
		quality = 0,
		fn = function(self, eater)
			eater:add_speed_rate("tp_junkfood", -.2, 60)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_junkfood")
			end
		end,
		desc = "食用后降低移速",
	},
	{
		id = "parasite",
		name = "寄生虫",
		bad = true,
		quality = 0,
		fn = function(self, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_parasite")
			end
		end,
		desc = "食用后的一段时间内，攻击敌人会失去生命值",
	},
	{
		id = "overdue",
		name = "过期",
		bad = true,
		quality = 0,
		fn = function(self, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_overdue")
			end	
		end,
		desc = "食用后减少理智上限",
	},
	{
		id = "pesticide",
		name = "农药残留",
		bad = true,
		quality = 0,
		fn = function(self, eater)
			if eater.components.tpbuff then
				eater.components.tpbuff:AddBuff("tp_pesticide")
			end
		end,
		desc = "食用后减少生命上限",
	},
	{
		id = "oblation",
		name = "祭品",
		bad = true,
		quality = 0,
		fn = function(self, eater)
			local pos = Vector3(eater.Transform:GetWorldPosition())
	        GetSeasonManager():DoLightningStrike(pos, false, eater) 
		end,
		desc = "食用后会引雷",
	},
	{
		id = "perish",
		name = "易腐",
		fn = function(self, eater)
		end,
		desc = "腐烂速度翻倍",
		bad = true,
		quality = 0,
	},
	{
		id = "dark",
		name = "黑暗料理",
		fn = function(self, eater)
			local attrs = {"health", "hunger", "sanity"}
			local attr = attrs[math.random(#attrs)]
			if eater.components[attr] then
				local p = 1
				if math.random() < .5 then
					p = .1
				end
				eater.components[attr]:SetPercent(p)
			end
		end,
		desc = "食用后三围中的某个属性变为百分之百或变为百分之十",
		bad = true,
		quality = 0,
	},



	{
		id = "sheildfruit",
		name = "守护果实",

		fn = function(self, eater)
			if eater.components.tppower then
				eater.components.tppower:SetPower(4)
			end
		end,
		desc = "元素生物食用后变为黄色元素",
		quality = 2,
	},
	{
		id = "icefruit",
		name = "寒冰果实",

		fn = function(self, eater)
			if eater.components.tppower then
				eater.components.tppower:SetPower(6)
			end
		end,
		desc = "元素生物食用后变为青色元素",
		quality = 2,
	},
	{
		id = "thunderfruit",
		name = "雷电果实",

		fn = function(self, eater)
			if eater.components.tppower then
				eater.components.tppower:SetPower(2)
			end
		end,
		desc = "元素生物食用后变为蓝色元素",
		quality = 2,
	},
	{
		id = "bloodfruit",
		name = "吸血果实",

		fn = function(self, eater)
			if eater.components.tppower then
				eater.components.tppower:SetPower(1)
			end
		end,
		desc = "元素生物食用后变为红色元素",
		quality = 2,
	},
	{
		id = "shadowfruit",
		name = "暗影果实",

		fn = function(self, eater)
			if eater.components.tppower then
				eater.components.tppower:SetPower(5)
			end
		end,
		desc = "元素生物食用后变为紫色元素",
		quality = 2,
	},
	{
		id = "poisonfruit",
		name = "毒素果实",

		fn = function(self, eater)
			if eater.components.tppower then
				eater.components.tppower:SetPower(3)
			end
		end,
		desc = "元素生物食用后变为绿色元素",
		quality = 2,
	},
	{
		id = "pure",
		name = "纯净物",
		fn = function(self, eater)
		end,
		desc = "几乎没有杂质，更没有其他效果",
		quality = 1,
	},
}

local PowerFruit = Class(function(self)
	self.name = ""
	self.id = ""
	self.fn = nil
	self.bad = nil
	self.element = nil
end)

local PowerFruitShelf = Class(function(self)
	self.fruits = {}
	self.num = 0
	self.ids = {}
end)

function PowerFruitShelf:AddFruit(fruit)
	self.fruits[fruit.id] = fruit
	self.num = self.num + 1
	self.ids[self.num] = fruit.id
end

function PowerFruitShelf:GetFruit(id)
	return self.fruits[id]
end

function PowerFruitShelf:GetRandomId()
	local n = math.random(self.num)
	return self.ids[n]
end

function PowerFruitShelf:GetName(id)
	local fruit = self.fruits[id]
	return fruit.name
end

local fruit_shelf = PowerFruitShelf()
for k, v in pairs(fruits) do
	local fruit = PowerFruit()
	fruit.id = v.id
	fruit.name = v.name
	fruit.fn = v.fn
	fruit.bad = v.bad
	fruit.element = v.element
	fruit.quality = v.quality or 0
	fruit_shelf:AddFruit(fruit)
end

WARGON.DATA.tp_data_power_fruit = fruit_shelf
WARGON.DATA.tp_data_power_fruit_table = fruits