local equips = {
	{
		id = "ice_iron",
		hp = 30,
		armor = .2,
		hit = function(inst, attacker, dmg, tool, proj)
			if attacker and not (attacker:HasTag("tp_hat_wrestle") 
			or attacker:HasTag("tp_hat_dragon_body"))
			and attacker.components.tpbuff then
				attacker.components.tpbuff:AddBuff("tp_ice_iron")
			end
		end,
		name = "兰顿",
		desc = "增加三十生命，百分之二十防御；降低攻击者攻速",
	},
	{
		id = "heal_armor",
		hp = 50,
		pass = function(inst)
			inst.components.health:StartRegen(20, 4)
		end,
		name = "狂徒",
		desc = "增加五十生命；每四秒回复二十点生命值",
	},
	{
		id = "ask_flag",
		hp = 10,
		hit = function(inst, attacker, dmg, tool, proj)
			if math.random() < .33 then
				local ents = inst:wg_finds(6)
				for k, v in pairs(ents) do
					if v.prefab == inst.prefab then
						if v.components.combat then
							v.components.combat:AddDamageModifier("ask_flag", .2)
						end
						if v.ask_flag_task then
							v.ask_flag_task:Cancel()
							v.ask_flag_task = nil
						end
						v.ask_flag_task = v:do_task(10, function()
							if v.components.combat then
								v.components.combat:RemoveDamageModifier("ask_flag")
							end
							v.ask_flag_task:Cancel()
							v.ask_flag_task = nil
						end)
					end
				end
			end
		end,
		name = "战旗",
		desc = "增加十点生命；被攻击时有几率增加周围同类的攻击力",
	},
	{
		id = "thorn_armor",
		armor = .3,
		hit = function(inst, attacker, dmg, tool, proj)
			if math.random() < .5 and attacker 
			and not (attacker:HasTag("tp_hat_wrestle")
			or attacker:HasTag("tp_hat_dragon_head")) then
				local data = {
					attacker = attacker,
					damage = dmg,
					weapon = tool,
					stimuli = proj,
				}
				if WARGON.can_thorns(inst, data) then
					if attacker.components.combat then
						attacker.components.combat:GetAttacked(inst, 5, nil, "thorns")
					end
				end
			end
		end,
		name = "反甲",
		desc = "增加百分之三十防御；被攻击时有几率对攻击者造成五点伤害",
	},
	{
		id = "salvation",
		hp = 10,
		hit = function(inst, attacker, dmg, tool, proj)
			if math.random() < .33 then
				local ents = inst:wg_finds(5)
				for k, v in pairs(ents) do
					if v.prefab == inst.prefab then
						if v:is_alive() then
							v.components.health:DoDelta(20)
						end
					end
				end
			end
		end,
		name = "救赎",
		desc = "增加十点生命；被攻击时有几率令周围的同类恢复二十点生命",
	},
	{
		id = "sun_cloak",
		hp = 30,
		armor = .2,
		hit = function(inst, attacker, dmg, tool, proj)
			if math.random() < .5 and attacker
			and not (attacker:HasTag("tp_hat_wrestle")
			or attacker:HasTag("tp_hat_dragon_head")) then
				WARGON.fire_prefab(attacker)
			end
		end,
		name = "日炎",
		desc = "增加三十生命，百分之二十防御；被攻击时有几率点燃攻击者",
	},
	{
		id = "board_armor",
		hp = 30,
		armor = .1,
		pass = function(inst)
			inst:do_task(5, function()
				inst:add_speed_rate("board_armor", .3)
				inst:AddTag("board_armor")
			end)
		end,
		atk = function(inst, target)
			if inst:HasTag("board_armor") then
				inst:RemoveTag("board_armor")
				target:add_speed_rate("board_armor_debuff", -.2, 5)
				if target.components.tpbuff then
					target.components.tpbuff:AddBuff("tp_board_armor")
				end
				inst:rm_speed_rate("board_armor")
				inst:do_task(5, function()
					inst:AddTag("board_armor")
					inst:add_speed_rate("board_armor", .3)
				end)
			end
		end,
		name = "板甲",
		desc = "增加三十生命，百分之十防御；充能五秒后，获得移速加成，下一次攻击会令敌人减速，并令自己失去加速效果，重新进入充能",
	},
	{
		id = "ice_fight",
		armor = .2,
		atk = function(inst, target)
			if not inst:HasTag("no_ice_fight") then
				target:add_speed_rate("ice_fight_attacked", -.3, 5)
				if target.components.tpbuff then
					target.components.tpbuff:AddBuff("tp_ice_fight")
				end
				WARGON.frozen_prefab(target)
				inst:AddTag("no_ice_fight")
				inst:do_task(5, function()
					inst:RemoveTag("no_ice_fight")
				end)
			end
		end,
		name = "冰拳",
		desc = "增加百分之二十防御；攻击会令敌人造成减速并附加冰冻效果，有五秒冷却时间",
	},
	{
		id = "army_group",
		armor = .1,
		pass = function(inst)
			inst.army_group_task = inst:per_task(1, function()
				local ents = inst:wg_finds(4)
				for k, v in pairs(ents) do
					if v.prefab == inst.prefab then
						v:add_speed_rate("army_group", .2, 1)
					end
				end
			end)
		end,
		name = "军团",
		desc = "持续为周围的友军提供移速",
	},
	{
		id = "infinite_blade",
		pass = function(inst)
			inst:add_dmg_rate("infinite_blade", .3)
		end,
		atk = function(inst, target, dmg)
			if math.random() < .33 then
				target.components.health:DoDelta(-dmg)
			end
		end,
		name = "无尽",
		desc = "增加百分之三十攻击力；有一定几率造成暴击",
	},
	{
		id = "drink_blood",
		pass = function(inst)
			inst:add_dmg_rate("drink_blood", .2)
		end,
		atk = function(inst, target, dmg)
			if inst.components.health then
				inst.components.health:DoDelta(dmg)
			end
		end,
		name = "饮血",
		desc = "增加百分之二十攻击；造成的伤害会回复生命",
	},
	{
		id = "black_cut",
		hp = 20,
		pass = function(inst)
			inst:add_dmg_rate("black_cut", .1)
		end,
		atk = function(inst, target)
			if math.random() < .33 then
				if target.components.tpbuff then
					target.components.tpbuff:AddBuff("tp_armor_broken")
				end
			end
		end,
		name = "黑切",
		desc = "增加二十生命，百分之十攻击；攻击有几率对敌人造成破甲",
	},
	{
		id = "ice_heart",
		armor = .3,
		hit = function(inst, attacker, dmg, tool, proj)
			if attacker and not (attacker:HasTag("tp_hat_wrestle")
			or attacker:HasTag("tp_hat_dragon_body")) 
			and attacker.components.tpbuff then
				attacker.components.tpbuff:AddBuff("tp_ice_heart")
			end
		end,
		name = "冰心",
		desc = "增加百分之三十防御；降低攻击者攻速"
	},
	{
		id = "justice_honor",
		armor = .1,
		hp = 20,
		pass = function(inst)
			inst.justice_honor_fn = function(inst)
				if inst.justice_honor_task then
					inst.justice_honor_task:Cancel()
					inst.justice_honor_task = nil
				end
				inst:do_task(5, function()
					inst:AddTag("justice_honor")
					inst:justice_honor_fn2()
				end)
			end
			inst.justice_honor_fn2 = function(inst)
				local target = inst.components.combat.target
				if target and inst:HasTag("justice_honor") then
					inst:RemoveTag("justice_honor")
					inst:add_speed_rate("justice_honor", .5, 5)
					if inst.justice_honor_task2 then
						inst.justice_honor_task2:Cancel()
						inst.justice_honor_task2 = nil
					end


					inst.justice_honor_task2 = inst:per_task(1, function()
						inst:justice_honor_fn3()
					end)
					inst.justice_honor_task3 = inst:do_task(5, function()
						if inst.justice_honor_task2 then
							inst.justice_honor_task2:Cancel()
							inst.justice_honor_task2 = nil
						end
						inst:justice_honor_fn()
					end)
				end
			end
			inst.justice_honor_fn3 = function(inst)
				local target = inst.components.combat.target
				if target and target:IsNear(inst, 4) then
					WARGON.make_fx(inst, "statue_transition")
					target:add_speed_rate("justice_honor_debuff", -.3, 5)
					if target.components.tpbuff then
						target.components.tpbuff:AddBuff("tp_justice_honor")
					end
				end
			end
			inst:justice_honor_fn()
		end,
		new = function(inst, target)
			if inst.justice_honor_fn2 then
				inst:justice_honor_fn2()
			end
		end,
		name = "正义荣耀",
		desc = "增加百分之十防御，二十生命；发现目标后，获得五秒的移速加成，加速期间，如果攻击目标在周围，降低其移速，每次发动此效果需要五秒的充能",
	},
	{
		id = "gargoyle_armor",
		armor = .3,
		pass = function(inst)
			inst:AddTag("gargoyle_armor")
		end,
		name = "石像鬼",
		desc = "增加百分之三十防御；受到攻击不会硬直",

	},
	{
		id = "broken_king",
		pass = function(inst)
			inst:add_dmg_rate("broken_king", .2)
		end,
		atk = function(inst, target)
			local maxhp = target.components.health.maxhealth
			target.components.health:DoDelta(-maxhp/10)
			inst.components.health:DoDelta(maxhp/10)
		end,
		name = "破败",
		desc = "增加百分之二十攻击；攻击时会造成目标十分之一的额外伤害，并恢复等量的生命",
	},
	{
		id = "phantom_dance",
		pass = function(inst)
			inst:add_speed_rate("phantom_dance", .2)
			inst:add_per_rate("phantom_dance", .3)
		end,
		hit = function(inst, attacker, dmg, tool, proj)
			if inst.components.health:GetPercent() < .3 then

				inst.components.health:AddAbsorbModifier("phantom_dance", .25)
			end
		end,
		name = "幻影之舞",
		desc = "增加百分之二十攻速，百分之三十移速；生命低于30%时，获得25%防御",
	},
	{
		id = "pure",
		name = "未买装备",
		desc = "没钱买装备，所以没效果",
	},
	{
		id = "templar",
		special = true,
		hp = 500,
		pass = function(inst)
			local cmp = inst.components.tppowernew
			cmp.templar_fn = function(inst)
				if cmp.templar_task == nil then
					cmp.templar_fx = WARGON.make_fx2("spear_lance_array", inst, {owner=inst})
					cmp.templar_fx2 = SpawnPrefab("tp_fx_force_field")
					inst:AddChild(cmp.templar_fx2)
					inst.components.health:SetInvincible(true,"tp_templar")
					inst:do_task(3, function()
						inst.components.health:SetInvincible(false, "tp_templar")
						if cmp.templar_fx2 then
							cmp.templar_fx2:Remove()
							cmp.templar_fx2 = nil
						end
					end)

					cmp.templar_task = inst:do_task(6, function()
						if cmp.templar_fx then
							cmp.templar_fx:Recycle()
							cmp.templar_fx = nil
						end
						if cmp.templar_task then
							cmp.templar_task:Cancel()
							cmp.templar_task = nil
						end
					end)
				end
			end
		end,
		hit = function(inst, target)
			if inst.components.tpbuff
			and not inst.components.tpbuff:HasBuff("tp_templar") then
				inst.components.tpbuff:AddBuff("tp_templar")
			else
				inst.components.tppowernew.templar_fn(inst)
			end
		end,
		atk = function(inst, target, damage, stimuli)
			if inst.components.tpbuff
			and not inst.components.tpbuff:HasBuff("tp_templar") then
				inst.components.tpbuff:AddBuff("tp_templar")
			else
				inst.components.tppowernew.templar_fn(inst)
			end
		end,
		name = "圣堂武士",
		desc = "增加五百生命值，攻击和受伤时会无敌3s，并召唤剑阵攻击敌人，剑阵每次攻击造成34点伤害并回复自身20点生命，有6s冷却时间",
	},





}

local ids = {}
local normal_equips = {}
for k, v in pairs(equips) do
	if not v.special then
		normal_equips[k] = v
	end
	ids[v.id] = v
end

WARGON.DATA.tp_data_power_new = equips
WARGON.DATA.tp_data_power_new_normal = normal_equips
WARGON.DATA.tp_data_power_new_ids = ids