local elves = {
	{
		id = "fire",
		work = function(inst, worker, left)
			if worker:HasTag("player") then
				if inst.components.burnable then
					inst.components.burnable:Ignite()
				end
			end
		end,
		name = "火精灵",
		desc = "被砍时会自燃",
	},
	{
		id = "light",
		pass = function(inst)
			local fx = SpawnPrefab("tp_tree_elf")
			inst:AddChild(fx)
			fx:set_pos(0, 0, 0)
			inst.components.tppowertree.light_fx = fx
		end,
		finish = function(inst)
			if inst.components.tppowertree.light_fx then
				local fx = inst.components.tppowertree.light_fx
				fx:Remove()
				inst.components.tppowertree.light_fx = nil
			end
		end,
		name = "光精灵",
		desc = "晚上会发光",
	},
	{
		id = "thorns",
		work = function(inst, worker, left)
			if math.random() < .5 then
				local fx = WARGON.make_fx(inst, "tp_fx_thorn")
				fx.target = worker
			end





		end,



		name = "木精灵",
		desc = "有几率刺伤砍伐者",
	},
	{
		id = "acorn",
		work = function(inst, worker, left)
			local pt = inst:GetPosition()
			if math.random() < .5 then
				for i = 1, math.random(2, 4) do
					local pos = WARGON.around_land(inst, math.random(3))
					if pos then
						if WARGON.on_water(inst, pos) then
							WARGON.make_fx(pos, "splash_water_drop")
						else
							local nuter = SpawnPrefab("birchnutdrake")
							if worker and nuter.components.combat:CanTarget(worker) then
								nuter.Transform:SetPosition(pos:Get())
								nuter.components.combat:SetTarget(worker)
							else
								nuter:Remove()
							end
						end
					end
				end
			end
		end,
		name = "橡果精灵",
		desc = "有几率召唤橡果精攻击砍伐者",
	},
	{
		id = "nature",
		work = function(inst, worker, left)
			if math.random() < .2 then
				if inst.components.lootdropper then
					inst.components.lootdropper:DropSingleLoot()
				end
			end
		end,
		name = "自然精灵",
		desc = "被砍时有几率掉落一个掉落物",
	},
	{
		id = "rain",
		finish = function(inst)
			if math.random() < .33 then
				if GetWorld().components.seasonmanager.precip then
			    else
			       GetWorld().components.seasonmanager:ForcePrecip()
			    end
			end
		end,
		name = "雨精灵",
		desc = "被砍倒后有几率会迎来降雨",
	},
	{
		id = "rock",
		finish = function(inst)
			if inst.components.lootdropper then
				local loots = {"rocks", "rocks"}
				if math.random() < .6 then
					table.insert(loots, "flint")
				end
				inst.components.lootdropper:DropLoot(nil, loots)
			end
		end,
		name = "岩精灵",
		desc = "额外掉落石头",
	},
	{
		id = "ice",
		finish = function(inst)
			if inst.components.lootdropper then
				local loots = {"ice", "ice"}
				if math.random() < .6 then
					table.insert(loots, "rocks")
				end
				inst.components.lootdropper:DropLoot(nil, loots)
			end
		end,
		name = "冰精灵",
		desc = "额外掉落冰块",
	},
	{
		id = "shadow",
		finish = function(inst)
			local night = {
				"crawlingnightmare",
				"nightmarebeak",
			}
			WARGON.make_spawn(inst, night[math.random(2)])
		end,
		name = "暗夜精灵",
		desc = "被砍倒后会生成一个影怪",
	},
	{
		id = "snow",
		work = function(inst, worker, left)
			WARGON.make_fx(inst, "tp_fx_snow_ball_shoot")
		end,
		name = "雪精灵",
		desc = "被砍时会释放雪球",
	},
	{
		id = "old",




		finish = function(inst)
			if inst.components.lootdropper then
				inst.components.lootdropper:SpawnLootPrefab("livinglog")
			end
		end,
		name = "远古精灵",
		desc = "掉落物会增加一个活木",
	},
	{
		id = "life",
		work = function(inst, worker, left)
			if math.random() < .33 then
				if worker.components.health then
					worker.components.health:DoDelta(-3)

				end
			end
		end,
		finish = function(inst, worker)
			if worker.components.health then
				worker.components.health:DoDelta(10)
			end
		end,
		name = "生命精灵",
		desc = "被砍时有几率吸取砍伐者三点生命值；砍到后会回复砍伐者十点生命值",
	},
	{
		id = "huge",
		pass = function(inst)
			inst.Transform:SetScale(2, 2, 2)
		end,
		finish = function(inst)
			if inst.components.lootdropper then
				inst.components.lootdropper:DropLoot()
			end
		end,
		name = "巨型精灵",
		desc = "树木会变得巨大，被砍伐后会掉落两倍的掉落物",
	},
	{
		id = "smart",
		pass = function(inst)









		end,
		finish = function(inst)





		end,
		name = "智慧精灵",
		desc = "效果已禁用",

	},
	{
		id = "mini",
		pass = function(inst)
			inst:AddTag("tp_no_drop_loot")
			inst.Transform:SetScale(.5, .5, .5)
		end,
		finish = function(inst)
			inst.components.lootdropper:DropSingleLoot()
		end,
		name = "微型精灵",
		desc = "植物会变得微小，砍到后只会掉落一个物品",
	},
	{
		id = "spider",
		finish = function(inst, worker)
			local critter = "spider"



			local spider = WARGON.make_spawn(inst, critter)
			if worker.components.combat then
				spider.components.combat:SetTarget(worker)
			end
		end,
		name = "蜘蛛精灵",
		desc = "砍到后会出现一只蜘蛛",
	},
	{
		id = "hard",
		finish = function(inst, worker)
			inst:do_task(.6, function()
				WARGON.make_fx(inst, "tp_fx_hard_elf")
			end)
		end,
		name = "硬木精灵",
		desc = "树木倒下时会造成伤害，并摧毁周围建筑",
	},
	{
		id = "pure",
		name = "纯净精灵",
		desc = "不知道干啥的精灵，也没什么效果",
	},
}

local ids = {}
for k, v in pairs(elves) do
	ids[v.id] = v
end

WARGON.DATA.tp_data_power_tree = elves
WARGON.DATA.tp_data_power_tree_ids = ids