local ImportantPoint = Class(function(self)
	self.name = nil
	self.book = nil
	self.img = nil
	self.pos = nil
	self.limit = 19
end)

function ImportantPoint:Transform()
	local player = GetPlayer()
	if self.pos
	and (player.components.inventory:Has("scroll_pig_teleport", 1)
	or player:HasTag("tp_tele_book")) then
		player:set_pos(self.pos:Get())
		player.components.sanity:DoDelta(-30)
		TheFrontEnd:Fade(true,1)
		if player:HasTag("tp_tele_book") then
			player:RemoveTag("tp_tele_book")
		else
			player.components.inventory:ConsumeByName("scroll_pig_teleport", 1)
		end


	end
end

function ImportantPoint:SplitString(str)
	local len = string.len(str)/3
	local substr = nil
	if len > self.limit then
		substr = string.sub(str, self.limit*3+1, -1)
		str = string.sub(str, 1, self.limit*3)
	end
	return str, substr
end

function ImportantPoint:GetString()

	local str, substr = WARGON.split_string(self.book, self.limit)
	local sentence = str

	while substr do
		str, substr = WARGON.split_string(substr, self.limit)

		sentence = sentence.."\n"..str
	end
	return sentence
end

function ImportantPoint:__tostring()
	return string.format("ImportantPoint %s", self.name)
end

local TransSystem = Class(ShelfData, function(self)
	ShelfData._ctor(self, "传送卷轴", 4)
end)

local mooneyes = {
	"redmooneye",
	"bluemooneye",
	"purplemooneye",
	"orangemooneye",
	"greenmooneye",
	"yellowmooneye",
}

function TransSystem:CollectPositions()
	self:ClearShelf()
	for k, v in pairs(mooneyes) do
		local item = c_find(v)
		print(item)
		if item then
			local point = ImportantPoint()
			point.name = v
			point.img = v.."#"
			point.book = STRINGS.NAMES[string.upper(v)]
			point.pos = item:GetPosition()
			self:AddItem(point)
		end
	end
end

function TransSystem:Init()
	self:CollectPositions()
end

local trans_system = TransSystem()

WARGON.DATA.tp_data_trans = trans_system