local function composed(bool)
	WARGON.DEBUG.COMPOSED = not WARGON.DEBUG.COMPOSED
end

local function fruit(power, food)
	local item = SpawnPrefab(food or "carrot")
	if item.components.tppowerfruit then
		item.components.tppowerfruit:Set(power, 1)
	end
	GetPlayer().components.inventory:GiveItem(item)
end

local elements = {
	blood = 1,
	thunder = 2,
	poison = 3,
	sheild = 4,
	shadow = 5,
	ice = 6,
}
local function element(power, prefab)
	local name = prefab or "pigman"
	local item = SpawnPrefab(name)
	if item.components.tppower then
		if type(power) == "string" then
			power = elements[power]
		end
		item.components.tppower:SetPower(power)
	end
	item:set_pos(GetPlayer():GetPosition():Get())
end

local function tree(power, prefab)
	local item = SpawnPrefab(prefab or "evergreen")
	if item.components.tppowertree then
		item.components.tppowertree:SetPower(power)
	end
	item:set_pos(GetPlayer():GetPosition():Get())
end

local function equip(power, prefab)
	local item = SpawnPrefab(prefab or "spider")
	if item.components.tppowernew then
		item.components.tppowernew:SetPower(power)
	end
	item:set_pos(GetPlayer():GetPosition():Get())
end

local function trans(name)
	local target = c_find(name)
	if target then
		GetPlayer():set_pos(target:GetPosition():Get())
	end
end

local function catch(name)
	local target = c_find(name)
	if target and target.components.inventoryitem then
		GetPlayer().components.inventory:GiveItem(target)
	end
end

local function recharge()
	local player = GetPlayer()
	player.components.talker:Say("拿在手上的物品不会加速冷却")
	local items = player.components.inventory:FindItems(function(item)
		return item.components.tprecharge
	end)
	for k, v in pairs(items) do
		v.components.tprecharge:SetRechargeTime(.5)
	end
end

GLOBAL.WARGON.DEBUG = {
	composed 	= composed,
	fruit 		= fruit,
	element 	= element,
	tree 		= tree,
	equip 		= equip,
	trans 		= trans,
	catch 		= catch,
	recharge 	= recharge,
}