if GLOBAL.WARGON.CONFIG.diff == "dead" then



local bosses = {
	"deerclops",
	"moose",
	"dragonfly",
	"bearger",
	"minotaur",
	"twister",
	"tigershark",
	"kraken",
	"pugalisk",
	"antqueen",
	"ancient_herald",
	"ancient_hulk",


}
for k, v in pairs(bosses) do
	AddPrefabPostInit(v, function(inst)
        inst:AddTag("tp_only_player_attack")

        if inst.components.combat 
        and inst.components.combat.playerdamagepercent < 1 then
            inst.components.combat.playerdamagepercent = 1
        end
	end)
end


AddPrefabPostInit("kraken", function(inst)

    local health = 3000
	inst.components.health:SetMaxHealth(health)
end)


local element_power = {

    "bee",
    "killerbee",
	"firehound",
	"icehound",





	"tallbird",
	"tentacle",
	"merm",
	"worm",
	"bat",
}
for k, v in pairs(element_power) do
	AddPrefabPostInit(v, function(inst)
		inst:AddComponent("tppower")
        inst.components.tppower:Random()

	end)
end


AddPrefabPostInit("rocky", function(inst)
    local function FindRocky(inst)
        return WARGON.find(inst, 15, function(guy)
            return guy:HasTag('rocky')
        end)
    end
    inst.components.combat:SetRetargetFunction(3, FindRocky)
end)


AddPrefabPostInit("sanityrock", function(inst)
    WARGON.do_task(inst, 0, function()
        local pos = inst:GetPosition()
        inst:Remove()
        WARGON.make_spawn(pos, "pigtorch")
    end)
end)
AddPrefabPostInit("insanityrock", function(inst)
    WARGON.do_task(inst, 0, function()
        local pos = inst:GetPosition()
        inst:Remove()
        WARGON.make_spawn(pos, "pigtorch")
    end)
end)



AddPrefabPostInit("nightmarelight", function(inst)
    inst.Physics:ClearCollisionMask()











end)


local wargs = {
    "warg",
    "tp_blue_warg",
    "tp_red_warg",
}
local buffs = {
    "scroll_pig_speed",
    "scroll_pig_heal",
    "scroll_pig_damage",
    "scroll_pig_armorex",
}
for k, warg in pairs(wargs) do
    AddPrefabPostInit(warg, function(inst)
        inst.tp_howl_fn = function(inst)
            local hounds = WARGON.finds(inst, 20, {"hound"}, {"warg"})
            for k, v in pairs(hounds) do
                if v and v.components.tpbuff then
                    v.components.tpbuff:AddBuff(buffs[math.random(#buffs)])
                end
            end
        end
    end)
end


AddPrefabPostInit("rider_sp", function(inst)
    inst.riders = {
        "tp_sign_rider",
        "tp_sign_rider_2",
        "tp_sign_rider_3",
        "tp_sign_rider_4",
    }
end)


AddPrefabPostInit("tp_fx_snow_ball", function(inst)
    inst.diff = true
end)


AddPrefabPostInit("tp_werepig_king", function(inst)
    inst.diff = true
end)


AddComponentPostInit("combat", function(self)
    local old_can = self.CanBeAttacked
    function self:CanBeAttacked(attacker)
        if not (attacker:HasTag("player") 
        or attacker:HasTag("pig")) 
        and self.inst:HasTag("tp_only_player_attack") then
            return false
        end
        return old_can(self, attacker)
    end
end)


AddComponentPostInit("tpangry", function(self)

end)




local tuning = GLOBAL.TUNING
tuning.DEERCLOPS_HEALTH 	    = 5000
tuning.DRAGONFLY_HEALTH 	    = 5000
tuning.BEARGER_HEALTH 		    = 5000
tuning.MOOSE_HEALTH 		    = 5000
tuning.MINOTAUR_HEALTH 		    = 5000
tuning.TWISTER_HEALTH 		    = 5000
tuning.TIGERSHARK_HEALTH 	    = 5000
tuning.ANTQUEEN_HEALTH 		    = 5000
tuning.PUGALISK_HEALTH 		    = 5000
tuning.ANCIENT_HERALD_HEALTH    = 5000
    
end