local ImageButton = require "widgets/imagebutton"


AddPlayerPostInit(function(inst)
	inst:AddComponent("tpbody")

	inst:AddComponent("tpcallbeast")	
	inst:AddComponent("tpmadvalue")
	inst:AddComponent("tpbuff")
	inst:AddComponent("tplevel")
	inst:AddComponent("tpbuy")

	inst.components.tplevel:Init()



	inst:AddComponent("tpreportspawner")
	inst:AddComponent("tpprefabspawner")



	inst.components.tpprefabspawner:AddPrefab("tp_hornet")
	inst.components.tpprefabspawner:AddPrefab("tp_combat_lord")
	inst.components.tpprefabspawner:AddPrefab("tp_soul_student")
	inst.components.tpprefabspawner:AddPrefab("tp_werepig_king")
	inst.components.tpprefabspawner:AddPrefab("tp_blood_lord")
	inst.components.tpprefabspawner:AddPrefab("tp_thunder_lord")
	inst.components.tpprefabspawner:AddPrefab("tp_ice_lord")
	inst.components.tpprefabspawner:AddPrefab("tp_fire_lord")
	inst.components.tpprefabspawner:AddPrefab("tp_poison_lord")
	inst.components.tpprefabspawner:AddPrefab("tp_shadow_lord")
	inst.components.tpprefabspawner:AddPrefab("tp_pig_book")
	inst.components.tpprefabspawner:AddPrefab("tp_pigking_hat")
	inst.components.tpprefabspawner:AddPrefab("tp_super_calculator_bp")
	inst:AddComponent("tpvehicleowner")




	local old_light_fn = inst.components.playerlightningtarget.onstrikefn
	local old_get_drying_rate = inst.components.moisture.GetDryingRate
	function inst.components.moisture:GetDryingRate()
		local rate = old_get_drying_rate(inst.components.moisture)
		if inst.components.tpbody.dry_rate then
			rate = rate + inst.components.tpbody.dry_rate
		end
		return rate
	end
	local old_can_attack = inst.components.combat.CanAttack
	function inst.components.combat:CanAttack(target)
		if inst:HasTag("tp_not_combat") then
			return false
		end
		return old_can_attack(inst.components.combat, target)
	end
	local gifts = inst.components.inventory.starting_inventory or {}
	table.insert(gifts, "tp_gift4")
	table.insert(gifts, "tp_gps")
	inst.components.inventory.starting_inventory = gifts
	inst.components.playerlightningtarget:SetOnStrikeFn(function(inst)
		if old_light_fn then
			old_light_fn(inst)
		end
		inst:PushEvent("tp_lightning_strike")
	end)
	WARGON.do_task(inst, 0, function()
		if inst.components.tpreportspawner then
			inst.components.tpreportspawner:Spawn()
		end
	end)
	inst:ListenForEvent("killed", function(inst, data)
		local weapon = inst.components.combat:GetWeapon()
		if weapon then

			weapon:PushEvent("tp_owner_killed", {owner=inst, victim=data.victim})
		end
	end)

	inst:ListenForEvent("doattack", function(inst, data)
		if inst:HasTag("tp_cane_buff") then
			local current = inst.components.combat:GetWeapon()

			if current and current:HasTag("tp_auto_cane") then
				local weapon = inst.components.inventory:FindItem(function(item, inst)
					return item.components.weapon
					and item.components.weapon.damage>10
				end)
				if weapon then
					inst.components.inventory:Equip(weapon)
				end
			end
		end
	end)
	inst:ListenForEvent("locomote", function(inst, data)
		if inst:HasTag("tp_cane_buff") 
		and not inst.sg:HasStateTag("attack")
		and not inst.sg:HasStateTag("busy")
		and inst.sg:HasStateTag("moving")
		and inst.components.locomotor
		and inst.components.locomotor:WantsToMoveForward() then
			local current = inst.components.combat:GetWeapon()

			if current and not current:HasTag("tp_auto_cane") then
				local cane = inst.components.inventory:FindItem(function(item, inst)

					return item:HasTag("tp_auto_cane")
				end)
				if cane then
					inst.components.inventory:Equip(cane)
				end
			end
		end
	end)
	inst:AddComponent("tpdemonstrike")
	inst:ListenForEvent("test_button_click", function(inst, data)


		for k, v in pairs(Ents) do
			if v.components.tpenchantment and v.components.tpenchantment.greengem and v.components.tpenchantment.greengem>0 then
				print(v.prefab)
			end
		end
	end)
end)

AddPrefabPostInit("sewing_kit", function(inst)
	local old_fn = inst.components.sewing.onsewn
	inst.components.sewing.onsewn = function(inst, target, doer)
		old_fn(inst, target, doer)
		if target:HasTag("tp_tent") then
			local use = target.components.finiteuses:GetUses()
			local total = target.components.finiteuses.total
			if use <= target.components.finiteuses.total then
				target.components.finiteuses:SetUses(math.min(use+5, total))
			end
			target.components.fueled:SetPercent(.9)
		end
	end
end)
 








local tree_seeds = {
	"acorn",
	"pinecone",
	"jungletreeseed",
	"teatree_nut",
	"coconut",
}
for k, v in pairs(tree_seeds) do
	AddPrefabPostInit(v, function(inst)
		inst:AddComponent('tpammo')
		inst:AddTag("tp_tree_seed")
	end)
end

AddPrefabPostInit("birchnutdrake", function(inst)
	local old_target_fn = inst.components.combat.targetfn
	inst.components.combat.targetfn = function(inst)
		local guy = old_target_fn(inst)
		if guy and not guy:HasTag("tp_oak_armor") 
		and not (inst:HasTag("tp_defense_tree_nut") and guy:HasTag("player")) then
			return guy
		end
	end
	local can_be_attacked = inst.components.combat.canbeattackedfn
	inst.components.combat.canbeattackedfn = function(inst, attacker)
		local can = can_be_attacked(inst, attacker)
		if attacker:HasTag("tp_oak_armor") then
			return false
		end
		return can
	end
end)





local function add_prefab_tag(name, tag)
	local function add_tag(name, tag)
		AddPrefabPostInit(name, function(inst)
			if type(tag) == "table" then
				for k, v in pairs(tag) do
					inst:AddTag(v)
				end
			else
				inst:AddTag(tag)
			end
		end)
	end
	if type(name) == "table" then
		for k, v in pairs(name) do
			add_tag(v, tag)
		end
	else
		add_tag(name, tag)
	end
end

add_prefab_tag("log", "tp_chop_pig_item")
add_prefab_tag("cork", "tp_chop_pig_item")
add_prefab_tag("livinglog", "tp_chop_pig_item")
add_prefab_tag("bamboo", "tp_hack_pig_item")
add_prefab_tag("vine", "tp_hack_pig_item")
add_prefab_tag("cutgrass", "tp_hack_pig_item")

AddPrefabPostInitAny(function(inst)
	if string.find(inst.prefab, 'seeds') then
		inst:AddTag("tp_farm_pig_item")
		inst:AddTag("tp_seed")
	end
	if inst:HasTag("smallcreature") and inst:HasTag("canbetrapped") then
		inst:AddTag("tp_strawhat_target")
	end
end)

local normal_trees = {
	"evergreen", "evergreen_sparse",
	"deciduoustree", "rainforesttree", "teatree",
	"clawpalmtree", "jungletree", "palmtree", 
}
for k, v in pairs(normal_trees) do
	AddPrefabPostInit(v, function(inst)
		inst:AddComponent("tppowertree")
		inst.components.tppowertree:Random()
	end)
end

local trees = deepcopy(normal_trees)
table.insert(trees, "gingko_tree")
for k, v in pairs(trees) do
	add_prefab_tag(v, 'tp_chop_pig_target')
end

local hackables = {
	"bambootree", "bush_vine", "grass_tall",
}
for k, v in pairs(hackables) do
	add_prefab_tag(v, 'tp_hack_pig_target')
end

local farms = {
	'fast_farmplot', 'slow_farmplot', "tp_farm_pile"
}
for k, v in pairs(farms) do
	add_prefab_tag(v, 'tp_farm_pig_target')
end

local strawhat_targets = {
	"pigman", "bunnyman", "perd", "beefalo", "primeape", "wildbore",
}
for k, v in pairs(strawhat_targets) do
	add_prefab_tag(v, 'tp_strawhat_target')
end
add_prefab_tag('perd', 'tp_strawhat_perd')
add_prefab_tag('beefalo', 'tp_strawhat_beefalo')

local small_boats = {
	"rowboat",
	"corkboat",
}
for k, v in pairs(small_boats) do
	AddPrefabPostInit(v, function(inst)
		inst:ListenForEvent('onbuilt', function()
			if GetPlayer():HasTag("sea_prince") then
				local sail = SpawnPrefab("sail")
				local torch = SpawnPrefab("boat_torch")
				inst.components.container:Equip(sail)
				inst.components.container:Equip(torch)
			end
		end)
	end)
end

local med_boats = {
	"cargoboat",
}
for k, v in pairs(med_boats) do
	AddPrefabPostInit(v, function(inst)
		inst:ListenForEvent('onbuilt', function()
			if GetPlayer():HasTag("sea_prince") then
				local sail = SpawnPrefab("clothsail")
				local torch = SpawnPrefab("boat_torch")
				inst.components.container:Equip(sail)
				inst.components.container:Equip(torch)
			end
		end)
	end)
end

local big_boats = {
	"armouredboat",
	"encrustedboat",
}
for k, v in pairs(big_boats) do
	AddPrefabPostInit(v, function(inst)
		inst:ListenForEvent("onbuilt", function()
			if GetPlayer():HasTag("sea_prince") then
				local sail = SpawnPrefab("clothsail")
				local torch = SpawnPrefab("boatcannon")
				inst.components.container:Equip(sail)
				inst.components.container:Equip(torch)
			end
		end)
	end)
end

AddPrefabPostInit('pigking', function(inst)
	inst:AddTag("pigking")
	inst:AddComponent("tpwerekingspawner")





































end)

local life_tree_plants = {
	"carrot_planted",
	"lichen",
	"sweet_potato_planted",
	"asparagus_planted",
}
add_prefab_tag(life_tree_plants, "life_tree_plant")

add_prefab_tag('snakebonesoup', 'tplevel_food_small')

add_prefab_tag('pinecone', 'tp_war_tree_gift')

AddPrefabPostInit('leif', function(inst)
	local function leif_test(inst, item)
		return item:HasTag("tp_war_tree_gift") and inst:HasTag("tp_war_tree")
	end
	local function leif_accept(inst, giver, item)
		if giver == inst.components.combat.target then
			inst.components.combat:SetTarget(nil)
		else
			inst.SoundEmitter:PlaySound("dontstarve/common/makeFriend")
			giver.components.leader:AddFollower(inst)
		    inst.components.follower:AddLoyaltyTime(30*16)
		end
	end
    WARGON.CMP.add_cmps(inst, {
    	follow = {max=TUNING.PIG_LOYALTY_MAXTIME},
    	trader = {accept=leif_accept, test=leif_test},
    	})
    local old_save = inst.OnSave
    local old_load = inst.OnLoad
    inst.OnSave = function(inst, data)
    	if old_save then old_save(inst, data) end
    	if data and inst:HasTag("tp_war_tree") then
    		data.war_tree = true
    	end
	end
	inst.OnLoad = function(inst, data)
		if old_load then old_load(inst, data) end
		if data and data.war_tree then
			inst:AddTag("tp_war_tree")
		end
	end
end)

AddPrefabPostInit("perd", function(inst)
	local old_save = inst.OnSave
    local old_load = inst.OnLoad
    inst.OnSave = function(inst, data)
    	if old_save then old_save(inst, data) end
    	if data and inst.tp_perd then
    		data.tp_perd = inst.tp_perd
    	end
	end
	inst.OnLoad = function(inst, data)
		if old_load then old_load(inst, data) end
		if data and data.tp_perd then
			inst.tp_perd = data.tp_perd
			inst:SetBrain(require "brains/tp_perd_brain")
			inst.AnimState:Show("HAT")
			inst.AnimState:OverrideSymbol("swap_hat", "strawhat_cowboy", "swap_hat")
		end
	end
end)




local bosses = {
	"deerclops",
	"moose",
	"dragonfly",
	"bearger",
	"minotaur",
	"twister",
	"tigershark",
	"kraken",
	"pugalisk",
	"antqueen",
	"ancient_herald",
	"ancient_hulk",


}

for k, v in pairs(bosses) do
	AddPrefabPostInit(v, function(inst)

		inst:AddTag("tp_sign_damage")
		inst.components.lootdropper:AddLoot("tp_boss_loot")


		if v.prefab ~= "pugalisk" then
			inst:AddComponent("tppowernew")
			inst.components.tppowernew:RandomTwo()
		end







	end)
end




AddPrefabPostInit("deerclops", function(inst)
















	inst:AddComponent("tppowerboss")
	inst.components.tppowerboss:SetPower("snow")
end)

AddPrefabPostInit("dragonfly", function(inst)
	inst.components.groundpounder.destroyer = true
	inst.components.groundpounder.destructionRings = 1
	inst.components.lootdropper:AddChanceLoot("tp_dragon_cage_bp", .2)

	inst:AddComponent("tppowerboss")
	inst.components.tppowerboss:SetPower("fire")










end)




AddPrefabPostInit("moose", function(inst)

	inst:AddComponent("tppowerboss")
	inst.components.tppowerboss:SetPower("tornado")
	inst.components.combat:SetAreaDamage(TUNING.DEERCLOPS_AOE_RANGE, TUNING.DEERCLOPS_AOE_SCALE)
end)

AddPrefabPostInit("mossling", function(inst)
	inst:AddTag("tp_tornado_power")
	inst.components.combat.canbeattackedfn = function(inst, attacker)
		return not attacker:HasTag("moose")
	end
end)

AddPrefabPostInit("bearger", function(inst)
	inst:AddComponent("tppowerboss")
	inst.components.tppowerboss:SetPower("ground")
end)

local season_bosses = {
	"dragonfly",
	"deerclops",
	"moose",
	"bearger",
}
for k, v in pairs(season_bosses) do
	AddPrefabPostInit(v, function(inst)

		WARGON.make_map(inst, "tp_"..v.."_ice_statue.tex")
	end)
end

AddPrefabPostInit("minotaur", function(inst)
	inst:AddComponent("tppowerboss")

	inst.components.tppowerboss:SetPower("shadow")
end)

AddPrefabPostInit("kraken", function(inst)

	local health = 2000
	inst.components.health:SetMaxHealth(health)
	inst:AddComponent("tppowerboss")
	inst.components.tppowerboss:SetPower("siren")
end)

AddPrefabPostInit("kraken_tentacle", function(inst)
	inst:AddComponent("tppower")
	inst.components.tppower:Random()
end)

AddPrefabPostInit("tigershark", function(inst)
	inst:AddComponent("tppowerboss")

	inst.components.tppowerboss:SetPower("tsunami")
end)

AddPrefabPostInit("twister", function(inst)
	inst:AddComponent("tppowerboss")
	inst.components.tppowerboss:SetPower("hurricane")
end)

AddPrefabPostInit("pugalisk", function(inst)
	inst:ListenForEvent("healthdelta", function(inst, data)
		inst.components.health:SetInvincible(true)
		WARGON.do_task(inst, .5, function()
			inst.components.health:SetInvincible(false)
		end)
	end)
end)

AddPrefabPostInit("pugalisk_body", function(inst)
	local function redirect_health(inst, amount, overtime, cause, ignore_invincible)
	    local originalinst = inst
	    if inst.startpt then
	        inst = inst.startpt
	    end
	    if amount < 0 and( (inst.components.segmented and inst.components.segmented.vulnerablesegments == 0) or inst:HasTag("tail") or inst:HasTag("head") ) then
	        print("invulnerable",cause,GetPlayer().prefab)
	        if cause == GetPlayer().prefab then
	            GetPlayer().components.talker:Say(GetString(GetPlayer().prefab, "ANNOUNCE_PUGALISK_INVULNERABLE"))        
	        end
	        inst.SoundEmitter:PlaySound("dontstarve/common/destroy_metal",nil,.25)
	        inst.SoundEmitter:PlaySound("dontstarve/wilson/hit_metal")

	    elseif amount and inst.host and not inst.host.tp_invincible then

	        local fx = SpawnPrefab("snake_scales_fx")
	        fx.Transform:SetScale(1.5,1.5,1.5)
	        local pt= Vector3(originalinst.Transform:GetWorldPosition())
	        fx.Transform:SetPosition(pt.x,pt.y + 2 + math.random()*2,pt.z)

	        inst:PushEvent("dohitanim")
	        inst.host.components.health:DoDelta(amount, overtime, cause, false, true)
	        inst.host:PushEvent("attacked")
	    end    
	end
	inst.components.health.redirect = redirect_health
end)

AddPrefabPostInit("ancient_hulk", function(inst)
	inst:AddComponent("tpbuff")
	inst:ListenForEvent("attacked", function(inst, data)
		if not inst:HasTag("tp_ancient_hulk_buff") and math.random() < .2 then
			local buffs = {
				"damage", "defense", "heal",
			}
			local buff_name = "tp_ancient_hulk_"..buffs[math.random(#buffs)]
			inst.components.tpbuff:AddBuff(buff_name)
		end
	end)
	inst:AddComponent("tppowerboss")
	inst.components.tppowerboss:SetPower("war")
end)

AddPrefabPostInit("antqueen", function(inst)
	inst:AddComponent("tppowerboss")
	inst.components.tppowerboss:Random()
end)

AddPrefabPostInit("ancient_herald", function(inst)
	inst:AddComponent("tppowerboss")
	inst.components.tppowerboss:Random()
end)

local epic_creatures = {
	"leif",
	"leif_sparse",
	"spiderqueen",
	"treeguard",
}



for k, v in pairs(epic_creatures) do
	AddPrefabPostInit(v, function(inst)
		if inst.components.lootdropper then
			inst.components.lootdropper:AddLoot("tp_epic", 1)
		end
		inst:AddComponent("tppowernew")
		inst.components.tppowerboss:Random()

	end)
end

AddPrefabPostInit("pillar_ruins", function(inst)
	local function on_hammered(inst, worker)

		local shadow = WARGON.make_spawn(inst, "nightmarebeak")

		SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
		inst:Remove()
	end
	inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(4)
	inst.components.workable:SetOnFinishCallback(on_hammered)
end)

AddPrefabPostInit("campfire", function(inst)
	local function onhammered(inst, worker)
		local ash = SpawnPrefab("ash")
		ash.Transform:SetPosition(inst.Transform:GetWorldPosition())
		SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
		inst:Remove()
	end
	inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(4)
	inst.components.workable:SetOnFinishCallback(onhammered)
end)













































AddPrefabPostInit("beefalohat", function(inst)
	local old_equip = inst.components.equippable.onequipfn
	local old_unequip = inst.components.equippable.onunequipfn
	inst.components.equippable:SetOnEquip(function(inst, owner)
		old_equip(inst, owner)
		owner:AddTagNum("beefalo", 1)
	end)
	inst.components.equippable:SetOnUnequip(function(inst, owner)
		old_unequip(inst, owner)
		owner:AddTagNum("beefalo", -1)
	end)
end)

AddPrefabPostInit("armorvortexcloak", function(inst)
	local old_equip = inst.components.equippable.onequipfn
	local old_unequip = inst.components.equippable.onunequipfn
	inst.components.equippable:SetOnEquip(function(inst, owner)
		old_equip(inst, owner)
		owner:AddTagNum("not_hit_stunned", 1)
	end)
	inst.components.equippable:SetOnUnequip(function(inst, owner)
		old_unequip(inst, owner)
		owner:AddTagNum("not_hit_stunned", -1)
	end)
end)

add_prefab_tag("trap_teeth", "tp_trap_teeth")
add_prefab_tag("trap_bramble", "tp_trap_teeth")
add_prefab_tag('tent', 'tp_sea_sleep')
add_prefab_tag('meatrack', 'tp_sea_dryer')
add_prefab_tag('grass_water', 'tp_grass_water')

AddPrefabPostInit("ice", function(inst)
	local anim = inst.animname or "f"..math.random(3)
	MakeInventoryFloatable(inst, anim, anim)
end)

AddPrefabPostInit("octopusking", function(inst)


end)

local mangrovetrees = {
	"mangrovetree",
	"mangrovetree_normal",
	"mangrovetree_tall",
	"mangrovetree_short",
	"mangrovetree_burnt",
	"mangrovetree_stump",
}

add_prefab_tag(mangrovetrees, 'tp_mangrovetree')

AddPrefabPostInit("octopuschest", function(inst)
	WARGON.do_task(inst, 0, function()
		local container = inst.components.container
		if not inst.trigger and container 
		and container:Has("boatcannon", 1) then




		end
		inst.trigger = true
	end)
	inst:hook_save(function(inst, data)
		data.trigger = inst.trigger
	end)
	inst:hook_load(function(inst, data)
		inst.trigger = data and data.trigger
	end)
end)

AddPrefabPostInit("tornado", function(inst)
	inst:AddComponent("tpwindattack")
end)

add_prefab_tag("pinecone", "tp_gingko")






























local ponds = {
	"pond",

}

AddPrefabPostInit("pond", function(inst)
	inst:AddTag("tp_diving_target")
	inst:AddComponent("tpdivable")
	if GetWorld().tp_pools == nil then
		GetWorld().tp_pools = {}
		GetWorld().tp_pool_start = inst
	end





	table.insert(GetWorld().tp_pools, inst)
	inst.tp_pool_id = #GetWorld().tp_pools
end)




















add_prefab_tag({
	"bonestaff", 
	"hambat", 
	"tp_hambat",
}, "tp_must_spoilsh")

local pigs = {
	"pigman",
	"pigguard",
	"wildbore",
}
for k, v in pairs(pigs) do
	AddPrefabPostInit(v, function(inst)

		inst:AddTag("tp_pig_killer_target")
		inst:AddComponent("tpbuff")
		inst:AddComponent("tppower")
		inst.components.tppower:Random()
		inst:AddComponent("tppowernew")
		inst.components.tppowernew:Random()
		local old_set_were = inst.components.werebeast.SetWere
		function inst.components.werebeast:SetWere(...)
			if inst:HasTag("scroll_pig_super") then
				return
			else
				old_set_were(inst.components.werebeast, ...)
			end
		end
	end)
end

local spiders = {
	"spider",
	"spider_warrior",
	"spider_hider",
	"spider_spitter",
	"spider_dropper",
}
for k, v in pairs(spiders) do
	AddPrefabPostInit(v, function(inst)
		inst:AddComponent("inventory")
		inst:AddComponent("tppower")
		inst.components.tppower:Random()
		inst:AddComponent("tppowernew")
		inst.components.tppowernew:Random()
	end)
end

AddPrefabPostInit("hound", function(inst)
	inst:AddComponent("inventory")
	inst:AddComponent("tpbuff")
	inst:AddComponent("tppower")
	inst.components.tppower:Random()
	inst:AddComponent("tppowernew")
	inst.components.tppowernew:Random()
end)


local sw_animals ={
	"crocodog",
	"dragoon",
	"snake",
}
for k, v in pairs(sw_animals) do
	AddPrefabPostInit(v, function(inst)
		inst:AddComponent("inventory")
		inst:AddComponent("tppower")
		inst.components.tppower:Random()
		inst:AddComponent("tppowernew")
		inst.components.tppowernew:Random()
	end)
end


local ham_animals = {
	"vampirebat",
	"mean_flytrap",
	"adult_flytrap",
}
for k, v in pairs(ham_animals) do
	AddPrefabPostInit(v, function(inst)
		inst:AddComponent("inventory")
		inst:AddComponent("tppower")
		inst.components.tppower:Random()
		inst:AddComponent("tppowernew")
		inst.components.tppowernew:Random()
	end)
end















































AddPrefabPostInit("meat", function(inst)
	inst:AddComponent("tpinterable")
	inst:AddTag("tp_hambat_fuel")
end)

AddPrefabPostInit("beefalo", function(inst)
	inst.components.lootdropper:AddChanceLoot("tp_horn", .08)
end)

local monkeys = {"primeape", "monkey"}
for k, v in pairs(monkeys) do
	AddPrefabPostInit(v, function(inst)
		if math.random() < .1 then
			inst.AnimState:SetMultColour(1, 1, .1, 1)
			inst:AddTag("tp_gold_primeape")
			inst.components.lootdropper:AddLoot("tp_treasure_map")
			inst.components.lootdropper:AddChanceLoot("tp_bench_bp", .05)
			inst.nameoverride = "GOLD_PRIMEAPE"
		end
	end)
end


local pots = {
	"tp_cook_pot",
	"tp_easy_pot",
}
for k, v in pairs(pots) do
	AddPrefabPostInit(v, function(inst)
		if TUNING.IAI_COOK then
			inst.components.container.acceptsstacks = TUNING.IAI_COOK
			inst:AddTag("iai_cook")
		end
	end)
end


local beefalos = {
	"beefalo",

}
for k, v in pairs(beefalos) do
	AddPrefabPostInit(v, function(inst)
		local slotpos = {}
		for y = 2, 0, -1 do
			for x = 0, 2 do
				table.insert(slotpos, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
			end
		end
		inst:AddComponent("container")
		inst.components.container:SetNumSlots(#slotpos)




		inst.components.container.widgetslotpos = slotpos
		inst.components.container.widgetanimbank = "ui_chest_3x3"
		inst.components.container.widgetanimbuild = "ui_chest_3x3"
		inst.components.container.widgetpos = Vector3(0,200,0)
		inst.components.container.side_align_tip = 160
		inst.components.container.canbeopened = false
		inst:add_listener("saddlechanged", function(inst, data)
			if data.saddle 
			and data.saddle:HasTag("tp_open_beefalo_container") then
				inst.components.container.canbeopened = true
			else
				inst.components.container.canbeopened = false
			end
		end)
		inst:add_listener("riderchanged", function(inst, data)
			inst.components.container:Close()
		end)









	end)
end

AddPrefabPostInit("krampus", function(inst)
	inst.components.lootdropper:AddChanceLoot("tp_red_dragon_sack_dropper", .2)
end)

AddPrefabPostInit("world", function(inst)
	inst:AddComponent("tpbossspawner")
end)

AddPrefabPostInit("frog", function(inst)
	inst.components.lootdropper:AddChanceLoot("tp_gasmaskhat_2", .01)

end)
AddPrefabPostInit("frog_poison", function(inst)
	inst.components.lootdropper:AddChanceLoot("tp_gasmaskhat_2", .01)

end)

AddPrefabPostInitAny(function(inst)
	if not inst:HasTag("tp_item")
	and inst.components.equippable 


	and inst.components.inventoryitem
	and inst.components.inventoryitem.cangoincontainer
	and not inst.components.stackable then
		inst:AddComponent("tpenchantment")
	end
end)

AddPrefabPostInit(function(inst)
	if inst.components.equippable
	and inst.components.inventoryitem
	and not inst.components.inventoryitem.cangoincontainer
	and inst.components.container then
		inst:AddComponent("tppack")
	end
end)

local gems = {"red", "green", "blue", "orange", "purple", "yellow"}
for k, v in pairs(gems) do
	AddPrefabPostInit(v.."gem", function(inst)
		inst:AddTag("tp_gem")
	end)
end

AddPrefabPostInitAny(function(inst)
	if inst.components.dryable then
		inst:AddComponent("tpdryable")
		inst.components.tpdryable.time = inst.components.dryable:GetDryingTime()
	end
end)

AddPrefabPostInit("transistor", function(inst)
	inst:AddComponent("tradable")
end)

AddPrefabPostInitAny(function(inst)
	if inst.components.edible 
	and (inst.components.edible.healthvalue > 6
	or inst.components.edible.hungervalue > 6
	or inst.components.edible.sanityvalue > 6) 
	and inst.components.edible.foodtype ~= "WOOD"
	and inst.components.edible.foodtype ~= "ROUGHAGE"
	and inst.components.edible.foodtype ~= "GEARS"
	and inst.components.edible.foodtype ~= "ELEMENTAL" then
		inst:AddComponent("tppowerfruit")
		inst.components.tppowerfruit:Random()
	end
end)

AddPrefabPostInit("cave_entrance", function(inst)
	inst:AddTag("tp_mine_source")
end)

AddPrefabPostInit("nightmarefuel", function(inst)
	inst:AddComponent("tpblink")
end)

AddPrefabPostInit("plant_normal", function(inst)
	inst:AddTag("tp_plant_army_base")
end)






































local inter_items = {
	"flint", "goldnugget", "spear", "petals", "pigskin", "boards",
	"nightmarefuel", "marble", "thulecite", "nitre", "dead_swordfish",
	"alloy", "fish", "fish3", "fish4", "fish5", "fish_med", 
	"tropical_fish", "eel",
}
for k, v in pairs(inter_items) do
	AddPrefabPostInit(v, function(inst)
		inst:AddComponent('tpinterable')
	end)
end

local fishes = {
	"fish", "fish3", "fish4", "fish5", "fish_med", 
	"tropical_fish", "eel",
}
add_prefab_tag(fishes, "tp_fish")

local trade_items = {
	"charcoal",
}
for k, v in pairs(trade_items) do
	AddPrefabPostInit(v, function(inst)
		inst:AddComponent("tradable")
	end)
end



AddPrefabPostInit("hambat", function(inst)







end)

AddPrefabPostInit("watermelonhat", function(inst)
	inst:AddComponent("edible")
	inst.components.edible.foodtype = "VEGGIE"
    inst.components.edible.healthvalue = 3
    inst.components.edible.hungervalue = 12.5
    inst.components.edible.sanityvalue = 5
    inst.components.edible.CollectInventoryActions = function()
	end
end)

AddPrefabPostInit("icehat", function(inst)
	inst:AddComponent("edible")

    inst.components.edible.healthvalue = 5
    inst.components.edible.hungervalue = 23
    inst.components.edible.sanityvalue = 0
    inst.components.edible.CollectInventoryActions = function()
	end
end)

AddPrefabPostInit("bushhat", function(inst)


end)


AddPrefabPostInit("eyebrellahat", function(inst)
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(60)
end)

AddPrefabPostInit("armordragonfly", function(inst)
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(100)
end)

AddPrefabPostInit("beargervest", function(inst)
	inst:add_cmps({
		cont = {typ="1x4"},	
	})
	inst.components.container.itemtestfn = function(inst, item, slot)
		return inst ~= item
	end
	inst.components.container.CollectSceneActions = function()
	end
	inst.components.container.CollectInventoryActions = function()
	end
	inst:ListenForEvent("percentusedchange", function(inst, data)
		if data and data.fuel and data.fuel <= 0 then
			inst.components.container:DropEverything()
		end
	end)
	inst:ListenForEvent("unequipped", function(inst, data)
		inst.components.container:Close()
	end)
end)






AddPrefabPostInit("living_artifact", function(inst)
	inst:AddComponent("tpuplevelcore")
	inst.components.tpuplevelcore.type = "fast"
end)







AddPrefabPostInit("resurrectionstone", function(inst)
	inst.components.resurrector.doresurrect = function(inst, dude)
		inst:AddTag("busy")	
		inst.MiniMapEntity:SetEnabled(false)
	    if inst.Physics then
			MakeInventoryPhysics(inst)
	    end

	    if dude.components.poisonable and dude.components.poisonable:IsPoisoned() then 
			dude.components.poisonable:Cure()
		end 
		
	    ProfileStatsSet("resurrectionstone_used", true)

		GetClock():MakeNextDay()
	    dude.Transform:SetPosition(inst.Transform:GetWorldPosition())
	    dude:Hide()

	    dude:ClearBufferedAction()

	    if dude.HUD then
	        dude.HUD:Hide()
	    end
	    if dude.components.playercontroller then
	        dude.components.playercontroller:Enable(false)
	    end


			TheCamera:SetDistance(12)


		if TheCamera.interior then
			print("XXXXXXXXXXXXXXXX")
			local interiorSpawner = GetWorld().components.interiorspawner
			print("XXXXXXXXXXXXXXXX2")
			interiorSpawner:PlayTransition(GetPlayer(), nil, nil, inst)	
		end

		dude.components.hunger:Pause()

		if(dude == GetPlayer()) then
			if dude.components.driver:GetIsDriving() then 
				dude.components.driver:OnDismount()
			end 
		end 
		
	    scheduler:ExecuteInTime(3, function()
	        dude:Show()


	        GetSeasonManager():DoLightningStrike(Vector3(inst.Transform:GetWorldPosition()))


			inst.SoundEmitter:PlaySound("dontstarve/common/resurrectionstone_break")
	        inst.components.lootdropper:DropLoot()
	        inst:Remove()
	        
	        if dude.components.hunger then
	            dude.components.hunger:SetPercent(2/3)
	        end

	        if dude.components.health then
	            dude.components.health:Respawn(TUNING.RESURRECT_HEALTH)
	        end
	        
	        if dude.components.sanity then
				dude.components.sanity:SetPercent(.5)
	        end

	        if dude.components.moisture then
	        	dude.components.moisture.moisture = 0
	        end

	        if dude.components.temperature then
	        	dude.components.temperature:SetTemperature(TUNING.STARTING_TEMP)
	        end
	        
	        dude.components.hunger:Resume()
	        
	        dude.sg:GoToState("wakeup")
	        
	        
	        dude:DoTaskInTime(3, function(inst) 
			            if dude.HUD then
			                dude.HUD:Show()
			            end
			            TheCamera:SetDefault()
			            inst:RemoveTag("busy")



	        end)
	        
	    end)
	end
end)

























AddPrefabPostInit("tar", function(inst)
	inst:AddComponent("tpenergysource")
	inst.components.tpenergysource.fuel = 200
end)

local witch_staffs = {
	"icestaff",
	"firestaff",
}
for k, v in pairs(witch_staffs) do
	AddPrefabPostInit(v, function(inst)
		inst:AddTag("tp_witch_staff")
	end)
end

AddPrefabPostInit("tentacle_pillar_arm", function(inst)
	inst:AddTag("tp_not_reward")
end)

local crops = {
	"grass",
	"sapling",
	"reeds",
	"marsh_bush",
	"berrybush",
	"slow_farmplot",
	"fast_farmplot",
	"red_mushroom",
	"green_mushroom",
	"blue_mushroom",
	"flower_cave",
	"flower_cave_double",
	"flower_cave_triple",
	"grass",
	"sapling",
	"plant_normal",
}

for k, v in pairs(crops) do
	AddPrefabPostInit(v, function(inst)
		inst:AddTag("tp_can_fast_harvest")
	end)
end


add_prefab_tag({
	"grass", "sapling", "berrybush",
}, "tp_auto_picker_target")

add_prefab_tag({
	"beebox", "meatrack",
}, "tp_auto_harvester_target")

local shadow_creatures = {
	"nightmarebeak",
	"crawlingnightmare",
	"crawlinghorror",
	"terrorbeak"
}
for k, v in pairs(shadow_creatures) do
	AddPrefabPostInit(v, function(inst)
		inst:ListenForEvent("newcombattarget", function(inst, data)	
			if data.target then
				if data.target:HasTag("player")
				and not data.target:HasTag("tp_brave_nightmare") 
				and data.target.components.sanity
				and data.target.components.sanity:IsCrazy() then
					inst.components.combat:SetRange(8, 12)
				else
					inst.components.combat:SetRange(3, 3)
				end
			end






		end)
	end)
end

AddPrefabPostInit("firerain", function(inst)
	local cmp = inst.components.groundpounder

	local GroundPound = cmp.GroundPound
	function cmp:GroundPound(...)
		GroundPound(cmp, ...)
		local ents = inst:wg_finds(6, {"tp_fire_power"})
		for k, v in pairs(ents) do
			if v:is_alive() then
				v.components.health:DoDelta(50)
			end
		end
	end
end)

local function tool_recharged(inst, player, action, old, new)
	if inst.tp_recharged then
		inst.tp_recharged = false
		player.components.talker:Say("普通模式")
		inst.components.tool:SetAction(action, old[1])
		inst.components.finiteuses:SetConsumption(action, old[2])
	else
		inst.tp_recharged = true
		player.components.talker:Say("过载模式，提升效率但会消耗更多的耐久")
		inst.components.tool:SetAction(action, new[1])
		inst.components.finiteuses:SetConsumption(action, new[2])
	end
end

local tool_recharged_data = {
	axe = {
		ACTIONS.CHOP, {1,1}, {5,8},
		ingds = {
			twigs = 1,
		},
	},
	goldenaxe = {
		ACTIONS.CHOP, {1,0}, {5,2},
		ingds = {
			twigs = 2,
			goldnugget = 1,
		},
	},
	pickaxe = {
		ACTIONS.MINE, {1,1}, {3,4},
		ingds = {
			twigs = 1,
			flint = 1,
		},
	},
	goldenpickaxe = {
		ACTIONS.MINE, {1,0}, {3,1},
		ingds = {
			twigs = 2,
			goldnugget = 1,
		},
	},
	machete = {
		ACTIONS.HACK, {1,0}, {3,1},
		ingds = {
			twigs = 1,
			flint = 1,
		},
	},
	goldenmachete = {
		ACTIONS.HACK, {1,0}, {3,1},
		ingds = {
			twigs = 2,
			goldnugget = 1,
		},
	},
	hammer = {
		ACTIONS.HAMMER, {1,1}, {4,5},
		ingds = {
			twigs = 2,
			cutgrass = 3,
			rocks = 1,
		},
	},
}
for k, v in pairs(tool_recharged_data) do
	AddPrefabPostInit(k, function(inst)
		inst.skill_fn = function(item, player)
			tool_recharged(item, player, v[1], v[2], v[3])
		end
		inst.skill_fn2 = function(item, player)
			for k2, v2 in pairs(v.ingds) do
				c_give(k2,v2)
			end
			if k == "axe" and math.random() < .5 then
				c_give("flint")
			end
			item:Remove()
		end
	end)
end

local function chest_collect_item(inst, item)
	if item.components.stackable then
        item = item.components.stackable:Get()
    end
	inst.components.container:GiveItem(item)
end

local function chest_collect(inst)
	local pt = inst:GetPosition()
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, TUNING.ORANGEAMULET_RANGE,nil,{"INLIMBO", "NOFORAGE"})
	for i = 1, 10 do
		for k,v in pairs(ents) do
			if v.components.inventoryitem 
			and v.components.inventoryitem.canbepickedup 
			and v.components.inventoryitem.cangoincontainer 
			and not v.components.inventoryitem:IsHeld() then
				if not inst.components.container:IsFull() then
					chest_collect_item(inst, v)
					return
				elseif v.components.stackable then
					local stack = inst.components.container:FindItem(
						function(item) 
							return (item.prefab == v.prefab 
								and not item.components.stackable:IsFull()) 
						end)
					if stack then
						chest_collect_item(inst, v)
						return
					end
				end
			end
		end
	end
end


















