
local function tech_prince_test(inst)
	return inst:HasTag("tech_prince")
end
local function mad_prince_test(inst)
	return inst:HasTag("mad_prince")
end

local function set_pig_test(rcp)

	rcp.wargon_test = function(inst)
		return inst.components.inventory:Has("tp_grass_pigking", 1)
	end
end

local function set_pig_test2(rcp)
	rcp.wargon_test = function(inst)
		local pigking = c_find('pigking')
		if pigking then
			return inst:IsNear(pigking, 4)
		end
	end
end

local function set_octopus_test(rcp)

	rcp.wargon_test = function(inst)
		return inst.components.inventory:Has("tp_octopus", 1)
	end
end

local function set_img(rcp, atlas, img)
	img = img or atlas
	rcp.atlas = "images/inventoryimages/"..atlas..".xml"
	rcp.image = img..".tex"
end

local function get_img(img)



	local atlas, image = WARGON.resolve_img_path(img)
	return atlas, image
end

local function get_ori_img(img, two)
	local atlas = "images/inventoryimages.xml"
	if two then
		atlas = "images/inventoryimages_2.xml"
	end
	local tex = img..".tex"
	return atlas, tex
end






AddPlayerPostInit(function(inst)
	local rtb2 = {
		str="tp_animals", sort=12, icon="tp_recipe2.tex",
		icon_atlas="images/hud/tp_recipe2.xml",
		crafting_station=true, priority=4, 

	}
	inst.components.builder:AddGlobalRecipeTab(rtb2)

	
	local rtb3 = {
		str="tp_tech", sort=12, icon="tp_recipe3.tex",
		icon_atlas="images/hud/tp_recipe3.xml",
		crafting_station=true, priority=5, 

	}
	inst.components.builder:AddGlobalRecipeTab(rtb3)

	local rtb4 = {
		str="tp_magic", sort=12, icon="tp_recipe4.tex",
		icon_atlas="images/hud/tp_recipe4.xml",
		crafting_station=true, priority=6, 

	}
	inst.components.builder:AddGlobalRecipeTab(rtb4)

	local rtb = {
		str="tp_invent", sort=999, icon="tp_recipe.tex",
		icon_atlas="images/hud/tp_recipe.xml", 

	}
	inst.components.builder:AddRecipeTab(rtb)





local super_calculator = _G.WARGON.add_recipe(
"tp_super_calculator", 
{
	tp_alloy={1, get_img({"tp_alloys", "tp_alloy"})}, 
	transistor = 2,
}, rtb, "lost", nil, "tp_super_calculator_placer"
)
set_img(super_calculator, "tp_super_calculator")

local shop = _G.WARGON.add_recipe("tp_shop", {
	goldnugget=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "tp_shop_placer")
set_img(shop, "tp_structures_3", "tp_shop")
shop.wargon_test = tech_prince_test

local train_center = _G.WARGON.add_recipe("tp_train_center", {
	cutstone=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "tp_train_center_placer")
set_img(train_center, "tp_structures_3", "tp_train_center")
train_center.wargon_test = tech_prince_test








local flare = _G.WARGON.add_recipe('tp_flare', 
{cutgrass=5, twigs=1, gunpowder=1}, rtb, 'none')
set_img(flare, "tp_flare")













local resource_transporter = _G.WARGON.add_recipe("tp_resource_transporter", {

	gears=1, 
	transistor=1,

}, rtb, "none", nil, "tp_resource_transporter_placer")
set_img(resource_transporter, "tp_structures_2", "tp_resource_transporter")


local thumper = _G.WARGON.add_recipe('tp_thumper',
{boards=3, cutstone=1, transistor=1}, rtb, 'lost', 
nil, "tp_thumper_placer")
set_img(thumper, 'tp_thumper')

local egg_tool = _G.WARGON.add_recipe('tp_egg_tool',
{rocks=1, twigs=2}, rtb, 'lost')
set_img(egg_tool, 'tp_egg_tool')

local farm_pile = _G.WARGON.add_recipe('tp_farm_pile',
{poop=4, cutstone=1,}, rtb, 'lost', nil, "tp_farm_pile_placer")

set_img(farm_pile, "tp_structures_2", "tp_farm_pile")

local tent = _G.WARGON.add_recipe('tp_tent', {silk=10, twigs=6, rope=4}, 
rtb, 'lost', nil, "tp_tent_placer")




set_img(tent, "tp_structures_3", "tp_tent")
tent.tp_pot_structure = true

local function create_scroll_rec(recs)
	for i, v in pairs(recs) do
		local ingd = {papyrus=1, honey=1}
		ingd[v[1]] = v[2]
		local rcp = _G.WARGON.add_recipe('scroll_'..i, ingd, rtb, v[3])
		set_img(rcp, 'scroll_'..i)
		if string.find(i, "pig") then
			set_pig_test(rcp)
		else
			rcp.wargon_test = tech_prince_test
		end
	end
end

local bf_sp = _G.WARGON.add_recipe('bigfoot_sp', 
{san=50}, rtb4, "m_2")
bf_sp.image = "bell.tex"
bf_sp.wargon_test = mad_prince_test



local red_gem = _G.WARGON.add_recipe("redgem",
{bluegem=1}, rtb4, "m_2")
red_gem.wargon_test = mad_prince_test

local blue_gem = _G.WARGON.add_recipe("bluegem",
{redgem=1}, rtb4, "m_2")
blue_gem.wargon_test = mad_prince_test

local green_gem = _G.WARGON.add_recipe("greengem",
{bluegem=1, yellowgem=1}, rtb4, "m_2")
green_gem.wargon_test = mad_prince_test

local orange_gem = _G.WARGON.add_recipe("orangegem",
{redgem=1, yellowgem=1}, rtb4, "m_2")
orange_gem.wargon_test = mad_prince_test

local yellow_gem = _G.WARGON.add_recipe("yellowgem",
{redgem=1, greengem=1}, rtb4, "m_2")
yellow_gem.wargon_test = mad_prince_test

if not _G.WARGON.is_dlc(1) then
local raft = _G.WARGON.add_recipe("tp_raft", 
	{cutgrass=4, log=4},

rtb, "none", {"sw", "ham"}, "tp_raft_placer", true)

raft.atlas = "minimap/minimap_data.xml"
raft.image = "lily_pad.png"

end



local smelter = _G.WARGON.add_recipe('tp_smelter', 
{
tp_alloy={1, get_img({"tp_alloys", "tp_alloy"})}, 
	redgem=2, goldnugget=10
}, 
rtb, 'none', nil, "tp_smelter_placer")
set_img(smelter, "tp_furnace")

local tp_desk = _G.WARGON.add_recipe('tp_desk', 
{
	boards=4,
	tp_alloy={1, get_img({"tp_alloys", "tp_alloy"})},
}, rtb, 'none', nil, 'tp_desk_placer')
set_img(tp_desk, 'tp_desk')


local lab = _G.WARGON.add_recipe('tp_lab',
{
	tp_alloy={1, get_img({"tp_alloys", "tp_alloy"})},
	goldnugget=4, boards=2,
}, rtb, 'none', nil, 'tp_lab_placer')
set_img(lab, 'tp_lab')

local research_center = _G.WARGON.add_recipe("tp_research_center",
{
	boards = 2, papyrus=2,
}, rtb, "none", nil, "tp_research_center_placer")
set_img(research_center, "tp_research_center")

local equip_bench = _G.WARGON.add_recipe("tp_equip_bench",
{
	cutstone=2, tp_alloy_red={1, get_img({"tp_alloys", "tp_alloy_red"})},
}, rtb, "none", nil, "tp_equip_bench_placer")
set_img(equip_bench, "tp_equip_bench")

local equip_bench2 = _G.WARGON.add_recipe("tp_equip_bench2",
{
	goldnugget=4, tp_alloy={1, get_img({"tp_alloys", "tp_alloy"})},
}, rtb, "none", nil, "tp_equip_bench2_placer")
set_img(equip_bench2, "tp_equip_bench2")

local equip_bench3 = _G.WARGON.add_recipe("tp_equip_bench3",
{
	goldnugget=4, cutstone=2, 
	tp_alloy_great={1, get_img({"tp_alloys", "tp_alloy_great"})},
}, rtb, "none", nil, "tp_equip_bench3_placer")
set_img(equip_bench3, "tp_equip_bench3")

local desk2 = _G.WARGON.add_recipe("tp_desk2",
{
	boards=2, papyrus=1, tp_alloy_great={1, get_img({"tp_alloys", "tp_alloy_great"})},
}, rtb, "none", nil, "tp_desk2_placer")
set_img(desk2, "tp_desk2")

local processing = _G.WARGON.add_recipe("tp_processing", {
	goldnugget=2, cutstone=1, gears=1,
}, rtb, "none", nil, "tp_processing_placer")
set_img(processing, "tp_processing")

local food_station = _G.WARGON.add_recipe("tp_food_station",
{
	charcoal=2, cutstone=3,
}, rtb, "none", nil, "tp_food_station_placer")
set_img(food_station, "tp_food_station")

local excellentize_station = _G.WARGON.add_recipe(
"tp_excellentize_station",
{
	tp_alloy={1, get_img({"tp_alloys", "tp_alloy"})}, 

	gears = 1,
	cutstone=1,
}, rtb, "none", nil, "tp_excellentize_station_placer")
set_img(excellentize_station, "tp_excellentize_station")

local bench = _G.WARGON.add_recipe('tp_bench',
{
	tp_alloy_red={2, get_img({"tp_alloys", "tp_alloy_red"})}, 
	bluegem=2, goldnugget=4,

}, rtb3, 'lost', nil, 'tp_bench_placer')


set_img(bench, "tp_bench")


local enchantmenter = _G.WARGON.add_recipe("tp_enchantmenter",
{
	tp_alloy_red={2, get_img({"tp_alloys", "tp_alloy_red"})},
	redgem=2, goldnugget=4,
}, rtb3, "lost", nil, "tp_enchantmenter_placer")
set_img(enchantmenter, "tp_enchantmenter")


local food_changer = _G.WARGON.add_recipe("tp_food_changer",
{
	tp_alloy_red={1, get_img({"tp_alloys", "tp_alloy_red"})},
	cutstone=2, transistor=2,
}, rtb3, "s_1", nil, "tp_food_changer_placer")
set_img(food_changer, "tp_food_changer")
food_changer.wargon_test = tech_prince_test

local signal_tower = _G.WARGON.add_recipe("tp_signal_tower",
{

	transistor = 2,
	diviningrod = 1, trinket_6=2,	
}, rtb, "none", nil, "tp_signal_tower_placer")
set_img(signal_tower, "tp_signal_tower")

local robot_cleaner_home = _G.WARGON.add_recipe("tp_robot_cleaner_home",
{
	gears=2, transistor=2, cutstone=2,
}, rtb, "none", nil, "tp_robot_cleaner_home_placer")
set_img(robot_cleaner_home, "tp_robot_cleaner_home")

local robot_finder = _G.WARGON.add_recipe("tp_robot_finder", {
	gears=1, transistor=1, cutstone=1,	
}, rtb, "none", nil, "tp_robot_finder_placer")
set_img(robot_finder, "tp_robot_finder")



local dragon_cage = _G.WARGON.add_recipe("tp_dragon_cage",
{
	tp_alloy = {2, get_img({"tp_alloys", "tp_alloy"})},
	goldnugget=2, dragon_scales=1,
}, rtb, 'lost', nil, 'tp_dragon_cage_placer')

set_img(dragon_cage, "tp_structures_3", "tp_dragon_cage")

local chop_home = _G.WARGON.add_recipe('tp_chop_pig_home', 
{boards=4, pigskin=4, axe=1}, rtb, 'lost',
nil, "tp_chop_pig_home_placer")
set_img(chop_home, "tp_structures_2", "tp_chop_pig_home")


local hack_home = _G.WARGON.add_recipe('tp_hack_pig_home', 
{boards=4, pigskin=4, machete=1}, rtb, 'lost',
nil, "tp_hack_pig_home_placer")
set_img(hack_home, "tp_structures_2", "tp_hack_pig_home")


local farm_home = _G.WARGON.add_recipe('tp_farm_pig_home', 
{boards=4, pigskin=4, fertilizer=1}, rtb, 'lost',
nil, "tp_farm_pig_home_placer")
set_img(farm_home, "tp_structures_2", "tp_farm_pig_home")


local white_pig_house = _G.WARGON.add_recipe("tp_white_pig_house",
{boards=4, pigskin=4, cutstone=4}, rtb3, "s_1",
nil, "tp_white_pig_house_placer")
white_pig_house.image = "pighouse.tex"
white_pig_house.wargon_test = tech_prince_test

local engine = _G.WARGON.add_recipe("tp_engine", {
	gears=4, transistor=4, trinket_6=4,
}, rtb2, "none")
set_img(engine, "tp_engine")

local bulldozer = _G.WARGON.add_recipe('tp_bulldozer', 
{
	infused_iron=4, tp_engine={1, get_img("tp_engine#")}
}, rtb2, 'none', 
nil, "tp_bulldozer_placer")
bulldozer.atlas = "minimap/minimap_data.xml"
bulldozer.image = "metal_head.png"

local boss1 = _G.WARGON.add_recipe("tp_deerclops", 
{
	infused_iron = 2,
	tp_engine = {1, get_img("tp_engine#")},
	deerclops_eyeball = 1,
},
rtb2, "none", nil, "tp_deerclops_placer")
set_img(boss1, "tp_deerclops_ice_statue")

local boss2 = _G.WARGON.add_recipe("tp_moose",
{
	infused_iron = 2,
	tp_engine = {1, get_img("tp_engine#")},
	goose_feather = 3,	
},
rtb2, "none", nil, "tp_moose_placer")
set_img(boss2, "tp_moose_ice_statue")

local boss3 = _G.WARGON.add_recipe("tp_dragonfly", 
{
	infused_iron = 2,
	tp_engine = {1, get_img("tp_engine#")},
	dragon_scales = 1,	
},
rtb2, "none", nil, "tp_dragonfly_placer")
set_img(boss3, "tp_dragonfly_ice_statue")

local boss4 = _G.WARGON.add_recipe("tp_bearger", 
{
	infused_iron = 2,
	tp_engine = {1, get_img("tp_engine#")},
	bearger_fur = 1,	
},
rtb2, "none", nil, "tp_bearger_placer")
set_img(boss4, "tp_bearger_ice_statue")


if _G.WARGON.is_dlc(2) then
local boat = _G.WARGON.add_recipe("tp_boat",
{gears=2, transistor=2},
rtb2, "none", nil, "tp_boat_placer", true)
set_img(boat, "knight_boat_head")


else
local bike = _G.WARGON.add_recipe("tp_bike", 
{gears=2, transistor=2},
rtb2, "none", nil, "tp_bike_placer")
set_img(bike, "knight_head")


end

local coal_beast = _G.WARGON.add_recipe("tp_coal_beast",
{tp_engine={1, get_img("tp_engine#")}, beardhair=5},
rtb2, "none", nil, "tp_coal_beast_placer")
set_img(coal_beast, "spider_monkey_head")



local rook = _G.WARGON.add_recipe("tp_rook",
{tp_engine={1, get_img("tp_engine#")}, horn=1},
rtb2, "none", nil, "tp_rook_placer")
set_img(rook, "rook_head")



local fant = _G.WARGON.add_recipe("tp_fant",
{tp_engine={1, get_img("tp_engine#")}, axe=1},
rtb2, "none", nil, "tp_fant_placer")
set_img(fant, "koalefant_head")

local spat = _G.WARGON.add_recipe("tp_spat",
{tp_engine={1, get_img("tp_engine#")}, shovel=1},
rtb2, "none", nil, "tp_spat_placer")
set_img(spat, "spat_head")



local egg_cooker = _G.WARGON.add_recipe("tp_egg_cooker",
{tp_alloy={1, get_img({"tp_alloys", "tp_alloy"})}, 
cutstone=3, boards=4}, rtb, "lost",
nil, "tp_egg_cooker_placer")
set_img(egg_cooker, "tp_egg_cooker")


local fire_pot = _G.WARGON.add_recipe("tp_fire_pot",
{
	cutstone=3, charcoal=6, 
	tp_flavour = {3, get_img('tp_flavour#')},
}, 
rtb, "lost", nil, "tp_fire_pot_placer")

set_img(fire_pot, "tp_structures_3", "tp_fire_pot")

local rot_pot = _G.WARGON.add_recipe("tp_rot_pot",
{
	cutstone = 3, charcoal = 6,
	tp_alloy = {1, get_img({"tp_alloys", "tp_alloy"})},
},
rtb, "lost", nil, "tp_rot_pot_placer")

set_img(rot_pot, "tp_structures_3", "tp_rot_pot")

local dry_pot = _G.WARGON.add_recipe("tp_dry_pot",
{
	cutstone=3, charcoal=6,
	tp_alloy = {1, get_img({"tp_alloys", "tp_alloy"})},
},
rtb, "lost", nil, "tp_dry_pot_placer")

set_img(dry_pot, "tp_structures_3", "tp_dry_pot")

local mine_machine = _G.WARGON.add_recipe("tp_mine_machine", 
{
	infused_iron = 4,
	tp_engine = {1, get_img("tp_engine#")},
},
rtb3, "s_1", nil, "tp_mine_machine_placer")
set_img(mine_machine, "tp_mine_machine")
mine_machine.wargon_test = tech_prince_test

local slaughter_house = _G.WARGON.add_recipe("tp_slaughter_house",
{
	boards = 4, gears = 2, cutstone=3,
},
rtb3, "s_1", nil, "tp_slaughter_house_placer")
set_img(slaughter_house, "tp_slaughter_house")

slaughter_house.wargon_test = tech_prince_test

local ancient_tech = _G.WARGON.add_recipe("tp_ancient_tech", 
{
	thulecite = 6,
	purplegem = 2,
	livinglog = 4,	
},
rtb4, "m_2", nil, "tp_ancient_tech_placer")

set_img(ancient_tech, "tp_structures_3", "tp_ancient_tech")
ancient_tech.wargon_test = mad_prince_test

local auto_chopper = _G.WARGON.add_recipe("tp_auto_chopper", 
{
	axe=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(auto_chopper, "tp_auto_chopper")
auto_chopper.wargon_test = tech_prince_test

local auto_picker = _G.WARGON.add_recipe("tp_auto_picker", 
{
	strawhat=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(auto_picker, "tp_auto_picker")
auto_picker.wargon_test = tech_prince_test

local auto_planter = _G.WARGON.add_recipe("tp_auto_planter", 
{
	shovel=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(auto_planter, "tp_auto_planter")
auto_planter.wargon_test = tech_prince_test

local auto_harvester = _G.WARGON.add_recipe("tp_auto_harvester", 
{
	honey=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(auto_harvester, "tp_auto_harvester")
auto_harvester.wargon_test = tech_prince_test

local auto_fertilizer = _G.WARGON.add_recipe("tp_auto_fertilizer", 
{
	fertilizer=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(auto_fertilizer, "tp_auto_fertilizer")
auto_fertilizer.wargon_test = tech_prince_test

local auto_dryer = _G.WARGON.add_recipe("tp_auto_dryer", 
{
	charcoal=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(auto_dryer, "tp_auto_dryer")
auto_dryer.wargon_test = tech_prince_test

local auto_miner = _G.WARGON.add_recipe("tp_auto_miner", 
{
	pickaxe=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(auto_miner, "tp_auto_miner")
auto_miner.wargon_test = tech_prince_test

local auto_farmer = _G.WARGON.add_recipe("tp_auto_farmer", 
{
	seeds=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(auto_farmer, "tp_auto_farmer")
auto_farmer.wargon_test = tech_prince_test

local auto_transporter = _G.WARGON.add_recipe("tp_auto_transporter", 
{
	transistor=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(auto_transporter, "tp_auto_transporter")
auto_transporter.wargon_test = tech_prince_test

local auto_food_mover = _G.WARGON.add_recipe("tp_auto_food_mover", 
{
	meatballs=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(auto_food_mover, "tp_auto_food_mover")
auto_food_mover.wargon_test = tech_prince_test

local small_battery = _G.WARGON.add_recipe("tp_small_battery", 
{
	nitre=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(small_battery, "tp_small_battery")
small_battery.wargon_test = tech_prince_test

local big_battery = _G.WARGON.add_recipe("tp_big_battery", 
{
	purplegem=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(big_battery, "tp_big_battery")
big_battery.wargon_test = tech_prince_test

local love_generator = _G.WARGON.add_recipe("tp_love_generator", 
{
	boards=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(love_generator, "tp_love_generator")
love_generator.wargon_test = tech_prince_test

local charcoal_generator = _G.WARGON.add_recipe("tp_charcoal_generator", 
{
	cutstone=2, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "firesuppressor_placer")
set_img(charcoal_generator, "tp_charcoal_generator")
charcoal_generator.wargon_test = tech_prince_test

local light2 = _G.WARGON.add_recipe("tp_light2", {
	lightbulb=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "tp_light2_placer")
set_img(light2, "tp_light2")
light2.wargon_test = tech_prince_test

local oil_refinery = _G.WARGON.add_recipe("tp_oil_refinery", {
	thulecite=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "tp_oil_refinery_placer")
set_img(oil_refinery, "tp_oil_refinery")
oil_refinery.wargon_test = tech_prince_test

local cure_desk = _G.WARGON.add_recipe("tp_cure_desk", {
	spidergland=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "tp_cure_desk_placer")
set_img(cure_desk, "tp_structures_3", "tp_cure_desk")
cure_desk.wargon_test = tech_prince_test

local fridge = _G.WARGON.add_recipe("tp_fridge", {
	transistor=1, gears=1, trinket_6=1,
}, rtb3, "s_1", nil, "tp_fridge_placer")
set_img(fridge, "tp_structures_3", "tp_fridge")
fridge.wargon_test = tech_prince_test


















	








	










































































































































































































































































































































		




end)