local function tp_health_equip_complete(inst)
	if inst:HasTag("tp_hat_health") and inst:HasTag("tp_armor_health")
	and inst:HasTag("tp_spear_blood") then
		if inst.tp_health_equip_task == nil then
			inst.tp_health_equip_task = WARGON.per_task(inst, 4, function()
				if inst.components.health then
					inst.components.health:DoDelta(2, true, "tp_health_equip")
				end
			end)
		end
	end
end

local function tp_health_equip_incomplete(inst)
	if inst.tp_health_equip_task then
		inst.tp_health_equip_task:Cancel()
		inst.tp_health_equip_task = nil
	end
end

GLOBAL.WARGON.EQUIP.tp_health_equip_complete = tp_health_equip_complete
GLOBAL.WARGON.EQUIP.tp_health_equip_incomplete = tp_health_equip_incomplete

WgImg = Class(function(self, img)
	self.atlas, self.img = WARGON.resolve_img_path(img)
end)

function WgImg:GetImg()
	return self.atlas, self.img
end

WgAnim = Class(function(self, anims, is_loop)
	self.bank = anims[1]
	self.build = anims[2]
	self.anim = anims[3]
	self.is_loop = is_loop
end)

function WgAnim:SetAnim(anim)
	anim:SetBank(self.bank)
	anim:SetBuild(self.build)
	anim:PlayAnimation(self.anim, self.is_loop)
end

function WgAnim:GetAnim()
	return {self.bank, self.build, self.anim}
end

ShelfData = Class(function(self, title, unit)
	self.shelf = {}
	self.title = title or ""
	self.unit = unit or 10
	self.cur = 1
	self.max = 0
	self.point = {}
end)

function ShelfData:ClearShelf()
	self.shelf = {}
	self.cur = 1
	self.max = 0
	self.point = {}
end

function ShelfData:AddBar()
	table.insert(self.shelf, {})
	self.max = self.max + 1
	self.point[self.max] = 1
end

function ShelfData:AddItem(item)
	if self.max <= 0 then
		self:AddBar()
	end
	if #self.shelf[self.max] >= self.unit then
		self:AddBar()
	end
	table.insert(self.shelf[self.max], item)
end

function ShelfData:PageTurn(dt)
	self.cur = math.max(1, math.min(self.max, self.cur+dt))


end

function ShelfData:SetPoint(p)
	self.point[self.cur] = p
end

function ShelfData:GetPoint()
	return self.point[self.cur]
end

function ShelfData:GetItems()
	if self.max <= 0 then
		return {}
	else
		return self.shelf[self.cur]
	end
end

function ShelfData:GetAllItems()
	local t = {}
	for k, v in pairs(self.shelf) do
		for k2, v2 in pairs(v) do
			table.insert(t, v2)
		end
	end
	return t
end

function ShelfData:GetItem()
	if self.max > 0 then

		local point = self.point[self.cur]
		return self.shelf[self.cur][point]
	end
end

function ShelfData:__tostring()
	return string.format("ShelfData %s",self.title)
end

require "prefabs"
_G.Prefab.HookFn = function(self, fn)
	local old = self.fn
	self.fn = function(inst)
		local inst = old()
		fn(inst)
		return inst
	end
end

_G.Prefab.SetName = function(self, name)
	self.name = string.sub(name, string.find(name, "[^/]*$"))
end