require "behaviours/follow"
require "behaviours/wander"

local MIN_FOLLOW = 4
local MAX_FOLLOW = 11
local MED_FOLLOW = 6
local MAX_WANDER_DIST = 10

local TpSporeBrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

function TpSporeBrain:OnStart()
    local root = PriorityNode({
            Follow(self.inst, function() return self.inst.components.follower.leader end, MIN_FOLLOW, MED_FOLLOW, MAX_FOLLOW, true),


            Wander(self.inst, function() return Point(GetPlayer().Transform:GetWorldPosition()) end , MAX_WANDER_DIST),
        },1)
    
    self.bt = BT(self.inst, root)
    
end

return TpSporeBrain
