local TpElectricity = require("components/tpelectricity")

local TpBattery = Class(TpElectricity, function(self, inst)
    TpElectricity._ctor(self, inst)
    self.event = "tp_battery_delta"

    self.single_power = 10
    self.max_power = 100
    self.inst:RemoveTag("tp_electricity")
    self.inst:AddTag("tp_battery")
end)

















function TpBattery:Init(single_power, max_power)
    self.single_power = single_power
    self.max_power = max_power
end





function TpBattery:GetPower()


    if self.inst:HasTag("tp_not_get_electricity")
    or self:IsFull() then
        return
    end
    local ents = self.inst:wg_finds(15, {"tp_generator"}, {"tp_not_get_electricity"})
    for k, v in pairs(ents) do

            if v.components.tpvalue and not v.components.tpvalue:IsEmpty() then
                local cost = self:GetCost()
                local amount = math.min(cost, v.components.tpvalue.current)
                print("electric power", amount)
                v.components.tpvalue:DoDelta(-amount)
                self:DoDelta(amount)
                WARGON.make_fx2("lightning_rod_fx", self.inst)
                if self:IsFull() then
                    break
                end
            end

    end
end

function TpBattery:StartGetPower()
    self:StopGetPower()
    self.get_power_task = self.inst:per_task(2, function()
        self:GetPower()
    end)
end

function TpBattery:StopGetPower()
    if self.get_power_task then
        self.get_power_task:Cancel()
        self.get_power_task = nil
    end
end

function TpBattery:PowerSupply()
    if (self.inst.components.machine
    and not self.inst.components.machine:IsOn())
    or self:IsEmpty() then
        return
    end
    local ents = self.inst:wg_finds(15, {"tp_electricity"}, {"tp_not_get_electricity"})
    local sum_power = 0
    for k, v in pairs(ents) do
        if self:IsEmpty() or sum_power >= self.max_power then
            break
        end
        if v.components.tpelectricity
        and v.components.tpelectricity:GetCost() >= 10 then


            local dt = v.components.tpelectricity:GetCost()
            local amount = math.min(dt, self.single_power, self.current)
            print("power supply", amount)
            self:DoDelta(-amount)
            v.components.tpelectricity:DoDelta(amount)
            WARGON.make_fx2("lightning_rod_fx", v)
            sum_power = sum_power + amount

        end
    end
end

function TpBattery:StartPowerSupply()
    print("TpBattery Start")
    self:StopPowerSupply()
    self.power_supply_task = self.inst:per_task(1, function()
        self:PowerSupply()
    end)
end

function TpBattery:StopPowerSupply()
    print("TpBattery Stop")
    if self.power_supply_task then
        self.power_supply_task:Cancel()
        self.power_supply_task = nil
    end
end

function TpBattery:GetWargonString()
    return string.format("特殊值：%d/%d\n速率：%d，%d", self.current, self.max, self.period, self.rate)
end

return TpBattery