local TpBody = Class(function(self, inst)
	self.inst = inst
	self.absorb_mods = {}
	self.scale_mods = {}
	self.max_health_mods = {}
	self.max_health_save = {}

	self.old_max_health = 0
	self.max_sanity_mods = {}
	self.max_hunger_mods = {}
	self.fire = 1
	self.lucky = 0
	self.health_penalty_mods = {}
	self.sanity_penalty_mods = {}
	self.poison_damage_stack = 0
	self.drying_rate = 0

	self.inst:ListenForEvent("oneat", function(inst, data)
		if data and data.food then
			if not inst:HasTag("tp_good_stomach") 
			and data.food.components.edible
			and data.food.components.edible.hungervalue > 50 then
				self.inst:AddTag("tp_insomniac")
			end
		end
	end)
	self.inst:ListenForEvent("daytime", function(world, data)
		self.inst:RemoveTag("tp_insomniac")
	end, GetWorld())
	self.inst:ListenForEvent("dusktime", function(world, data)
		self.inst:RemoveTag("tp_insomniac")
	end, GetWorld())
	self.inst:ListenForEvent("nighttime", function(world, data)
		self.inst:RemoveTag("tp_insomniac")
	end, GetWorld())
	self.inst:ListenForEvent("hungerdelta", function(inst, data)
		local p = inst.components.hunger:GetPercent()
		inst:add_speed_rate("tp_body_hungry", (p-1)/10)
		inst:add_dmg_rate("tp_body_hungry", (p-1)/10)





	end)
	self.inst:ListenForEvent("sanitydelta", function(inst, data)
		local p = inst.components.sanity:GetPercent()
		inst:add_dmg_rate("tp_body_insanely", (p-1)/10)





	end)
	self.inst:ListenForEvent("healthdelta", function(inst, data)
		if data and data.newpercent and data.oldpercent
		and data.newpercent < data.oldpercent 
		and data.newpercent < .3 then
			local dt_p = data.newpercent - data.oldpercent
			local dt = inst.components.sanity:GetMaxSanity()*dt_p
			inst.components.sanity:DoDelta(dt)
		end
	end)
	self.inst:ListenForEvent("poisondamage", function(inst, data)
		if not inst:HasTag("tp_not_extra_poison") then
			local n = self.poison_damage_stack
			if n < 2 then
				n = n + .1
			else
				n = math.min(10, n+1)
			end
			self.inst.components.health:DoDelta(-n*self.fire)
			self.poison_damage_stack = n
		end
	end)
	self.inst:ListenForEvent("tp_poison_cure", function(inst, data)
		self.poison_damage_stack = 0
	end)













end)

function TpBody:AddWound(time)
	time = time or 1
	if self.fx == nil then
		self.fx = SpawnPrefab("poisonbubble")
		self.inst:AddChild(self.fx)
		self.fx.Transform:SetPosition(0, 0, 0)
		self.fx.AnimState:SetMultColour(1, .1, .1, 1)
	end
	self.inst:AddTag("tp_wound")
	if self.task then
		self.task:Cancel()
		self.task = nil
	end
	self.task = WARGON.do_task(self.inst, time, function()
		if self.fx then
			self.fx:Remove()
			self.fx = nil
		end
		self.inst:RemoveTag("tp_wound")
	end)
end






function TpBody:AddMaxHealthModifier(key, mod, save_p)





	self.inst.components.health:AddMaxHealthModifier(key, mod, save_p)
end

function TpBody:RemoveMaxHealthModifier(key, save_p)





	self.inst.components.health:RemoveMaxHealthModifier(key, save_p)
end

function TpBody:GetMaxHealthModifier()





	return self.inst.components.health:GetMaxHealthModifier()
end

function TpBody:SetMaxHealth(save_p)
	local p = 0
	if save_p then
		p = self.inst.components.health:GetPercent()
	end
	local max = 0
	if self.inst.components.tplevel then
		max = self.inst.components.tplevel.attr.health 
	end
	max = max + self:GetMaxHealthModifier()
	self.inst.components.health.maxhealth = max
	self.inst.components.health:DoDelta(0)

	if save_p then
		self.inst.components.health:SetPercent(p)
	end
end

function TpBody:RemoveMaxHealthSave()
	for k, v in pairs(self.max_health_save) do
		self:RemoveMaxHealthModifier(k, true)
	end
end


function TpBody:AddMaxSanityModifier(key, mod, save_p)


	self.inst.components.sanity:AddMaxSanityModifier(key, mod, save_p)
end

function TpBody:RemoveMaxSanityModifier(key, save_p)


	self.inst.components.sanity:RemoveMaxSanityModifier(key, save_p)
end

function TpBody:GetMaxSanityModifier()





	return self:GetMaxSanityModifier()
end

function TpBody:SetMaxSanity(save_p)
	local p = 0
	if save_p then
		p = self.inst.components.sanity:GetPercent()
	end
	local max = 0
	if self.inst.components.tplevel then
		max = self.inst.components.tplevel.attr.sanity 
	end
	max = max + self:GetMaxSanityModifier()
	self.inst.components.sanity.max = max
	self.inst.components.sanity:DoDelta(0)
	if save_p then
		self.inst.components.sanity:SetPercent(p)
	end
end


function TpBody:AddMaxHungerModifier(key, mod, save_p)


	self.inst.components.hunger:AddMaxHungerModifier(key, mod, save_p)
end

function TpBody:RemoveMaxHungerModifier(key, save_p)


	self.inst.components.hunger:RemoveMaxHungerModifier(key, save_p)
end

function TpBody:GetMaxHungerModifier()





	return self.inst.components.hunger:GetMaxHungerModifier()
end

function TpBody:SetMaxHunger(save_p)
	local p = 0
	if save_p then
		p = self.inst.components.hunger:GetPercent()
	end
	local max = 0
	if self.inst.components.tplevel then
		max = self.inst.components.tplevel.attr.hunger
	end
	max = max + self:GetMaxHungerModifier()
	self.inst.components.hunger.max = max
	self.inst.components.hunger:DoDelta(0)
	if save_p then
		self.inst.components.hunger:SetPercent(p)
	end
end


function TpBody:AddAbsorbModifier(key, mod)
	self.absorb_mods[key] = mod
	if self.inst.components.health then
		self.inst.components.health:AddAbsorbModifier(key, mod)
	end
end

function TpBody:RemoveAbsorbModifier(key)
	self.absorb_mods[key] = nil
	if self.inst.components.health then
		self.inst.components.health:RemoveAbsorbModifier(key)
	end
end

function TpBody:GetAbsorbModifier()
	local mod = 0
	for k, v in pairs(self.absorb_mods) do
		mod = mod + v
	end
	return mod
end


function TpBody:AddScaleModifier(key, mod)
	self.scale_mods[key] = mod
	self:SetScale()
end

function TpBody:RemoveScaleModifier(key)
	self.scale_mods[key] = nil
	self:SetScale()
end

function TpBody:GetScaleModifier()
	local mod = 1
	for k, v in pairs(self.scale_mods) do
		mod = mod + v
	end
	return mod
end


function TpBody:SetScale()
	local mod = self:GetScaleModifier()
	self.inst.Transform:SetScale(mod, mod, mod)
end


function TpBody:AddHealthPenaltyModifier(key, mod)

	self.inst.components.health:AddHealthPenaltyModifier(key, mod)
end

function TpBody:RemoveHealthPenaltyModifier(key, mod)

	self.inst.components.health:RemoveHealthPenaltyModifier(key)
end

function TpBody:GetHealthPenaltyModifier()
	local mod = 0
	for k, v in pairs(self.health_penalty_mods) do
		mod = mod + v
	end
	return mod
end


function TpBody:AddSanityPenaltyModifier(key, mod)

	self.inst.components.sanity:AddSanityPenaltyModifier(key, mod)
end

function TpBody:RemoveSanityPenaltyModifier(key, mod)

	self.inst.components.sanity:RemoveSanityPenaltyModifier(key)
end

function TpBody:GetSanityPenaltyModifier()
	local mod = 0
	for k, v in pairs(self.sanity_penalty_mods) do
		mod = mod + v
	end
	return mod
end


function TpBody:SetFire(p)
	self.fire = p
end


function TpBody:SetLucky(amount)
	self.lucky = amount
end

function TpBody:GetLucky()
	return self.lucky/100
end

function TpBody:GetWargonString()

	local strs = {
		string.format("中毒层数:%d", self.poison_damage_stack),
		string.format("理智上限降低:%d", self:GetSanityPenaltyModifier()),
		string.format("烧伤系数:%d", self.fire),
		string.format("幸运:%d%%", self.lucky),
	}
	return strs[1] or ""
end

return TpBody