local TpBossSpawner = Class(function(self, inst)
	self.inst = inst
	self.pos_list = {}
	self.inst:do_task(0, function()
		self:Init()
		self:CheckBoss("tp_hornet", true)
		self:CheckBoss("tp_combat_lord", true)
		self:CheckBoss("tp_soul_student", true)
		self:CheckBoss("tp_coal_beast", nil, true)
	end)
end)

function TpBossSpawner:CheckBoss(boss, is_room, is_name)
	local inst = self.inst
	if c_find(boss) == nil
	and GetPlayer().components.tpprefabspawner:CanSpawn(boss) then
		local pos, idx = self:GetPos()
		if pos then
			table.remove(self.pos_list, idx)
			if is_room then
				WARGON.make_spawn(pos, boss.."_room")
			elseif is_name then
				WARGON.make_spawn(pos, boss)
			else
				WARGON.make_spawn(pos, boss.."_sleep")
			end
			GetPlayer().components.tpprefabspawner:TriggerPrefab(boss)
		end
	end
end

function TpBossSpawner:Init()
	local target = c_find("tp_boss_spawner")
	while target do
		local pos = target:GetPosition()
		table.insert(self.pos_list, pos)
		target:Remove()
		target = c_find("tp_boss_spawner")
	end
end

function TpBossSpawner:GetPos()
	if #self.pos_list > 0 then
		local idx = math.random(#self.pos_list)
		return self.pos_list[idx], idx
	end
end

function TpBossSpawner:OnSave()
	return {
		pos_list = self.pos_list,
	}
end

function TpBossSpawner:OnLoad(data)
	if data.pos_list then
		self.pos_list = data.pos_list
	end
end

return TpBossSpawner