local TpBullets = Class(function(self, inst)
	self.inst = inst
	self.max = 20
	self.fast = false

	self.cur = 0
	self.bullets = {}
end)

function TpBullets:GetBullet()
	return self.cur > 0 and self.bullets[self.cur] or nil
end

function TpBullets:SetMax(max)
	self.max = max
end

function TpBullets:SetFast()
	self.fast = true
	self.inst:AddTag("tp_fast_gun")
end

function TpBullets:GetNum()
	return self.cur
end

function TpBullets:IsFull()
	return self.cur >= self.max
end

function TpBullets:Add(amount, bullet)
	local old = self.cur
	local num = amount
	if old <= 0 then
		if self.take_fn then
			self.take_fn(self.inst)
		end
	end

	for i = 1, amount do
		if self.cur >= self.max then
			break
		end
		self.cur = self.cur + 1
		self.bullets[self.cur] = bullet
	end





	local current = self:GetBullet()
	if self.change_fn then
		self.change_fn(self.inst, current)
	end
	self.inst:PushEvent("tp_bullet_change", {current=current})
	print("TpBullets", current)
end

function TpBullets:Lose(amount)
	for i = 1, amount do
		if self.cur <= 0 then
			break
		end
		self.bullets[self.cur] = nil
		self.cur = self.cur - 1
	end
	if self.cur <= 0 then
		if self.lose_fn then
			self.lose_fn(self.inst)
		end
	end
	local current = self:GetBullet()
	if self.change_fn then
		self.change_fn(self.inst, current)
	end
	self.inst:PushEvent("tp_bullet_change", {current=current})
	print("TpBullets", current)
end

function TpBullets:OnSave()
	return {

		bullets = deepcopy(self.bullets),
		max = self.max,
		fast = self.fast,
	}
end

function TpBullets:OnLoad(data)



	if data then
		if data.max then
			self.max = data.max
		end
		if data.fast then
			self:SetFast()
		end
		if data.bullets then
			local bullets = data.bullets or {}
			for k, v in pairs(bullets) do
				self:Add(1, v)
			end
		end
	end
end

return TpBullets