local TpCollecter = Class(function(self, inst)
	self.inst = inst
	self.time = 0
	self.level = 0
	self.max = 10
end)

function TpCollecter:LevelUp()
	self.level = math.min(self.max, self.level + 1)
	self.time = 120
	self:Start()
end

function TpCollecter:Start()
	if self.task == nil then
		self.task = self.inst:per_task(1, function()
			self.time = self.time - 1
			if self.time <= 0 then
				self.time = 0
				self.level = self.level - 1
				if self.level <= 0 then
					self.level = 0
					self.task:Cancel()
					self.task = nil
				else
					self.time = 10
				end
			end
		end)
	end
end

function TpCollecter:OnSave()
	return {
		level = self.level,
		time = self.time,
	}
end

function TpCollecter:OnLoad(data)
	if data then
		self.level = data.level or 0
		self.time = data.time or 0
		if self.level > 0 then
			self:Start()
		end
	end
end

return TpCollecter