local TpDemonStrike = Class(function(self, inst)
    self.inst = inst
    self.kill_prefabs = {}
    self.ex_damage = 0
end)

function TpDemonStrike:Kill(victim)
    if victim.prefab and not self.kill_prefabs[victim.prefab] then
        self.ex_damage = self.ex_damage + 1
        self.kill_prefabs[victim.prefab] = true
        WARGON.make_fx2("statue_transition_2", self.inst)
    end
end

function TpDemonStrike:GetDamage()
    return self.ex_damage
end

function TpDemonStrike:OnSave()
    local data = {}
    data.kill_prefabs = {}
    data.ex_damage = self.ex_damage
    for k, v in pairs(self.kill_prefabs) do
        data.kill_prefabs[k] = v
    end
    return data
end

function TpDemonStrike:OnLoad(data)
    if data then
        self.ex_damage = data.ex_damage or 0
        for k, v in pairs(data.kill_prefabs or {}) do
            self.kill_prefabs[k] = v
        end
    end
end

return TpDemonStrike