local TpValue = require("components/tpvalue")

TpElectricity = Class(TpValue, function(self, inst)
    TpValue._ctor(self, inst)
    self.event = "tp_electricity_delta"

    self.task:Cancel()
    self.task = nil
    self.inst:AddTag("tp_electricity")






end)

function TpElectricity:OnRemoveEntity()
    if self.fx then
        self.fx:Recycle()
        self.fx = nil
    end
end

function TpElectricity:ShowNoElectricFx()
    if self.fx == nil then
        self.fx = WARGON.make_fx2("no_electric", self.inst)
    end
end

function TpElectricity:DoDelta(amount)
    local old = self.current
    TpElectricity._base.DoDelta(self, amount)
    if self.current <= 0 and old > 0 then
        self:ShowNoElectricFx()
    end
    if self.current > 0 and old <= 0 then
        if self.fx then
            self.fx:Recycle()
            self.fx = nil
        end
    end
end





function TpElectricity:OnLoad(data)
    TpElectricity._base.OnLoad(self, data)
    if self.current <= 0 then
        self:ShowNoElectricFx()
    end
end

function TpElectricity:GetWargonString()
    return string.format("电力：%d/%d\n速率：%d，%d", self.current, self.max, self.period, self.rate)
end

return TpElectricity