
local Melter = require "components/melter"

local TpEnchantmenter = Class(Melter, function(self, inst)
	Melter._ctor(self, inst)
	self.spoiledproduct = "tp_spear_mix"
    self.min_num_for_cook = 2
    self.max_num_for_cook = 4
end)





    






    
























local function dostew(inst)
	local stewercmp = inst.components.tpenchantmenter
	stewercmp.task = nil
	
	if stewercmp.ondonecooking then
		stewercmp.ondonecooking(inst)
	end














	stewercmp.done = true
	stewercmp.cooking = nil

	local weapon = inst.components.container:FindItem(function(item)
		return item.components.tpenchantment
	end)
	for k, v in pairs(inst.components.container.slots) do
		if v and v:HasTag("tp_gem") then
			local stack = 1
			if v.components.stackable then
				stack = v.components.stackable:StackSize()
			end
			weapon.components.tpenchantment:DeltaAttribute(v.prefab, stack)
			local gem = inst.components.container:RemoveItemBySlot(k)
			if gem then
				gem:Remove()
			end
		end
	end
	inst.components.container.canbeopened = true
	stewercmp.done = nil
end













function TpEnchantmenter:CanCook()
	local num = 0
	for k,v in pairs (self.inst.components.container.slots) do
		num = num + 1 
	end

	local weapon = self.inst.components.container:FindItem(function(item)
		return item.components.tpenchantment
	end)
	return num >= self.min_num_for_cook and num <= self.max_num_for_cook
		and weapon ~= nil
end


function TpEnchantmenter:StartCooking()
	if not self.done and not self.cooking then
		if self.inst.components.container then
		
			self.done = nil
			self.cooking = true
			
			if self.onstartcooking then
				self.onstartcooking(self.inst)
			end
		
			

			local spoilage_total = 0
			local spoilage_n = 0

























			local cooktime = 0.2
			self.productcooker = self.inst.prefab
			
			local grow_time = TUNING.BASE_COOK_TIME * cooktime
			self.targettime = GetTime() + grow_time
			self.task = self.inst:DoTaskInTime(grow_time, dostew, "stew")

			self.inst.components.container:Close()

			self.inst.components.container.canbeopened = false
		end
		
	end
end



























function TpEnchantmenter:OnLoad(data)

    if data.cooking then
		self.product = data.product
		self.productcooker = data.productcooker or (self.cookername or self.inst.prefab)
		if self.oncontinuecooking then
			local time = data.time or 1
			self.product_spoilage = data.product_spoilage or 1
			self.oncontinuecooking(self.inst)
			self.cooking = true
			self.targettime = GetTime() + time
			self.task = self.inst:DoTaskInTime(time, dostew, "stew")
			
			if self.inst.components.container then		
				self.inst.components.container.canbeopened = false
			end
			
		end
    elseif data.done then
		self.product_spoilage = data.product_spoilage or 1
		self.done = true
		self.targettime = data.timesincefinish
		self.product = data.product
		self.productcooker = data.productcooker or (self.cookername or self.inst.prefab)
		if self.oncontinuedone then
			self.oncontinuedone(self.inst)
		end
		self.spoiltargettime = data.spoiltime and GetTime() + data.spoiltime or nil
		if self.spoiltargettime then





		end
		if self.inst.components.container then		
			self.inst.components.container.canbeopened = false
		end
		
    end
end



    










    



    



    








































function TpEnchantmenter:Harvest( harvester )
	print("HERE?")
	if self.done then
		if self.onharvest then
			self.onharvest(self.inst)
		end
		self.done = nil
		if self.product then
			if harvester and harvester.components.inventory then




















				














			end
			self.product = nil
			self.spoiltargettime = nil

			if self.spoiltask then 
				self.spoiltask:Cancel()
				self.spoiltask = nil
			end
		end
		
		if self.inst.components.container and not self.inst:HasTag("flooded") then		
			self.inst.components.container.canbeopened = true
		end
		
		return true
	end
end

function TpEnchantmenter:LongUpdate(dt)
    if not self.paused and self.targettime ~= nil then
		if self.task ~= nil then
			self.task:Cancel()
			self.task = nil
		end

        self.targettime = self.targettime - dt

        if self.cooking then
            local time_to_wait = self.targettime - GetTime()
            if time_to_wait < 0 then
                dostew(self.inst)
            else
                self.task = self.inst:DoTaskInTime(time_to_wait, dostew, "stew")
            end
        end
    end

	if self.spoiltask ~= nil then
		self.spoiltask:Cancel()
		self.spoiltask = nil
        self.spoiltargettime = self.spoiltargettime - dt
		local time_to_wait = self.spoiltargettime - GetTime()
		if time_to_wait <= 0 then
			dospoil(self.inst)
		else
			self.spoiltask = self.inst:DoTaskInTime(time_to_wait, dospoil)
		end
	end
end

function TpEnchantmenter:CollectSceneActions(doer, actions, right)
	if not doer.components.rider or not doer.components.rider:IsRiding() then
		if not self.inst:HasTag("burnt") then
		    if not self.done then

		    elseif not self.done and right and self:CanCook() then
				table.insert(actions, ACTIONS.COOK)
		    end
		end
	end
end

return TpEnchantmenter
