local cooking = require "cooking"

local TpFirePot = Class(function(self, inst)
	self.inst = inst
	self.time = 0
	self.cooker = false
end)

function TpFirePot:Start(time)

	self.time = time
	if self.start then
		self.start(self.inst)
	end
	if self.task then
		self.task:Cancel()
		self.task = nil
	end
	self.task = self.inst:per_task(1, function()
		self.time = self.time - 1
		if self.time <= 0 then
			self:Stop()
		end
	end)
end

function TpFirePot:Stop()
	if self.stop then
		self.stop(self.inst)
	end
	if self.task then
		self.task:Cancel()
		self.task = nil
	end
	self.time = 0
end

function TpFirePot:IsCooking()
	return self.time > 0
end

local dinners = {
	drumstick = "turkeydinner",
	drumstick_cooked = "turkeydinner",
	tallbirdegg = "baconeggs",
	tallbirdegg_cooked = "baconeggs",
	doydoyegg = "baconeggs",
	doydoyegg_cooked = "baconeggs",
	butterflywings = "butterflymuffin",
	coffeebeans = "coffee",
	coffeebeans_cooked = "coffee",
	cave_banana = "bananapop",
	honey = "taffy",
	pumpkin = "pumpkincookie",
	pumpkin_cooked = "pumpkincookie",
	froglegs = "frogglebunwich",
	froglegs_cooked = "frogglebunwich",
	watermelon = "watermelonicle",
	snakebone = "snakebonesoup",
	eggplant = "stuffedeggplant",
	eggplant_cooked = "stuffedeggplant",
	limpets = "bisque",
	limpets_cooked = "bisque",
	eel = "unagi",
	eel_cooked = "unagi",
	lobster = "surfnturf",
	piko_orange = "tea",
	durian = "guacamole",
	durian_cooked = "guacamole",
}

function TpFirePot:Cook()
	if self.inst.components.container then
		self.inst.components.container:Close()
	else
		return
	end
	local item = self.inst.components.container.slots[1]
	if item and item.prefab ~= "tp_flavour" then

		local ings = {}
		for i = 1, 4 do
			ings[i] = item.prefab
		end
		local stuff = self.inst.components.container:RemoveItemBySlot(1)
		if stuff then
			stuff:Remove()
		end
		if cooking.ValidRecipe("cookpot", ings) then
			local product = cooking.CalculateRecipe("cookpot", ings)
			if dinners[ings[1]] then
				product = dinners[ings[1]]
			end
			local dinner = SpawnPrefab(product)
			if dinner.components.tppowerfruit and math.random() < 5 then

				dinner.components.tppowerfruit:Set("hot", 1)
			end
			self.cooker = true
			self.inst.components.container:GiveItem(dinner)
			self.cooker = false
		end
	elseif item and item.prefab == "tp_flavour" then

		local stuff = self.inst.components.container:RemoveItemBySlot(1)
		if stuff then
			stuff:Remove()
		end
		self:Start(15)
	end


































end

function TpFirePot:OnSave()
	return {
		time = self.time,
	}
end

function TpFirePot:OnLoad(data)
	if data then
		if data.time and data.time > 0 then
			self:Start(data.time)
		end
	end
end

return TpFirePot