local TpImg = require "widgets/tp_follow_image"

local TpFollowImage = Class(function(self, inst)
	self.inst = inst
end)

function TpFollowImage:SetImage(atlas, img, hide)
	WARGON.do_task(self.inst, 0, function()
		if self.widget == nil then
			if GetPlayer().HUD then
				self.widget = GetPlayer().HUD:AddChild(TpImg(atlas, img))
				self.widget:SetOffset(self.offset or Vector3(0, -80, 0))
				if self.scale then
					self.widget.tp_image:SetScale(self.scale, self.scale, self.scale)
				end
				self.widget:SetTarget(self.inst)
			end
		else
			self.widget.tp_image:SetTexture(atlas, img)
		end
		print("is hide", hide)
		if hide then
			print("Hide Image")
			self.widget:Hide()
		else
			if not self.widget.shown then
				self.widget:Show()
			end
		end
	end)
end

function TpFollowImage:Hide()
	if self.widget then
		self.widget:Hide()
	end
end

function TpFollowImage:Show()
	if self.widget then
		self.widget:Show()
	end
end

function TpFollowImage:Kill()
	if self.widget then

		self.widget:Kill()
		self.widget = nil
	end
end

function TpFollowImage:OnRemoveEntity()
	self:Kill()
end

return TpFollowImage