local GroundPounder = require "components/groundpounder"

local TpGroundPounder = Class(GroundPounder, function(self, inst)
	GroundPounder._ctor(self, inst)
	table.insert(self.noTags, "player")
	table.insert(self.noTags, "tp_perseus")
	self.tags = nil
	self.range = 3
end)

function TpGroundPounder:DestroyPoints(points, breakobjects, dodamage)
	local getEnts = breakobjects or dodamage

	for k,v in pairs(points) do

		local ents = nil
		if getEnts then
			ents = TheSim:FindEntities(v.x, v.y, v.z, self.range, self.tags, self.noTags)
		end
		if ents and breakobjects then

		    for k2,v2 in pairs(ents) do
		        if v2 and self.burner and v2.components.burnable and not v2:HasTag("fire") and not v2:HasTag("burnt") then
		        	v2.components.burnable:Ignite()
		        end

		        if v2 and self.destroyer and v2.components.workable and v2.components.workable.workleft > 0 and v2.components.workable.action ~= ACTIONS.NET then
	        	    v2.components.workable:Destroy(self.inst)
			end
		        if v2 and self.destroyer and v2.components.crop then
			    	print("Has Crop:",v2)
	        	    v2.components.crop:ForceHarvest()
				end
		    end
		end
		if ents and dodamage then
		    for k2,v2 in pairs(ents) do
		    	if not self.ignoreEnts then 
		    		self.ignoreEnts = {}
		    	end 
		    	if not self.ignoreEnts[v2.GUID] then

			        if v2 and v2.components.health and not v2.components.health:IsDead() and 
			        self.inst.components.combat:CanTarget(v2) then
			            self.inst.components.combat:DoAttack(v2, nil, nil, nil, self.groundpounddamagemult)
			        end
			        self.ignoreEnts[v2.GUID] = true
			    end 
		    end
		end

		local map = GetMap()
		if map then
			local ground = map:GetTileAtPoint(v.x, 0, v.z)

			if ground == GROUND.IMPASSABLE or map:IsWater(ground) then

			else
				if self.groundpoundfx then 

					WARGON.make_fx2(self.groundpoundfx, v)
				end 
			end
		end
		
	end
end

function TpGroundPounder:GroundPound(pt)
	local pt = pt or self.inst:GetPosition()
	local ground = GetMap():GetTileAtPoint(pt.x, 0, pt.z)

	if self.groundpoundringfx and not GetMap():IsWater(ground) then 

		local ring = WARGON.make_fx2(self.groundpoundringfx, pt)
		ring.Transform:SetScale(self.ring_fx_scale, self.ring_fx_scale, self.ring_fx_scale)

	end 
	local points = self:GetPoints(pt)
	local delay = 0
	self.ignoreEnts = nil 
	for i = 1, self.numRings do
		self.inst:DoTaskInTime(delay, function() 
			self:DestroyPoints(points[i], i <= self.destructionRings, i <= self.damageRings)
			if i == self.numRings and self.onfinished then
				self.onfinished(self.inst)
			end
		end)

		delay = delay + self.ringDelay
	end
end

return TpGroundPounder
