local TpHatBall = Class(function(self, inst)
	self.inst = inst
	self.pet = nil
end)

function TpHatBall:Trigger(giver)
	local inst = self.inst
	local guy = WARGON.find(inst, 2, nil, {"tp_strawhat_target"})

	if guy then

		self:Bind(guy)

	end
end

function TpHatBall:Bind(guy)
	self.pet = guy
	self.inst:AddChild(guy)
	guy:set_pos(0, 0, 0)
	guy.Transform:SetRotation(0)
	guy:RemoveFromScene()
	if guy.components.brain then
		BrainManager:Hibernate(guy)
	end
	if guy.SoundEmitter then
		guy.SoundEmitter:KillAllSounds()
	end
	self.inst:PushEvent("tp_capture", {guy=guy})
	guy:PushEvent("tp_captured")
	self.inst:RemoveComponent("equippable")
end

function TpHatBall:Release(giver)
	if self.pet then
		local inst = self.inst
		local guy = self.pet
		self.inst:RemoveChild(guy)
		guy:ReturnToScene()
		local pos = self.inst:GetPosition()
		local owner = self.inst.components.inventoryitem:GetGrandOwner() 
		if owner then
			pos = owner:GetPosition()
		end
		guy:set_pos(pos:Get())
		if guy.components.brain then
			BrainManager:Wake(guy)
		end
		if not guy.components.health:IsDead() then
			guy.sg:GoToState("idle")
		end
		if guy:HasTag("tp_strawhat_perd") then



			guy.tp_perd = true
			guy:SetBrain(require "brains/tp_perd_brain")
			guy.AnimState:Show("HAT")
			guy.AnimState:OverrideSymbol("swap_hat", "hat_straw", "swap_hat")
		elseif guy:HasTag("tp_strawhat_beefalo") then


			guy.components.domesticatable:DeltaObedience(1)
			guy.components.domesticatable:DeltaDomestication(1)
	        GetPlayer():PushEvent("saddle", { target = guy })

	        local item = SpawnPrefab("tp_strawhat_3")
	        guy.components.rideable:SetSaddle(GetPlayer(), item)
		elseif guy:HasTag("canbetrapped") and guy:HasTag("smallcreature") then

			local trap = WARGON.make_spawn(guy, "tp_strawhat_4")
			trap.components.trap:Set()
		else

			local item = SpawnPrefab("strawhat")
			local percent = inst.components.finiteuses:GetPercent()
			item.components.fueled:SetPercent(percent)
			local current = guy.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
			if current then
				guy.components.inventory:DropItem(current)
			end
			guy.components.inventory:Equip(item)
			guy.AnimState:Show('hat')
			if giver and giver.components.leader then
				guy.SoundEmitter:PlaySound("dontstarve/common/makeFriend")
				giver.components.leader:AddFollower(guy)
				guy.components.follower:AddLoyaltyTime(30 * 16)
			end
		end
		self.pet = nil
		self.inst:PushEvent("tp_release", {guy=guy})
		guy:PushEvent("tp_released")
	end
end

function TpHatBall:OnSave()
	local data = {}
	if self.pet then
		data.pet = self.pet:GetSaveRecord()
	end
	return data
end

function TpHatBall:OnLoad(data)
	if data and data.pet then

		local pet = SpawnSaveRecord(data.pet)
		self:Bind(pet)
	end
end

function TpHatBall:OnRemoveEntity()
	if self.pet then
		self:Release()
	end
end

return TpHatBall
