local attr_tbl = {
	health = -50,
	sanity = -50,
	hunger = -50,
	damage = -.1,

	speed = 0,
	eater  = .9,
	hungry = .1,
	absorb = -.1,
	horror = .1,
	nature = 1.1,
	forge  = 0,
	madval = 100,
	attack_period = 0,
	lucky  = 0,

	fixup = 0,
	good_stomach = 0,
	antivenom = 0,
	brave_nightmare = 0,
}

local TpLevel = Class(function(self, inst)
	self.inst = inst
	self.level = 1
	self.max = 10
	self.exp = 0
	self.gifted = false
	self.gifted2 = false
	self.gifted3 = false

	self.cur_lv = 0
	self.attr = attr_tbl
	self.inited = nil
end)


function TpLevel:Init()
	if not self.inited then
		self.inited = true
		self:Apply()
	end
end

function TpLevel:Apply(not_load, old_save)
	local inst = self.inst
	if self.attr.health then
		print("TpLevel", 1)


		inst.components.health:AddMaxHealthModifier("tplevel", self.attr.health)




		if not_load then
			print("TpLevel", 3)
			inst.components.health:SetPercent(1)
		end

	end
	if self.attr.hunger then





		inst.components.hunger:AddMaxHungerModifier("tplevel", self.attr.hunger)
		if not_load then
			inst.components.hunger:SetPercent(1)
		end

	end
	if self.attr.sanity then





		inst.components.sanity:AddMaxSanityModifier("tplevel", self.attr.sanity)
		if not_load then
			inst.components.sanity:SetPercent(1)
		end

	end
	if self.attr.damage then

		inst.components.combat:AddDamageModifier("tplevel", self.attr.damage)
	end
	if self.attr.speed then

		inst.components.locomotor:AddSpeedModifier_Mult("tplevel", self.attr.speed)
		if old_save then
			WARGON.do_task(self.inst, 0, function()

				inst.components.locomotor:AddSpeedModifier_Mult("tplevel", self.attr.speed)
			end)
		end	
	end
	if self.attr.eater then

		local rate = self.attr.eater
		inst.components.eater:SetAbsorptionModifiers(rate, rate, rate)
	end
	if self.attr.hungry then

		inst.components.hunger:AddBurnRateModifier("tplevel", self.attr.hungry)
	end
	if self.attr.horror then





		inst.components.sanity:AddRateModifier("tplevel", self.attr.horror)
	end
	if self.attr.forge then

	end
	if self.attr.madval then

		if inst.components.tpmadvalue then
			inst.components.tpmadvalue:SetMax(self.attr.madval)
		end
	end
	if self.attr.attack_period then
		local rate = -self.attr.attack_period/100
		inst.components.combat:AddPeriodModifier("tplevel", rate)





	end
	if self.attr.absorb then

		inst.components.combat:AddAbsorbModifier("tplevel", self.attr.absorb)
	end
	if inst.components.tpbody then





		if self.attr.nature then


			inst.components.tpbody.fire = self.attr.nature
			inst.components.health.poison_damage_scale = self.attr.nature
			inst.components.health.gas_damage_scale = self.attr.nature
		end
		if self.attr.lucky then
			inst.components.tpbody.lucky = self.attr.lucky
		end
	end
	if self.attr.beard then
		inst.components.beard.insulation_factor = self.attr.beard
	end
	if self.attr.fixup then
	end
	if self.attr.good_stomach and self.attr.good_stomach>0 then
		self.inst:AddTag("tp_good_stomach")
	end
	if self.attr.antivenom and self.attr.antivenom>0 then
		self.inst:AddTag("tp_not_extra_poison")
	end
	if self.attr.brave_nightmare and self.attr.brave_nightmare>0 then
		self.inst:AddTag("tp_brave_nightmare")
	end
end

function TpLevel:GetLevel()
	return self.cur_lv
end

function TpLevel:LevelUp(level)
	self.cur_lv = self.cur_lv+level
end

function TpLevel:OnSave()
	return {
		level = self.level, 
		exp = self.exp, 
		gifted2 = self.gifted2,
		gifted3 = self.gifted3,
		cur_lv = self.cur_lv,
		attr = self.attr,
		inited = self.inited,
	}
end

function TpLevel:OnLoad(data)
	if data then
		self.cur_lv = data.cur_lv or 0
		self.inited = data.inited
		local old_save = false
		if data.attr == nil then
			old_save = true
		end

		for k, v in pairs(data.attr) do
			self.attr[k] = v
		end
		self:Apply(nil, old_save)
	end
end

function TpLevel:GetEssence()
	return self.inst.components.inventory:Count("tp_epic")
end

return TpLevel