local TpMagicTool = Class(function(self, inst)
	self.inst = inst
	self.level = 1
	self.exp = 0
	self.action = nil
end)

function TpMagicTool:ExpDelta(dt)

	self.exp = self.exp + dt
	if self.exp >= 20 then
		self.exp = 0
		self:LevelUp()
	end
end

function TpMagicTool:LevelUp()

	self.level = math.min(15, self.level + 1)
	self:Set()
end

function TpMagicTool:Set()
	self.inst.components.tool:SetAction(self.action, self.level)
	if self.level > 5 then
		if self.anim then
			self.inst.AnimState:SetBank(self.anim[1])
			self.inst.AnimState:SetBuild(self.anim[2])
		end
		if self.img then
			local atlas, img = WARGON.resolve_img_path(self.img)
			img = string.sub(img, 1, -5)
			self.inst.components.inventoryitem.atlasname = atlas
			self.inst.components.inventoryitem:ChangeImageName(img)
		end
		if self.inst.components.equippable:IsEquipped() then
			local owner = self.inst.components.equippable.owner
			if owner then
				WARGON.EQUIP.object_on(owner, self.inst.swap_build2, self.inst.swap_symbol2)
			end
		end
	end
end

function TpMagicTool:OnSave()
	return {
		level = self.level,
		exp = self.exp,
	}
end

function TpMagicTool:OnLoad(data)
	if data then
		self.level = data.level or 1
		self.exp = data.exp or 0
		self:Set()
	end
end

function TpMagicTool:GetWargonString()
	local s = string.format("魔法工具:等级%d,经验%d", self.level, self.exp)
	return s
end

return TpMagicTool