
local Melter = require "components/melter"

local TpMelter = Class(Melter, function(self, inst)
	Melter._ctor(self, inst)
	self.spoiledproduct = "tp_spear_mix"
    self.min_num_for_cook = 3
    self.max_num_for_cook = 3
end)





    






    
























local function dostew(inst)
	local stewercmp = inst.components.tpmelter
	stewercmp.task = nil
	
	if stewercmp.ondonecooking then
		stewercmp.ondonecooking(inst)
	end














	stewercmp.done = true
	stewercmp.cooking = nil
end













function TpMelter:CanCook()
	local num = 0
	for k,v in pairs (self.inst.components.container.slots) do
		num = num + 1 
	end
	return num >= self.min_num_for_cook and num <= self.max_num_for_cook
		and self.product == nil
end


function TpMelter:StartCooking()
	if not self.done and not self.cooking then
		if self.inst.components.container then
		
			self.done = nil
			self.cooking = true
			
			if self.onstartcooking then
				self.onstartcooking(self.inst)
			end
		
			

			local spoilage_total = 0
			local spoilage_n = 0
























			self.product = "tp_spear_mix"
			local cooktime = 0.2
			self.productcooker = self.inst.prefab
			
			local grow_time = TUNING.BASE_COOK_TIME * cooktime
			self.targettime = GetTime() + grow_time
			self.task = self.inst:DoTaskInTime(grow_time, dostew, "stew")

			self.inst.components.container:Close()

			self.inst.components.container.canbeopened = false
		end
		
	end
end



























function TpMelter:OnLoad(data)

    if data.cooking then
		self.product = data.product
		self.productcooker = data.productcooker or (self.cookername or self.inst.prefab)
		if self.oncontinuecooking then
			local time = data.time or 1
			self.product_spoilage = data.product_spoilage or 1
			self.oncontinuecooking(self.inst)
			self.cooking = true
			self.targettime = GetTime() + time
			self.task = self.inst:DoTaskInTime(time, dostew, "stew")
			
			if self.inst.components.container then		
				self.inst.components.container.canbeopened = false
			end
			
		end
    elseif data.done then
		self.product_spoilage = data.product_spoilage or 1
		self.done = true
		self.targettime = data.timesincefinish
		self.product = data.product
		self.productcooker = data.productcooker or (self.cookername or self.inst.prefab)
		if self.oncontinuedone then
			self.oncontinuedone(self.inst)
		end
		self.spoiltargettime = data.spoiltime and GetTime() + data.spoiltime or nil
		if self.spoiltargettime then





		end
		if self.inst.components.container then		
			self.inst.components.container.canbeopened = false
		end
		
    end
end



    










    



    



    








































function TpMelter:Harvest( harvester )
	print("HERE?")
	if self.done then
		if self.onharvest then
			self.onharvest(self.inst)
		end
		self.done = nil
		if self.product then
			if harvester and harvester.components.inventory then
				local loot = nil
				loot = SpawnPrefab("tp_spear_mix")
				local ings = {}
				for k,v in pairs(self.inst.components.container.slots) do
					local insert = true
					for k1, v1 in pairs(ings) do
						if v1 == v.prefab then
							insert = false
							break
						end
					end
					if insert then
						table.insert(ings, v.prefab)
					end
				end	
				self.inst.components.container:DestroyContents()
				if loot.components.tpmixweapon then
					loot.components.tpmixweapon:SetWeapons(ings)
				end













				if loot then  
					harvester.components.inventory:GiveItem(loot, nil, Vector3(TheSim:GetScreenPos(self.inst.Transform:GetWorldPosition())))
				end
			end
			self.product = nil
			self.spoiltargettime = nil

			if self.spoiltask then 
				self.spoiltask:Cancel()
				self.spoiltask = nil
			end
		end
		
		if self.inst.components.container and not self.inst:HasTag("flooded") then		
			self.inst.components.container.canbeopened = true
		end
		
		return true
	end
end

function TpMelter:LongUpdate(dt)
    if not self.paused and self.targettime ~= nil then
		if self.task ~= nil then
			self.task:Cancel()
			self.task = nil
		end

        self.targettime = self.targettime - dt

        if self.cooking then
            local time_to_wait = self.targettime - GetTime()
            if time_to_wait < 0 then
                dostew(self.inst)
            else
                self.task = self.inst:DoTaskInTime(time_to_wait, dostew, "stew")
            end
        end
    end












end

return TpMelter
