local TpPowerBoss = Class(function(self, inst)
	self.inst = inst
	self.power = nil
	self.stack = 1
	self.tasks = {}
	inst:ListenForEvent("attacked", function(inst, data)
		if self.power == "snow" then
			self:SpawnSnow()
		end
	end)
	inst:ListenForEvent("firedamage", function(inst, data)
		if self.power == "snow" then
			self:SpawnSnow()
		end
	end)










end)

local powers = {
	"snow",
	"tornado",
	"fire",
	"ground",
	"shadow",
	"hurricane",
	"tsunami",

	"war",
}

local fns = {
snow = function(inst, cmp)
	cmp:SpawnSnow()
end,
tornado = function(inst, cmp)
	cmp:SpawnTornado()
end,
fire = function(inst, cmp)
	cmp:SpawnFire()
end,
ground = function(inst, cmp)
	cmp:SpawnGround()
end,
shadow = function(inst, cmp)
	cmp:SpawnShadow()
end,
hurricane = function(inst, cmp)
	cmp:SpawnHurricane()
end,
tsunami = function(inst, cmp)
	cmp:SpawnTsunami()
end,
war = function(inst, cmp)
	cmp:SpawnWar()
end,
}

function TpPowerBoss:GetName()
	if self.power then
		return STRINGS.TP_STR.tp_boss_power[self.power]
	end
end

function TpPowerBoss:Random()
	self:SetPower( powers[math.random(#powers)] )
end

function TpPowerBoss:SetPower(power)
	if self.power == nil then
		self.power = power
	end
	if self.power == "snow" then
		self.inst:AddTag("tp_snow_power")
	end
	if self.power == "fire" then
		self.inst:AddTag("tp_not_fire_damage")
		self.inst:AddTag("tp_fire_power")
		self.inst:AddTag("groundpoundimmune")
	end
	if self.power == "ground" then
		self.inst:AddTag("groundpoundimmune")
	end
	if self.power == "tornado" then
		self.inst:AddTag("tp_tornado_power")
	end
	if self.power == "hurricane" then
		self.inst:AddTag("tp_tornado_power")
		self.inst:ListenForEvent("newcombattarget", function()
			if self.tasks["hurricane"] == nil then
				self.tasks["hurricane"] = self.inst:per_task(5, function()
					self:UsePower()
				end)
			end
		end)
		self.inst:ListenForEvent("losttarget", function()
			if self.tasks["hurricane"] then
				self.tasks["hurricane"]:Cancel()
				self.tasks["hurricane"] = nil
			end
		end)
	end
	if self.power == "shadow" then
		self.inst:AddTag("tp_shadow_power")
	end
	if self.power == "tsunami" then
		self.inst:AddTag("tp_tsunami_power")
		if self.tasks["tsunami"] == nil then
			self.tasks["tsunami"] = self.inst:per_task(.5, function()
				if self.inst.sg and self.inst.sg:HasStateTag("moving") then
					self:UsePower()
				end
			end)
		end
	end
	if self.power == "war" then
		self.inst:ListenForEvent("newcombattarget", function()
			if self.tasks["war"] == nil then
				self.tasks["war"] = self.inst:per_task(1, function()
					self:UsePower()
				end)
			end
		end)
		self.inst:ListenForEvent("losttarget", function()
			if self.tasks["war"] then
				self.tasks["war"]:Cancel()
				self.tasks["war"] = nil
			end
		end)
	end
end

function TpPowerBoss:IsSeasonBoss()
	local names = {
		"deerclops",
		"moose",
		"dragonfly",
		"bearger",

	}
	for k, v in pairs(names) do
		if self.inst.prefab == v then
			return true
		end
	end
	return false
end

function TpPowerBoss:SpawnSnow()
	print("TpPowerBoss snow")
	if self.task == nil then
		self.task = self.inst:per_task(.2, function()

			WARGON.make_fx2("snow_ball_shoot", self.inst)
		end)
		self.inst:do_task(2, function()
			if self.task then
				self.task:Cancel()
				self.task = nil
			end
		end)
	end
end

function TpPowerBoss:SpawnFire()
	print("TpPowerBoss fire")
	local delay = 0.0
	local inst = self.inst
    for i = 1, 6 do
        inst:DoTaskInTime(delay, function(inst)
            local target = inst.components.combat.target or inst
            local pos = Vector3(target.Transform:GetWorldPosition())
            local x, y, z = TUNING.VOLCANOBOOK_FIRERAIN_RADIUS * UnitRand() + pos.x, pos.y, TUNING.VOLCANOBOOK_FIRERAIN_RADIUS * UnitRand() + pos.z
            local firerain = SpawnPrefab("firerain")
            firerain.Transform:SetPosition(x, y, z)
            firerain:StartStep()
        end)
        delay = delay + TUNING.VOLCANOBOOK_FIRERAIN_DELAY
    end
end

local function getspawnlocation(inst, target)
	local tarPos = target:GetPosition()
	local pos = inst:GetPosition()
	local vec = tarPos - pos
	vec = vec:Normalize()
	local dist = pos:Dist(tarPos)
	return pos + (vec * (dist * .15))
end

function TpPowerBoss:SpawnTornado()
	print("TpPowerBoss tornado")
	local inst = self.inst
	local target = inst.components.combat.target
	if target then
	    if target.components.inventory then
	        target.components.inventory:DropEverything()
	    end
	    local tornado = SpawnPrefab("tornado")
	    tornado.WINDSTAFF_CASTER = inst
	    local totalRadius = target.Physics and target.Physics:GetRadius() or 0.5 + tornado.Physics:GetRadius() + 0.5
	    local targetPos = target:GetPosition() + (TheCamera:GetDownVec() * totalRadius)
	    tornado.Transform:SetPosition(getspawnlocation(inst, target):Get())
	    tornado.components.knownlocations:RememberLocation("target", targetPos)
	end
end

function TpPowerBoss:SpawnGround()
	print("TpPowerBoss ground")
	local inst = self.inst
    local fx = WARGON.make_fx2("bearger_line", inst)
    fx.master = inst
    local rot = inst.Transform:GetRotation()
    fx.Transform:SetRotation(rot)




end

function TpPowerBoss:SpawnShadow()
	print("TpPowerBoss shadow")
	local fx = WARGON.make_fx2("minotaur_shadow_spawner", self.inst, {owner=self.inst})




end

function TpPowerBoss:SpawnHurricane()
	print("TpPowerBoss Hurricane")
	local inst = self.inst
	local target = inst.components.combat.target
	if target then
	    local tornado = SpawnPrefab("tornado")
	    tornado.WINDSTAFF_CASTER = inst
	    local totalRadius = target.Physics and target.Physics:GetRadius() or 0.5 + tornado.Physics:GetRadius() + 0.5
	    local targetPos = target:GetPosition() + (TheCamera:GetDownVec() * totalRadius)
	    tornado.Transform:SetPosition(getspawnlocation(inst, target):Get())
	    tornado.components.knownlocations:RememberLocation("target", targetPos)
	end
end

function TpPowerBoss:SpawnTsunami()
	print("TpPowerBoss Tsunami")
	WARGON.make_fx2("tigershark_wave_maker", self.inst, {owner=self.inst})
end

function TpPowerBoss:SpawnWar()
	print("TpPowerBoss War")
	if self.inst:HasTag("tp_ancient_hulk_buff")
	and not self.inst:HasTag("tp_ancient_hulk_recharging") then
		WARGON.make_fx2("ancient_hulk_bullet", self.inst, {owner=self.inst})
	end
end

function TpPowerBoss:UsePower()
	local fn = fns[self.power]
	if fn then
		fn(self.inst, self)
	end















end

return TpPowerBoss