local Data = WARGON.DATA.tp_data_power_fruit

local TpPowerFruit = Class(function(self, inst)
	self.inst = inst
	self.power = nil
	self.quality = 1
	self.rate = .1
	self.limit_day = 0
	self.enable = WARGON.CONFIG.fruit
	self.inst:ListenForEvent("oneaten", function(inst, data)
		if self.enable and data.eater 
		and not data.eater:HasTag("tp_hat_druid")
		and not (data.eater:HasTag("tp_potion_holy")
		and self:GetQuality() <=0 ) then
			self:Eaten(data.eater)
		end
	end)
end)



local rates = {.1, .15, .2, .25}

function TpPowerFruit:Set(power)
	self.power = power
	local fruit = Data:GetFruit(self.power)
	print(fruit.quality)
	self.quality = fruit.quality or 1

	self.rate = rates[self.quality]
end

function TpPowerFruit:Random()

	if WARGON.enable_power("fruit") then
		self.power = Data:GetRandomId()
		local fruit = Data:GetFruit(self.power)

		self.quality = fruit.quality or 1

		self.rate = 1
	else
		self.power = "pure"
	end
end

function TpPowerFruit:GetName()
	return self.power and Data:GetName(self.power)
end

function TpPowerFruit:IsDelicacy()
	return self.power == "delicacy"

end
function TpPowerFruit:IsTerriable()
	return self.power == "terriable"
end

function TpPowerFruit:IsFresh()
	return self.power == "fresh"
end

function TpPowerFruit:IsForever()
	return self.quality == 4



end

function TpPowerFruit:IsPerish()
	return self.power == "perish"
end

function TpPowerFruit:GetQuality()
	local fruit = Data:GetFruit(self.power)
	if fruit.bad then
		return 0
	elseif fruit.element then
		return 4
	else
		return self.quality
	end
end

function TpPowerFruit:Eaten(eater)
	local inst = self.inst
	if self.power then
		local fruit = Data:GetFruit(self.power)
		if fruit.fn then
			fruit.fn(self, eater)
		end
	end
end

function TpPowerFruit:OnSave()
	return {
		power = self.power,

	}
end

function TpPowerFruit:OnLoad(data)
	if data then
		local power = data.power or 1

		self:Set(power)
	end
end

function TpPowerFruit:GetWargonString()
	local str = string.format("fruit:%s, quality:%s", self.power, self.quality)
	return str
end

return TpPowerFruit