local TpPowerManager = Class(function(self, inst)
    self.inst = inst
    self.power = {
        element = false,
        equip = false,
        tree = false,
        fruit = false,
    }




    self.inst:ListenForEvent("daytime", function()
        local interval = 20
        local day = WARGON.get_days() or 0
        if WARGON.CONFIG.diff == "easy" then
            day = day - 60
        elseif WARGON.CONFIG.diff == "hard" then
            interval = 10
        end
        if day/interval >= self:GetPowerNumber() then
            self:RandomEnablePower()
        end
    end)
    inst:do_task(0, function()
        if not self.inited then
            self.inited = true
            if WARGON.CONFIG.diff == "normal" then
                self:RandomEnablePower()
            elseif WARGON.CONFIG.diff == "hard" then
                self:RandomEnablePower()
                self:RandomEnablePower()


            elseif WARGON.CONFIG.diff == "dead" then
                self:RandomEnablePower()
                self:RandomEnablePower()
                self:RandomEnablePower()
                self:RandomEnablePower()
            end
        end
    end)
end)

function TpPowerManager:GetPowerNumber()
    local number = 0
    for k, v in pairs(self.power) do
        if v then
            number = number + 1
        end
    end
    return number
end

function TpPowerManager:RandomEnablePower()
    local kinds = {}
    local config = WARGON.CONFIG.first_power
    for k, v in pairs(self.power) do
        if not v then
            table.insert(kinds, k)
        elseif k == config then
            config = nil
        end
    end
    local n = #kinds
    if n > 0 then

        local kind = kinds[math.random(n)]
        if config then
            kind = config
        end
        self:EnablePower(kind)
    end
end

function TpPowerManager:EnablePower(kind)








    print("enable power "..kind)
    self.power[kind] = true
end

function TpPowerManager:IsEnablePower(kind)
    return self.power[kind]
end

function TpPowerManager:DisablePower(kind)
    self.power[kind] = false
end

function TpPowerManager:DisableAllPower()
    for k, v in pairs(self.power) do
        self.power[k] = false
    end
end

function TpPowerManager:OnSave()

    local data = {power={}}
    for k, v in pairs(self.power) do
        data.power[k] = v
    end
    data.inited = true


    return data
end

function TpPowerManager:OnLoad(data)
    if data then
        self.inited = data.inited


        for k, v in pairs(data.power or {}) do
            self.power[k] = v
        end
    end
end

function TpPowerManager:GetWargonString()
    local str = ""
    for k, v in pairs(self.power) do
        if v then
            str = str.."\n"..k
        end
    end
    return str
end

return TpPowerManager