local Data = WARGON.DATA.tp_data_power_new_normal
local Data2 = WARGON.DATA.tp_data_power_new
local equips = WARGON.DATA.tp_data_power_new_ids





local TpPowerNew = Class(function(self, inst)
	self.inst = inst
	self.power = nil
	self.sec_power = nil
	self.equip = nil
	self.sec_equip = nil
	self.limit_day = 0
	self.enable = WARGON.CONFIG.equip
	if self.enable then
		self.inst:ListenForEvent("onhitother", function(inst, data)
			if data and data.target and data.damage then
				self:Attack(self.inst, data.target, data.damage, data.stimuli)
			end
		end)
		self.inst:ListenForEvent("attacked", function(inst, data)
			if data and data.attacker and data.damage then
				self:Hit(self.inst, data.attacker, data.damage, data.weapon, data.stimuli)
			end
		end)
		self.inst:ListenForEvent("newcombattarget", function(inst, data)
			if data and data.target then
				self:NewTarget(self.inst, data.target)
			end
		end)
		self.inst:do_task(0, function()
			self:Passive(self.inst)
		end)
	end
	self.inst:ListenForEvent("death", function(inst, data)
		if WARGON.enable_power("equip") then
			local drop = false
			if (self.inst.components.health
			and self.inst.components.health:GetMaxHealth()>=250
			and math.random()<.33) or math.random()<.1 then
				drop = true
			end
			if drop then
				local gift = "tp_coin"
				local n = math.random()
				if n < .01 then
					gift = "tp_coin100"
				elseif n < .1 then
					gift = "tp_coin10"
				end
				local loot = SpawnPrefab(gift)
				if loot then
					WARGON.throw_item(self.inst, loot)
				end
			end
		end
	end)
end)

function TpPowerNew:Random()

	if WARGON.enable_power("equip") then
		self.power = Data[math.random(#Data)].id



	else
		self.power = "pure"
	end
	self.equip = equips[self.power]

end

function TpPowerNew:RandomTwo()
	local n = math.random(#Data)

	if WARGON.enable_power("equip") then
		self.power = Data[n].id
	else
		self.power = "pure"
	end
	local m = math.random(#Data2)

	if WARGON.enable_power("equip") then
		if m == n then
			m = m + 1
			if m > #Data2 then
				m = 1
			end
		end
		self.sec_power = Data2[m].id
	else
		self.sec_power = "pure"
	end
	self.equip = equips[self.power]
	self.sec_equip = equips[self.sec_power]
end

function TpPowerNew:SetPower(power)
	self.power = power
	self.equip = equips[self.power]
end

function TpPowerNew:GetName()
	local name = nil
	if self.power then
		name = equips[self.power].name
	end
	if self.sec_power then
		name = name.."\n"..equips[self.sec_power].name
	end
	return name

end

function TpPowerNew:Passive(inst)

	local equip = equips[self.power]
	local sec_equip = equips[self.sec_power]
	if equip then

		if not self.inited then

			self.inited = true
			local max_hp = inst.components.health.maxhealth 
			if equip.hp then
				max_hp = max_hp + equip.hp
				self.inst.components.health.equip_hp = equip.hp
			end
			if sec_equip and sec_equip.hp then
				max_hp = max_hp + sec_equip.hp
				self.inst.components.health.sec_equip_hp = sec_equip.hp
			end

			inst.components.health.maxhealth = max_hp
			inst.components.health:SetPercent(1)
		end
		if equip.armor then

			inst.components.health:AddAbsorbModifier("tp_power_new", equip.armor)
		end
		if equip.pass then
			equip.pass(inst)
		end
	end

	if sec_equip then
		if sec_equip and sec_equip.armor then
			inst.components.health:AddAbsorbModifier("tp_power_new_sec", sec_equip.armor)
		end
		if sec_equip and sec_equip.pass then
			sec_equip.pass(inst)
		end
	end
end

function TpPowerNew:Hit(inst, attacker, damage, weapon, stimuli)

	local equip = equips[self.power]
	if equip and equip.hit then
		equip.hit(inst, attacker, damage, weapon, stimuli)
	end
	local sec_equip = equips[self.sec_power]
	if sec_equip and sec_equip.hit then
		sec_equip.hit(inst, attacker, damage, weapon, stimuli)
	end
end

function TpPowerNew:Attack(inst, target, damage, stimuli)

	local equip = equips[self.power]
	if equip and equip.atk then
		equip.atk(inst, target, damage, stimuli)
	end
	local sec_equip = equips[self.sec_power]
	if sec_equip and sec_equip.atk then
		sec_equip.atk(inst, target, damage, stimuli)
	end
end

function TpPowerNew:NewTarget(inst, target)
	local equip = equips[self.power]
	if equip and equip.new then
		equip.new(inst, target)
	end
	local sec_equip = equips[self.sec_power]
	if sec_equip and sec_equip.new then
		sec_equip.new(inst, target)
	end
end

function TpPowerNew:OnSave()
	return {
		power = self.power,
		sec_power = self.sec_power,
		inited = self.inited,
	}
end

function TpPowerNew:OnLoad(data)
	if data then
		if data.power then
			self.power = data.power
		end
		if data.sec_power then
			self.sec_power = data.sec_power
		end
		self.inited = data.inited
	end
end

return TpPowerNew