local elves = WARGON.DATA.tp_data_power_tree
local ids = WARGON.DATA.tp_data_power_tree_ids

local TpPowerTree = Class(function(self, inst)
	self.inst = inst
	self.power = nil
	self.limit_day = 0
	self.enable = WARGON.CONFIG.elf
	if self.enable then
		inst:ListenForEvent("worked", function(inst, data)
			self:Work(data.worker, data.workleft)
		end)



		inst:do_task(0, function()
			self:Passive()
		end)
	end
end)

function TpPowerTree:Random()

	if WARGON.enable_power("tree") then
		local power = elves[math.random(#elves)].id
		self:SetPower(power)
	else
		self:SetPower("pure")
	end
end

function TpPowerTree:SetPower(power)
	self.power = power
end

function TpPowerTree:GetName()
	local name = ids[self.power].name
	return name
end

function TpPowerTree:Work(worker, left)
	if not self.inst:HasTag("stump") 
	and not self.inst.monster


	and worker and not worker:HasTag("tp_magic_tool_owner")
	and not worker:HasTag("tp_pig_worker")
	and not worker:HasTag("epic")
	then
		local elf = ids[self.power]
		if elf then
			if elf.work then
				elf.work(self.inst, worker, left)
			end
			if left <= 0 then
				if elf.finish then
					elf.finish(self.inst, worker)
				end
			end
		end
	end
end

function TpPowerTree:Finish()
	if not self.inst:HasTag("stump") 


	then
		local elf = ids[self.power]
		if elf then
			if elf.finish then
				elf.finish(self.inst)
			end
		end
	end
end

function TpPowerTree:Passive()
	if not self.inst:HasTag("stump") 


	then
		local elf = ids[self.power]
		if elf then
			if elf.pass then
				elf.pass(self.inst)
			end
		end
	end
end

function TpPowerTree:OnSave()
	return {
		power = self.power,
	}
end

function TpPowerTree:OnLoad(data)
	if data then
		if data.power then
			self:SetPower(data.power)
		end
	end
end

return TpPowerTree