local function creatInterior(inst, name)
    print("TpRoomDrivable", 2)

    if not inst.components.tproomdrivable.have then


        local interior_spawner = GetWorld().components.interiorspawner














        local palaceID = interior_spawner:GetNewID()

        local depth = 18
        local width = 26        

        local exterior_door_def =
        {
            my_door_id = name..palaceID.."_door",
            target_door_id = name..palaceID.."_exit",
            target_interior = palaceID
        }

        interior_spawner:AddDoor(inst, exterior_door_def)



        local addprops = {}

        local floortexture = "levels/textures/noise_woodfloor.tex"
        local walltexture = "levels/textures/interiors/shop_wall_woodwall.tex"
        local minimaptexture = "levels/textures/map_interior/mini_ruins_slab.tex"
        local colorcube = "images/colour_cubes/pigshop_interior_cc.tex"

        addprops = {
            { name = "prop_door", x_offset = 5, z_offset = 0, animdata = {bank ="pig_shop_doormats", build ="pig_shop_doormats", anim="idle_old", background=true}, 
                my_door_id = exterior_door_def.target_door_id, target_door_id = exterior_door_def.my_door_id, addtags={"guard_entrance", "ship_door"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "deco_roomglow", x_offset = 0, z_offset = 0 }, 

            { name = "shelves_cinderblocks",      x_offset = -4.5, z_offset = -15/3.5, rotation= -90, addtags={"playercrafted"} },
            { name = "deco_antiquities_wallfish", x_offset = -5,   z_offset =  3.9,    rotation = 90, addtags={"playercrafted"} },

            { name = "deco_antiquities_cornerbeam",  x_offset = -5,  z_offset =  -15/2, rotation =  90, flip=true, addtags={"playercrafted"} },
            { name = "deco_antiquities_cornerbeam",  x_offset = -5,  z_offset =   15/2, rotation =  90,            addtags={"playercrafted"} },
            { name = "deco_antiquities_cornerbeam2", x_offset = 4.7, z_offset =  -15/2, rotation =  90, flip=true, addtags={"playercrafted"} },
            { name = "deco_antiquities_cornerbeam2", x_offset = 4.7, z_offset =   15/2, rotation =  90,            addtags={"playercrafted"} },
            { name = "swinging_light_rope_1",        x_offset = -2,  z_offset =  0,     rotation = -90,            addtags={"playercrafted"} },

            { name = "charcoal", x_offset = -3, z_offset = -2 },
            { name = "charcoal", x_offset =  2, z_offset =  3 },

            { name = "window_round_curtains_nails", x_offset = 0, z_offset = 15/2, rotation = 90, addtags={"playercrafted"} },
        }










        interior_spawner:CreateRoom("generic_interior", 15, nil, 10, name..palaceID, palaceID, addprops, {}, walltexture, floortexture, minimaptexture, nil, colorcube, nil, nil, "inside", "HOUSE","WOOD")

        inst.interiorID = palaceID

        inst.components.tproomdrivable.have = true
    end
end

local TpRoomDrivable = Class(function(self, inst)
    self.inst = inst
    self.owner = nil
    self.have = nil
    self.inst:AddTag("guard_entrance")
    self.inst:AddComponent("door")
    self.inst.components.door.CollectSceneActions = function()
    end
    self.inst:do_task(0, function()
        print("TpRoomDrivable", 1)
        creatInterior(self.inst, "DriverRoom")
    end)
    self.inst:ListenForEvent("mounted", function(inst, data)
        if data and data.driver then
            if data.driver:HasTag("player") then
                print("TpRoomDrivable",10)
                self.owner = data.driver
            end
        end
    end)
    self.inst:ListenForEvent("dismounted", function(inst, data)
        print("TpRoomDrivable",11)
        self.owner = nil
    end)
end)



function TpRoomDrivable:Use(doer)
    print("TpRoomDrivable", 3)

    if self.owner == doer then
        print("TpRoomDrivable", 4)
        if doer.components.driver.vehicle then

            print("TpRoomDrivable", 5)
            local pos = doer:GetPosition()
            print("TpRoomDrivable", 6)
            doer.components.health:SetInvincible(true, "ship_door")
            doer:AddTag("ship_door")
            doer.components.driver:OnDismount(nil)

            print("TpRoomDrivable", 7)
            self.owner = doer
            print("TpRoomDrivable", 8)
            self.inst.components.door:Activate(doer)
            doer.components.health:SetInvincible(false, "ship_door")
            doer:do_task(.5, function()
                doer:RemoveTag("ship_door")
            end)

        end
    end
end

function TpRoomDrivable:OnSave()
    return {
        have = self.have,
        driving = self.owner and true or false,
    }
end

function TpRoomDrivable:OnLoad(data)
    if data then
        self.have = data.have
        if data.driving then
            self.owner = GetPlayer()
        end
    end
end

return TpRoomDrivable