local Stewer = require "components/stewer"

local product_tbl = {}

local TpStewer = Class(Stewer, function(self, inst)
	Stewer._ctor(self, inst)
	self.spoiledproduct = "ash"

	self.product_tbl = product_tbl
	self.product_size = 1
	self.size = 1
end)

function TpStewer:CalculateRecipe(ings)
	local product = "ash"

	for i, v in pairs(self.product_tbl) do
		product = i
		for i2, v2 in pairs(v) do







			if ings[i2] == nil or ings[i2] < v2 then
				product = "ash"
				break
			end
		end
		if product ~= "ash" then
			return product
		end
	end
	return product
end

function TpStewer:ConsumeRecipe(ings)
	if self.product then
		if self.product == "ash" then
			self.inst.components.container:DestroyContents()
			return 1
		else
			local has_tbl = {}
			local size = 40



			for k, v in pairs(self.inst.components.container.slots) do
				local item_size = 1
				if v.components.stackable then
					item_size = v.components.stackable:StackSize()
				end
				if size > item_size then
					size = item_size
				end
			end

			for k2, v2 in pairs(ings) do
				self.inst.components.container:ConsumeByName(k2, size*v2)
			end

			self.inst.components.container:DropEverything()
			return size







		end
	end
end






    






    
























local function dostew(inst)
	local stewercmp = inst.components.tpstewer
	stewercmp.task = nil
	
	if stewercmp.ondonecooking then
		stewercmp.ondonecooking(inst)
	end













	
	stewercmp.done = true
	stewercmp.cooking = nil
end

function Stewer:SetCookerName(_name)
	self.cookername = _name
end

function Stewer:GetTimeToCook()
	if self.cooking then
		return self.targettime - GetTime()
	end
	return 0
end











function TpStewer:StartCooking()
	if not self.done and not self.cooking then
		if self.inst.components.container then
		
			self.done = nil
			self.cooking = true
			
			if self.onstartcooking then
				self.onstartcooking(self.inst)
			end
		
			

			local spoilage_total = 0
			local spoilage_n = 0
			local ings = {}			
			for k,v in pairs (self.inst.components.container.slots) do
				if ings[v.prefab] == nil then
					ings[v.prefab] = 1
				else
					ings[v.prefab] = ings[v.prefab] + 1
				end







			end





			
			

			local cooktime = 0









				local cooker = self.cookername or self.inst.prefab

				self.product = self:CalculateRecipe(ings)
				self.size =  self:ConsumeRecipe(ings)
				self.productcooker = cooker


			
			local grow_time = TUNING.BASE_COOK_TIME * cooktime
			self.targettime = GetTime() + grow_time
			self.task = self.inst:DoTaskInTime(grow_time, dostew, "stew")

			self.inst.components.container:Close()
			self.inst.components.container:DestroyContents()
			self.inst.components.container.canbeopened = false
		end
		
	end
end

function TpStewer:OnSave()
    local time = GetTime()
    if self.cooking then
		local data = {}
		data.cooking = true
		data.product = self.product
		data.productcooker = self.productcooker

		if self.targettime and self.targettime > time then
			data.time = self.targettime - time
		end
		return data
    elseif self.done then
		local data = {}
		data.product = self.product
		data.productcooker = self.productcooker




		data.timesincefinish = -(GetTime() - (self.targettime or 0))
		data.done = true

		data.size = self.size
		return data		
    end
end

function TpStewer:OnLoad(data)

    if data.cooking then
		self.product = data.product
		self.productcooker = data.productcooker or (self.cookername or self.inst.prefab)
		if self.oncontinuecooking then
			local time = data.time or 0

			self.oncontinuecooking(self.inst)
			self.cooking = true
			self.targettime = GetTime() + time
			self.task = self.inst:DoTaskInTime(time, dostew, "stew")
			
			if self.inst.components.container then		
				self.inst.components.container.canbeopened = false
			end
			
		end
    elseif data.done then

		self.done = true
		self.targettime = data.timesincefinish
		self.product = data.product
		self.productcooker = data.productcooker or (self.cookername or self.inst.prefab)
		if self.oncontinuedone then
			self.oncontinuedone(self.inst)
		end








		if self.inst.components.container then		
			self.inst.components.container.canbeopened = false
		end

		self.size = data.size or 1
    end
end



    










    



    



    








































function TpStewer:Harvest( harvester )
	if self.done then
		if self.onharvest then
			self.onharvest(self.inst)
		end
		self.done = nil
		if self.product then
			if harvester and harvester.components.inventory then
				for i = 1, self.size do
					local loot = nil
					if self.product ~= "ash" then
						loot = SpawnPrefab(self.product)
						if self.product == "tp_alloy"
						or self.product == "tp_alloy_red" then
							if loot.components.stackable then
								loot.components.stackable:SetStackSize(4)
							end




						end





					else
						loot = SpawnPrefab("ash")
					end
					
					if loot then                    








						if loot.components.inventoryitem then
							harvester.components.inventory:GiveItem(loot, nil, Vector3(TheSim:GetScreenPos(self.inst.Transform:GetWorldPosition())))
						elseif self.inst.components.lootdropper then

							self.inst.components.lootdropper:DropLootPrefab(loot)
						end
					end
				end
				self.size = 1
			end
			self.product = nil
			self.spoiltargettime = nil

			if self.spoiltask then 
				self.spoiltask:Cancel()
				self.spoiltask = nil
			end
		end
		
		if self.inst.components.container and not self.inst:HasTag("flooded") then		
			self.inst.components.container.canbeopened = true
		end
		
		return true
	end
end

function TpStewer:LongUpdate(dt)
    if not self.paused and self.targettime ~= nil then
		if self.task ~= nil then
			self.task:Cancel()
			self.task = nil
		end

        self.targettime = self.targettime - dt

        if self.cooking then
            local time_to_wait = self.targettime - GetTime()
            if time_to_wait < 0 then
                dostew(self.inst)
            else
                self.task = self.inst:DoTaskInTime(time_to_wait, dostew, "stew")
            end
        end
    end

	if self.spoiltask ~= nil then
		self.spoiltask:Cancel()
		self.spoiltask = nil
        self.spoiltargettime = self.spoiltargettime - dt
		local time_to_wait = self.spoiltargettime - GetTime()
		if time_to_wait <= 0 then
			dospoil(self.inst)
		else
			self.spoiltask = self.inst:DoTaskInTime(time_to_wait, dospoil)
		end
	end
end

function TpStewer:ResolvePath(img)
	local atlas = "images/inventoryimages"
	if string.find(img, "!") then
		img = string.sub(img, 1, -2)
		if img > "torch" then
			atlas = atlas.."_2"
		end



	else
		atlas = atlas.."/"..img
	end
	return atlas..".xml", img..".tex"
end



return TpStewer