local cores = {
    {"conqueror", "speed", "strength", "gold",},
    {"ice", "poison", "fire", "earth",},
    { "blood", "shadow", "combat", "laevatain"},
}

local cores2 = {
    "strength", "weak", "hunter",
    "thunder", "tornado",
    "loot", "fast",
}

local function do_area_damage(inst, range, dmg, reason, fn)
	local owner = inst.components.inventoryitem.owner
	WARGON.area_dmg(inst, range, owner, dmg, reason, fn)
end

local function do_area_damage2(inst, data)
    local owner = inst.components.inventoryitem.owner
    data.attacker = owner
    WARGON.area_dmg2(inst, data)
end

local function get_attacked(target, owner, dmg, inst)
	if target.components.health and target.components.combat
	and owner.components.combat:CanTarget(target) then
		target.components.combat:GetAttacked(owner, dmg, inst or nil, inst and inst.prefab or nil)
	end
end

local TpSword = Class(function(self, inst)
    self.inst = inst
    self.level = 1
    self.core = {}
    self.core_num = 0

    self.inst:ListenForEvent("tp_owner_killed", function(inst, data)
        self:OnKill(data)
    end)
end)

function TpSword:CanSetCore(item)
    return self.core_num < self.level
end

function TpSword:SetCore(core)
    if self:CanSetCore() then
        self.core[core] = true
        self.core_num = self.core_num + 1
        if core == "fast" then
            self.inst:AddTag("tp_forest_gun")
            self.inst:AddTag("tp_fast_gun")
        end
    end
end

function TpSword:CalculateDamage()
    local dmg = 26+8*self.level
    local owner = self.inst.components.equippable.owner
    if owner then



    end
    if self.core["strength"] then
        local forge = 0
        if owner and owner.components.tplevel then
            forge = owner.components.tplevel.attr.forge
        end
        dmg = dmg + 10 + forge
    end
    return dmg
end

function TpSword:OnKill(data)
    local owner, victim = data.owner, data.victim
    if self.core["gold"] then
        if victim then
            if victim:HasTag("epic") then
                c_give("tp_coin100")
            elseif victim:HasTag("largecreature") then
                c_give("tp_coin10")
            elseif victim:HasTag("monster") then
                c_give("tp_coin")
            end
        end
    end
    if self.core["hunter"] then
        if victim then
            if victim:HasTag("epic") or victim:HasTag("monster") then
                if owner.components.sanity then
                    owner.components.sanity:DoDelta(5)
                end
                if owner.components.health then
                    owner.components.health:DoDelta(5)
                end
                if owner.components.tpbuff then
                    owner.components.tpbuff:AddBuff("tp_core_hunter")
                end
            end
        end
    end
end

function TpSword:OnAttack(owner, target)
    local inst = self.inst
    if self.core["conqueror"] then
        if owner.components.tpbuff and (target:HasTag("monster") 
        or target:HasTag("epic")) then
            owner.components.tpbuff:AddBuff("tp_spear_conqueror")
        end
        if owner:HasTag("tp_spear_conqueror") then
            if owner.components.health then
                owner.components.health:DoDelta(3)
            end
            if owner.components.sanity then
                owner.components.sanity:DoDelta(3)
            end
            get_attacked(target, owner, 3, self.inst)
        end
    end
    if self.core["speed"] then
        if owner.components.tpbuff then
            owner.components.tpbuff:AddBuff("tp_spear_speed")
        end
    end
    if self.core["rose"] then
        if math.random() < .3 then
            local fx = WARGON.make_fx2("bramblefx", target)
			fx.AnimState:SetMultColour(.3, 1, .3, 1)
            fx:ListenForEvent("tp_recycle", function()
                fx.AnimState:SetMultColour(1, 1, 1, 1)
            end)

			do_area_damage2(inst, {
                range=5, dmg=20, reason=inst.prefab, target=target,
            })
        end
    end
    if self.core["ice"] then
        if math.random() < .33 then
            WARGON.frozen_prefab(target)
        end
    end
    if self.core["fire"] then
        if target.components.burnable
        and target.components.burnable:IsBurning() then
            local dmg = self:CalculateDamage()
            get_attacked(target, owner, dmg*.5, inst)
        end
        if math.random() < .66 then
            WARGON.fire_prefab(target)
        end
    end
    if self.core["earth"] then


            local fx = WARGON.make_fx2("groundpound_fx", self.inst)
            fx.Transform:SetScale(.5, .5, .5)
            fx:ListenForEvent("tp_recycle", function()
                fx.Transform:SetScale(1, 1, 1)
            end)
            local fx2 = WARGON.make_fx2("groundpoundring_fx", self.inst)
            fx2.Transform:SetScale(.5, .5, .5)
            fx2:ListenForEvent("tp_recycle", function()
                fx2.Transform:SetScale(1, 1, 1)
            end)


            local ents = inst:wg_finds(3, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "groundpoundimmune", "player"})
            for k,v in pairs(ents) do
                if v and v.components.workable 
                and v.components.workable.workleft > 0 
                and v.components.workable.action ~= ACTIONS.NET then
                    v.components.workable:Destroy(self.inst)
                end
                if v and v.components.crop then
                    v.components.crop:ForceHarvest()
                end
            end
            for k,v in pairs(ents) do
                if owner and v and v ~= target 
                and v.components.health 
                and not v.components.health:IsDead() and 
                owner.components.combat:CanTarget(v) then

                    v.components.combat:GetAttacked(owner, 34, inst, "tp_spear_dream")
                end
            end

    end
    if self.core["thunder"] then

            local new_target = WARGON.find(target, 5, function(guy)
                return WARGON.can_enemy(owner, guy)
                    and guy ~= target
            end)	
            if new_target then
                local proj = WARGON.make_spawn(target, "tp_charge_proj")
                proj.master = owner
                table.insert(proj.no_targets, target)
                proj.components.tpproj:Throw(owner, new_target, owner)
            end



    end
    if self.core["poison"] then
        if math.random() < .66 then
            WARGON.poison_prefab(target)
        end
        if target.components.poisonable:IsPoisoned() then


            target:add_speed_rate(inst.prefab, -.25, 10)
        end
    end
    if self.core["blood"] then
        if owner.components.sanity then
            local p = owner.components.sanity:GetPercent()
            if p >= .05 then
                if owner.components.health
                and owner.components.health:GetPercent() < 1 then
                    local dt = owner.components.sanity:GetMaxSanity()*.05
                    owner.components.sanity:DoDelta(-dt)
                    local dt2 = owner.components.health:GetMaxHealth()*.05
                    owner.components.health:DoDelta(dt2)
                end
            end
        end
    end
    if self.core["shadow"] then
        if target:HasTag("shadowcreature") then
            if owner.components.inventory
            and owner.components.inventory:Has("nightmarefuel", 1) then
                owner.components.inventory:ConsumeByName("nightmarefuel", 1)
                get_attacked(target, owner, 300, inst)
            end
        end
    end
    if self.core["combat"] then
        if owner.components.tpbuff then
            owner.components.tpbuff:AddBuff("tp_spear_combat")
        end
    end
    if self.core["laevatain"] then
        if owner.components.health and target.components.health then
            local dt = owner.components.health:GetMaxHealth()*.05
            local dt2 = target.components.health:GetMaxHealth()*.05
            owner.components.health:DoDelta(-dt)
            target.components.health:DoDelta(-dt2)

            WARGON.make_fx2("tauntfire_fx", target)
            if math.random() < .1 and owner.components.talker then
                owner.components.talker:Say("莱瓦汀")
            end
        end
    end
    if self.core["weak"] then
        target:add_speed_rate("tp_core_weak", -.25)
    end
    if self.core["tornado"] then
        if math.random() < .33 then
            WARGON.spawn_tornado(owner, target)
        end
    end
    if self.core["loot"] then
        if math.random() < .15 then
			if target.components.lootdropper then
				target.components.lootdropper:DropSingleLoot()
			end
		end
    end
end

function TpSword:OnSave()
    local data = {}
    data.core = self.core
    return data
end

function TpSword:OnLoad(data)
    if data then
        for k, v in pairs(data.core or {}) do
            self:SetCore(k)
        end
    end
end

function TpSword:GetWargonString()
    local s = "核心："
    for k, v in pairs(self.core) do
        local w = STRINGS.TP_STR.tp_cores[k]
        if w then
            s = s..w..","
        end
    end
    return s
end

return TpSword