local TpVehicleController = Class(function(self, inst)
	self.inst = inst
	self.enabled = false

    self.handler = TheInput:AddGeneralControlHandler(function(control, value) self:OnControl(control, value) end)



    self.inst:StartUpdatingComponent(self)
    self.draggingonground = false
    self.startdragtestpos = nil
    self.startdragtime = nil

    self.reticule = nil

    self.terraformer = nil

    self.LMBaction = nil
    self.RMBaction = nil

    self.mousetimeout = 10
    self.time_direct_walking = 0


    self.can_attack = false

    self.should_walk = false
end)

function TpVehicleController:IsEnabled()
	return self.enabled
end

function TpVehicleController:OnControl(control, down)

	if not self:IsEnabled() then return end
	if not IsPaused() then

		if self.inst and (control == CONTROL_SECONDARY or control == CONTROL_CONTROLLER_ALTACTION) then
			if not down then
				self.inst:PushEvent("rightbuttonup")
			else
				self.inst:PushEvent("rightbuttondown")
			end
		end








	
		if down then

			if control == nil then




			elseif control == CONTROL_ATTACK then
				self:DoAttackButton()







			elseif control == CONTROL_ROTATE_LEFT then


			elseif control == CONTROL_ROTATE_RIGHT then					


			end
				
		end
	end
end

function TpVehicleController:DoAttackButton()
	if not self.can_attack then
		return
	end
	local attack_target = self:GetAttackTarget(TheInput:IsControlPressed(CONTROL_FORCE_ATTACK)) 			

	if attack_target and self.inst.components.combat.target ~= attack_target then

		local action = BufferedAction(self.inst, attack_target, ACTIONS.ATTACK)

		local can_run = self.run_attack
		self.inst.components.locomotor:PushAction(action, can_run)
	else
		return
	end	
end

function TpVehicleController:GetAttackTarget(force_attack)

	local x,y,z = self.inst.Transform:GetWorldPosition()
	
	local rad = self.inst.components.combat:GetAttackRange()
	
	
	if not self.directwalking then rad = rad + 6 end
	

	local nearby_ents = TheSim:FindEntities(x,y,z, rad + 5, nil, {"falling", "FX", "NOCLICK", "DECOR", "INLIMBO", "player"})


	local has_weapon = false
	
	local playerRad = self.inst.Physics:GetRadius()
	local lastresort = nil
	for k,guy in ipairs(nearby_ents) do

	   	local guyradius = 0 
	   	if guy.Physics then
	   	 	guyradius = guy.Physics:GetRadius() 
	   	end

		if guy ~= self.inst and
		guy:IsValid() and not guy:IsInLimbo() 
		and not (guy.sg and guy.sg:HasStateTag("invisible")) 
		and guy.components.health 
		and not guy.components.health:IsDead() 
		and guy.components.combat 
		and guy.components.combat:CanBeAttacked(self.inst) 
		and not (guy.components.follower 
		and guy.components.follower.leader == self.inst) 

		and distsq(guy:GetPosition(), self.inst:GetPosition()) <= math.pow(rad + playerRad + guyradius + 0.1 , 2) then
			if (guy:HasTag("monster") and has_weapon) 
			or guy:HasTag("hostile") 
			or self.inst.components.combat:IsRecentTarget(guy) 
			or guy.components.combat.target == self.inst 
			or force_attack then


				local ok = true
				if guy:HasTag("spider") and self.inst:HasTag("spiderwhisperer") then
					ok = false
					if guy.components.combat 
					and guy.components.combat.target 
					and (guy.components.combat.target == self.inst 
					or (guy.components.combat.target.components.follower 
					and guy.components.combat.target.components.follower.leader == self.inst)) then							
						ok = true
				    end
				end

				if ok or force_attack then
					if guy:HasTag("lastresort") then
						lastresort = guy
					else
						return guy
					end
				end
			end
		end
	end
	if lastresort then
		return lastresort
	end
end

function TpVehicleController:DoControllerAction()
	self.time_direct_walking = 0
	if self.deployplacer then
		if self.deployplacer.components.placer.can_build then
			local act = self.deployplacer.components.placer:GetDeployAction()
			if act.distance < 1 then 
				act.distance = 1
			end 
			self:DoAction(act)
		end
	elseif self.controller_target then
		self:DoAction( self:GetSceneItemControllerAction(self.controller_target) )
	end
end

function TpVehicleController:GetSceneItemControllerAction(item)
    local lmb, rmb = nil, nil
    

	local acts = self.inst.components.tpvehicleactionpicker:GetClickActions(item)
	if acts and #acts > 0 then
		local action = acts[1]
		if action.action ~= ACTIONS.LOOKAT and action.action ~= ACTIONS.ATTACK and action.action ~= ACTIONS.WALKTO then
			lmb = acts[1]
		end
	end


	acts = self.inst.components.tpvehicleactionpicker:GetRightClickActions(item)
	if acts and #acts > 0 then
		local action = acts[1]
		if action.action ~= ACTIONS.LOOKAT and action.action ~= ACTIONS.ATTACK and action.action ~= ACTIONS.WALKTO then
			rmb = action
		end
	end
	
	if rmb and lmb and rmb.action == lmb.action then
		rmb = nil
	end
	
	return lmb, rmb
end

function TpVehicleController:DoActionButton()
	local ba = self:GetActionButtonAction()
	if ba then
		self.inst.components.locomotor:PushAction(ba, true)
	end
end

function TpVehicleController:GetActionButtonAction()
	if self.actionbuttonoverride then
		return self.actionbuttonoverride(self.inst)
	end
	if self:IsEnabled() and not (self.inst.sg:HasStateTag("working")
	or self.inst.sg:HasStateTag("doing")) then

	end
end

function TpVehicleController:DisMount()
	if self.inst.components.tpvehicle 
	and self.inst.components.tpvehicle.owner then
		self.inst.components.tpvehicle:DownCar()
	end
end

function TpVehicleController:RotLeft()
	local rotamount = 45
	if TheCamera:CanControl() then  
		
		if IsPaused() then
			if GetWorld().minimap.MiniMap:IsVisible() then
				TheCamera:SetHeadingTarget(TheCamera:GetHeadingTarget() - rotamount) 
				TheCamera:Snap()
			end
		else
			TheCamera:SetHeadingTarget(TheCamera:GetHeadingTarget() - rotamount) 

		end
	end
end

function TpVehicleController:RotRight()
	local rotamount = 45
	if TheCamera:CanControl() then  
		
		if IsPaused() then
			if GetWorld().minimap.MiniMap:IsVisible() then
				TheCamera:SetHeadingTarget(TheCamera:GetHeadingTarget() + rotamount) 
				TheCamera:Snap()
			end
		else
			TheCamera:SetHeadingTarget(TheCamera:GetHeadingTarget() + rotamount) 

		end
	end
end

function TpVehicleController:OnRemoveEntity()
	self.handler:Remove()

end

function TpVehicleController:Enable(val)
	self.enabled = val
end

function TpVehicleController:UpdateControllerInteractionTarget(dt)
	if self.controller_target and (not self.controller_target:IsValid() or self.controller_target:IsInLimbo() or self.controller_target:HasTag("NOCLICK")) then
		self.controller_target = nil
	end

	if self.placer or ( self.deployplacer and self.deploy_mode ) then
		self.controller_target = nil
		self.controllertargetage = 0
		return
	end

	if self.controllertargetage then
		self.controllertargetage = self.controllertargetage + dt
	end

	if self.controllertargetage and self.controllertargetage < .2 then return end

	local heading_angle = -(self.inst.Transform:GetRotation())
	local dir = Vector3(math.cos(heading_angle*DEGREES),0, math.sin(heading_angle*DEGREES))

	local me_pos = Vector3(self.inst.Transform:GetWorldPosition())

	local inspect_rad = .75
	local min_rad = 1.5
	local max_rad = 6
	local rad = max_rad
	if self.controller_target and self.controller_target:IsValid() then
		local dsq = self.inst:GetDistanceSqToInst(self.controller_target)
		rad = math.max(min_rad, math.min(rad, math.sqrt(dsq)))
	end

	local x,y,z = me_pos:Get()

	local nearby_ents = TheSim:FindEntities(x,y,z, rad, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO"})

	if self.controller_target and not self.controller_target:IsInLimbo() then
		table.insert(nearby_ents, self.controller_target)
	end


	local target = nil
	local target_score = nil
	local target_action = nil
	local target_dist = nil

	local lastresort = nil

	for k,v in pairs(nearby_ents) do
		if v ~= self.inst then
		
			local px,py,pz = v.Transform:GetWorldPosition()
			local ox,oy,oz = px - me_pos.x, py-me_pos.y, pz-me_pos.z
			local dsq = ox*ox + oy*oy +oz*oz

			local already_target = self.controller_target == v or self.controller_attack_target == v
									
			local should_consider = dsq < min_rad*min_rad or
									(ox*dir.x + oy*dir.y +oz*dir.z) > 0 or
									already_target
									
			

			if dsq > max_rad*max_rad then
				should_consider = false
			end

			if should_consider then

				local dist = dsq > 0 and math.sqrt(dsq) or 0

				local dot = 0
				if dist > 0 then
					local nx, ny, nz = ox/dist, oy/dist, oz/dist
					dot = nx*dir.x + ny*dir.y + nz*dir.z
				end
				

				local angle_component = (dot + 1)/2
				

				local dist_component = dsq < min_rad*min_rad and 1 or (1 / (dsq/(min_rad*min_rad)))
				local add = 0
				

				if dsq < .25*.25 then
					add = 1
				end
				local mult = 1
				
				if v == self.controller_target and not v:HasTag("wall") then
					mult = 1.5
				end
				
				local score = angle_component*dist_component*mult + add
				

				
				if not target_score or score > target_score or not target_action then
					

					local l,r = self:GetSceneItemControllerAction(v)
					local action = l or r







					if v:HasTag("lastresort") then
						lastresort = v
					elseif ((action or (v.components.inspectable and not v.components.inspectable.inspectdisabled) ) and (not target_score or score > target_score))


						then
							target = v
							target_dist = dist
							target_score = score
							target_action = action
					end
				end
			end
		end
	end

	if not target and lastresort then
		target = lastresort
	end
	if target ~= self.controller_target then
		self.controller_target = target
		self.controllertargetage = 0
	end
	
end

function TpVehicleController:OnUpdate(dt)
	if self:IsEnabled() then

		if not self.inst.sg:HasStateTag("busy") then
			
			if self.draggingonground then
				local pt = TheInput:GetWorldPosition()
				local dst = distsq(pt, Vector3(self.inst.Transform:GetWorldPosition()))

				if dst > 1 then
					local angle = self.inst:GetAngleToPoint(pt)
					self.inst:ClearBufferedAction()
					if self.should_walk then

						self.inst.components.locomotor:WalkInDirection(angle, false)
					else

						self.inst.components.locomotor:RunInDirection(angle)
					end
				end
				self.directwalking = false
			else


		        self:DoDirectWalking(dt)
			end
	    end


	    if not self.inst.sg:HasStateTag("busy") 
	    and not self.directwalking then
	    	if TheInput:IsControlPressed(CONTROL_ATTACK) then
				self:OnControl(CONTROL_ATTACK, true)


			end
		end
	end
end

function TpVehicleController:GetWorldControllerVector()
	local xdir = TheInput:GetAnalogControlValue(CONTROL_MOVE_RIGHT) - TheInput:GetAnalogControlValue(CONTROL_MOVE_LEFT)
	local ydir = TheInput:GetAnalogControlValue(CONTROL_MOVE_UP) - TheInput:GetAnalogControlValue(CONTROL_MOVE_DOWN)
	local deadzone = .3

	if math.abs(xdir) < deadzone and math.abs(ydir) < deadzone then xdir = 0 ydir = 0 end
	if xdir ~= 0 or ydir ~= 0 then
	    local CameraRight = TheCamera:GetRightVec()
		local CameraDown = TheCamera:GetDownVec()
		local dir = CameraRight * xdir - CameraDown * ydir
		dir = dir:GetNormalized()
		return dir
	end
end

function TpVehicleController:DoDirectWalking(dt)
	if self.inst.components.locomotor.bufferedaction ~= nil then
		if self.inst.components.locomotor.bufferedaction.action.overrides_direct_walk then
			return
		end
	end

	if self.inst.bufferedaction ~= nil then
		if self.inst.bufferedaction.action.overrides_direct_walk then
			return
		end
	end

	local dir = self:GetWorldControllerVector()
	if dir then
		local ang = -math.atan2(dir.z, dir.x)/DEGREES

		self.inst:ClearBufferedAction()
		self.inst.components.locomotor:SetBufferedAction(nil)
		if self.should_walk then
			self.inst.components.locomotor:WalkInDirection(ang)
		else
			self.inst.components.locomotor:RunInDirection(ang)
		end
		if not self.directwalking then
			self.time_direct_walking = 0
		end

		self.directwalking = true

		self.time_direct_walking = self.time_direct_walking + dt

		if self.time_direct_walking > .2 then
			if not self.inst.sg:HasStateTag("attack") then
				self.inst.components.combat:SetTarget(nil)
			end
		end
	else
		if self.directwalking then
			self.inst.components.locomotor:Stop()
			self.directwalking = false
		end
	end
end






    



		







	



    

    





    



    

    




    


































    


return TpVehicleController