local Image = require "widgets/image"

local car_uis = {
	tp_coal_beast = {
		{
			img = "transistor",
			txt = "换挡",
			fn = function(inst, player)
				if inst.components.tpenergy:IsEmpty() then
					player.components.talker:Say("燃料不足")
				else
					if inst.components.tpenergy.burn_modifier["fast"] then
						inst:rm_speed_rate("tp_coal_beast")
						inst.components.tpenergy:RemoveBurnModifier("fast")
						player.components.talker:Say("一档")
					else
						inst:add_speed_rate("tp_coal_beast", .5)
						inst.components.tpenergy:AddBurnModifier("fast", 1)
						player.components.talker:Say("二档")
					end
				end
			end,
		},
		{
			img = "record_01",
			txt = "音乐",
			fn = function(inst, player)
				if math.random() < .5 then
					inst.SoundEmitter:PlaySound("tp_coal_beast_2/tp_coal_beast_2/bgm", "bgm")
				else
					inst.SoundEmitter:PlaySound("coal_beast_music/music/bgm", "bgm")
				end
				player.components.talker:Say("点歌")
			end,
		},
		{
			img = "record_02",
			txt = "关闭音乐",
			fn = function(inst, player)
				inst.SoundEmitter:KillSound("bgm")
				player.components.talker:Say("关闭音乐")
			end,
		},
		{
			img = "heat_rock1",
			txt = "冷气",
			fn = function(inst, player)
				if inst.components.tpenergy:IsEmpty() then
					player.components.talker:Say("燃料不足")
				else
					inst.components.tpenergy:RemoveBurnModifier("warm")
					if inst.components.tpenergy.burn_modifier["cool"] then
						inst.components.tpenergy:RemoveBurnModifier("cool")
						player.components.talker:Say("冷气关闭")
					else
						inst.components.tpenergy:AddBurnModifier("cool", 1)
						player.components.talker:Say("暖气关闭，冷气开启")
					end
				end
			end,
		},
		{
			img = "heat_rock5",
			txt = "暖气",
			fn = function(inst, player)
				if inst.components.tpenergy:IsEmpty() then
					player.components.talker:Say("燃料不足")
				else
					if inst.components.tpenergy.burn_modifier["warm"] then
						inst.components.tpenergy:RemoveBurnModifier("warm")
						player.components.talker:Say("暖气关闭")
					else
						inst.components.tpenergy:RemoveBurnModifier("cool")
						inst.components.tpenergy:AddBurnModifier("warm", 1)
						player.components.talker:Say("冷气关闭，暖气开启")
					end
				end
			end,
		},
		{
			img = "pig_shop_weapons",
			txt = "狂暴",
			fn = function(inst, player)
				if inst.components.tpenergy:IsEmpty() then
					player.components.talker:Say("燃料不足")
				else
					if inst.components.tpenergy.burn_modifier["warth"] then
						inst.components.tpenergy:RemoveBurnModifier("warth")
						inst.components.combat:SetAreaDamage()
						player.components.talker:Say("范围伤害关闭")
					else
						inst.components.tpenergy:AddBurnModifier("warth", 1)
						inst.components.combat:SetAreaDamage(4, .5)
						player.components.talker:Say("范围伤害开启")
					end
				end
			end,
		},
		{
			img = "mandrakesoup",
			txt = "复苏",
			fn = function(inst, player)
				if inst.components.tpenergy:IsEmpty() then
					player.components.talker:Say("燃料不足")
				else
					if inst.components.tpenergy.burn_modifier["heal"] then
						inst.components.health:StopRegen()
						inst.components.tpenergy:RemoveBurnModifier("heal")
						player.components.talker:Say("血量回复关闭")
					else
						inst.components.health:StartRegen(30, 2)
						inst.components.tpenergy:AddBurnModifier("heal", 1)
						player.components.talker:Say("血量回复开启")
					end
				end
			end,
		},
		{
			img = "armorseashell",
			txt = "坚固",
			fn = function(inst, player)
				if inst.components.tpenergy:IsEmpty() then
					player.components.talker:Say("燃料不足")
				else
					if inst.components.tpenergy.burn_modifier["armor"] then

						inst.components.health:SetAbsorptionAmount(0)
						inst.components.tpenergy:RemoveBurnModifier("armor")
						player.components.talker:Say("伤害减免关闭")
					else

						inst.components.health:SetAbsorptionAmount(.5)
						inst.components.tpenergy:AddBurnModifier("armor", 1)
						player.components.talker:Say("伤害减免开启")
					end
				end
			end,
		},
		{
			img = "treasurechest",
			txt = "后备箱",
			fn = function(inst, player)
				if inst.components.container.open then
					inst.components.container:Close(player)
				else
					inst.components.container:Open(player)
				end
			end,
		},
		{
			img = "lantern",
			txt = "车灯",
			fn = function(inst, player)
				if inst.components.tpenergy:IsEmpty() then
					player.components.talker:Say("燃料不足")
				else
					if inst.components.tpenergy.burn_modifier["light"] then
						player.components.talker:Say("关闭车灯")
						inst.Light:Enable(false)
						inst.components.tpenergy:RemoveBurnModifier("light")
					else
						player.components.talker:Say("打开车灯")
						inst.Light:Enable(true)
						inst.components.tpenergy:AddBurnModifier("light", .5)
					end
				end
			end,
		},
	},
	tp_bike = {
		{
			img = "peg_leg",
			txt = "蹬",
			fn = function(inst, player)
				inst:add_speed_rate("tp_bike_fast", .2, 1)
			end,
		},
	},
	tp_bearger = {
		{
			img = "transistor",
			txt = "换挡",
			fn = function(inst, player)
				if inst.components.tpenergy:IsEmpty() then
					player.components.talker:Say("燃料不足")
				else
					if inst.components.tpenergy.burn_modifier["fast"] then
						player.components.talker:Say("一档")
						inst.components.tpvehiclecontroller.should_walk = true
						inst.components.tpenergy:RemoveBurnModifier("fast")
					else
						player.components.talker:Say("二档")
						inst.components.tpvehiclecontroller.should_walk = false
						inst.components.tpenergy:AddBurnModifier("fast", 1)
					end
				end
			end,
		},
		{
			img = "thumper",
			txt = "冲击波",
			fn = function(inst, player)
				if inst.components.tpenergy.current >= 10 then
					if not (
					inst.sg:HasStateTag("busy")
					or inst.sg:HasStateTag("doing")
					or inst.sg:HasStateTag("attack")
					) then
						inst.sg:GoToState("pound")
						inst.components.tpenergy:DoDelta(-10)
					end
				else
					player.components.talker:Say("燃料不足")
				end
			end,
		},
	},
	tp_dragonfly = {
		{
			img = "obsidianfirepit",
			txt = "灯光",
			fn = function(inst, player)
				inst.components.tpenergy:Toggle("light", 1, 
					function(inst, player)
						inst.Light:Enable(true)
						inst.AnimState:SetBuild("dragonfly_fire_build")

						local fx = SpawnPrefab("firesplash_fx")
						inst:AddChild(fx)
						fx:set_pos(0, 0, 0)
					end,
					function(inst, player)
						inst.Light:Enable(false)
						inst.AnimState:SetBuild("dragonfly_build")

						local fx = SpawnPrefab("firesplash_fx")
						inst:AddChild(fx)
						fx:set_pos(0, 0, 0)
					end
				)
			end,
		},
		{
			img = "bee",
			txt = "无人机",
			fn = function(inst, player)
				if inst.components.tpenergy.current >= 5 then
					if not (
					inst.sg:HasStateTag("busy")
					or inst.sg:HasStateTag("doing")
					or inst.sg:HasStateTag("attack")
					) then
						inst.sg:GoToState("spawn")
						inst.components.tpenergy:DoDelta(-5)
					end
				else
					player.components.talker:Say("燃料不足")
				end
			end,
		},
		{
			img = "obsidiancoconade",
			txt = "轰炸",
			fn = function(inst, player)
				if inst.components.tpenergy.burn_modifier["light"] then
					if inst.components.tpenergy.current >= 30 then
						if not (
						inst.sg:HasStateTag("busy")
						or inst.sg:HasStateTag("doing")
						or inst.sg:HasStateTag("attack")
						) then
							inst.sg:GoToState("taunt_pre")
							inst.components.tpenergy:DoDelta(-30)
						end
					else
						player.components.talker:Say("燃料不足")
					end
				else
					player.components.talker:Say("请先开启灯光")
				end
			end,
		},
	},
	tp_moose = {
		{
			img = "featherfan",
			txt = "扇风",
			fn = function(inst, player)
				if inst.components.tpenergy.current < 10 then
					player.components.talker:Say("燃料不足")
				else
					if not (
					inst.sg:HasStateTag("busy")
					or inst.sg:HasStateTag("doing")
					or inst.sg:HasStateTag("attack")
					) then
						inst.sg:GoToState("fan")
						inst.components.tpenergy:DoDelta(-10)
					end
				end
			end,
		},
	},
	tp_fant = {
		{
			img = "treasurechest",
			txt = "货箱",
			fn = function(inst, player)
				if inst.components.container.open then
					inst.components.container:Close(player)
				else
					inst.components.container:Open(player)
				end
			end,
		},
		{
			img = "boomerang",
			txt = "收割",
			fn = function(inst, player)
				if inst.components.tpenergy:IsEmpty() then
					player.components.talker:Say("燃料不足")
				else
					if inst.components.tpenergy.burn_modifier["harvest"] then
						inst.components.tpenergy:RemoveBurnModifier("harvest")
						inst.components.tpfollowimage:Kill()
						player.components.talker:Say("停止收割")
						if inst.task then
							inst.task:Cancel()
							inst.task = nil
						end
					else
						inst.components.tpenergy:AddBurnModifier("harvest", 1)
						player.components.talker:Say("开始收割")
						inst.components.tpfollowimage:SetImage(WARGON.resolve_img_path("boomerang"))
						inst:do_task(.1, function()
							local widget = inst.components.tpfollowimage.widget
							if widget then
								widget.tp_image:Hide()
								local img1 = widget:AddChild(Image(WARGON.resolve_img_path("boomerang")))
								local img2 = widget:AddChild(Image(WARGON.resolve_img_path("boomerang")))
								img1:SetPosition(80, 0, 0)
								img2:SetPosition(-80, 0, 0)
								img1.inst:per_task(1/30, function()
									local angle = img1.angle or 1
									img1.angle = angle + 1
									img1:SetRotation(angle*360/30)
								end)
								img2.inst:per_task(1/30, function()
									local angle = img2.angle or 1
									img2.angle = angle + 1
									img2:SetRotation(angle*360/30)
								end)
							end
						end)
						if inst.task == nil then
							inst.task = inst:per_task(.5, function()
								local ents = inst:wg_finds(5, {"tp_can_fast_harvest"})
								for k, v in pairs(ents) do
									if v.components.harvestable then
										v.components.harvestable:Harvest(player)
									elseif v.components.crop then
										v.components.crop:Harvest(player)
									elseif v.components.pickable then
										v.components.pickable:Pick(player)
									end
								end
							end)
						end
					end
				end
			end,
		},
	},
	tp_spat = {
		{
			img = "goldenshovel",
			txt = "铲草",
			fn = function(inst, player)
				if inst.components.tpenergy:IsEmpty() then
					player.components.talker:Say("燃料不足")
				else
					if inst.components.tpenergy.burn_modifier["shovel"] then
						inst.components.tpenergy:RemoveBurnModifier("shovel")
						player.components.talker:Say("停止铲草")
						if inst.task then
							inst.task:Cancel()
							inst.task = nil
						end
					else
						inst.components.tpenergy:AddBurnModifier("shovel", 1)
						player.components.talker:Say("开始铲草")
						if inst.task == nil then
							inst.task = inst:per_task(.5, function()
								local ents = inst:wg_finds(5, nil, {"FX", "BLOCK", "NOCLICK"})

								for k, v in pairs(ents) do
									if v.components.workable
									and v.components.workable.action == ACTIONS.DIG then
										v.components.workable:Destroy(inst)
									end
								end
								if inst.make_fx then
									WARGON.make_fx(inst, "groundpound_fx")
									inst.make_fx = nil
								else
									inst.make_fx = true
								end
							end)
						end
					end
				end
			end,
		},
	},









}

return car_uis