local function simple(item, player)
	if item.skill_fn
	and (not item.components.tprecharge 
	or item.components.tprecharge:IsRecharged()) then
		item.skill_fn(item, player)
	end
end

local function simple2(item, player)
	if item.skill_fn
	and (not item.components.tprecharge 
	or item.components.tprecharge:IsRecharged()) then
		item.skill_fn2(item, player)
	end
end

local equip_uis = {
	tp_spear_bag = {
		slot = "hand",
		img = "tp_spear_bag#",
		txt = "容器开关",
		fn = function(item, player)
			if item.components.container.open then
				item.components.container:Close(player)
			else
				item.components.container:Open(player)
			end
		end,
	},
	tp_armor_bag = {
		slot = "body",
		img = "tp_armor_bag#",
		txt = "容器开关",
		fn = function(item, player)
			if item.components.container.open then
				item.components.container:Close(player)
			else
				item.components.container:Open(player)
			end
		end,
	},
	tp_hat_bag = {
		slot = "head",
		img = "tp_hat_bag#",
		txt = "容器开关",
		fn = function(item, player)
			if item.components.container.open then
				item.components.container:Close(player)
			else
				item.components.container:Open(player)
			end
		end,
	},
	tp_hat_burn = {
		slot = "head",
		img = "tp_hat_burn#",
		txt = "灼烧开关",
		fn = function(item, player)
			if player:HasTag("tp_hat_burn") then
				player:RemoveTag("tp_hat_burn")
			else
				player:AddTag("tp_hat_burn")
			end
		end,
	},
	tp_spear_dream = {
		slot = "hand",
		img = "tp_spear_dream#",
		txt = "武器栏",
		fn = function(item, player)
			if item.components.container.open then
				item.components.container:Close(player)
			else
				item.components.container:Open(player)
			end
		end,
	},
	tp_hat_forest = {
		slot = "head",
		img = "tp_hat_forest#",
		txt = "草木皆兵",
		fn = function(item, player)
			item.spawn_eyeplant(item, player)
		end,
	},
	tp_hambat_2 = {
		slot = "hand",
		img = "hambat",
		txt = "吃",
		fn = function(item, player)
			if not player.sg:HasStateTag("busy")
			or player.sg:HasStateTag("doing") then
				if item.components.equippable:IsEquipped() then
					player.components.inventory:GiveItem(item)
				end
				local ba = BufferedAction(player, nil, ACTIONS.EAT, item)
				player:PushBufferedAction(ba)
			end
		end,
	},
	tp_pigking_hat = {
		slot = "head",
		img = "beefalohat_pigking#",
		txt = "召唤",
		fn = function(item, player)
			item.spawn_pig(item, player)
		end,
	},
	tp_hat_wolf = {
		slot = "head",
		img = "hat_dog_helm#",
		txt = "召唤",
		fn = function(item, player)
			item.spawn_pet(item, player)
		end,
	},
	tp_armor_airi = {
		slot = "body",
		img = "tp_armor_airi#",
		txt = "召唤",
		fn = function(item, player)
			item.spawn_pet(item, player)
		end,
	},
	tp_armorwood_2 = {
		slot = "body",
		img = "armorwood",
		txt = "爆衣",
		fn = function(item, player)
			if item.components.armor then
				item.components.armor:SetPercent(0)
				WARGON.make_fx(player, "bramblefx")
				WARGON.area_dmg(player, 4, player, 34, item.prefab)
			end
		end,
	},
	tp_cane_2 = {
		slot = "hand",
		img = "cane",
		txt = "自动切换",
		fn = function(item, player)
			if player.components.tpbuff then
				player.components.tpbuff:AddBuff("tp_cane_buff")
			end
		end,
	},
	spear = {
		slot = "hand",
		img = "spear",
		txt = "拆解",
		fn = function(item, player)
			item:Remove()
			if player.components.inventory then
				player.components.inventory:GiveItem(SpawnPrefab("twigs"))
				player.components.inventory:GiveItem(SpawnPrefab("rope"))
			end
		end,
	},
	tp_footballhat_2 = {
		slot = "head",
		img = "footballhat",
		txt = "快跑",
		fn = function(item, player)
			if player.components.inventory then
				player.components.inventory:DropItem(item, nil, true, nil, nil, nil, 4)
				player:add_speed_rate("give_up_"..item.prefab, .3, 1)
			end
		end,
	},
	tp_armorgrass_2 = {
		slot = "body",
		img = "armorgrass",
		txt = "快跑",
		fn = function(item, player)
			if player.components.inventory then
				player.components.inventory:DropItem(item, nil, true, nil, nil, nil, 4)
				player:add_speed_rate("give_up_"..item.prefab, .3, 1)
			end
		end,
	},
	tp_armormarble_2 = {
		slot = "body",
		img = "armormarble",
		txt = "快跑",
		fn = function(item, player)
			if player.components.inventory then
				player.components.inventory:DropItem(item, nil, true, nil, nil, nil, 4)
				player:add_speed_rate("give_up_"..item.prefab, .5, 1)
			end
		end,
	},
	torch = {
		slot = "hand",
		img = "torch",
		txt = "打上火花",
		fn = function(item, player)
			if player.components.tpbuff then
				player.components.tpbuff:AddBuff("tp_torch_buff")
				item:Remove()
			end
		end,
	},
	flowerhat = {
		slot = "head",
		img = "flowerhat",
		txt = "引蝶",
		fn = function(item, player)
			item:Remove()
			if player.components.inventory then
				player.components.inventory:GiveItem(SpawnPrefab("butterfly"))
			end 
		end,
	},
	watermelonhat = {
		slot = "head",
		img = "watermelonhat",
		txt = "吃",
		fn = function(item, player)
			if not player.sg:HasStateTag("busy")
			or player.sg:HasStateTag("doing") then
				if item.components.equippable:IsEquipped() then
					player.components.inventory:GiveItem(item)
				end
				local ba = BufferedAction(player, nil, ACTIONS.EAT, item)
				player:PushBufferedAction(ba)
			end
		end,
	},
	icehat = {
		slot = "head",
		img = "icehat",
		txt = "吃",
		fn = function(item, player)
			if not player.sg:HasStateTag("busy")
			or player.sg:HasStateTag("doing") then
				if item.components.equippable:IsEquipped() then
					player.components.inventory:GiveItem(item)
				end
				local ba = BufferedAction(player, nil, ACTIONS.EAT, item)
				player:PushBufferedAction(ba)
			end
		end,
	},
	bushhat = {
		slot = "head",
		img = "bushhat",
		txt = "采收",
		fn = function(item, player)
			player.components.inventory:GiveItem(SpawnPrefab("berries"))
			item:Remove()







		end,
	},
	beargervest = {
		slot = "body",
		img = "beargervest",
		txt = "容器开关",
		fn = function(item, player)
			if item.components.container.open then
				item.components.container:Close(player)
			else
				item.components.container:Open(player)
			end
		end,
	},
	tp_spear_leaf = {
		slot = "hand",
		img = "tp_spear_leaf#",
		txt = "容器开关",
		fn = function(item, player)
			if item.components.container.open then
				item.components.container:Close(player)
			else
				item.components.container:Open(player)
			end
		end,
	},
	eyebrellahat = {
		slot = "head",
		img = "eyebrellahat",
		txt = "遮雨棚",
		fn = function(item, player)
			if item.components.tprecharge:IsRecharged() then
				item.components.tprecharge:SetRechargeTime(60)
				local t = WARGON.make_spawn(item, "palmleaf_hut")
				t:AddTag("tp_no_drop_loot")
				t:no_save()
				t:do_task(0, function()
					t:PushEvent("onbuilt")
				end)
				t:do_task(50, function()
					WARGON.make_fx(t, "collapse_big")
					t:Remove()
				end)
			end
		end,
	},
	armordragonfly = {
		slot = "body",
		img = "armordragonfly",
		txt = "火堆",
		fn = function(item, player)
			if item.components.tprecharge:IsRecharged() then
				item.components.tprecharge:SetRechargeTime(100)
				local t = WARGON.make_spawn(item, "firepit")
				t:AddTag("tp_no_drop_loot")
				t:no_save()
				t:do_task(0, function()
					t.components.fueled:SetPercent(0)
					t:PushEvent("onbuilt")
				end)
				t:do_task(90, function()
					WARGON.make_fx(t, "collapse_big")
					t:Remove()
				end)
			end
		end,
	},
	tp_icestaff_2 = {
		txt = "拆解",
		fn = function(item, player)
			item:Remove()
			if player.components.inventory then
				local spear = SpawnPrefab("spear")
				player.components.inventory:GiveItem(spear)
			end
		end,
	},
	tp_icestaff_3 = {


		txt = "降温",
		fn = function(item, player)
			if item.components.finiteuses then
				item.components.finiteuses:Use()
			end
			if player.components.temperature then
				player.components.temperature:DoDelta(-15)
			end
			if player.components.freezable then
				player.components.freezable:AddColdness(1)
			end
		end
	},
	tp_firestaff_2 = {
		txt = "拆解",
		fn = function(item, player)
			item:Remove()
			if player.components.inventory then
				local spear = SpawnPrefab("spear")
				player.components.inventory:GiveItem(spear)
			end
			c_give("nightmarefuel", 2)
		end,
	},
	tp_firestaff_3 = {


		txt = "解冻",
		fn = function(item, player)
			if item.components.finiteuses then
				item.components.finiteuses:Use()
			end
			if player.components.temperature then
				player.components.temperature:DoDelta(15)
			end
			if player.components.health then
				player.components.health:DoFireDamage(4, nil, true)
			end
			if player.components.freezable 
			and player.components.freezable:IsFrozen() then
				player.components.freezable:Unfreeze()
			end
		end,
	},
	tp_tentaclespike_2 = {
		txt = "种植",
		fn = function(item, player)
			item:Remove()
			WARGON.make_spawn(player, "tentacle")
		end,
	},
	tp_spear_fire_2 = {
		txt = "点燃开关",
		img = "tp_spear_fire#",
		fn = function(item, player)
			if item:HasTag("tp_spear_fire_burn") then
				player.components.talker:Say("点燃关闭")
				item:RemoveTag("tp_spear_fire_burn")
			else
				player.components.talker:Say("点燃开启")
				item:AddTag("tp_spear_fire_burn")
			end
		end,
	},
	tp_spear_a = {
		txt = "战斗强化",

		fn = function(item, player)
			if item.skill_fn
			and (not item.components.tprecharge 
			or item.components.tprecharge:IsRecharged()) then
				item.skill_fn(item, player)
			end
		end,
	},
	tp_yellowamulet_3 = {
		txt = "拆解",
		fn = function(item, player)
			item:Remove()
			c_give("yellowgem")
		end,
	},
	tp_ruins_bat_4 = {
		txt = "重剑/轻剑",
		fn = simple,
	},
	tp_ruins_bat_5 = {
		txt = "至高之剑",
		fn = simple,
	},
	tp_cutlass_5 = {
		txt = "真浪斩",
		fn = simple,
	},
	tp_armor_sanity_5 = {
		txt = "随机闪烁",
		fn = simple,
	},
	tp_blunderbuss_5 = {
		txt = "超载模式",
		fn = simple,
	},
	axe = {
		txt = "过载模式",
		fn = simple,
		txt2 = "拆解",
		fn2 = simple2,
	}
}

equip_uis["tp_spear_fire_3"] = equip_uis["tp_spear_fire_2"]
equip_uis["tp_spear_a_2"] = equip_uis["tp_spear_a"]
equip_uis["tp_spear_a_3"] = equip_uis["tp_spear_a"]
equip_uis["tp_spear_b"] = equip_uis["tp_spear_a"]
equip_uis["tp_spear_b_2"] = equip_uis["tp_spear_a"]
equip_uis["tp_spear_b_3"] = equip_uis["tp_spear_a"]
equip_uis["tp_cane_4"] = equip_uis["tp_cane_2"]
equip_uis["tp_yellowamulet_2"] = equip_uis["tp_footballhat_2"]
equip_uis["tp_beefalohat_2"] = equip_uis["tp_footballhat_2"]




equip_uis["tp_beefalohat_5"] = equip_uis["tp_pigking_hat"]
equip_uis["tp_beefalohat_6"] = equip_uis["tp_pigking_hat"]
equip_uis["pickaxe"] = equip_uis["axe"]
equip_uis["machete"] = equip_uis["axe"]
equip_uis["goldenaxe"] = equip_uis["axe"]
equip_uis["goldenpickaxe"] = equip_uis["axe"]
equip_uis["goldenmachete"] = equip_uis["axe"]
equip_uis["hammer"] = equip_uis["axe"]

return equip_uis