local assets =
{

}

local NUM_VARIATIONS = 3
local MIN_SCALE = 1
local MAX_SCALE = 1.8

local function PlayShadowAnim(inst, data)




    local anim, scale, flip = data.anim, data.scale, data.flip
    if inst.set_can_sleep == nil then
        inst.entity:SetCanSleep(false)
        inst.set_can_sleep = true
    end







    inst.AnimState:SetBank("cane_shadow_fx")
    inst.AnimState:SetBuild("cane_shadow_fx")
    inst.AnimState:SetScale(flip and -scale or scale, scale)
    inst.AnimState:SetMultColour(1, 1, 1, .5)
    inst.AnimState:PlayAnimation(anim)

    inst:ListenForEvent("animover", inst.Recycle)
end

local function OnRandDirty(inst)
    if inst._complete or inst._rand <= 0 then
        return
    end

    local flip = inst._rand > 31
    local scale = MIN_SCALE + (MAX_SCALE - MIN_SCALE) * (flip and inst._rand - 32 or inst._rand - 1) / 30

    inst:do_task(0, function()
        WARGON.make_fx2("shadow_anim", inst, {
            anim = "shad"..inst.variation,
            scale = scale,
            flip = flip,
        })
    end)
end

local function MakeShadowFX(name, num, prefabs)
    local function fn(inst, data)
        inst:AddTag("shadowtrail")

        inst.variation = tostring(data and data.num or math.random(NUM_VARIATIONS))

		inst._rand = math.random(62)
        inst._complete = false
		OnRandDirty(inst)


        inst:DoTaskInTime(1.5, inst.Recycle)





    end
    return fn
end










local ret = {
    shadow_dust = MakeShadowFX(),
    shadow_anim = PlayShadowAnim,
}


return ret
