local Anims = {
    lake = {"oasis_tile", "oasis_tile", "idle"},
    wathgrithr = {"wilson", "wathgrithr", "sleep"},
    wendy = {"wilson", "wendy", "sleep"},
    wes = {"wilson", "wes", "sleep"},
    waxwell = {"wilson", "waxwell", "sleep"},
}

local function onsave(inst, data)
    if inst:HasTag("spawned_shop") then
        data.spawned_shop = true
    end
end

local function onload(inst, data)
    if data and data.spawned_shop then
        inst:AddTag("spawned_shop")
    end
end

local function createInterior(inst, name)
    if not inst:HasTag("spawned_shop") then

        local interior_spawner = GetWorld().components.interiorspawner

        local palaceID = interior_spawner:GetNewID()

        local depth = 18
        local width = 26        

        local exterior_door_def =
        {
            my_door_id = name..palaceID.."_door",
            target_door_id = name..palaceID.."_exit",
            target_interior = palaceID
        }

        interior_spawner:AddDoor(inst, exterior_door_def)

        local floortexture   = "levels/textures/interiors/floor_marble_royal.tex"
        local walltexture    = "levels/textures/interiors/wall_royal_high.tex"
        local minimaptexture = "levels/textures/map_interior/mini_floor_marble_royal.tex"




        local addprops = {}     
        addprops =
        {
            { name = "prop_door", x_offset = 9, z_offset = 0, animdata = {bank = "palace_door", build = "palace_door", anim = "south", background = false }, 
                my_door_id = exterior_door_def.target_door_id, target_door_id = exterior_door_def.my_door_id, rotation = -90, addtags = {"guard_entrance"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },

            { name = "prop_door_shadow", x_offset = 9, z_offset = 0, animdata = {bank = "palace_door", build = "palace_door", anim = "south_floor"} },

            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },
           
            { name = "deco_palace_beam_room_tall_corner_front", x_offset =  18/2, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_beam_room_tall_corner_front", x_offset =  18/2, z_offset =  26/2, rotation = 90 }, 

            { name = "deco_palace_banner_small_front", x_offset = -18/2, z_offset = -26/18-3, rotation = 90 },
            { name = "deco_palace_banner_small_front", x_offset = -18/2, z_offset =  26/18+3, rotation = 90 }, 

            { name = "deco_palace_banner_small_front", x_offset = -18/2, z_offset = -26/18 - 26/3, rotation = 90 },
            { name = "deco_palace_banner_small_front", x_offset = -18/2, z_offset =  26/18 - 26/3, rotation = 90 },        

            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14, z_offset =  26/2, rotation = 90 },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14, z_offset =  26/2, rotation = 90 },

            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14 * 3, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14 * 3, z_offset =  26/2, rotation = 90 },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14 * 3, z_offset = -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14 * 3, z_offset =  26/2, rotation = 90 },

            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14 * 5, z_offset =  -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset = -18/14 * 5, z_offset =   26/2, rotation = 90 },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14 * 5, z_offset =  -26/2, rotation = 90, flip = true },
            { name = "deco_palace_banner_small_sidewall", x_offset =  18/14 * 5, z_offset =   26/2, rotation = 90 },

            { name = inst.boss_name,       x_offset = -3, z_offset = 0 },


            { name = "rug_palace_corners", x_offset = -18/2, z_offset =  26/2, rotation = 90  },
            { name = "rug_palace_corners", x_offset =  18/2, z_offset =  26/2, rotation = 180 },
            { name = "rug_palace_corners", x_offset =  18/2, z_offset = -26/2, rotation = 270 },
            { name = "rug_palace_corners", x_offset = -18/2, z_offset = -26/2, rotation = 0   },


            { name = "swinglightobject", x_offset = 18/2, z_offset = -26/3, rotation = -90 }, 
            { name = "swinglightobject", x_offset = 18/2, z_offset =  26/3, rotation = -90 }, 


            { name = "window_round_light_backwall", x_offset = -18/2, z_offset = -26/3, rotation = -90 }, 
            { name = "window_palace",               x_offset = -18/2, z_offset = -26/3, rotation =  90 },
            { name = "window_round_light_backwall", x_offset = -18/2, z_offset =  26/3, rotation = -90 }, 
            { name = "window_palace",               x_offset = -18/2, z_offset =  26/3, rotation =  90 }, 
            { name = "window_round_light_backwall", x_offset = -18/2, z_offset =     0, rotation = -90 }, 
            { name = "window_palace_stainglass",    x_offset = -18/2, z_offset =     0, rotation =  90 }, 
        }

        interior_spawner:CreateRoom("generic_interior", width, 13, depth, name, palaceID, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE","STONE")

        inst.interiorID = palaceID
        inst:AddTag("spawned_shop")
    end
end

local function create_void_room(inst, name)
    if not inst:HasTag("spawned_shop") then

        local interior_spawner = GetWorld().components.interiorspawner

        local palaceID = interior_spawner:GetNewID()

        local depth = 18
        local width = 26        

        local exterior_door_def =
        {
            my_door_id = name..palaceID.."_door",
            target_door_id = name..palaceID.."_exit",
            target_interior = palaceID,
        }

        interior_spawner:AddDoor(inst, exterior_door_def)

        local    floortexture = "levels/textures/interiors/batcave_floor.tex"
        local    walltexture =  "levels/textures/interiors/batcave_wall_rock.tex"
        local    minimaptexture = "levels/textures/map_interior/mini_vamp_cave_noise.tex"




        local addprops = {}     
        addprops =
        {
            { name = "prop_door", x_offset = 9, z_offset = 0, animdata = {bank = "exitrope", build = "cave_exit_rope", anim = "idle_loop", background = false }, 
                my_door_id = exterior_door_def.target_door_id, target_door_id = exterior_door_def.my_door_id, rotation = -90, addtags = {"guard_entrance"}, usesounds={"dontstarve_DLC003/common/objects/store/door_close"} },



            { name = "deco_roomglow_large", x_offset = 0, z_offset = 0 },

           
























            { name = inst.boss_name,       x_offset = -3, z_offset = 0 },








            { name = "swinglightobject", x_offset = 18/2, z_offset = -26/3, rotation = -90 }, 
            { name = "swinglightobject", x_offset = 18/2, z_offset =  26/3, rotation = -90 }, 








        }

        interior_spawner:CreateRoom("generic_interior", width, 13, depth, name, palaceID, addprops, {}, walltexture, floortexture, minimaptexture, nil, "images/colour_cubes/pigshop_interior_cc.tex", nil, nil, "palace", "PALACE","STONE")

        inst.interiorID = palaceID
        inst:AddTag("spawned_shop")
    end
end

local function MakeBossRoom(name, anims, boss_name, speical_fn)
    local function fn()
        local inst = WARGON.make_prefab(anims)
    	
        inst:AddComponent("door")
        inst:AddComponent("inspectable")
        inst:AddTag("guard_entrance")


        inst.OnSave = onsave 
        inst.OnLoad = onload


        inst.boss_name = boss_name

        if speical_fn then
            speical_fn(inst)
        end

        return inst
    end
    return Prefab("common/objects/"..name, fn, {})
end

local function common_room(inst)
    inst:DoTaskInTime(0, function() 
        createInterior(inst, "boss_room")
    end)
end

local function hornet_room_fn(inst)
    common_room(inst)
    WARGON.EQUIP.body_on(inst, "armor_vortex_cloak", "swap_body")
    WARGON.EQUIP.hat_on(inst, "hat_bandit", nil, true)
    WARGON.EQUIP.object_on(inst, "tp_spear_lance", "swap_object")
end

local function combat_lord_room_fn(inst)
    common_room(inst)



    WARGON.EQUIP.hat_on(inst, "hat_wathgrithr", nil, true)
    WARGON.EQUIP.object_on(inst, "swap_spear_wathgrithr", "swap_spear_wathgrithr")
end

local function soul_student_room_fn(inst)
    common_room(inst)



    WARGON.EQUIP.hat_on(inst, "hat_top", nil, true)
    WARGON.EQUIP.object_on(inst, "swap_staffs", "redstaff")
    WARGON.EQUIP.body_on(inst, "armor_sanity", "swap_body")
end

local function fool_spider_room_fn(inst)
    inst:AddTag("tp_moon_lake")
    inst:do_task(0, function(inst)
        create_void_room(inst, "moon_lake")
    end)
    inst.AnimState:PlayAnimation("idle", true)
    inst:AddTag("NOCLICK")

    inst.AnimState:SetOrientation( ANIM_ORIENTATION.OnGround )
    inst.AnimState:SetLayer( LAYER_BACKGROUND )
    inst.AnimState:SetSortOrder( 3 )
    inst:ListenForEvent("nighttime", function()
        if WARGON.is_full_moon() then
            inst:RemoveTag("NOCLICK")
        end
    end, GetWorld())
    inst:ListenForEvent("daytime", function()
        inst:AddTag("NOCLICK")
    end, GetWorld())
    inst:do_task(0, function()
        if WARGON.is_full_moon() then
            inst:RemoveTag("NOCLICK")
        end
    end)
end

local BossRoom = Class(Prefab, function(self, name, data)
    Prefab._ctor(self, name)
    self.data = data
    self.fn = function()
        local inst = WARGON.make_prefab(data.anim or {})
        inst:add_cmps({ 
            inspect = {},
        })
        
        inst:AddComponent("door")
        inst:AddComponent("inspectable")
        inst:AddTag("guard_entrance")


        inst.OnSave = onsave 
        inst.OnLoad = onload

        inst.boss_name = data.boss

        if data.room then
            inst:DoTaskInTime(0, function() 
                createInterior(inst, "boss_room")
            end)
        end

        if data.fn then
            data.fn(inst)
        end

        return inst
    end
end)

function BossRoom:__tostring()
    return string.format("BossRoom %s - %s", self.name, self.desc)
end

local fake_knight_room = BossRoom("tp_fake_knight_room", {
    anim = Anims.wes,
    boss = "tp_fake_knight",
    room = true,
    fn = function(inst)
        WARGON.EQUIP.body_on(inst, "armor_metalplate", "swap_body")
        WARGON.EQUIP.hat_on(inst, "hat_metalplate", nil, true)
        WARGON.EQUIP.object_on(inst, "swap_halberd", "swap_halberd")
    end
})

return 
MakeBossRoom("tp_combat_lord_room", Anims.wathgrithr, "tp_combat_lord", combat_lord_room_fn),
MakeBossRoom("tp_soul_student_room", Anims.waxwell, "tp_soul_student_point", soul_student_room_fn),
MakeBossRoom("tp_fool_spider_room", Anims.lake, "tp_moon_sea_handler", fool_spider_room_fn),
fake_knight_room,

MakeBossRoom("tp_hornet_room", Anims.wendy, "tp_hornet", hornet_room_fn)

