local function bigfoot_fn()
	local inst = WARGON.make_prefab()
	WARGON.do_task(inst, 0, function()
		if GetWorld().components.bigfooter then
			GetWorld().components.bigfooter:SummonFoot(GetPlayer():GetPosition())
		end

		inst:Remove()
	end)

	return inst
end

local function morph_fn()
	local inst = WARGON.make_prefab()
	WARGON.do_task(inst, 0, function()
		local player = GetPlayer()
		if player.components.sciencemorph then
			player.components.sciencemorph:Morph()
		end
		inst:Remove()
	end)
	return inst
end

local function callbeast_fn()
	local inst = WARGON.make_prefab()
	WARGON.do_task(inst, 0, function()
		local player = GetPlayer()
		if player.components.tpcallbeast then
			player.components.tpcallbeast:CallBeast()
		end
		inst:Remove()
	end)
	return inst
end

local function beefalo_fn()
	local inst = WARGON.make_prefab()
	WARGON.do_task(inst, 0, function()
		local pos = WARGON.around_land(inst, math.random(2,4))
		if pos then
			if WARGON.on_water(inst, pos) then
				WARGON.make_fx(pos, "splash_water_drop")
			else
				WARGON.make_spawn(pos, "tp_beefalo")







			end
			inst:Remove()
		end
	end)
	return inst
end

local function rider_fn()
	local inst = WARGON.make_prefab()
	inst.riders = {"tp_sign_rider"}
	WARGON.do_task(inst, 0, function()
		local player = GetPlayer()
		if c_findtag("tp_sign_rider", 9001) == nil then
			for k, v in pairs(inst.riders) do
				local radius = 10
				local pos = WARGON.around_land(player, radius)
				if pos then
					WARGON.make_spawn(pos, v)
					WARGON.make_fx(pos, "statue_transition")
					WARGON.make_fx(pos, "statue_transition_2")
				end
			end
















		end
		inst:Remove()
	end)
	return inst
end

local function perd_fn()
	local inst = WARGON.make_prefab()
	inst:do_task(0, function()
		local perd = WARGON.make_spawn(inst, "perd")
		perd.tp_perd = true
		perd:SetBrain(require "brains/tp_perd_brain")
		perd.AnimState:Show("HAT")
		perd.AnimState:OverrideSymbol("swap_hat", "strawhat_cowboy", "swap_hat")
		perd:no_save()
		perd:ListenForEvent("nighttime", function()
			local player = GetPlayer()
			perd.components.inventory:TransferInventory(player)
			perd:Remove()
		end)
		perd:Remove()
		inst:Remove()
	end)
	return inst
end

local function shadow_fn()
	local inst = WARGON.make_prefab()
	inst:do_task(0, function()
		if GetPlayer().components.sanity:GetMaxSanity() >= TUNING.SHADOWWAXWELL_SANITY_PENALTY then
			local pos = inst:around_land(math.random(3))
			if pos then
				WARGON.make_fx(pos, "statue_transition")
				WARGON.make_fx(pos, "statue_transition_2")
				local shadow = WARGON.make_spawn(pos, "tp_unreal_short_wilson")
				if shadow:on_water() then
					shadow:SpawnShadowBoat(pos)
				end
				shadow.components.follower:SetLeader(GetPlayer())
				GetPlayer().components.sanity:RecalculatePenalty()
			end
		end
		inst:Remove()
	end)
	return inst
end

local function boss_follower_fn()
	local inst = WARGON.make_prefab()
	inst:do_task(0, function()
		local boss_name = inst.boss_name or "bearger"
		local boss = WARGON.make_spawn(inst, boss_name)
		boss:AddTag("tp_summon_creature")
		boss:AddTag("tp_summon_boss")
		if boss.components.follower == nil then
			boss:AddComponent("follower")
		end
		GetPlayer().components.leader:AddFollower(boss)
		boss.components.combat:SetRetargetFunction(3, function(inst, target)
			local notags = {"FX", "NOCLICK","INLIMBO"}
		    local newtarget = FindEntity(inst, 20, function(guy)
		        return  guy.components.combat 
		       		and inst.components.combat:CanTarget(guy) 
		       		and (guy.components.combat.target == GetPlayer() 
		       		or GetPlayer().components.combat.target == guy)
		    end, nil, notags)

		    return newtarget
		end)
		boss:SetBrain(require "brains/abigailbrain")
		boss.AnimState:SetMultColour(1, 1, 1, .7)
		boss:AddTag("tp_no_drop_loot")

		if boss.components.sanityaura then
			boss.components.sanityaura.aurafn = function()
				return 0
			end
		end
		WARGON.no_save(boss)
		boss:do_task(30*16*5, function()
			if inst:is_alive() then
				inst.components.health:Kill()
			end
		end)
		inst:Remove()
	end)
	return inst
end

return 
	Prefab("common/bigfoot_sp", bigfoot_fn, {}),
	Prefab("common/morph_sp", morph_fn, {}),
	Prefab("common/callbeast_sp", callbeast_fn, {}),
	Prefab("common/beefalo_sp", beefalo_fn, {}),
	Prefab("common/rider_sp", rider_fn, {}),
	Prefab("common/shadow_sp", shadow_fn, {}),
	Prefab("common/boss_follower_sp", boss_follower_fn, {}),

	Prefab("common/perd_sp", perd_fn, {})