
local notags = {'NOBLOCK', 'player', 'FX', "tp_bulldozer"}
local function test_ground(inst, pt)
    local tiletype = GetGroundTypeAtPosition(pt)
    local ground_OK = tiletype ~= GROUND.ROCKY and tiletype ~= GROUND.ROAD 
        and tiletype ~= GROUND.IMPASSABLE and tiletype ~= GROUND.INTERIOR 
        and tiletype ~= GROUND.UNDERROCK and tiletype ~= GROUND.WOODFLOOR 
        and tiletype ~= GROUND.MAGMAFIELD and tiletype ~= GROUND.CARPET 
        and tiletype ~= GROUND.CHECKER and tiletype ~= GROUND.ASH 
        and tiletype ~= GROUND.VOLCANO and tiletype ~= GROUND.VOLCANO_ROCK 
        and tiletype ~= GROUND.BRICK_GLOW and tiletype < GROUND.UNDERGROUND
    local ground = GetWorld()
    if ground.Map:IsWater(tiletype) then 
        ground_OK = false 
    end
    if ground_OK then

        pt.x = math.floor(pt.x/4)*4+2
        pt.z = math.floor(pt.z/4)*4+2
        local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 4, nil, notags)
        local min_spacing = 4
        for k, v in pairs(ents) do
            if v ~= inst and v:IsValid() and v.entity:IsVisible() and not v.components.placer and v.parent == nil then
                if distsq( Vector3(v.Transform:GetWorldPosition()), pt) < min_spacing*min_spacing then
                    return false
                end
            end
        end
        return true
    end
    return false 
end

local function get_point_special_actions(inst, pos, useitem, right)
    if right then
        if test_ground(inst, inst:GetPosition()) then
            return {ACTIONS.TP_ASSART}
        end
    end
end

local function action_button_picker(inst)
    return BufferedAction(inst, inst.components.tpvehicleowner.vehicle, ACTIONS.TP_DOWN_CAR)
end

local function left_click_picker(inst, target, pos)
    if target and target.components.tpvehicle
    and target.components.tpvehicle:CanDownCar() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.TP_DOWN_CAR}, target, nil)
    end
    if pos and test_ground(inst, pos) then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.TP_ASSART}, pos, nil)
    end
end

local function right_click_picker(inst, target, pos)
    return {}
end

local function fn(Sim)
    local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize(6, 3.5)
    
    local minimap = inst.entity:AddMiniMapEntity()
    minimap:SetIcon( "metal_head.png" )
    
    inst.Transform:SetSixFaced()

	MakeCharacterPhysics(inst, 1000, 1.5)



    anim:SetBank("metal_hulk")
    anim:SetBuild("metal_hulk_build")
    anim:PlayAnimation("idle", true)
    
    anim:AddOverrideBuild("laser_explode_sm")
    anim:AddOverrideBuild("smoke_aoe")    
    anim:AddOverrideBuild("laser_explosion")   
    anim:AddOverrideBuild("ground_chunks_breaking")   

     





    inst:AddTag("scarytoprey")
    inst:AddTag("companion")




    inst:AddTag("tp_bulldozer")







    
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(TUNING.BEARGER_HEALTH)


    


    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(TUNING.ANCIENT_HULK_DAMAGE)

    inst.components.combat:SetRange(TUNING.ANCIENT_HULK_ATTACK_RANGE, TUNING.ANCIENT_HULK_MELEE_RANGE)
    inst.components.combat:SetAreaDamage(5.5, 0.8)
    inst.components.combat.hiteffectsymbol = "segment01"
    inst.components.combat:SetAttackPeriod(TUNING.BEARGER_ATTACK_PERIOD)










    inst.orbs = 2


    inst:AddComponent("lootdropper")

    


    inst:AddComponent("inspectable")















    inst:AddComponent("fader")
    inst.glow = inst.entity:AddLight()    
    inst.glow:SetIntensity(.6)
    inst.glow:SetRadius(5)
    inst.glow:SetFalloff(3)
    inst.glow:SetColour(1, 0.3, 0.3)
    inst.glow:Enable(false)













    


    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed = TUNING.BEARGER_CALM_WALK_SPEED
    inst.components.locomotor.runspeed = TUNING.BEARGER_RUN_SPEED


    inst:SetStateGraph("SGtp_bulldozer")




    if not inst.shotspawn then
        inst.shotspawn = SpawnPrefab( "ancient_hulk_marker" )        
        inst.shotspawn:Hide()
        inst.shotspawn.persists = false
        local follower = inst.shotspawn.entity:AddFollower()
        follower:FollowSymbol( inst.GUID, "hand01", 0,0,0 )
    end

    inst:ListenForEvent("death", function(inst, data)
        inst.components.lootdropper:DropLoot()
    end)

    inst:AddComponent("tpenergy")
    inst.components.tpenergy:SetMax(300)
    inst.components.tpenergy:SetRate(1)

    inst:AddComponent("tpvehicle")
    inst.components.tpvehicle.ex_up_car = function(inst, doer)



        doer.components.playercontroller.actionbuttonoverride = action_button_picker
        doer.components.playeractionpicker.leftclickoverride = left_click_picker
        doer.components.playeractionpicker.rightclickoverride = right_click_picker
    end
    inst.components.tpvehicle.ex_down_car = function(inst, doer)



        doer.components.playercontroller.actionbuttonoverride = nil
        doer.components.playeractionpicker.leftclickoverride = nil
        doer.components.playeractionpicker.rightclickoverride = nil
    end
    inst:AddComponent("tpvehiclecontroller")
    inst:AddComponent("tpvehicleactionpicker")

    inst:ListenForEvent("actionfailed", function(inst, data)
        print(data.reason)
    end)

    return inst
end

return Prefab("common/tp_bulldozer", fn, {}),
MakePlacer("common/tp_bulldozer_placer", "metal_hulk", "metal_hulk_build", "idle")