


local assets = 
{






    Asset("SOUND", "sound/coal_beast_music.fsb"),
    Asset("SOUNDPACKAGE", "sound/coal_beast_music.fev"),
    Asset("SOUND", "sound/tp_coal_beast_2.fsb"),
    Asset("SOUNDPACKAGE", "sound/tp_coal_beast_2.fev"),
    Asset("SOUND", "sound/tp_boss_scroll_bgm.fsb"),
    Asset("SOUNDPACKAGE", "sound/tp_boss_scroll_bgm.fev"),  
}

local prefabs = 
{




}

local SLEEP_DIST_FROMHOME   = 1
local SLEEP_DIST_FROMTHREAT = 20
local MAX_CHASEAWAY_DIST    = 32
local MAX_TARGET_SHARES     = 5
local SHARE_TARGET_DIST     = 40












local function oneat(inst)

	if inst.components.inventory then
		local maxpoop = 3
		local poopstack = inst.components.inventory:FindItem(function(item) return item.prefab == "poop" end)
		if poopstack and poopstack.components.stackable.stacksize < maxpoop then
			local newpoop = SpawnPrefab("poop")
			inst.components.inventory:GiveItem(newpoop)
		elseif not poopstack then
			local newpoop = SpawnPrefab("poop")
			inst.components.inventory:GiveItem(newpoop)
		end
	end
end

local function OnAttacked(inst, data)
	inst.components.combat:SuggestTarget(data.attacker)
end

local function FindThreatToNest(inst)
    local notags = {"FX", "NOCLICK", "INLIMBO", "spidermonkey"}
    local yestags = {"character", "animal", "monster"}
    if inst.components.homeseeker and inst.components.homeseeker:HasHome() then
        return FindEntity(inst.components.homeseeker.home, TUNING.SPIDER_MONKEY_DEFEND_DIST, function(guy)
            return guy.components.health
                and not guy.components.health:IsDead()
                and inst.components.combat:CanTarget(guy)
        end, nil, notags, yestags)
    end
end

local function retargetfn(inst)
	local newtarget = FindThreatToNest(inst)

    if not newtarget then
        local notags = {"FX", "NOCLICK", "INLIMBO", "aquatic", "werepig"}
        local yestags = {"pig"}
        newtarget = FindEntity(inst,TUNING.SPIDER_MONKEY_TARGET_DIST, function(guy)
            return guy.components.health
                   and not guy.components.health:IsDead()
                   and inst.components.combat:CanTarget(guy)
        end, yestags, notags)
    end

    if not newtarget then
        local notags = {"FX", "NOCLICK", "INLIMBO", "aquatic", "spidermonkey", "aquatic"}
        local yestags = {"character", "monster"}
        newtarget = FindEntity(inst,TUNING.SPIDER_MONKEY_TARGET_DIST, function(guy)
            return  guy.components.health
                and not guy.components.health:IsDead()
                and inst.components.combat:CanTarget(guy)
        end, nil, notags, yestags)
    end

	return newtarget	
end

local function KeepTarget(inst, target)
    local home = inst.components.homeseeker and inst.components.homeseeker.home

    if home then     
        return distsq(Vector3(home.Transform:GetWorldPosition()), Vector3(inst.Transform:GetWorldPosition())) < MAX_CHASEAWAY_DIST*MAX_CHASEAWAY_DIST       
    else
        return true
    end
end

local function IsInCharacterList(name)
	local characters = GetActiveCharacterList()

	for k,v in pairs(characters) do
		if name == v then
			return true
		end
	end
end

local function OnMonkeyDeath(inst, data)
	if data.inst:HasTag("monkey") then
		if IsInCharacterList(data.cause) then

			inst:DoTaskInTime(math.random(), function() 
				if inst.components.inventory then
					inst.components.inventory:DropEverything(false, true)
				end

				if inst.components.homeseeker and inst.components.homeseeker.home then
					inst.components.homeseeker.home:PushEvent("monkeydanger")
				end
			end)
		end
	end
end

local function onpickup(inst, data)
	if data.item then
		if data.item.components.equippable and
		data.item.components.equippable.equipslot == EQUIPSLOTS.HEAD and not 
		inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD) then


			inst:DoTaskInTime(0.1, function() inst.components.inventory:Equip(data.item) end)		
		end
	end
end

local function DoFx(inst)
    if ExecutingLongUpdate then
        return
    end
    inst.SoundEmitter:PlaySound("dontstarve/common/ghost_spawn")
    
    local fx = SpawnPrefab("statue_transition_2")
    if fx then
        fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
        fx.AnimState:SetScale(.8, .8, .8)
    end
    fx = SpawnPrefab("statue_transition")
    if fx then
        fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
        fx.AnimState:SetScale(.8, .8, .8)
    end
end

local function onnear(inst) 
    inst:AddTag("agitated")
    inst:PushEvent("agitated")

end

local function onfar(inst) 
    inst:RemoveTag("agitated")

end

local function OnSave(inst, data)

end

local function OnLoad(inst, data)

end

local function action_button_picker(inst)
    return BufferedAction(inst, inst.components.tpvehicleowner.vehicle, ACTIONS.TP_DOWN_CAR)
end

local function left_click_picker(inst, target, pos)
    if target and target.components.tpvehicle
    and target.components.tpvehicle:CanDownCar() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.TP_DOWN_CAR}, target, nil)
    end



end

local function right_click_picker(inst, target, pos)
    return {}
end

local function energy_off(inst)

    inst:rm_speed_rate("tp_coal_beast")
    inst.components.tpenergy:RemoveBurnModifier("fast")

    inst.components.tpenergy:RemoveBurnModifier("warm")
    inst.components.tpenergy:RemoveBurnModifier("cool")

    inst.components.tpenergy:RemoveBurnModifier("warth")
    inst.components.combat:SetAreaDamage()

    inst.components.health:StopRegen()
    inst.components.tpenergy:RemoveBurnModifier("heal")


    inst.components.health:SetAbsorptionAmount(0)
    inst.components.tpenergy:RemoveBurnModifier("armor")

    inst.components.tpenergy:RemoveBurnModifier("light")
    inst.Light:Enable(false)
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()	
    inst.soundtype = ""
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize(2, 1.25)
	
	inst.Transform:SetFourFaced()


	MakeCharacterPhysics(inst, 40, 1.5)



    anim:SetBank("spiderape")
	anim:SetBuild("SpiderApe_build")
	
	anim:PlayAnimation("idle_loop", true)






	inst:AddComponent("inspectable")



    inst:AddComponent("locomotor")



    inst.components.locomotor.walkspeed = TUNING.SPIDER_MONKEY_SPEED_AGITATED
    inst.components.locomotor.runspeed = TUNING.SPIDER_MONKEY_SPEED_AGITATED

    inst:AddComponent("combat")
    inst.components.combat:SetAttackPeriod(TUNING.SPIDER_MONKEY_ATTACK_PERIOD)
    inst.components.combat:SetRange(TUNING.SPIDER_MONKEY_MELEE_RANGE)

    inst.components.combat:SetDefaultDamage(TUNING.SPIDER_MONKEY_DAMAGE)


    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(TUNING.SPIDER_MONKEY_HEALTH)
    







    inst:AddComponent("lootdropper")










    inst:AddComponent("knownlocations")







    






    inst:SetBrain(require "brains/wilsonbrain")

    inst:SetStateGraph("SGspidermonkey")
    inst.components.combat.not_battle_cry = true








    WARGON.make_map(inst, "spider_monkey_head.tex")

    inst:AddTag("scarytoprey")
    inst:AddTag("companion")
    inst:AddTag("tp_coal_beast")


    inst.entity:AddLight()
    inst.Light:SetColour(180/255, 195/255, 150/255)
    inst.Light:SetIntensity(.6)
    inst.Light:SetRadius(5)
    inst.Light:SetFalloff(.9)
    inst.Light:Enable(false)

    inst:add_cmps({
        cont = {typ="chest"},
    })
    inst.components.container.CollectSceneActions = function()
    end
    inst.components.container.CollectInventoryActions = function()
    end
    inst:ListenForEvent("death", function(inst, data)
        if inst.components.container then
            inst.components.container:DropEverything()
        end
    end)

    inst:AddComponent("tpenergy")
    inst.components.tpenergy:SetMax(1000)
    inst.components.tpenergy:SetRate(.75)
    inst.components.tpenergy.run_out = function(inst)
        energy_off(inst)
        GetPlayer().components.talker:Say("燃料耗尽，所有效果关闭")
    end

    inst:AddComponent("heater")
    inst.components.heater.heatfn = function(inst)





        if inst.components.tpenergy.burn_modifier["warm"] then
            return 70
        elseif inst.components.tpenergy.burn_modifier["cool"] then
            return -10
        end
        return 0
    end

    inst:AddComponent("tpvehicle")
    inst:AddComponent("tpvehiclecontroller")
    inst:AddComponent("tpvehicleactionpicker")

    inst.components.tpvehicle.ex_up_car = function(inst, doer)
        doer.components.playercontroller.actionbuttonoverride = action_button_picker
        doer.components.playeractionpicker.leftclickoverride = left_click_picker
        doer.components.playeractionpicker.rightclickoverride = right_click_picker

    end
    inst.components.tpvehicle.ex_down_car = function(inst, doer)
        doer.components.playercontroller.actionbuttonoverride = nil
        doer.components.playeractionpicker.leftclickoverride = nil
        doer.components.playeractionpicker.rightclickoverride = nil

        inst.SoundEmitter:KillSound("bgm")
        inst.components.container:Close()
        energy_off(inst)
    end
    inst.components.tpvehiclecontroller.can_attack = true

    inst:do_task(0, function()

        inst:rm_speed_rate("tp_coal_beast")
    end)









    inst.OnSave = OnSave
    inst.OnLoad = OnLoad

	return inst
end

return Prefab("common/object/tp_coal_beast", fn, assets, prefabs),
MakePlacer("common/tp_coal_beast_placer", "spiderape", "SpiderApe_build", "idle_loop")
