local Anims = {
	tent = {"tent", "tent", "idle"},
	structures = {"tp_structures", "tp_structures", "tp_auto_chopper"},
}

require "prefabutil"



local assets=
{


}

local prefabs = {}

local function make_strucutres_placer(prefab)
	return WARGON.make_placer(prefab, {"tp_structures", "tp_structures", prefab})
end

local function onhammered(inst, worker)
	if inst:HasTag("fire") and inst.components.burnable then
		inst.components.burnable:Extinguish()
	end
	if not inst:HasTag("burnt") and inst.components.tpstewer and inst.components.tpstewer.product and inst.components.tpstewer.done then
		inst.components.lootdropper:AddChanceLoot(inst.components.tpstewer.product, 1)
	end
	inst.components.lootdropper:DropLoot()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_metal")
	inst:Remove()
end

local function onhit(inst, worker)
	if not inst:HasTag("burnt") then

		
		if inst.components.tpstewer.cooking then


		elseif inst.components.tpstewer.done then

		else

		end
	end
end

local slotpos = {	Vector3(0,64+32+8+4,0), 
					Vector3(0,32+4,0),
					Vector3(0,-(32+4),0), 
					Vector3(0,-(64+32+8+4),0)}

local widgetbuttoninfo = {

	text = STRINGS.TP_STR.tp_craft,
	position = Vector3(0, -165, 0),
	fn = function(inst)
		inst.components.tpstewer:StartCooking()	
	end,
	
	validfn = function(inst)
		return inst.components.tpstewer:CanCook()
	end,
}

local function itemtest(inst, item, slot)
	if not inst:HasTag("burnt") then

			return true

	end
end


local function ShowProduct(inst)
	if not inst:HasTag("burnt") then
		local product = inst.components.tpstewer.product
		if inst.fx == nil then


			inst.fx = WARGON.make_fx2("has_item", inst, {follow=true})
			if product then


				local product_img_manager = WARGON.DATA.tp_data_composed.product_img_manager
				local atlas, image = product_img_manager:get_img(product)
				inst.fx.components.tpfollowimage:SetImage(atlas, image)


			end
		end
	end
end

local function startcookfn(inst)
	if not inst:HasTag("burnt") then








		inst.Light:Enable(true)
	end
end


local function onopen(inst)
	if not inst:HasTag("burnt") then
		inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")
	end
end

local function onclose(inst)
	if not inst:HasTag("burnt") then
		if not inst.components.tpstewer.cooking then


			inst.SoundEmitter:KillSound("snd")
		end
		inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")
	end
end

local function spoilfn(inst)
	if not inst:HasTag("burnt") then
		inst.components.tpstewer.product = inst.components.tpstewer.spoiledproduct
		ShowProduct(inst)
	end
end

local function donecookfn(inst)
	if not inst:HasTag("burnt") then




		ShowProduct(inst)

		inst.Light:Enable(false)




































	end
end

local function continuedonefn(inst)
	if not inst:HasTag("burnt") then


		ShowProduct(inst)
	end
end

local function continuecookfn(inst)
	if not inst:HasTag("burnt") then



		inst.Light:Enable(true)

		inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/smelter/smelt_LP", "snd")
	end
end

local function harvestfn(inst)
	if not inst:HasTag("burnt") then


		if inst.fx then
			inst.fx:Recycle()
			inst.fx = nil
		end
	end
end

local function getstatus(inst)
	if inst:HasTag("burnt") then
		return "BURNT"
	elseif inst.components.tpstewer.cooking and inst.components.tpstewer:GetTimeToCook() > 15 then
		return "COOKING_LONG"
	elseif inst.components.tpstewer.cooking then
		return "COOKING_SHORT"
	elseif inst.components.tpstewer.done then
		return "DONE"
	else
		return "EMPTY"
	end
end

local function onfar(inst)
	if inst.components.container then
		inst.components.container:Close()
	end
end

local function onbuilt(inst)





	inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/smelter/build")






























end

local function onsave(inst, data)
	if inst:HasTag("burnt") or inst:HasTag("fire") then
        data.burnt = true
    end
end

local function onload(inst, data)
	if data and data.burnt then
        inst.components.burnable.onburnt(inst)
        inst.Light:Enable(false)
    end
end

local function onFloodedStart(inst)
	if inst.components.container then 
		inst.components.container.canbeopened = false 
	end 
	if inst.components.tpstewer then 
		if inst.components.tpstewer.cooking then 
			inst.components.tpstewer.product = "wetgoop"
		end 
	end 
end 

local function onFloodedEnd(inst)
	if inst.components.container then 
		inst.components.container.canbeopened = true 
	end 
end 

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	local minimap = inst.entity:AddMiniMapEntity()

	
    local light = inst.entity:AddLight()
    inst.Light:Enable(false)
	inst.Light:SetRadius(.6)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(.5)
    inst.Light:SetColour(235/255,62/255,12/255)
    
    inst:AddTag("structure")
    MakeObstaclePhysics(inst, .5)
    








    inst:AddComponent("tpstewer")
    inst.components.tpstewer.onstartcooking = startcookfn
    inst.components.tpstewer.oncontinuecooking = continuecookfn
    inst.components.tpstewer.oncontinuedone = continuedonefn
    inst.components.tpstewer.ondonecooking = donecookfn
    inst.components.tpstewer.onharvest = harvestfn
    inst.components.tpstewer.onspoil = spoilfn

        
    inst:AddComponent("container")
    inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(4)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_cookpot_1x4"
    inst.components.container.widgetanimbuild = "ui_cookpot_1x4"
    inst.components.container.widgetpos = Vector3(200,0,0)
    inst.components.container.side_align_tip = 100
    inst.components.container.widgetbuttoninfo = widgetbuttoninfo

    inst.components.container.type = "cooker"

    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose

    inst:AddComponent("inspectable")


    inst:AddComponent("playerprox")
    inst.components.playerprox:SetDist(3,5)
    inst.components.playerprox:SetOnPlayerFar(onfar)

    inst:AddComponent("lootdropper")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(4)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)













	inst.OnSave = onsave 
   	inst.OnLoad = onload

    return inst
end

local ComposerData = Class(Prefab, function(self, name, data)
	Prefab._ctor(self, name)
	self.fn = function()
		local inst = fn()
		if data.anim then
			inst.AnimState:SetBank(data.anim[1])
			inst.AnimState:SetBuild(data.anim[2])
			inst.AnimState:PlayAnimation(data.anim[3])
		end
		if data.map then
			inst.MiniMapEntity:SetIcon(data.map)
		end
		if data.products then
			inst.components.tpstewer.product_tbl = data.products
		end
		if data.fn then
			data.fn(inst)
		end
		return inst
	end
end)

local research_center = ComposerData("tp_research_center", {
	anim = {"tp_structures", "tp_structures", "tp_research_center"},
	map = "tp_research_center.tex",

	products = WARGON.DATA.tp_data_composed.all_items[4],
})

local equip_bench = ComposerData("tp_equip_bench", {


	anim = {"tp_structures", "tp_structures", "tp_equip_bench"},
	map = "tp_equip_bench.tex",
	products = WARGON.DATA.tp_data_composed.all_items[5],
})

local equip_bench2 = ComposerData("tp_equip_bench2", {


	anim = {"tp_structures", "tp_structures", "tp_equip_bench2"},
	map = "tp_equip_bench2.tex",
	products = WARGON.DATA.tp_data_composed.all_items[6],
})

local equip_bench3 = ComposerData("tp_equip_bench3", {


	anim = {"tp_structures", "tp_structures", "tp_equip_bench3"},
	map = "tp_equip_bench3.tex",
	products = WARGON.DATA.tp_data_composed.all_items[7],
})

local food_station = ComposerData("tp_food_station", {


	anim = {"tp_structures", "tp_structures", "tp_food_station"},
	map = "tp_food_station.tex",
	products = WARGON.DATA.tp_data_composed.all_items[8],
})

local excellentize_station = ComposerData("tp_excellentize_station", {


	anim = {"tp_structures", "tp_structures", "tp_excellentize_station"},
	map = "tp_excellentize_station.tex",
	products = WARGON.DATA.tp_data_composed.all_items[9],
})

local processing = ComposerData("tp_processing", {
	anim = {"tp_structures", "tp_structures", "tp_processing"},
	map = "tp_processing.tex",
	products = WARGON.DATA.tp_data_composed.all_items[10],
})

local desk2 = ComposerData("tp_desk2", {
	anim = {"tp_structures", "tp_structures", "tp_desk2"},
	map = "tp_desk2.tex",
	products = WARGON.DATA.tp_data_composed.all_items[11],
})

return
research_center,
make_strucutres_placer("tp_research_center"),

equip_bench,

make_strucutres_placer("tp_equip_bench"),
equip_bench2,

make_strucutres_placer("tp_equip_bench2"),
equip_bench3,
make_strucutres_placer("tp_equip_bench3"),

excellentize_station,
make_strucutres_placer("tp_excellentize_station"),

desk2,
make_strucutres_placer("tp_desk2"),
processing,
make_strucutres_placer("tp_processing"),

food_station,
make_strucutres_placer("tp_food_station")






