local brain = require "brains/deerclopsbrain"
require "stategraphs/SGdeerclops"

local assets =
{





}

local prefabs =
{







}

local TARGET_DIST = 30


local function CalcSanityAura(inst, observer)
	
	if inst.components.combat.target then
		return -TUNING.SANITYAURA_HUGE
	else
		return -TUNING.SANITYAURA_LARGE
	end
	
	return 0
end

local function RetargetFn(inst)
    return FindEntity(inst, TARGET_DIST, function(guy)
        return inst.components.combat:CanTarget(guy)
               and not guy:HasTag("prey")
               and not guy:HasTag("smallcreature")
               and (inst.components.knownlocations:GetLocation("targetbase") == nil or guy.components.combat.target == inst)
    end)
end


local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)
end

local function AfterWorking(inst)
    inst.structuresDestroyed = inst.structuresDestroyed + 1
end

local function ShouldSleep(inst)
    return false
end

local function ShouldWake(inst)
    return true
end

local function OnEntitySleep(inst)
    if inst.shouldGoAway then
        inst:Remove()
    end
    inst.structuresDestroyed = 0
end

local function OnSave(inst, data)
    data.structuresDestroyed = inst.structuresDestroyed
    data.shouldGoAway = inst.shouldGoAway
end
        
local function OnLoad(inst, data)
    if data and data.structuresDestroyed and data.shouldGoAway then
        inst.structuresDestroyed = data.structuresDestroyed
        inst.shouldGoAway = data.shouldGoAway
    end
end

local function OnSeasonChange(inst, data)
    inst.shouldGoAway = (GetSeasonManager():GetSeason() ~= SEASONS.WINTER or GetSeasonManager().incaves)
    if inst:IsAsleep() then
        OnEntitySleep(inst)
    end
end

local function OnHitOther(inst, data)
    local other = data.target
    if other and other.components.freezable then
        other.components.freezable:AddColdness(2)
        other.components.freezable:SpawnShatterFX()
    end
end

local function OnAttacked(inst, data)
    inst.components.combat:SetTarget(data.attacker)
end

local function oncollide(inst, other)
    if other == nil or not other:HasTag("tree") then return end
    
    local v1 = Vector3(inst.Physics:GetVelocity())
    if v1:LengthSq() < 1 then return end

    inst:DoTaskInTime(2*FRAMES, function()
        if other and other.components.workable and other.components.workable.workleft > 0 then
            SpawnPrefab("collapse_small").Transform:SetPosition(other:GetPosition():Get())
            other.components.workable:Destroy(inst)
        end
    end)

end

local loot = {"meat", "meat", "meat", "meat", "meat", "meat", "meat", "meat", "deerclops_eyeball"}

local notags = {'NOBLOCK', 'player', 'FX', "tp_deerclops"}
local function test_ground(inst, pt)
    local tiletype = GetGroundTypeAtPosition(pt)
    local ground_OK = tiletype ~= GROUND.ROCKY and tiletype ~= GROUND.ROAD 
        and tiletype ~= GROUND.IMPASSABLE and tiletype ~= GROUND.INTERIOR 
        and tiletype ~= GROUND.UNDERROCK and tiletype ~= GROUND.WOODFLOOR 
        and tiletype ~= GROUND.MAGMAFIELD and tiletype ~= GROUND.CARPET 
        and tiletype ~= GROUND.CHECKER and tiletype ~= GROUND.ASH 
        and tiletype ~= GROUND.VOLCANO and tiletype ~= GROUND.VOLCANO_ROCK 
        and tiletype ~= GROUND.BRICK_GLOW and tiletype < GROUND.UNDERGROUND
    local ground = GetWorld()
    if ground.Map:IsWater(tiletype) then 
        ground_OK = false 
    end
    if ground_OK then

        pt.x = math.floor(pt.x/4)*4+2
        pt.z = math.floor(pt.z/4)*4+2
        local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 4, nil, notags)
        local min_spacing = 4
        for k, v in pairs(ents) do
            if v ~= inst and v:IsValid() and v.entity:IsVisible() and not v.components.placer and v.parent == nil then
                if distsq( Vector3(v.Transform:GetWorldPosition()), pt) < min_spacing*min_spacing then
                    return false
                end
            end
        end
        return true
    end
    return false 
end

local function action_button_picker(inst)
    return BufferedAction(inst, inst.components.tpvehicleowner.vehicle, ACTIONS.TP_DOWN_CAR)
end

local function left_click_picker(inst, target, pos)
    if target and target.components.tpvehicle
    and target.components.tpvehicle:CanDownCar() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.TP_DOWN_CAR}, target, nil)
    end
    if pos and test_ground(inst, pos) then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.TP_MAKE_ICE}, pos, nil)
    end



end

local function right_click_picker(inst, target, pos)
    return {}
end

local function fn(Sim)
    
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
    local s  = 1.65
    inst.Transform:SetScale(s,s,s)
	shadow:SetSize( 6, 3.5 )
    inst.Transform:SetFourFaced()
    
    inst.structuresDestroyed = 0
    inst.shouldGoAway = false
	

	MakeCharacterPhysics(inst, 1000, .5)
    inst.Physics:SetCollisionCallback(oncollide)









    anim:SetBank("deerclops")
    anim:SetBuild("deerclops_build")
    anim:PlayAnimation("idle_loop", true)
    


    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed = 3  
    

    inst:SetStateGraph("SGtp_deerclops")












    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(TUNING.DEERCLOPS_HEALTH)


    
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(TUNING.DEERCLOPS_DAMAGE)

    inst.components.combat:SetRange(TUNING.DEERCLOPS_ATTACK_RANGE)

    inst.components.combat.hiteffectsymbol = "deerclops_body"
    inst.components.combat:SetAttackPeriod(TUNING.DEERCLOPS_ATTACK_PERIOD)


    

 




    


    inst:AddComponent("lootdropper")

    


    inst:AddComponent("inspectable")
	inst.components.inspectable:RecordViews()



    






    inst:AddTag("scarytoprey")
    inst:AddTag("companion")
    inst:AddTag("tp_deerclops")

    inst:AddComponent("tpenergy")
    inst.components.tpenergy:SetMax(600)
    inst.components.tpenergy:SetRate(1)

    inst:AddComponent("tpvehicle")
    inst:AddComponent("tpvehiclecontroller")
    inst:AddComponent("tpvehicleactionpicker")
    inst.components.tpvehicle.ex_up_car = function(inst, doer)
        doer.components.playercontroller.actionbuttonoverride = action_button_picker
        doer.components.playeractionpicker.leftclickoverride = left_click_picker
        doer.components.playeractionpicker.rightclickoverride = right_click_picker
    end
    inst.components.tpvehicle.ex_down_car = function(inst, doer)
        doer.components.playercontroller.actionbuttonoverride = nil
        doer.components.playeractionpicker.leftclickoverride = nil
        doer.components.playeractionpicker.rightclickoverride = nil
    end

    inst.OnSave = OnSave
    inst.OnLoad = OnLoad

    return inst
end

return Prefab( "common/object/tp_deerclops", fn, assets, prefabs),
MakePlacer("common/tp_deerclops_placer", "deerclops", "deerclops_build", "idle_loop",nil,nil,nil,1.65)