require "prefabutil"



local assets=
{


}

local prefabs = {}


local function onhammered(inst, worker)
	if inst:HasTag("fire") and inst.components.burnable then
		inst.components.burnable:Extinguish()
	end



	inst.components.lootdropper:DropLoot()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_metal")
	inst:Remove()
end

local function onhit(inst, worker)
	if not inst:HasTag("burnt") then

		
		if inst.components.tpenchantmenter.cooking then

		elseif inst.components.tpenchantmenter.done then

		else

		end
	end
end

local slotpos = {	Vector3(0,64+32+8+4,0), 
					Vector3(0,32+4,0),
					Vector3(0,-(32+4),0), 
					Vector3(0,-(64+32+8+4),0)
				}

local widgetbuttoninfo = {
	text = STRINGS.ACTIONS.COOK.SMELT,
	position = Vector3(0, -165, 0),
	fn = function(inst)
		inst.components.tpenchantmenter:StartCooking()	
	end,
	
	validfn = function(inst)
		return inst.components.tpenchantmenter:CanCook()
	end,
}

local function itemtest(inst, item, slot)

	if not inst:HasTag("burnt") then
		if inst.components.container:IsEmpty() 
		and item.components.tpenchantment 
		and not item:HasTag("tp_item") then
			if item.components.stackable
			and item.components.stackable:StackSize() > 1 then
				return false
			end
			return true
		end
		if not inst.components.container:IsEmpty() 
		and item:HasTag("tp_gem") then
			return true
		end
	end
end


local function ShowProduct(inst)
	if not inst:HasTag("burnt") then














	end
end

local function startcookfn(inst)
	if not inst:HasTag("burnt") then







		inst.Light:Enable(true)
	end
end


local function onopen(inst)
	if not inst:HasTag("burnt") then
		inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")
	end
end

local function onclose(inst)
	if not inst:HasTag("burnt") then
		if not inst.components.tpenchantmenter.cooking then


			inst.SoundEmitter:KillSound("snd")
		end
		inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")
	end
end

local function spoilfn(inst)
	if not inst:HasTag("burnt") then
		inst.components.tpenchantmenter.product = inst.components.tpenchantmenter.spoiledproduct
		ShowProduct(inst)
	end
end

local function donecookfn(inst)
	if not inst:HasTag("burnt") then




		ShowProduct(inst)

		inst.Light:Enable(false)




































	end
end

local function continuedonefn(inst)
	if not inst:HasTag("burnt") then


		ShowProduct(inst)
	end
end

local function continuecookfn(inst)
	if not inst:HasTag("burnt") then


		inst.Light:Enable(true)

		inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/smelter/smelt_LP", "snd")
	end
end

local function harvestfn(inst)
	if not inst:HasTag("burnt") then


		if inst.fx then
			inst.fx:Remove()
			inst.fx = nil
		end
	end
end

local function getstatus(inst)
	if inst:HasTag("burnt") then
		return "BURNT"
	elseif inst.components.tpenchantmenter.cooking and inst.components.tpenchantmenter:GetTimeToCook() > 15 then
		return "COOKING_LONG"
	elseif inst.components.tpenchantmenter.cooking then
		return "COOKING_SHORT"
	elseif inst.components.tpenchantmenter.done then
		return "DONE"
	else
		return "EMPTY"
	end
end

local function onfar(inst)
	if inst.components.container then
		inst.components.container:Close()
	end
end

local function onbuilt(inst)




	inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/smelter/build")






























end

local function onsave(inst, data)
	if inst:HasTag("burnt") or inst:HasTag("fire") then
        data.burnt = true
    end
end

local function onload(inst, data)
	if data and data.burnt then
        inst.components.burnable.onburnt(inst)
        inst.Light:Enable(false)
    end
end

local function onFloodedStart(inst)
	if inst.components.container then 
		inst.components.container.canbeopened = false 
	end 
	if inst.components.tpenchantmenter then 
		if inst.components.tpenchantmenter.cooking then 
			inst.components.tpenchantmenter.product = "wetgoop"
		end 
	end 
end 

local function onFloodedEnd(inst)
	if inst.components.container then 
		inst.components.container.canbeopened = true 
	end 
end 

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "tp_enchantmenter.tex" )

	
    local light = inst.entity:AddLight()
    inst.Light:Enable(false)
	inst.Light:SetRadius(.6)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(.5)
    inst.Light:SetColour(235/255,62/255,12/255)
    
    inst:AddTag("structure")
    MakeObstaclePhysics(inst, .5)
   






	inst.AnimState:SetBank("tp_structures")
    inst.AnimState:SetBuild("tp_structures")
    inst.AnimState:PlayAnimation("tp_enchantmenter")


    inst:AddComponent("tpenchantmenter")
    inst.components.tpenchantmenter.onstartcooking = startcookfn
    inst.components.tpenchantmenter.oncontinuecooking = continuecookfn
    inst.components.tpenchantmenter.oncontinuedone = continuedonefn
    inst.components.tpenchantmenter.ondonecooking = donecookfn
    inst.components.tpenchantmenter.onharvest = harvestfn
    inst.components.tpenchantmenter.onspoil = spoilfn
    
    inst:AddComponent("container")
    inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_cookpot_1x4"
    inst.components.container.widgetanimbuild = "ui_cookpot_1x4"
    inst.components.container.widgetpos = Vector3(200,0,0)
    inst.components.container.side_align_tip = 100
    inst.components.container.widgetbuttoninfo = widgetbuttoninfo
    inst.components.container.acceptsstacks = false
    inst.components.container.type = "cooker"

    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose

    inst:AddComponent("inspectable")


    inst:AddComponent("playerprox")
    inst.components.playerprox:SetDist(3,5)
    inst.components.playerprox:SetOnPlayerFar(onfar)

    inst:AddComponent("lootdropper")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(4)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)








	inst:ListenForEvent( "onbuilt", onbuilt)




	inst.OnSave = onsave 
   	inst.OnLoad = onload

    return inst
end

return Prefab( "common/tp_enchantmenter", fn, assets, prefabs),
		MakePlacer( "common/tp_enchantmenter_placer", "tp_structures", "tp_structures", "tp_enchantmenter" ) 
