local brain = require "brains/koalefantbrain"
require "stategraphs/SGkoalefant"

local assets=
{






}

local prefabs =
{




}





local WAKE_TO_RUN_DISTANCE = 10
local SLEEP_NEAR_ENEMY_DISTANCE = 14

local function ShouldWakeUp(inst)
    return DefaultWakeTest(inst) or inst:IsNear(GetPlayer(), WAKE_TO_RUN_DISTANCE)
end

local function ShouldSleep(inst)
    return DefaultSleepTest(inst) and not inst:IsNear(GetPlayer(), SLEEP_NEAR_ENEMY_DISTANCE)
end

local function Retarget(inst)

end

local function KeepTarget(inst, target)
    return distsq(Vector3(target.Transform:GetWorldPosition() ), Vector3(inst.Transform:GetWorldPosition() ) ) < TUNING.KOALEFANT_CHASE_DIST * TUNING.KOALEFANT_CHASE_DIST
end

local function OnNewTarget(inst, data)

end

local function GetStatus(inst)

end

local function OnAttacked(inst, data)
    inst.components.combat:SetTarget(data.attacker)
    inst.components.combat:ShareTarget(data.attacker, 30,function(dude)
        return dude:HasTag("koalefant") and not dude:HasTag("player") and not dude.components.health:IsDead()
    end, 5)
end


local function action_button_picker(inst)
    return BufferedAction(inst, inst.components.tpvehicleowner.vehicle, ACTIONS.TP_DOWN_CAR)
end

local function left_click_picker(inst, target, pos)
    if target and target.components.tpvehicle
    and target.components.tpvehicle:CanDownCar() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.TP_DOWN_CAR}, target, nil)
    end



end

local function right_click_picker(inst, target, pos)
    return {}
end

local function energy_off(inst)

    inst.components.tpenergy:RemoveBurnModifier("harvest")
    inst.components.tpfollowimage:Kill()
    if inst.task then
        inst.task:Cancel()
        inst.task = nil
    end
end


local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 4.5, 2 )
    inst.Transform:SetFourFaced()

    MakePoisonableCharacter(inst)
    MakeCharacterPhysics(inst, 100, .75)
    
    anim:SetBank("koalefant")
    anim:SetBuild("koalefant_summer_build")
    anim:PlayAnimation("idle_loop", true)
    



    


    
    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "beefalo_body"
    inst.components.combat:SetDefaultDamage(TUNING.KOALEFANT_DAMAGE)




    
     
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(TUNING.KOALEFANT_HEALTH)

    inst:AddComponent("lootdropper")
    
    inst:AddComponent("inspectable")

    

    










    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed = 1.5
    inst.components.locomotor.runspeed = 7
    




    

    inst:SetStateGraph("SGkoalefant")

    WARGON.make_map(inst, "koalefant_head.tex")

    inst:AddTag("scarytoprey")
    inst:AddTag("companion")
    inst:AddTag("tp_fant")

    inst:add_cmps({
        cont = {typ="3x4"},
    })
    inst.components.container.CollectSceneActions = function()
    end
    inst.components.container.CollectInventoryActions = function()
    end
    inst:ListenForEvent("death", function(inst, data)
        if inst.components.container then
            inst.components.container:DropEverything()
        end
    end)

    inst:AddComponent("tpfollowimage")

    inst:AddComponent("tpenergy")
    inst.components.tpenergy:SetMax(500)
    inst.components.tpenergy:SetRate(.5)
    inst.components.tpenergy.run_out = function(inst)
        energy_off(inst)
        GetPlayer().components.talker:Say("燃料耗尽，所有效果关闭")
    end

    inst:AddComponent("tpvehicle")
    inst:AddComponent("tpvehiclecontroller")
    inst:AddComponent("tpvehicleactionpicker")
    inst.components.tpvehicle.ex_up_car = function(inst, doer)
        doer.components.playercontroller.actionbuttonoverride = action_button_picker
        doer.components.playeractionpicker.leftclickoverride = left_click_picker
        doer.components.playeractionpicker.rightclickoverride = right_click_picker
    end
    inst.components.tpvehicle.ex_down_car = function(inst, doer)
        doer.components.playercontroller.actionbuttonoverride = nil
        doer.components.playeractionpicker.leftclickoverride = nil
        doer.components.playeractionpicker.rightclickoverride = nil
        inst.components.container:Close()
        energy_off(inst)
    end

    return inst
end



















return Prefab( "common/object/tp_fant", fn, assets, prefabs),
MakePlacer("tp_fant_placer", "koalefant", "koalefant_summer_build", "idle_loop")

