local GiftDialog = require("screens/gift_select")

local Anims = {
	log = {"log", "log", "idle"},
	acorn = {"acorn", "acorn", "idle", },
	coconut = {"coconut", "coconut", "idle", },
	teatree_nut = {"teatree_nut", "teatree_nut", "idle", },
	soft_wood = {"armor_wood_haramaki", "armor_wood_haramaki", "anim", "idle_water", },
	wood = {"armor_wood_fangedcollar", "armor_wood_fangedcollar", "anim", "idle_water", },
	strawhat = {"strawhat", "strawhat_cowboy", "anim", "idle_water", },
	ham = {"ham_bat", "ham_bat_spiralcut", "idle", "idle_water", },
	gasmask = {"gasmaskhat", "hat_gasmask", "anim", "idle_water", },
	fix_powder = {"tp_fix_powder", "tp_fix_powder", "idle", "idle_water", },
	tall_bird_egg = {"egg", "tallbird_egg", "egg", "idle_water", },
	book_maxwell = {"book_maxwell", "book_maxwell", "idle", "idle_water", },
	map = {"stash_map", "stash_map", "idle", "idle_water", },
	ballhat = {"footballhat", "footballhat_combathelm", "anim", "idle_water", },
	cutlass = {"tp_cutlass", "tp_cutlass", "idle", "idle_water", },
	ice_staff = {"staffs", "icestaff_bee", "bluestaff", "bluestaff_water", },
	pigking_hat = {"beefalohat", "beefalohat_pigking", "anim", "idle_water", },
	egg_tool = {"tp_egg_tool", "tp_egg_tool", "idle", "idle_water", },
	epic = {"tp_items", "tp_items", "tp_epic", "tp_epic", },
	rocket = {"tp_rocket", "tp_rocket", "idle", },
	books = {"books", "books", "book_sleep", "book_sleep_water", },
	gingko_leaf = {"tp_gingko_leaf", "tp_gingko_leaf", "idle", },
	gift = {"tp_gift", "tp_gift", "idle", },
	spear = {"spear", "spear_bee", "idle", "idle_water", },
	grass_pigking = {"topiary", "topiary_pigking_build", "idle", },
	octopus = {"tp_octopus", "tp_octopus", "idle", "idle_water", },
	horn = {"horn", "horn", "idle", "idle_water", },
	gun = {"tp_swords", "tp_swords", "tp_forest_handarm", "tp_forest_handarm_water", },
	wortox_soul = {"wortox_soul_ball", "wortox_soul_ball", "idle_loop", "idle_loop", },
	amulet = {"amulets", "amulet_red_occulteye", "redamulet", "redamulet_water", },
	alloy = {"tp_alloy", "tp_alloy", "idle", "idle_water", },
	sword = {"nightmaresword", "nightsword_sharp", "idle", "idle_water", },
	jungletreeseed = {"jungletreeseed", "jungletreeseed", "idle", },
	pinecone = {"pinecone", "pinecone", "idle", },
	strawhat_trap = {"tp_strawhat_trap", "tp_strawhat_trap", "idle", "idle_water", },
	pig_lamp = {"pig_lamp", "pig_lamp", "idle_on", "idle_on_water", },
	pig_book = {"pig_book", "pig_book", "idle", "idle_water", },
	cane = {"cane", "cane_ancient", "idle", "idle_water", },
	sign = {"tp_sign_staff", "tp_sign_staff", "idle", "idle_water", },
	flare = {"tp_flare", "tp_flare", "idle", },
	ash = {"ash", "ash", "idle", },
	fire_staff = {"staffs", "firestaff_bee", "redstaff", "redstaff_water", },
	bat_scythe = {"batbat", "batbat_scythe", "idle", "idle_water"},
	flavour = {"tp_flavour", "tp_flavour", "idle", },
	tracker = {"tracker", "tracker", "idle"},
	trinket19 = {"trinkets", "trinkets", "19", "19_water"},
	redmooneye = {"redmooneye", "redmooneye", "idle"},
	bluemooneye = {"bluemooneye", "bluemooneye", "idle"},
	purplemooneye = {"purplemooneye", "purplemooneye", "idle"},
	greenmooneye = {"greenmooneye", "greenmooneye", "idle"},
	orangemooneye = {"orangemooneye", "orangemooneye", "idle"},
	yellowmooneye = {"yellowmooneye", "yellowmooneye", "idle"},
	axe_northern = {"axe", "axe_northern", "idle", "idle_water"},
	goldenaxe_northern = {"goldenaxe", "goldenaxe_northern", "idle", "idle_water"},
	pickaxe_northern = {"pickaxe", "pickaxe_northern", "idle", "idle_water"},
	goldenpickaxe_northern = {"goldenpickaxe", "goldenpickaxe_northern", "idle", "idle_water"},
	shovel_northern = {"shovel", "shovel_northern", "idle", "idle_water"},
	goldenshovel_northern = {"goldenshovel", "goldenshovel_northern", "idle", "idle_water"},
	spear_gun = {"tp_spear_gun", "tp_spear_gun", "idle", "idle_water"},
	bugnet_spider = {"bugnet", "bugnet_spider", "idle", "idle_water"},
	fodder = {"tp_fodder", "tp_fodder", "idle"},
	tuna = {"tuna", "tuna", "idle", "idle_water"},
	big_gun = {"big_gun", "big_gun", "idle", "idle_water"},
	ham_potroast = {"ham_bat", "ham_bat_potroast", "idle", "idle_water", },
	hat_chef = {"tp_hat_chef", "tp_hat_chef", "anim", "idle_water"},

	sleeping_pill = {"tp_sleeping_pill", "tp_sleeping_pill", "idle"},
	magic_books = {"tp_magic_books", "tp_magic_books", "book1"},
}

local function MakeItem(name, anims, item_fn, atlas, img)
	local function fn()
		local the_atlas, the_img
		if atlas and img then
			the_atlas = atlas and "images/inventoryimages/"..atlas..".xml" 
			the_img = img
		else
			the_atlas, the_img = WARGON.resolve_img_path(atlas)
		end
		the_img = string.sub(the_img, 1, -5)
	 	local inst = WARGON.make_prefab(anims, anims[4], "inv", nil, nil)
	 	WARGON_CMP_EX.add_cmps(inst, {
	 		invitem = {atlas=the_atlas, img=the_img},
	 	})
	 	inst:AddTag("tp_item")
	 	if item_fn then
	 		item_fn(inst)
	 	end

	    return inst
	end
	return Prefab("common/inventory/"..name, fn, {})
end

local function do_area_damage(inst, range, dmg, reason)
	local owner = inst.components.inventoryitem.owner
	WARGON.area_dmg(inst, range, owner, dmg, reason)
end

local function on_finish(inst)
	inst:Remove()
end

local function head_unequip(inst, owner)
	WARGON.EQUIP.hat_off(owner)
	if inst.components.fueled then
		inst.components.fueled:StopConsuming()
	end
end

local function hand_unequip(inst, owner)
	WARGON_EQUIP_EX.object_off(owner)
end

local function strawhat_equip(inst, owner)

	WARGON_EQUIP_EX.object_on(owner, "tp_strawhat", "swap_object")
end

local function strawhat_score(inst, giver)
	local pos = inst:GetPosition()
	if pos.y <= 0.1 then

		inst.components.tphatball:Trigger(giver)
		if inst.tp_per_task then
			inst.tp_per_task:Cancel()
			inst.tp_per_task = nil
		end
	end
end

local function strawhat_throw(inst, thrower, pt)

	inst.Physics:SetFriction(.2)
	if inst.tp_per_task == nil 
	and not inst.components.tphatball.pet then

		inst.tp_per_task = WARGON.per_task(inst, .1, function() 
			strawhat_score(inst, thrower) 
		end)
	end
end

local function strawhat_fn(inst)
	WARGON_CMP_EX.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=1},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		equip = {equip=strawhat_equip, unequip=hand_unequip},
		throw = {throw=strawhat_throw},
		tphatball = {},
		tpuse = {},
	})
	inst.components.tpuse.use = function(inst, doer)
		if inst.components.tphatball.pet then
			inst.components.tphatball:Release(doer)
			inst:Remove()
		end
	end
	inst.components.tpuse.can = function(inst)
		return inst.components.tphatball.pet ~= nil
	end

end

local function strawhat2_equip(inst, owner)
	WARGON.EQUIP.hat_on(owner, "strawhat_cowboy")
	inst.components.fueled:StartConsuming()
end

local function strawhat2_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		equip = {equip=strawhat2_equip, unequip=head_unequip, slot='head'},
		water = {value=TUNING.WATERPROOFNESS_SMALL},
		insu = {value=TUNING.INSULATION_SMALL, typ="summer"},
		fueled = {time=TUNING.STRAWHAT_PERISHTIME, typ="usage", fn={finish=on_finish}},
	})
end

local function strawhat_saddle_finish(inst)
	on_finish(inst)
end

local function strawhat_saddle_fn(inst)
	inst:add_tags({
		"tp_open_beefalo_container",
	})
	inst.mounted_foleysound = "dontstarve/beefalo/saddle/regular_foley"
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		finite = {max=10, use=10, fn=strawhat_saddle_finish},
		saddler = {},
		})
	inst.components.saddler:SetBonusDamage(1)
    inst.components.saddler:SetBonusSpeedMult(1)
    inst.components.saddler:SetSwaps("strawhat_cowboy", "swap_hat")
    inst.components.saddler:SetDiscardedCallback(function() end)
end

local function strawhat_trap_harvest(inst)
	inst.components.finiteuses:Use()
end

local function strawhat_trap_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		trap = {},
		finite = {use=10, max=10, fn=on_finish},
		})
	WARGON.add_tags(inst, {
		"trap",
		})
	inst.components.trap.targettag = "canbetrapped"
	inst.components.trap:SetOnHarvestFn(strawhat_trap_harvest)
	inst.components.trap.baitsortorder = 1
	inst:SetStateGraph("SGtrap")
	inst.sounds = {
		close = "dontstarve/common/trap_close",
		rustle = "dontstarve/common/trap_rustle",
	}
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon("strawhat_cowboy.tex")
end

local function ballhat_attacked(owner, data)
	local pt = owner:GetPosition()
	pt.y = pt.y + 1.5

	if math.random() < .3 then
		if owner.components.tpbuff then
			owner.components.tpbuff:AddBuff("tp_ballhat")
		end
	end
end

local function ballhat_equip(inst, owner)
	WARGON.EQUIP.hat_on(owner, "footballhat_combathelm")



	owner:ListenForEvent("attacked", ballhat_attacked)
end

local function ballhat_unequip(inst, owner)
	WARGON.EQUIP.hat_off(owner)
	owner:RemoveEventCallback("attacked", ballhat_attacked)

end

local function ballhat_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		armor = {armor=TUNING.ARMOR_FOOTBALLHAT, absorb=.8},
		equip = {slot="head", equip=ballhat_equip, unequip=ballhat_unequip},
		water = {value=TUNING.WATERPROOFNESS_SMALL},
		})
end

local function wood_equip(inst, owner)
	WARGON_EQUIP_EX.object_on(owner, "armor_wood_fangedcollar", "swap_body")
end

local function wood_fn(inst)
	WARGON_CMP_EX.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34*1.5},
		equip = {equip=wood_equip, unequip=hand_unequip},
		armor = {armor=TUNING.ARMORWOOD , absorb=.8},
		fuel = {value=TUNING.LARGE_FUEL},
	})
	WARGON.make_burn(inst, "small", TUNING.SMALL_BURNTIME)
	WARGON.make_prop(inst, "small")
	inst.components.burnable:MakeDragonflyBait(3)
	WARGON.add_tags(inst, {"slowattack"})
end

local function ham_update(inst)
	if inst.components.perishable and inst.components.weapon then
		local dmg = 34*1.75 * inst.components.perishable:GetPercent()
        dmg = Remap(dmg, 0, 34*1.75, TUNING.HAMBAT_MIN_DAMAGE_MODIFIER*34*1.75, 34*1.75)
        inst.components.weapon:SetDamage(dmg)
	end
end

local function ham_weapon_fn(inst, owner, target)
	ham_update(inst)


	local p = inst.components.perishable:GetPercent()
	if math.random() < .1*p then
		local meat = SpawnPrefab("smallmeat")
		WARGON.pigking_throw(inst, meat)
	end
end

local function ham_equip(inst, owner)
	WARGON_EQUIP_EX.object_on(owner, "swap_ham_bat_spiralcut", "swap_ham_bat")
end






























local function ham_onload(inst, data)
	ham_update(inst)
end

local function ham_fn(inst)
	WARGON_CMP_EX.add_cmps(inst, {
		perish = {time=TUNING.PERISH_MED, spoil="spoiled_food"},
		weapon = {dmg=34*1.75, fn=ham_weapon_fn},
		equip = {equip=ham_equip, unequip=hand_unequip},

	})
	WARGON.add_tags(inst, {
		"show_spoilage", "icebox_valid", "tp_must_spoilsh"
	})



	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(20)
	inst:AddTag("tp_move_no_target")

	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_TOU"
	inst.components.tpmove.onmove = function()
		inst.components.tprecharge:SetRechargeTime()
		WARGON.make_fx(inst, "tp_fx_ham_ground_pound")
	end
	inst:AddComponent("tpinter")
	inst.components.tpinter:SetFn(function(inst, item, doer)
		local delta = 0
		local item = item.components.stackable:Get()
		if item.components.perishable then
			delta = item.components.perishable.perishremainingtime
		end
		local current = item.components.perishable.perishremainingtime
		local max = item.components.perishable.perishtime
		local percent = (current + delta)/max
		inst.components.perishable:SetPercent(percent)
		item:Remove()
	end)
	inst.components.tpinter:SetCanFn(function(inst, item, doer)
		return item:HasTag("tp_hambat_fuel")
	end)
	inst.OnLoad = ham_onload
end

local function staff_trinity_equip(inst, owner)
	local bank, build = inst.components.tptrinity:GetBuild()
	WARGON.EQUIP.object_on(owner, bank, build)
end

local function staff_trinity_use_test(inst)
	return inst.components.equippable:IsEquipped()
end

local function staff_trinity_use_use(inst)
	inst.components.tptrinity:Change()
end

local function staff_trinity_spear(inst)
	WARGON.CMP.add_cmps(inst, {
		weapon = {dmg=34, fn="nil", fx='nil', range={nil,nil}},
	})

	WARGON.add_tags(inst, {"sharp"})
	WARGON.remove_tags(inst, {'rangedlighter', 'extinguisher', "tp_witch_staff"})
end

local function staff_trinity_ice_weapon_fn(inst, owner, target)



	WARGON.frozen_prefab(target, owner)
	if owner and owner.components.sanity then
		owner.components.sanity:DoDelta(-TUNING.SANITY_SUPERTINY)
	end
end

local function staff_trinity_ice(inst)
	WARGON.CMP.add_cmps(inst, {
		weapon = {dmg=0, fn=staff_trinity_ice_weapon_fn, fx='ice_projectile',
			range={8,10} },
	})







	WARGON.add_tags(inst, {'extinguisher', "tp_witch_staff"})
	WARGON.remove_tags(inst, {"sharp", 'rangedlighter'})
end

local function staff_trinity_fire_weapon_fn(inst, owner, target)
	WARGON.fire_prefab(target, owner)
    if owner and owner.components.sanity then
        owner.components.sanity:DoDelta(-TUNING.SANITY_SUPERTINY)
    end
    owner.SoundEmitter:PlaySound("dontstarve/wilson/fireball_explo")
    if not owner:HasTag("tp_hat_witch") then
	    target:PushEvent("attacked", { attacker = owner, damage = 0 })
    end
end

local function staff_trinity_fire(inst)
	WARGON.CMP.add_cmps(inst, {
		weapon = {dmg=0, fn=staff_trinity_fire_weapon_fn, fx='fire_projectile',
			range={8,10} },	
	})







	WARGON.add_tags(inst, {'rangedlighter', "tp_witch_staff"})
	WARGON.remove_tags(inst, {"sharp", 'extinguisher'})
end

local function staff_trinity_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34},
		equip = {equip=staff_trinity_equip, unequip=hand_unequip},
		finite = {use=150, max=150, fn=on_finish},
		use = {str="切换", test=staff_trinity_use_test, use=staff_trinity_use_use},
	})
	inst:AddComponent("tptrinity")
	inst.components.tptrinity:SetBuild({
		{'swap_spear_bee', 'swap_spear'},
		{'swap_icestaff_bee', 'swap_bluestaff'},
		{'swap_firestaff_bee', 'swap_redstaff'},
	})
	inst.components.tptrinity:SetImage({
		'spear_bee#',
		'icestaff_bee#',
		'firestaff_bee#',
	})
	inst.components.tptrinity:SetFn({
		staff_trinity_spear,
		staff_trinity_ice,
		staff_trinity_fire,
	})
end

local function flare_on(inst)
	inst:RemoveComponent("inventoryitem")
	WARGON.do_task(inst, .5, function()
		inst.Physics:SetMotorVel(0, 40, 0)
		WARGON.do_task(inst, 1, function()
			WARGON.do_task(GetPlayer(), 2, function()
				if GetWorld().components.seasonmanager.precip then
			       GetWorld().components.seasonmanager:StopPrecip()
			    else
			       GetWorld().components.seasonmanager:ForcePrecip()
			    end
			end)
			inst:Remove()
		end)
	end)
end

local function flare_machine_test(inst)
	if inst.components.inventoryitem then
		return inst.components.inventoryitem.owner == nil
	end
end

local function flare_drop(inst)
	inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("idle", false)
end

local function flare_ignite(inst)




	inst.AnimState:PlayAnimation("fire")
	inst:ListenForEvent("animover", function()

		WARGON.do_task(GetPlayer(), 2, function()
			if GetWorld().components.seasonmanager.precip then
		       GetWorld().components.seasonmanager:StopPrecip()
		    else
		       GetWorld().components.seasonmanager:ForcePrecip()
		    end
		end)
		inst:Remove()
	end)
end

local function flare_fn(inst)
	WARGON_CMP_EX.add_cmps(inst, {
		inspect = {},

		invitem = {drop=flare_drop},
		burnable = {},
	})
	WARGON.add_listen(inst, {
		onignite = flare_ignite
	})
end

local function cane_equip(inst, owner)
	WARGON_EQUIP_EX.object_on(owner, "swap_cane_ancient", "swap_cane")
	if inst.fx == nil then
		inst.fx = SpawnPrefab("tp_sparkle_fx")
		inst.fx.entity:AddFollower()
	end
	inst.fx.Follower:FollowSymbol(owner.GUID, "swap_object", 0, -110, 0)
end

local function cane_unequip(inst, owner)
	hand_unequip(inst, owner)
	if inst.fx then
		inst.fx:Remove()
		inst.fx = nil
	end
end

local function cane_fn(inst)
	WARGON_CMP_EX.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=10},
		equip = {equip=cane_equip, unequip=cane_unequip, effect={speed=0.25}},
		})
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(1)
	inst:AddTag("tp_move_no_target")
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_HUA"
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(1)
	end
end

local function mk_lv_dmg(inst, owner, target)



end

local function cutlass_weapon_fn(inst, attacker, target)
	if target:HasTag("epic") then
        target.components.health:DoTrueDelta(-TUNING.CUTLASS_BONUS_DAMAGE)
    end




end

local function cutlass_equip(inst, owner)
	WARGON_EQUIP_EX.object_on(owner, "tp_cutlass", "swap_object")






















end

local function cutlass_unequip(inst, owner)
	hand_unequip(inst, owner)




end

local function cutlass_fn(inst)
	WARGON_CMP_EX.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=TUNING.CUTLASS_DAMAGE, fn=cutlass_weapon_fn},
		equip = {equip=cutlass_equip, unequip=cutlass_unequip},
		finite = {use=TUNING.CUTLASS_USES, max=TUNING.CUTLASS_USES, fn=on_finish},
		})
	inst:AddTag("tp_forge_weapon")
	inst.components.weapon.getdamagefn = function(inst)
		local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
		local dmg = owner and owner.components.tplevel and owner.components.tplevel.attr.forge or 0
		return inst.components.weapon.damage + dmg
	end
	inst.AnimState:SetMultColour(1, 1, 1, .6)
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_CI"
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		inst:StartThread(function()
			for i = 1, 3 do
				do_area_damage(inst, 1.5, 50, "cutlass")
				WARGON.make_fx(inst, "splash_water_sink")
				Sleep(0.1)
			end
		end)
	end
end

local function sign_staff_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_sign_staff", "swap_object")
end

local function sign_staff_spell(staff, target, pos)
	WARGON.make_fx(pos, "tp_fx_sign_wan")
	staff.components.tprecharge:SetRechargeTime(30)
	staff.components.finiteuses:Use()
	local caster = staff.components.inventoryitem.owner
	if caster and caster.components.sanity then
		caster.components.sanity:DoDelta(-TUNING.SANITY_HUGE)
	end
end

local function sign_staff_test(staff, caster, target, pos)
	if staff.components.tprecharge then
		return staff.components.tprecharge:IsRecharged()
	end
end

local function sign_staff_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		equip = {equip=sign_staff_equip, unequip=hand_unequip},
		finite = {use=5, max=5, fn=on_finish},
		caster = {spell=sign_staff_spell, test=sign_staff_test, can={point=true, inv=false}},
		})
	WARGON.add_tags(inst, {"nosteal", "nopunch"})
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(30)
	inst.fxcolour = {223/255, 208/255, 69/255}
	inst.castsound = "dontstarve/common/staffteleport"
end

local function forest_gun_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_forest_handarm", "swap_object")







end

local function forest_gun_unequip(inst, owner)
	hand_unequip(inst, owner)




end

local function forest_gun_weapon_fn(inst, owner, target)
	if inst.components.tpbullets:GetNum() > 0 then

		inst.components.tpbullets:Lose(1)
		if math.random() < .01 then
			local pos = WARGON.around_land(inst, 2)
			if pos then
				WARGON.make_spawn(pos, "tp_reporter6")
			end
		end
	end
end

local function forest_gun_take_bullet(inst)
	WARGON.CMP.add_cmps(inst, {
		weapon = {dmg=48, fx="tp_tree_seed_bullet", range={11, 13}},
	})
	WARGON.add_tags(inst, {"projectile", "speargun", "tp_forest_gun"})
end

local function forest_gun_lose_bullet(inst)
	WARGON.CMP.add_cmps(inst, {
		weapon = {dmg=10, fx="nil", range={nil, nil}},
	})
	WARGON.remove_tags(inst, {"projectile", "speargun", "tp_forest_gun"})
end

local function forest_gun_change_bullet(inst, current)
	if current == "pinecone" then
		WARGON.CMP.add_cmps(inst, {
			weapon = {dmg=68, fx="tp_tree_seed_bullet_2", range={16, 18}},
		})
	elseif current == "acorn" then
		WARGON.CMP.add_cmps(inst, {
			weapon = {dmg=48, fx="tp_tree_seed_bullet", range={12, 14}},	
		})
	elseif current == "jungletreeseed" then
		WARGON.CMP.add_cmps(inst, {
			weapon = {dmg=68, fx="tp_tree_seed_bullet_3", range={12, 14}},	
		})
	elseif current == "teatree_nut" then
		WARGON.CMP.add_cmps(inst, {
			weapon = {dmg=68, fx="tp_tree_seed_bullet_4", range={12, 14}},	
		})
	elseif current == "coconut" then
		WARGON.CMP.add_cmps(inst, {
			weapon = {dmg=68, fx="tp_tree_seed_bullet_5", range={12, 14}},
		})
	end
end

local function forest_gun_trader_test(inst, item)
	local tree_seeds = {
		["pinecone"] = 1,
		["acorn"] = 1,
		["jungletreeseed"] = 1,
		["teatree_nut"] = 1,
		["coconut"] = 1,

	}
	if tree_seeds[item.prefab] and not inst.components.tpbullets:IsFull() then
		return true
	end
end

local function forest_gun_trader_accept(inst, giver, item)
	if not inst.components.tpbullets:IsFull() then

		inst.components.tpbullets:Add(1, item.prefab)
	end
end

local function forest_gun_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=10, fn=forest_gun_weapon_fn, },
		equip = {equip=forest_gun_equip, unequip=forest_gun_unequip},

		invitem = {
			atlas = "images/inventoryimages/tp_swords.xml",
			img = "tp_forest_handarm",
		}
	})

	inst:AddComponent("tpbullets")
	inst.components.tpbullets.take_fn = forest_gun_take_bullet
	inst.components.tpbullets.lose_fn = forest_gun_lose_bullet
	inst.components.tpbullets.change_fn = forest_gun_change_bullet
end

local function tree_seed_bullet_hit(inst, attacker, target, weapon)
	local leaf_fxs = {
		"red_leaves",
		"green_leaves",
		"fall_mangrove_blue",
	}




	local fx = WARGON.make_fx2("bramblefx", target)
	fx.AnimState:SetMultColour(.3, 1, .3, 1)
	fx:ListenForEvent("tp_recycle", function()
		fx.AnimState:SetMultColour(1, 1, 1, 1)
	end)
	WARGON.area_dmg(inst, 5, attacker, 20, inst.prefab)
	inst:Remove()
end

local function tree_seed_bullet_fn(inst)
	inst.colour = math.random(3)
	local colours = {0,0,0,.5}
	WARGON.do_task(inst, 0, function()
		local pt = inst:GetPosition()
		inst.Transform:SetPosition(pt.x, 1, pt.z)
	end)
	WARGON.per_task(inst, .05, function()



		WARGON.make_fx2("acorn_shadow", inst)
	end)
	WARGON.CMP.add_cmps(inst, {
		proj = {speed=30, hit=tree_seed_bullet_hit},
	})
	WARGON.add_tags(inst, {"projectile"})
	inst:RemoveComponent("inventoryitem")
end

local function tree_seed_bullet_hit_2(inst, attacker, target, weapon)
	local leaf_fxs = {
		"red_leaves",
		"green_leaves",
		"fall_mangrove_blue",
	}






	inst:Remove()
end

local function tree_seed_bullet_fn_2(inst)
	inst.colour = math.random(3)
	local colours = {0,0,0,.5}
	WARGON.do_task(inst,0, function()
		local pt = inst:GetPosition()
		inst.Transform:SetPosition(pt.x, 1, pt.z)
	end)
	WARGON.per_task(inst, .05, function()



		WARGON.make_fx2("pinecone_shadow", inst)
	end)
	WARGON.CMP.add_cmps(inst, {
		proj = {speed=35, hit=tree_seed_bullet_hit_2},
	})
	WARGON.add_tags(inst, {"projectile"})
	inst:RemoveComponent("inventoryitem")
end

local function tree_seed_bullet_hit_3(inst, attacker, target, weapon)
	local leaf_fxs = {
		"red_leaves",
		"green_leaves",
		"fall_mangrove_blue",
	}






	if attacker.components.health then
		attacker.components.health:DoDelta(10)
	end
	inst:Remove()
end

local function tree_seed_bullet_fn_3(inst)
	inst.colour = math.random(3)
	local colours = {0,0,0,.5}
	WARGON.do_task(inst,0, function()
		local pt = inst:GetPosition()
		inst.Transform:SetPosition(pt.x, 1, pt.z)
	end)
	WARGON.per_task(inst, .05, function()



		WARGON.make_fx2("jungletreeseed_shadow", inst)
	end)
	WARGON.CMP.add_cmps(inst, {
		proj = {speed=30, hit=tree_seed_bullet_hit_3},
	})
	WARGON.add_tags(inst, {"projectile"})
	inst:RemoveComponent("inventoryitem")
end

local function tree_seed_bullet_hit_4(inst, attacker, target, weapon)
	local leaf_fxs = {
		"red_leaves",
		"green_leaves",
		"fall_mangrove_blue",
	}








	WARGON.make_fx2("teatree_nut_sleeping", inst, {target=target})

		if target.components.sleeper
		and not target.components.sleeper:IsAsleep() then
            target.components.sleeper:AddSleepiness(1, 5)
        end


	inst:Remove()
end

local function tree_seed_bullet_fn_4(inst)
	inst.colour = math.random(3)
	local colours = {0,0,0,.5}
	WARGON.do_task(inst,0, function()
		local pt = inst:GetPosition()
		inst.Transform:SetPosition(pt.x, 1, pt.z)
	end)
	WARGON.per_task(inst, .05, function()



		WARGON.make_fx2("teatree_nut_shadow", inst)
	end)
	WARGON.CMP.add_cmps(inst, {
		proj = {speed=25, hit=tree_seed_bullet_hit_4},
	})
	WARGON.add_tags(inst, {"projectile"})
	inst:RemoveComponent("inventoryitem")
end

local function tree_seed_bullet_hit_5(inst, attacker, target, weapon)
	local leaf_fxs = {
		"red_leaves",
		"green_leaves",
		"fall_mangrove_blue",
	}





	local dist_mult = math.max(1, attacker:GetDistanceSqToPoint(target:GetPosition()) )

	local ex_dmg = 14*7 / dist_mult



	WARGON.get_attacked(attacker, target, ex_dmg)
	if math.random() < .2 then
        local pt = target:GetPosition()
        local st_pt =  FindWalkableOffset(pt or attacker:GetPosition(), math.random()*2*PI, 2, 3)
        if st_pt then
            inst.SoundEmitter:PlaySound("dontstarve/common/shadowTentacleAttack_1")
            inst.SoundEmitter:PlaySound("dontstarve/common/shadowTentacleAttack_2")            
            st_pt = st_pt + pt
            local st = SpawnPrefab("shadowtentacle")

            st.Transform:SetPosition(st_pt.x, st_pt.y, st_pt.z)
            st.components.combat:SetTarget(target)
        end
    end
	inst:Remove()
end

local function tree_seed_bullet_fn_5(inst)
	inst.colour = math.random(3)
	local colours = {0,0,0,.5}
	WARGON.do_task(inst,0, function()
		local pt = inst:GetPosition()
		inst.Transform:SetPosition(pt.x, 1, pt.z)
	end)
	WARGON.per_task(inst, .05, function()



		WARGON.make_fx2("coconut_shadow", inst)
	end)
	WARGON.CMP.add_cmps(inst, {
		proj = {speed=35, hit=tree_seed_bullet_hit_5},
	})
	WARGON.add_tags(inst, {"projectile"})
	inst:RemoveComponent("inventoryitem")
end

local function forest_gun_fn2(inst)
	forest_gun_fn(inst)
	inst.components.tpbullets:SetMax(40)
end

local function forest_gun_fn3(inst)
	forest_gun_fn2(inst)
	inst.components.tpbullets:SetFast()
end

local function unreal_sword_weapon_fn(inst, owner, target)
	inst.fx.target = target
	inst.fx:start_task(inst)
end

local function unreal_sword_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "swap_nightsword_sharp", "swap_nightmaresword")
	if inst.fx == nil then
		inst.fx = SpawnPrefab("tp_fx_shadow_arc_creater")
		inst:AddChild(inst.fx)
	end
end

local function unreal_sword_unequip(inst, owner)
	hand_unequip(inst, owner)
	if inst.fx then
		inst.fx:Remove()
		inst.fx = nil
	end
end

local function unreal_sword_spell(staff, target, pos)
	local owner = staff.components.inventoryitem.owner
	if target then
		local pt = owner:GetPosition()
		local pt2 = target:GetPosition()
		owner.Transform:SetPosition(pt2:Get())
		target.Transform:SetPosition(pt:Get())
	else
		owner.components.inventory:ConsumeByName("nightmarefuel", 1)

		WARGON.make_fx(pos, "statue_transition")
		WARGON.make_fx(pos, "statue_transition_2")
		WARGON.do_task(staff, .5, function()
			local shadow = WARGON.make_spawn(pos, "tp_unreal_wilson")
			if WARGON.on_water(shadow) then
				shadow:SpawnShadowBoat(pos)
			end
			shadow.components.follower:SetLeader(owner)
			owner.components.health:DoDelta(-TUNING.SHADOWWAXWELL_HEALTH_COST)
		    owner.components.sanity:RecalculatePenalty()
		    owner.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_appear")
		end)
	end
end

local function unreal_sword_test(staff, caster, target, pos)
	if target and target:HasTag("tp_unreal_wilson") then


		return true
	end
	if caster.components.inventory:Has("nightmarefuel", 1) then
		return caster.components.sanity:GetMaxSanity() >= TUNING.SHADOWWAXWELL_SANITY_PENALTY
	end
end

local function unreal_sword_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=TUNING.NIGHTSWORD_DAMAGE, fn=unreal_sword_weapon_fn,
			effect={san=-TUNING.DAPPERNESS_SMALL}},
		equip = {equip=unreal_sword_equip, unequip=unreal_sword_unequip},
		finite = {use=TUNING.NIGHTSWORD_USES, max=TUNING.NIGHTSWORD_USES},
		caster = {spell=unreal_sword_spell, test=unreal_sword_test, 
			can={point=true, inv=false, target=true}},
	})
end

local function oak_armor_spawn_nuter(inst, data)

	local pt = inst:GetPosition()
	if math.random() < .5 then
		for i = 1, math.random(2, 4) do
			local pos = WARGON.around_land(inst, math.random(3))
			if pos then
				if WARGON.on_water(inst, pos) then
					WARGON.make_fx(pos, "splash_water_drop")
				else
					local nuter = SpawnPrefab("birchnutdrake")
					if data.attacker and nuter.components.combat:CanTarget(data.attacker) then
						nuter.Transform:SetPosition(pos:Get())
						nuter.components.combat:SetTarget(data.attacker)

						nuter:AddTag("tp_no_drop_loot")
						WARGON.no_save(nuter)
					else
						nuter:Remove()
					end
				end
			end
		end
	end
end

local function oak_armor_equip(inst, owner)
	WARGON.EQUIP.body_on(owner, "armor_wood_haramaki", "swap_body")
	owner:AddTag("tp_oak_armor")





	owner:ListenForEvent("attacked", oak_armor_spawn_nuter)
end

local function oak_armor_unequip(inst, owner)
	WARGON.EQUIP.body_off(owner)
	owner:RemoveTag("tp_oak_armor")


	owner:RemoveEventCallback("attacked", oak_armor_spawn_nuter)
end

local function oak_armor_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		equip = {equip=oak_armor_equip, unequip=oak_armor_unequip, slot="body"},
		armor = {armor=TUNING.ARMORWOOD, absorb=.8},
		fuel = {value=TUNING.LARGE_FUEL},
	})
	WARGON.make_burn(inst, "small", TUNING.SMALL_BURNTIME)
	WARGON.make_prop(inst, "small")
	inst.components.burnable:MakeDragonflyBait(3)
end

local function pig_book_read_test(inst, reader)
	local inv = reader.components.inventory
	if inv:Has("meat", 1) or inv:Has("pigskin", 1) then
		return reader.components.sanity.current > 10
	end
end

local function pig_book_read_fn(inst, reader)
	local inv = reader.components.inventory
	if inv:Has("meat", 1) then
		inv:ConsumeByName("meat", 1)
	else
		inv:ConsumeByName("pigskin", 1)
	end
	reader.components.sanity:DoDelta(-10)

	local pos = WARGON.around_land(reader, math.random(3, 6))
	if pos then
		local pig = WARGON.make_spawn(pos, "pigman")
		if WARGON.on_water(pig) then

			WARGON.make_fx2("splash_water_sink", pos)
			pig:Remove()
		else
			WARGON.make_fx(pos, "tp_fx_shadow_bat")



			reader.components.leader:AddFollower(pig)
			pig.components.follower:AddLoyaltyTime(1200)
		end
		return true
	end
end

local function pig_book_fn(inst)
	inst.AnimState:PlayAnimation("book3")
	inst.components.inventoryitem:SetImage({"tp_maigc_books", "tp_magic_book_2"})
	inst:AddTag("irreplaceable")
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		book = {fn=pig_book_read_fn, test=pig_book_read_test},
	})
end

local function brave_amulet_on_hunger_delta(inst, data)
	local p = inst.components.hunger:GetPercent()
	WARGON.add_hunger_rate(inst, "tp_brave_amulet", p)
	WARGON.add_dmg_rate(inst, "tp_brave_amulet", .4*p)
	if inst.components.tpbody then
		inst.components.tpbody:AddAbsorbModifier("tp_brave_amulet", .6*p)
	end
end

local function brave_amulet_equip(inst, owner)
	WARGON.EQUIP.body_on(owner, "amulet_red_occulteye", "swap_body")
	owner:ListenForEvent("hungerdelta", brave_amulet_on_hunger_delta)





	inst.components.fueled:StartConsuming()
end

local function brave_amulet_unequip(inst, owner)
	WARGON.EQUIP.body_off(owner)
	owner:RemoveEventCallback("hungerdelta", brave_amulet_on_hunger_delta)
	WARGON.remove_hunger_rate(owner, "tp_brave_amulet")
	WARGON.remove_dmg_rate(owner, "tp_brave_amulet")
	if owner.components.tpbody then
		owner.components.tpbody:RemoveAbsorbModifier("tp_brave_amulet")
	end
	inst.components.fueled:StopConsuming()
end

local function brave_amulet_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		equip = {equip=brave_amulet_equip, unequip=brave_amulet_unequip, 
			slot=EQUIPSLOTS.NECK or EQUIPSLOTS.BODY, 
			effect={san=-TUNING.DAPPERNESS_SMALL} },
		fueled = {time=30*16, typ='nightmare', accept=true, 
			fn={finish=on_finish} },
	})
end

local function pig_lamp_put(inst, owner)
	inst.Light:Enable(false)
end

local function pig_lamp_drop(inst, dropper)
	inst.Light:Enable(true)
end

local function pig_lamp_test(inst)
	return GetClock():IsNight() and inst.components.cooldown:IsCharged()
end

local function pig_lamp_search_ents(name)
	for k,v in pairs(Ents) do
		if v.prefab == name then
			return v
		end
	end
end

local function pig_lamp_use(inst)
	if not pig_lamp_search_ents("tp_pig_spirit") then
		GetPlayer().components.sanity:DoDelta(-TUNING.SANITY_HUGE)
	    local spirit = WARGON.make_spawn(inst, "tp_pig_spirit")
	    inst.SoundEmitter:PlaySound("dontstarve/common/ghost_spawn")
	end
    inst:Remove()
end

local function pig_lamp_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		invitem = {put=pig_lamp_put, drop=pig_lamp_drop},
		use = {str="wipe", test=pig_lamp_test, use=pig_lamp_use},
		cd = {time=1},
	})

	WARGON.make_light(inst, 0.5, .75, 2, {197/255,197/255,50/255}, true)
	inst.components.cooldown:StartCharging()
	WARGON.do_task(inst, 0, function()
		if c_countprefabs('tp_pig_lamp') > 1 then
			inst:Remove()
		end
	end)
end

local function bird_egg_hatched(inst)
	local bird = WARGON.make_spawn(inst, 'tp_small_bird')
	bird.sg:GoToState('hatch')
	inst:Remove()
end

local function bird_egg_check_hatch(inst)
	if inst.player_near and inst.components.hatchable.state == 'hatch' then
		bird_egg_hatched(inst)
	end
end

local function bird_egg_uncomfy_snd(inst)
	inst.SoundEmitter:KillSound("uncomfy")
    if inst.components.hatchable.toohot then
        inst.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_hot_steam_LP", "uncomfy")
    elseif inst.components.hatchable.toocold then
        inst.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_cold_shiver_LP", "uncomfy")
    end
end


local function bird_egg_loot_drop(inst)
	inst:AddComponent("lootdropper")
	if inst.components.hatchable.toohot then
        inst.components.lootdropper:SetLoot({"cookedsmallmeat"})
    else
        inst.components.lootdropper:SetLoot({'wetgoop'})
    end
    inst.components.lootdropper:DropLoot()
end

local function bird_egg_hatch_state(inst, state)
	inst.SoundEmitter:KillSound("uncomfy")

    if inst.components.floatable.onwater then
    	WARGON.do_task(inst, 15*FRAMES, function()
    		inst.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_cold_freeze")
    	end)
    	WARGON.do_task(inst, 30*FRAMES, bird_egg_loot_drop)
        inst.AnimState:PlayAnimation("idle_cold_water")

        inst:ListenForEvent("animover", function(inst) inst:Remove() end)
    end

    if state == "crack" then
        local cracked = WARGON.make_spawn(inst, 'tp_bird_egg_cracked')
        cracked.AnimState:PlayAnimation("crack")
        cracked.AnimState:PushAnimation("idle_happy", true)
        cracked.components.floatable:UpdateAnimations("idle_crack_water", "idle_happy")
        cracked.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_hatch_crack")
        inst:Remove()
    elseif state == "uncomfy" then
        if inst.components.hatchable.toohot then
            inst.AnimState:PlayAnimation("idle_hot", true)
            inst.components.floatable:UpdateAnimations("idle_hot_water", "idle_hot")
        elseif inst.components.hatchable.toocold then
            inst.AnimState:PlayAnimation("idle_cold", true)
            inst.components.floatable:UpdateAnimations("idle_cold_water", "idle_cold")
        end
        bird_egg_uncomfy_snd(inst)
    elseif state == "comfy" then
        inst.AnimState:PlayAnimation("idle_happy", true)
        inst.components.floatable:UpdateAnimations("idle_crack_water", "idle_happy")
    elseif state == "hatch" then
        bird_egg_check_hatch(inst)
    elseif state == "dead" then
        if inst.components.hatchable.toohot then
            inst.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_hot_jump")
            WARGON.do_task(inst, 20*FRAMES, function()
            	inst.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_hot_explo")
            end)
            WARGON.do_task(inst, 20*FRAMES, bird_egg_loot_drop)
            inst.AnimState:PlayAnimation("toohot")
        elseif inst.components.hatchable.toocold then
        	WARGON.do_task(inst, 15*FRAMES, function()
        		inst.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_cold_freeze")
        	end)
        	WARGON.do_task(inst, 30*FRAMES, bird_egg_loot_drop)
            inst.AnimState:PlayAnimation("toocold")
        end
        
        inst:ListenForEvent("animover", function(inst) inst:Remove() end)
    end
end

local function bird_egg_drop(inst)
	inst.components.hatchable:StartUpdating()
	bird_egg_check_hatch(inst)
	bird_egg_uncomfy_snd(inst)
end

local function bird_egg_put(inst)
	inst.components.hatchable:StopUpdating()
    inst.SoundEmitter:KillSound("uncomfy")
end

local function bird_egg_fn(inst)
	MakeInventoryFloatable(inst, "idle_water", "egg")
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		hatch = {state=bird_egg_hatch_state, 
			crake=TUNING.SMALLBIRD_HATCH_CRACK_TIME,
			hatch=30*16*1,

			fail=TUNING.SMALLBIRD_HATCH_FAIL_TIME},
		invitem = {drop=bird_egg_drop, put=bird_egg_put},
	})
	inst.components.hatchable:StartUpdating()
	inst.player_near = false
end

local function bird_egg_cracked_near(inst)
	bird_egg_check_hatch(inst)
	inst.player_near = true
end

local function bird_egg_cracked_far(inst)
	inst.player_near = false
end

local function bird_egg_cracked_fn(inst)
	bird_egg_fn(inst)
	inst.components.hatchable.state = 'comfy'
	inst.components.floatable:UpdateAnimations("idle_crack_water", "idle_happy")
	WARGON.CMP.add_cmps(inst, {
		near = {dist={4,6}, near=bird_egg_cracked_near, far=bird_egg_cracked_far},
	})
end

local function pigking_hat_on_attacked(inst, data)
	if data.attacker then
		inst.components.combat:ShareTarget(data.attacker, 30, function(dude)
			return dude:HasTag('pig') and not dude:HasTag("guard")
				and not dude:HasTag("werepig") 
		end, 5)
	end
end

local function pigking_hat_equip(inst, owner)
	WARGON.EQUIP.hat_on(owner, "beefalohat_pigking")
	if owner:HasTag('player') then
		owner:ListenForEvent('attacked', pigking_hat_on_attacked)
		owner:AddTag("pigroyalty")
	end
end

local function pigking_hat_unequip(inst, owner)
	WARGON.EQUIP.hat_off(owner)
	if owner:HasTag("player") then
		owner:RemoveEventCallback('attacked', pigking_hat_on_attacked)
		owner:RemoveTag("pigroyalty")
	end
end

local function pigking_hat_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		equip = {slot="head", equip=pigking_hat_equip, unequip=pigking_hat_unequip},

		})
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(30)
	inst.spawn_pig = function(inst, owner)
		if inst.components.tprecharge:IsRecharged() then
			local pos = WARGON.around_land(owner, math.random(3, 6))
			if pos then
				local pig = WARGON.make_spawn(pos, "pigman")
				if WARGON.on_water(pig) then
					WARGON.make_fx(pos, "splash_water_sink")
					pig:Remove()
				else
					WARGON.make_fx(pos, "tp_fx_shadow_bat")
					owner.components.leader:AddFollower(pig)
					pig.components.follower:AddLoyaltyTime(1200)
					pig:no_save()
					pig:AddTag("tp_no_drop_loot")
					pig:do_task(20, function()
						if pig:is_alive() then
							pig.components.health:Kill()
						end
					end)
					inst.components.tprecharge:SetRechargeTime(30)
				end
			end
		end
	end
end

local function alloy_shine(inst)
	inst.task = nil
	if inst.onwater then
		inst.AnimState:PlayAnimation("sparkle_water")
		inst.AnimState:PushAnimation("idle_water")
	else
		inst.AnimState:PlayAnimation("sparkle")
		inst.AnimState:PushAnimation("idle")
    end
	inst.task = inst:DoTaskInTime(4+math.random()*5, function() alloy_shine(inst) end)
end

local function alloy_entity_wake(inst)
	inst.components.tiletracker:Start()
end

local function alloy_entity_sleep(inst)
	inst.components.tiletracker:Stop()
end

local function alloy_water_change(inst, onwater)
	inst.onwater = onwater
end

local function alloy_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		stack = {},
		})
	inst:AddComponent("tiletracker")
	inst.components.tiletracker:SetOnWaterChangeFn(alloy_water_change)
	inst.onwater = false
	inst.OnEntityWake = alloy_entity_wake
	inst.OnEntitySleep = alloy_entity_sleep
	alloy_shine(inst)
end

local TpGiftPanel = require "screens/tp_gift_panel"
local function gift_use(inst)
	TheFrontEnd:PushScreen(TpGiftPanel())
























end

local function gift_use_test(inst)
	return true
end

local function gift_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		use = {str="open", use=gift_use, test=gift_use_test},
	})
end

local function gingko_leaf_fn(inst)
	WARGON.set_scale(inst, .33)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		stack = {max=40},
		trade = {},
	})
	WARGON.make_burn(inst, "small", TUNING.SMALL_BURNTIME)
	WARGON.make_prop(inst, "small")
	WARGON.burn_bait(inst, 3)
	WARGON.make_blow(inst, TUNING.WINDBLOWN_SCALE_MIN.MEDIUM, TUNING.WINDBLOWN_SCALE_MAX.MEDIUM)
	inst:AddComponent("tpinterable")
end

local function grass_pigking_accept(inst, giver, item)
	if item.components.tradable 
	and item.components.tradable.goldvalue > 0 then





		for i = 1, item.components.tradable.goldvalue do

			local nug = SpawnPrefab("goldnugget")
			WARGON.pigking_throw(inst, nug)
		end



	end
end

local function grass_pigking_test(inst, item, giver)
	if item.components.tradable then
		if item.components.tradable.goldvalue > 0 then
			return true
		end
	end
end

local function grass_pigking_fn(inst)
	inst:AddTag("irreplaceable")
	WARGON.set_scale(inst, .33)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},


		trader = {accept=grass_pigking_accept, test=grass_pigking_test},
		tppigtask = {},
		})

	inst.AnimState:Hide("snow")
end

local function octopus_fn(inst)
	WARGON.set_scale(inst, 2)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},


	})

end

local function boss_loot_fn(inst)
	inst.components.inventoryitem.canbepickedup = false
	inst:add_cmps({
		loot = {},
		})
	local weapons = {

















	}
	WARGON.do_task(inst, 0, function()











		local loots = {"tp_gift3", "tp_gift5", "tp_gift7"}
		for k, v in pairs(loots) do
			local gift = SpawnPrefab(v)
			inst.components.lootdropper:DropLootPrefab(gift)
		end
		inst:Remove()
	end)
end

local function loot_fn(inst)
	inst:AddComponent('lootdropper')
	WARGON.do_task(inst, 0, function()
		if inst.loot_prefab then
			inst.components.lootdropper:SpawnLootPrefab(inst.loot_prefab)
		end
		inst:Remove()
	end)
end

local function epic_fn(inst)
	inst:AddTag("tp_level_epic")
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		stack = {max=40, },
		trade = {},

	})
	inst:AddTag("show_spoilage")
	inst:AddTag("tp_must_spoilsh")
	inst:AddComponent("tpinterable")





end

local function rider_spawner_fn(inst)
	WARGON.do_task(inst, 0, function()

		if c_findtag("tp_sign_rider", 9001) == nil then
			for i = 1, 4 do
				local radius = 10
				local pos = WARGON.around_land(inst, radius)
				if pos then
					if i <= 1 then
						WARGON.make_spawn(pos, "tp_sign_rider")
						
					else
						WARGON.make_spawn(pos, "tp_sign_rider_"..i)
					end
					WARGON.make_fx(pos, "statue_transition")
					WARGON.make_fx(pos, "statue_transition_2")
				end
			end
		end
		inst:Remove()
	end)
end

local function angry_remove_fn(inst)
	WARGON.do_task(inst, 0, function()
		local player = GetPlayer()
		if player.components.tpangry then
			player.components.tpangry:ReTime()
		end
		player.components.talker:Say(STRINGS.TP_STR.tp_curse)
		inst:Remove()
	end)
end

local function egg_tool_accept(inst, giver, item)
	if item.components.stackable then
		local size = item.components.stackable:StackSize()
		c_give("rottenegg", size)
		c_give("bird_egg_cooked", size)
		inst.components.finiteuses:Use()
	end
end

local function egg_tool_test(inst, item, giver)
	return item.prefab == "bird_egg"
end

local function egg_tool_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		trader = {accept=egg_tool_accept, test=egg_tool_test},
		finite = {max=5, use=5, fn=on_finish},
	})
end



local function intro_inspect(inst)

end

local function intro_fn(inst)
	MakeInventoryFloatable(inst, "book_meteor_water", "book_meteor")
	WARGON.CMP.add_cmps(inst, {
		inspect = {fn=intro_inspect},
	})
end



local function update_inspect(inst)

end

local function update_fn(inst)
	MakeInventoryFloatable(inst, "book_brimstone_water", "book_brimstone")
	WARGON.CMP.add_cmps(inst, {
		inspect = {fn=update_inspect},
	})
end

local function diving_mask_equip(inst, owner)
	owner:AddTag("tp_diver")
	WARGON.EQUIP.hat_open(owner, "hat_gasmask")
end

local function diving_mask_unequip(inst, owner)
	owner:RemoveTag("tp_diver")
	WARGON.EQUIP.hat_off(owner)
end

local function diving_mask_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		equip = {equip=diving_mask_equip, unequip=diving_mask_unequip, slot='head'}
		})
end

local function horn_use_test(inst)
	return true
end

local function horn_use(inst)
	GetPlayer().sg:GoToState("tp_spawn_beefalo")
	WARGON.make_spawn(inst, "rider_sp")
	inst:Remove()
end

local function horn_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		use = {use=horn_use, test=horn_use_test},
	})
end

local function magic_book_test(inst, item, slot)
    return item:HasTag("tp_scroll")
end

local function magic_book_fn(inst)
	inst.AnimState:PlayAnimation("book1")
	inst.components.inventoryitem:SetImage({"tp_magic_books", "tp_magic_book_1"})
    WARGON.CMP.add_cmps(inst, {
    	inspect = {},
        cont = {test=magic_book_test},
        })
    local slotpos = {}
    for y = 0, 6 do
        table.insert(slotpos, Vector3(-162, -y*75 + 240 ,0))
        table.insert(slotpos, Vector3(-162 +75, -y*75 + 240 ,0))
    end
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_krampusbag_2x8"
    inst.components.container.widgetanimbuild = "ui_krampusbag_2x8"
    inst.components.container.widgetpos = Vector3(-150,-120,0)
    inst.components.container.side_widget = true    
    inst.components.container.type = "scroll_container"
end

local function treasure_map_book_fn(inst, reader)
	for tries = 1, 100 do

		local pt = reader:GetPosition()
		local pos = nil



			pos = FindGroundOffset(pt, math.random() * 2 * math.pi, math.random(100, 700), 18)

		if pos then
			local pb = SpawnPrefab("buriedtreasure")

			local spawn_pos = pt + pos
			pb:set_pos(spawn_pos:Get())

			pb:SetRandomTreasure()
			pb:Reveal(pb)
			pb:RevealFog(pb)
			pb:FocusMinimap(pb)
			inst:Remove()
			return true
		end
	end
end

local function treasure_map_fn(inst)
	inst:add_cmps({
		inspect = {},
		book = {fn = treasure_map_book_fn, act="map"},
	})
end

local function fix_powder_fn(inst)
	inst:add_cmps({
		inspect = {},
		stack = {max=40},
		tpinterable = {},
	})
	inst:AddTag("tp_fix_powder")
	inst.components.tpinterable:SetFn(function(inst, target, doer)

























		local item = inst.components.stackable:Get()
		item:Remove()
		local fix = 50
		if doer.components.tplevel 
		and doer.components.tplevel.attr.fixup then
			fix = fix+doer.components.tplevel.attr.fixup
		end
		if target.components.finiteuses then
			target.components.finiteuses:DoDelta(fix)
		elseif target.components.armor then
			target.components.armor:DoDelta(fix*3)
		end
	end)
end

local function red_dragon_sack_dropper_fn(inst)

	inst:do_task(0, function()

		local can_spawn = true
		for k,v in pairs(Ents) do
			if v.prefab == "tp_red_dragon_sack" then
				can_spawn = false
				break
			end
		end
		if can_spawn then
			WARGON.make_spawn(inst, "tp_red_dragon_sack")
		end
		inst:Remove()
	end)
end

local function transport_plane_fn(inst)
	WARGON_CMP_EX.add_cmps(inst, {
		inspect = {},
		burnable = {},
	})
	inst:AddComponent("container")
	inst.components.container:SetNumSlots(1.1)
	inst.components.container.widgetslotpos = {Vector3(0,0,0)}
	inst.components.container.widgetanimbank = "ui_bundle_2x2"
	inst.components.container.widgetanimbuild = "ui_bundle_2x2"
	inst.components.container.widgetpos = Vector3(200,0,0)
	inst.components.container.side_align_tip = 100
	inst.components.container.type = "backpack"
	inst:ListenForEvent("onignite", function(inst, data)
	end)
	inst:AddComponent("tpinter")
	inst.components.tpinter:SetCanFn(function(inst, item, doer)
		return item.prefab == "tp_resource_transporter_controller"
	end)
	inst.components.tpinter:SetFn(function(inst)
		if inst.components.inventoryitem.owner then
			GetPlayer().components.talker:Say("需要将运输火箭放在地上")
		else
			inst:launch()
		end
	end)
	inst.launch = function(inst)
		inst:AddTag("launched")
		inst.fx = SpawnPrefab("torchfire")
		inst:AddChild(inst.fx)
		inst.fx.Transform:SetPosition(0, -.3, 0)
		inst.Physics:SetMotorVel(0, 30, 0)
		inst:do_task(2, function()
			local transporter = c_find("tp_resource_transporter")
			if transporter and transporter.components.container
			and not transporter.components.container:IsFull() then
				local item = inst.components.container:RemoveItemBySlot(1)
				if item then
					transporter.components.container:GiveItem(item)
				end
			else
				inst.components.container:DropEverything()
				GetPlayer().components.talker:Say("物资发射台已满或不存在")
			end
			inst:Remove()










		end)
	end
end

local function bat_scythe_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "swap_batbat_scythe", "swap_batbat")
	owner:AddTag("tp_bat_scythe")
end

local function bat_scythe_unequip(inst, owner)
	hand_unequip(inst, owner)
	owner:RemoveTag("tp_bat_scythe")
end

local function bat_scythe_fn(inst)
	inst:add_cmps({
		inspect = {},
		weapon = {dmg=10},
		equip = {equip=bat_scythe_equip, unequip=bat_scythe_unequip, },
		finite = {max=100, use=100},
	})
end

local function magic_book_loot_fn(inst)
	inst.components.inventoryitem.canbepickedup = false
	inst:add_cmps({
		loot = {},
		})
	inst:do_task(0, function()
		local book = SpawnPrefab("tp_magic_book")
		local scrolls = {





		}
		for k, v in pairs(scrolls) do
			local scroll = SpawnPrefab("scroll_"..v)
			if scroll.components.stackable then
				scroll.components.stackable:SetStackSize(10)
			end
			book.components.container:GiveItem(scroll)
		end
		for i = 1, 14 do
			local scroll = SpawnPrefab("tp_scroll")
			book.components.container:GiveItem(scroll)
		end
		inst.components.lootdropper:DropLootPrefab(book)
		inst:Remove()
	end)
end

local function pigking_loot_fn(inst)
	inst.components.inventoryitem.canbepickedup = false
	inst:add_cmps({
		loot = {},
		})
	inst:do_task(0, function()
		local loots = {}
		local speical_loots = {
			"tp_super_calculator_bp",
			"tp_small_pig_book",

			"tp_chop_pig_home_bp",
			"tp_hack_pig_home_bp",
			"tp_farm_pig_home_bp",
		}
		for k, v in pairs(speical_loots) do
			if GetPlayer().components.tpprefabspawner:CanSpawn(v) then
				table.insert(loots, v)
			end
		end
		if next(loots) == nil then

		else
			local item = loots[math.random(#loots)]
			inst.components.lootdropper:SpawnLootPrefab(item)
			if item ~= "tp_boss_loot" then
				GetPlayer().components.tpprefabspawner:TriggerPrefab(item)
			end
		end
		inst:Remove()
	end)
end

local ItemData = Class(Prefab, function(self, name, data)
	Prefab._ctor(self, name)
	self.data = data
	self.fn = function()
		local atlas, img = nil, nil
		if data.img then
			atlas, img = WARGON.resolve_img_path(data.img)
			img = string.sub(img, 1, -5)
		end
		local anims = data.anim or {}
	 	local inst = WARGON.make_prefab(anims, anims[4], "inv")
	 	inst:add_cmps({
	 		invitem = {atlas=atlas, img=img},
	 		inspect = {},
	 	})
	 	inst:AddTag("tp_item")
	 	if data.fn then
	 		data.fn(inst)
	 	end

	    return inst
	end
end)

function ItemData:__tostring()
	return string.format("Item %s - %s", self.name, self.desc)
end

local flavour = ItemData("tp_flavour", {
	anim = Anims.flavour,
	img = "tp_flavour#",
	fn = function(inst)
		inst:AddTag("tp_flavour")
		inst:add_cmps({
			stack = { max = 20, },
			food = {
				typ = "MEAT",
				health = 0,
				hunger = 5,
				san = 0,
			},
		})
	end,
})

local fodder = ItemData("tp_fodder", {
	anim = Anims.fodder,
	img = "tp_fodder#",
	fn = function(inst)
		inst:AddTag("tp_fodder")
		inst:add_cmps({
			stack = { max = 20, },
			food = {
				typ = "ROUGHAGE",
				health = 0,
				hunger = 250,
				san = 0,
			},

			trade = {},
		})
	end,
})


















local gps = ItemData("tp_gps", {
	anim = Anims.tracker,
	img = "tracker",
	fn = function(inst)
		inst:add_cmps{
			use = {
				use = function(inst)
					local px, py, pz = GetPlayer().Transform:GetWorldPosition()
			    	local leif = c_find("tp_leif")
			    	local boss = c_find("tp_fake_knight_room")
			    	if leif or boss then
				    	local map = GetWorld().Map
				    	local minimap = GetWorld().minimap.MiniMap
				    	GetPlayer().HUD.controls:ToggleMap()
				    	if leif then
				    		local x, y, z = leif.Transform:GetLocalPosition()
					        local cx, cy, cz = map:GetTileCenterPoint(x, 0, z)
					        minimap:ShowArea(cx, cy, cz, 30)
					        map:VisitTile(map:GetTileCoordsAtPoint(cx, cy, cz))

					    	minimap:Focus(x - px, z - pz, -minimap:GetZoom())
				    	end
				    	if boss then
					    	local x2, y2, z2 = boss.Transform:GetLocalPosition()
					    	local cx, cy, cz = map:GetTileCenterPoint(x2, 0, z2)
					        minimap:ShowArea(cx, cy, cz, 30)
					        map:VisitTile(map:GetTileCoordsAtPoint(cx, cy, cz))
					    	minimap:Focus(x2 - px, z2 - pz, -minimap:GetZoom())
				    	end
			    	end
			    	inst:Remove()

				end,
				test = function()
					return true
				end,
			},
		}
	end,
})

local sleeping_pill = ItemData("tp_sleeping_pill", {
	anim = Anims.sleeping_pill,
	img = "tp_sleeping_pill#",
	fn = function(inst)
		inst:add_cmps({
			stack = {max=40},
			food = {
				health = 0,
				hunger = 0,
				san = -1,
				fn = function(inst, eater)
					eater:RemoveTag("insomniac")
				end,
			}	
		})
	end,
})

local mooneyes = {
	"red", "blue", "purple",
	"green", "orange", "yellow",
}
for k, v in pairs(mooneyes) do
	local item = ItemData(v.."mooneye", {
		anim = Anims[v.."mooneye"],
		img = v.."mooneye#",
		fn = function(inst)
			inst:AddTag("nosteal")
			inst:AddTag(v.."mooneye")
			WARGON.make_map(inst, v.."mooneye.tex")
		end,
	})
	mooneyes[k] = item
end

local function magic_tool_worked(inst, data)
	local tool = inst:get_equip_item("hand")
	if tool and tool.components.tpmagictool then
		local act = tool.components.tpmagictool.action
		if data and data.action == act then
			tool.components.tpmagictool:ExpDelta(1)
		end
	end
end

local function magic_tool_equip(inst, owner)
	if inst.components.tpmagictool
	and inst.components.tpmagictool.level > 5 then
		owner:AddTag("tp_magic_tool_owner")
		WARGON.EQUIP.object_on(owner, inst.swap_build2, inst.swap_symbol2)
	else
		WARGON.EQUIP.object_on(owner, inst.swap_build, inst.swap_symbol)
	end
	owner:ListenForEvent("finishedwork", magic_tool_worked)
end

local function magic_tool_unequip(inst, owner)
	WARGON.EQUIP.object_off(owner)
	owner:RemoveEventCallback("finishedwork", magic_tool_worked)
	owner:RemoveTag("tp_magic_tool_owner")
end

local magic_tools = {
	{
		name = "tp_magic_axe",
		img = "axe_northern#",
		img2 = "goldenaxe_northern#",
		anim = Anims.axe_northern,
		anim2 = Anims.goldenaxe_northern,
		build = "swap_axe_northern",
		build2 = "swap_goldenaxe_northern",
		symbol = "swap_axe",
		symbol2 = "swap_goldenaxe",
		use = 200,
		act = ACTIONS.CHOP,
	},
	{
		name = "tp_magic_pickaxe",
		img = "pickaxe_northern#",
		img2 = "goldenpickaxe_northern#",
		anim = Anims.pickaxe_northern,
		anim2 = Anims.goldenpickaxe_northern,
		build = "swap_pickaxe_northern",
		build2 = "swap_goldenpickaxe_northern",
		symbol = "swap_pickaxe",
		symbol2 = "swap_goldenpickaxe",
		use = 66,
		act = ACTIONS.MINE,
	},
	{
		name = "tp_magic_shovel",
		img = "shovel_northern#",
		img2 = "goldenshovel_northern#",
		anim = Anims.shovel_northern,
		anim2 = Anims.goldenshovel_northern,
		build = "swap_shovel_northern",
		build2 = "swap_goldenshovel_northern",
		symbol = "swap_shovel",
		symbol2 = "swap_goldenshovel",
		use = 50,
		act = ACTIONS.DIG,
	},
}
for k, v in pairs(magic_tools) do
	local item = ItemData(v.name, {
		anim = v.anim,
		img = v.img,
		fn = function(inst)
			inst.swap_build = v.build
			inst.swap_build2 = v.build2
			inst.swap_symbol = v.symbol
			inst.swap_symbol2 = v.symbol2
			inst:add_cmps({
				weapon = { dmg=10 },
				finite = { use=v.use, max=v.use, 
					fn=function(inst)
						inst:Remove()
					end 
				},
				equip = {
					equip = magic_tool_equip,
					unequip = magic_tool_unequip,
				},
				tool = {},
			})
			inst.components.finiteuses:SetConsumption(v.act, 1)
			inst.components.tool:SetAction(v.act, 1)
			inst:AddComponent("tpmagictool")
			inst.components.tpmagictool.action = v.act
			inst.components.tpmagictool.anim = v.anim2
			inst.components.tpmagictool.img = v.img2

			inst:AddTag("sharp")
			inst:AddComponent("tpinter")
			inst.components.tpinter:SetFn(function(inst, item, doer)
				if item.prefab == "tp_epic" then
					local item = item.components.stackable:Get()
					item:Remove()
					inst.components.tpmagictool:ExpDelta(20)
				else
					local item = item.components.stackable:Get()
					item:Remove()
					local max = inst.components.finiteuses.total
					local use = inst.components.finiteuses.current
					local new = math.min(max, use+v.use/2)
					inst.components.finiteuses:SetUses(new)
				end
			end)
			inst.components.tpinter:SetCanFn(function(inst, item, doer)
				return item.prefab == "flint" 
				or (inst.components.tpmagictool.level >= 6
				and item.prefab == "goldnugget")
				or item.prefab == "tp_epic"
			end)
		end,	
	})
	magic_tools[k] = item
end

local spear_gun = ItemData("tp_spear_gun", {
	anim = Anims.spear_gun,
	img = "tp_spear_gun#",
	fn = function(inst)
		inst:add_cmps({
			finite = {max=10, use=0,
				fn = function(inst)
					inst:RemoveTag("speargun")
				    inst:RemoveTag("projectile")
					inst:add_cmps({
						weapon = {
							dmg=10, fx=nil, range={nil, nil},
						},
					})
				end,
			},	
			equip = {
				equip = function(inst, owner)
					WARGON.EQUIP.object_on(owner, "tp_spear_gun", "swap_object")
				end,
				unequip = function(inst, owner)
					WARGON.EQUIP.object_off(owner)
				end,
			},
			weapon = {dmg=10},
		})
		inst:ListenForEvent("percentusedchange", function(inst, data)
			if data and data.percent > 0 then
				inst:add_cmps({
					weapon = {
						dmg=40, fx="tp_spear_projectile", 
						range={10, 12},
					},
				})
				inst:AddTag("speargun")
			    inst:AddTag("projectile")
			end
		end)
		inst:AddComponent("tpinter")
		inst.components.tpinter:SetFn(function(inst, item, doer)
			item:Remove()
			inst.components.finiteuses:SetUses(10)
		end)
		inst.components.tpinter:SetCanFn(function(inst, item, doer)
			return item.prefab == "spear"
			and inst.components.finiteuses:GetPercent() < 1
		end)
	end,
})

local many_scroll = ItemData("tp_many_scroll", {
	fn = function(inst)
		inst:do_task(0, function()
			inst:Remove()
			c_give("scroll_grow")
			c_give("scroll_sleep")
			c_give("scroll_bird")
		end)
	end,
})

local function night_spider_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "swap_bugnet_spider", "swap_bugnet")
end

local function night_spider_unequip(inst, owner)
	WARGON.EQUIP.object_off(owner)
end

local night_spider = ItemData("tp_night_spider", {
	anim = Anims.bugnet_spider,
	img = "bugnet_spider#",
	fn = function(inst)
		inst:add_cmps({
			weapon = {dmg=10},
			finite = {max=10, use=10},
			equip = {
				equip=night_spider_equip, 
				unequip=night_spider_unequip, 
			},
			tool = {},
		})
		inst.components.weapon.attackwear = 3
		inst.components.tool:SetAction(ACTIONS.NET)
		inst.components.finiteuses:SetConsumption(ACTIONS.NET, 1)
		inst:AddTag("tp_night_spider")
		inst:ListenForEvent("percentusedchange", function(inst, data)
			if GetClock():IsNight() and not inst.fixed then
				inst.fixed = true
				local max = inst.components.finiteuses.total
				local use = inst.components.finiteuses.current
				local new = math.min(max, use+1)
				inst.components.finiteuses:SetUses(new)

				inst.fixed = nil
			end
		end)
	end,
})

local easy_pot = ItemData("tp_easy_pot", {
	anim = Anims.tuna,
	img = "tuna",
	fn = function(inst)
		inst:add_cmps({
			stack = {max=20},
			dep = {
				test = function(inst, pt)
					return not WARGON.on_water(inst, pt)
				end,
				deploy = function(inst, pt, deployer)
					local item = inst.components.stackable:Get()
					item:Remove()
					local pot = SpawnPrefab("tp_easy_cookpot") 
					if pot then 
						pt = Vector3(pt.x, 0, pt.z)
						pot.Physics:SetCollides(false)
						pot.Physics:Teleport(pt.x, pt.y, pt.z) 
						pot.Physics:SetCollides(true)
						pot.SoundEmitter:PlaySound("dontstarve/common/place_structure_stone")
						pot.AnimState:PlayAnimation("place")
						pot.AnimState:PushAnimation("idle_empty", false)
					end 
				end,
			},
		})
		inst.components.deployable.placer = "tp_easy_cookpot_placer"
	end,	
})

local function ham_tool_weapon_fn(inst)
	local p = inst.components.perishable:GetPercent()
	inst.components.weapon:SetDamage(p*34)
end

local ham_tool = ItemData("tp_ham_tool", {
	anims = Anims.ham_potroast,
	img = "ham_bat_potroast#",
	fn = function(inst)
		inst:add_cmps({
			weapon = { dmg=34, fn=ham_tool_weapon_fn },	
			perish = {time=10*16*30, spoil="spoiled_food"},
			tool = {
				act = {chop=1, mine=1, dig=1, ham=1, hack=1, shear=1},
			},
			equip = {
				equip = function(inst, owner)
					WARGON.EQUIP.object_on(owner, "swap_ham_bat_potroast", "swap_ham_bat")
				end,
				unequip = function(inst, owner)
					WARGON.EQUIP.object_off(owner)
				end,
			}
		})
		inst.components.perishable:StartPerishing()
		inst:AddTag("show_spoilage")
		inst:AddTag("tp_must_spoilsh")
		inst:AddTag("icebox_valid")
		inst.OnLoad = function(inst, data)
			ham_tool_weapon_fn(inst)
		end
	end,
})



















































return
MakeItem("tp_strawhat", Anims.strawhat, strawhat_fn, "strawhat_cowboy#"),
MakeItem("tp_strawhat2", Anims.strawhat, strawhat2_fn, "strawhat_cowboy#"),
MakeItem("tp_strawhat_saddle", Anims.strawhat, strawhat_saddle_fn, "strawhat_cowboy#"),
MakeItem("tp_strawhat_trap", Anims.strawhat_trap, strawhat_trap_fn, "strawhat_cowboy#"),
MakeItem("tp_ballhat", Anims.ballhat, ballhat_fn, "footballhat_combathelm#"),
MakeItem("tp_woodarmor", Anims.wood, wood_fn, "armor_wood_fangedcollar#"),
MakeItem("tp_hambat", Anims.ham, ham_fn, "ham_bat_spiralcut#"),
MakeItem("tp_staff_trinity", Anims.spear, staff_trinity_fn, "spear_bee#"),
MakeItem("tp_flare", Anims.flare, flare_fn, "tp_flare#"),
MakeItem("tp_cane", Anims.cane, cane_fn, "cane_ancient#"),
MakeItem("tp_cutlass", Anims.cutlass, cutlass_fn, "tp_cutlass#"),
MakeItem("tp_sign_staff", Anims.sign, sign_staff_fn, "tp_sign_staff#"),
MakeItem("tp_forest_gun", Anims.gun, forest_gun_fn, "tp_swords", "tp_forest_handarm"),
MakeItem("tp_forest_gun_2", Anims.gun, forest_gun_fn2, "tp_swords", "tp_forest_handarm"),
MakeItem("tp_forest_gun_3", Anims.gun, forest_gun_fn3, "tp_swords", "tp_forest_handarm"),
MakeItem("tp_tree_seed_bullet", Anims.acorn, tree_seed_bullet_fn, "acorn"),
MakeItem("tp_tree_seed_bullet_2", Anims.pinecone, tree_seed_bullet_fn_2, "acorn"),
MakeItem("tp_tree_seed_bullet_3", Anims.jungletreeseed, tree_seed_bullet_fn_3, "acorn"),
MakeItem("tp_tree_seed_bullet_4", Anims.teatree_nut, tree_seed_bullet_fn_4, "acorn"),
MakeItem("tp_tree_seed_bullet_5", Anims.coconut, tree_seed_bullet_fn_5, "acorn"),
MakeItem("tp_unreal_sword", Anims.sword, unreal_sword_fn, "nightsword_sharp#"),
MakeItem("tp_oak_armor", Anims.soft_wood, oak_armor_fn, "armor_wood_haramaki#"),
MakeItem("tp_pig_book", Anims.magic_books, pig_book_fn, "ash"),
MakeItem("tp_brave_amulet", Anims.amulet, brave_amulet_fn, "amulet_red_occulteye#"),
MakeItem("tp_pig_lamp", Anims.pig_lamp, pig_lamp_fn, "pig_lamp#"),
MakeItem('tp_bird_egg', Anims.tall_bird_egg, bird_egg_fn, 'tallbirdegg'),
MakeItem('tp_bird_egg_cracked', Anims.tall_bird_egg, bird_egg_cracked_fn, 'tallbirdegg_cracked'),
MakeItem('tp_pigking_hat', Anims.pigking_hat, pigking_hat_fn, 'beefalohat_pigking#'),


MakeItem('tp_gingko_leaf', Anims.gingko_leaf, gingko_leaf_fn, 'tp_gingko_leaf#'),
MakeItem('tp_grass_pigking', Anims.grass_pigking, grass_pigking_fn, 'tp_grass_pigking#'),
MakeItem('tp_octopus', Anims.octopus, octopus_fn, 'tp_octopus#'),
MakeItem('tp_boss_loot', {}, boss_loot_fn, 'tp_gift#'),
MakeItem('tp_loot', {}, loot_fn, 'tp_gift#'),
MakeItem('tp_epic', Anims.epic, epic_fn, {"tp_items", "tp_epic"}),
MakeItem('tp_egg_tool', Anims.egg_tool, egg_tool_fn, 'tp_egg_tool#'),
MakeItem('tp_intro', Anims.books, intro_fn, 'book_meteor'),
MakeItem('tp_update', Anims.books, update_fn, 'book_brimstone'),
MakeItem('tp_diving_mask', Anims.gasmask, diving_mask_fn, 'gasmaskhat'),
MakeItem("tp_magic_book", Anims.magic_books, magic_book_fn, "ash"),
MakeItem("tp_treasure_map", Anims.map, treasure_map_fn, "stash_map"),
MakeItem("tp_fix_powder", Anims.fix_powder, fix_powder_fn, "tp_fix_powder#"),
MakeItem("tp_red_dragon_sack_dropper", {}, red_dragon_sack_dropper_fn, "krampus_sack"),
MakeItem("tp_transport_plane", Anims.rocket, transport_plane_fn, "tp_rocket#"),
MakeItem("tp_bat_scythe", Anims.bat_scythe, bat_scythe_fn, "batbat_scythe#"),
MakeItem("tp_magic_book_loot", {}, magic_book_loot_fn, "ash"),
MakeItem("tp_pigking_loot", {}, pigking_loot_fn, "ash"),
flavour,
fodder,





gps,
sleeping_pill,
mooneyes[1],
mooneyes[2],
mooneyes[3],
mooneyes[4],
mooneyes[5],
mooneyes[6],
magic_tools[1],
magic_tools[2],
magic_tools[3],
spear_gun,
many_scroll,
night_spider,
easy_pot,
ham_tool,


MakeItem("tp_horn", Anims.horn, horn_fn, "horn")