








local Anims = {
	blue_flower_hat = {"flowerhat", "flowerhat_healing", "anim", "idle_water"},
	feather_flower_hat = {"flowerhat", "flowerhat_crown", "anim", "idle_water"},
	flower_grass_hat = {"strawhat", "strawhat_bonnet", "anim", "idle_water"},
	alloy = {"tp_alloys", "tp_alloys", "blue"},
	alloy_red = {"tp_alloys", "tp_alloys", "red"},
	alloy_great = {"tp_alloys", "tp_alloys", "purple"},


	hat_witch = {"tophat", "tophat_witch_pyre", "anim", "idle_water"},
	epic_red = {"tp_epic_red", "tp_epic_red", "idle"},
	book_elemental = {"books", "book_elemental", "book_meteor", "book_meteor_water"},
	book_fossil = {"books", "book_fossil", "book_gardening", "book_gardening_water"},
	book_skin3 = {"books", "book_brimstone_gilded", "book_brimstone", "book_brimstone_water"},
	cane_candy = {"cane", "cane_candycane", "idle", "idle_water"},
	icestaff_hockey = {"staffs", "icestaff_hockey", "bluestaff", "bluestaff_water"},
	tophat_skin = {"tophat", "tophat_festive_bell_red_firehound", "anim", "idle_water"},
	cutstone = {"cutstone", "cutstone", "idle"},
	rope = {"rope", "rope", "idle", "idle_water"},
	boards = {"boards", "boards", "idle", "idle_water"},
	nightmarefuel = {"nightmarefuel", "nightmarefuel", "idle_loop", "idle_loop_water"},
	papyrus = {"papyrus", "papyrus", "idle", "idle_water"},
	thulecite = {"thulecite", "thulecite", "anim"},
	transistor = {"transistor", "transistor", "idle", "idle_water"},
	gears = {"gears", "gears", "idle", "idle_water"},
	purplegem = {"gem", "gem", "purplegem_idle", "purplegem_idle_water"},
	nightmare_timepiece = {"nightmare_timepiece", "nightmare_timepiece", "idle_1"},
	tallbirdegg = {"egg", "tallbird_egg", "egg", "idle_water"},
	compass = {"compass", "compass", "idle", "idle_water"},
	engine = {"tp_engine", "tp_engine", "idle"},
	dimensional = {"tp_dimensional", "tp_dimensional", "idle"},
	pig_book = {"pig_book", "pig_book", "idle", "idle_water", },
	magic_books = {"tp_magic_books", "tp_magic_books", "book1"},
	coin = {"tp_coins", "tp_coins", "coin"},
	gift = {"tp_gifts", "tp_gifts", "gift"},
}

local ItemData = Class(Prefab, function(self, name, data)
	Prefab._ctor(self, name)
	self.data = data
	self.fn = function()
		local atlas, img = nil, nil
		if type(data.img) == "table" then
            atlas = "images/inventoryimages/"..data.img[1]..".xml"
            img = data.img[2]
        elseif data.img ~= nil then
            atlas, img = WARGON.resolve_img_path(data.img)
            img = string.sub(img, 1, -5)
        end
		local anims = data.anim or {}
	 	local inst = WARGON.make_prefab(anims, anims[4], "inv")
	 	inst:add_cmps({
	 		invitem = {atlas=atlas, img=img},
	 		inspect = {},
	 	})
	 	inst:AddTag("tp_item")
	 	if data.fn then
	 		data.fn(inst)
	 	end

	    return inst
	end
end)

local many_items = {}





















































































































local function alloy_shine(inst)
	inst.task = nil
	if inst.onwater then
		inst.AnimState:PlayAnimation("sparkle_water")
		inst.AnimState:PushAnimation("idle_water")
	else
		inst.AnimState:PlayAnimation("sparkle")
		inst.AnimState:PushAnimation("idle")
    end
	inst.task = inst:DoTaskInTime(4+math.random()*5, function() alloy_shine(inst) end)
end

local function alloy_entity_wake(inst)
	inst.components.tiletracker:Start()
end

local function alloy_entity_sleep(inst)
	inst.components.tiletracker:Stop()
end

local function alloy_water_change(inst, onwater)
	inst.onwater = onwater
end

local alloy = ItemData("tp_alloy", {
	anim = Anims.alloy,
	img = {"tp_alloys", "tp_alloy"},
	fn = function(inst)
		inst:add_cmps({

			stack = {},
		})
	end,
})

local alloy_great = ItemData("tp_alloy_great", {
	anim = Anims.alloy_great,

	img = {"tp_alloys", "tp_alloy_great"},
	fn = function(inst)
		inst:add_cmps({

			stack = {},
		})






	end,
})

local alloy_red = ItemData("tp_alloy_red", {
	anim = Anims.alloy_red,

	img = {"tp_alloys", "tp_alloy_red"},
	fn = function(inst)
		inst:add_cmps({

			stack = {},
		})






	end,
})





















local many_gem = ItemData("tp_many_gem", {
	fn = function(inst)
		inst:do_task(0, function()
			inst:Remove()
			c_give("greengem")
			c_give("yellowgem")
			c_give("orangegem")
		end)
	end,
})

local epic_red = ItemData("tp_epic_red", {
	anim = Anims.epic_red,
	img = "tp_epic_red#",
	fn = function(inst)
		inst:add_cmps({
			stack = {max=40},
		})
	end,
})

local plant_army_book = ItemData("tp_plant_army_book", {
	anim = Anims.magic_books,
	img = {"tp_magic_books", "tp_magic_book_3"},
	fn = function(inst)
		inst.AnimState:PlayAnimation("book3")
		WARGON.CMP.add_cmps(inst, {
			book = {
				fn = function(inst, reader)
					if reader.components.sanity then
						reader.components.sanity:DoDelta(-60)
					end
					local ents = inst:wg_finds(12, {"tp_plant_army_base"})
					for k, v in pairs(ents) do
						if v.components.crop then
							v.components.crop:SpawnPlantArmy()
						end
					end
					return true
				end, 
				test = function(inst, reader)
					return reader.components.sanity	
					and reader.components.sanity.current >= 60 
				end,
			},
		})
	end,
})

local TpTransPanel = require "screens/tp_trans_panel"
local tele_book = ItemData("tp_tele_book", {
	anim = Anims.magic_books,
	img = {"tp_magic_books", "tp_magic_book_4"},
	fn = function(inst)
		inst.AnimState:PlayAnimation("book4")
		WARGON.CMP.add_cmps(inst, {
			book = {
				fn = function(inst, reader)
					if reader.components.sanity then
						reader.components.sanity:DoDelta(-15)
					end
					reader:AddTag("tp_tele_book")
					TheFrontEnd:PushScreen(TpTransPanel())
					return true
				end, 
				test = function(inst, reader)
					return reader.components.sanity	
					and reader.components.sanity.current >= 15
				end,
			},
		})
	end
})

local spawn_book = ItemData("tp_spawn_book", {
	anim = Anims.magic_books,
	img = {"tp_magic_books", "tp_magic_book_5"},
	fn = function(inst)
		inst.AnimState:PlayAnimation("book5")
		WARGON.CMP.add_cmps(inst, {
			cont = {
				typ="1x4",
				test = function(inst, item, slot)
					return item:HasTag("tp_scroll")
				end,
			},
		})
		inst.components.container.acceptsstacks = false
	end
})


































































































































local engine = ItemData("tp_engine", {
	anim = Anims.engine,
	img = "tp_engine#",
})

local dimensional = ItemData("tp_dimensional", {
	anim = Anims.dimensional,
	img = "tp_dimensional#",
	fn = function(inst)
		inst:add_cmps({
			cont = {typ="1x4"},
		})
		inst.components.container.widgetpos = Vector3(-100,-120,0)
		inst.components.container.itemtestfn = function(inst, item, slot)
			return item ~= inst
		end
	end,
})


local excellentize_prefabs = WARGON.EXCELLENTIZE.items
local excellentize_items = {}

local function create_great_items(data)
	local items = {}
	items[1] = ItemData("tp_"..data.name.."_2", {
		anim = data.anim or Anims[data.name],
		img = data.img or data.name,
		fn = function(inst)
			if data.stack then
				inst:add_cmps({
					stack = {max=data.stack},
				})
			end
		end,
	})
	for i = 1, 5 do
		if i > 1 then
			items[i] = deepcopy(items[1])
			items[i]:SetName("tp_"..data.name.."_"..tostring(i+1))
		end
		table.insert( excellentize_items, items[i])
		table.insert(many_items, items[i])
	end
	return items
end

for k, v in pairs(excellentize_prefabs) do
	create_great_items({
		name = v,
		stack = 10,
	})
end

local small_pig_book = ItemData("tp_small_pig_book", {
	anim = Anims.pig_book,
	img = "pig_book#",
	fn = function(inst)
		inst:add_cmps({
			book = {
				fn=function(inst, reader)
					local inv = reader.components.inventory
					inv:ConsumeByName("pigskin", 1)
					reader.components.sanity:DoDelta(-10)
					reader.components.health:DoDelta(-10)
					local pos = WARGON.around_land(reader, math.random(3, 6))
					if pos then
						local pig = WARGON.make_spawn(pos, "pigman")
						if WARGON.on_water(pig) then

							WARGON.make_fx2("splash_water_sink", pos)
							pig:Remove()
						else
							WARGON.make_fx(pos, "tp_fx_shadow_bat")



							reader.components.leader:AddFollower(pig)
							pig.components.follower:AddLoyaltyTime(1200)
						end
						return true
					end
				end, 
				test=function(inst, reader)
					local inv = reader.components.inventory
					if inv:Has("pigskin", 1) then
						return reader.components.sanity.current > 10
							and reader.components.health.currenthealth > 10
					end
				end,
			},
		})
	end,
})

local gun_battery = ItemData("tp_gun_battery", {
	anim = {"tp_items", "tp_items", "tp_gun_battery"},
	img = {"tp_items", "tp_gun_battery"},
	fn = function(inst)
		inst:add_cmps({
			inspect = {},
			stack = {max=40},
		})
		inst:AddTag("tp_gun_battery")
		inst:AddComponent("tpinterable")
		inst.components.tpinterable:SetFn(function(inst, target, doer)
			local item = inst.components.stackable:Get()
			item:Remove()
			local fix = 100
			if doer.components.tplevel 
			and doer.components.tplevel.attr.fixup then
				fix = fix+doer.components.tplevel.attr.fixup
			end
			target.components.finiteuses:DoDelta(fix)
		end)
	end,
})

local coin = ItemData("tp_coin", {
	anim = Anims.coin,
	img = {"tp_coins", "tp_coin"},
	fn = function(inst)
		inst:add_cmps({

			stack = {max=40},
		})
	end,
})

local coin10 = deepcopy(coin)
coin10:SetName("tp_coin10")
coin10:HookFn(function(inst)

	inst.AnimState:PlayAnimation("coin_t")
	inst.components.inventoryitem.imagename = "tp_coin10"
end)

local coin100 = deepcopy(coin)
coin100:SetName("tp_coin100")
coin100:HookFn(function(inst)

	inst.AnimState:PlayAnimation("coin_h")
	inst.components.inventoryitem.imagename = "tp_coin100"
end)

local gift0 = ItemData("tp_gift0", {
	anim = Anims.gift,
	img = {"tp_gifts", "tp_gift"},
	fn = function(inst)
		inst:add_cmps({
			stack = {},

			loot = {},
		})
		inst:AddComponent("tpuse")
		inst.components.tpuse.use = function(inst)
			local item = inst.components.stackable:Get()

			if inst.loots and next(inst.loots) then
				local loot = weighted_random_choice(inst.loots)
				inst.components.lootdropper:SpawnLootPrefab(loot)
			end
			if inst.loot_fn then
				inst:loot_fn()
			end
			item:Remove()
		end
	end,
})

local gift = deepcopy(gift0)
gift:SetName("tp_gift")
gift:HookFn(function(inst)

	inst.loots = {}
	for k, v in pairs(WARGON.GIFT_LIST) do
		inst.loots[v] = 1
	end

end)

local gift2 = deepcopy(gift0)
gift2:SetName("tp_gift2")
gift2:HookFn(function(inst)

	inst.AnimState:PlayAnimation("gift_two")
	inst.components.inventoryitem.imagename = "tp_gift2"
	inst.loots = {}
	for k, v in pairs(WARGON.GIFT_LIST2) do
		inst.loots[v] = 1
	end

end)

local gift3 = deepcopy(gift0)
gift3:SetName("tp_gift3")
gift3:HookFn(function(inst)

	inst.AnimState:PlayAnimation("gift_three")
	inst.components.inventoryitem.imagename = "tp_gift3"
	inst.loots = {}
	for k, v in pairs(WARGON.GIFT_LIST3) do
		inst.loots[v] = 1
	end

end)

local gift4 = deepcopy(gift0)
gift4:SetName("tp_gift4")
gift4:HookFn(function(inst)
	inst:set_anim("tp_items", "tp_items", "tp_gift_epic")
	inst.components.inventoryitem:SetImage({"tp_items","tp_gift_epic"})
	inst.loots = {}
	for k, v in pairs(WARGON.GIFT_LIST4) do
		inst.loots[v] = 1
	end
end)

local gift5 = deepcopy(gift0)
gift5:SetName("tp_gift5")
gift5:HookFn(function(inst)
	inst:set_anim("tp_items", "tp_items", "tp_gift_resource")
	inst.components.inventoryitem:SetImage({"tp_items","tp_gift_resource"})

	inst.loot_fn = function(inst)
		for i = 1, 5 do
			inst.components.lootdropper:SpawnLootPrefab("tp_epic")
		end
		inst.components.lootdropper:SpawnLootPrefab("tp_treasure_map")


	end
end)

local gift6 = deepcopy(gift0)
gift6:SetName("tp_gift6")
gift6:HookFn(function(inst)
	inst:set_anim("tp_items", "tp_items", "tp_gift_equip")
	inst.components.inventoryitem:SetImage({"tp_items","tp_gift_equip"})

	inst.loot_fn = function(inst)

		for i = 1, math.random(4) do
			inst.components.lootdropper:SpawnLootPrefab("tp_epic")
		end
	end
end)

local gift7 = deepcopy(gift0)
gift7:SetName("tp_gift7")
gift7:HookFn(function(inst)
	inst:set_anim("tp_gifts", "tp_gifts", "gift_coin")
	inst.components.inventoryitem:SetImage({"tp_gifts", "tp_gift_coin"})
	inst.loot_fn = function(inst)

		local ten = math.random(10)
		local hun = math.random(4)-1
		for i = 1, ten do
			inst.components.lootdropper:SpawnLootPrefab("tp_coin10")
		end
		for i = 1, hun do
			inst.components.lootdropper:SpawnLootPrefab("tp_coin100")
		end
	end
end)

local gift8 = deepcopy(gift0)
gift8:SetName("tp_gift8")
gift8:HookFn(function(inst)
	inst:set_anim("tp_gifts", "tp_gifts", "gift_remind")
	inst.components.inventoryitem:SetImage({"tp_gifts", "tp_gift_remind"})
	inst.loots = {}
	for k, v in pairs( WARGON.GIFT_LIST8 ) do
		inst.loots[v] = 1
	end
end)

local many_epic = ItemData("tp_many_epic", {
	fn = function(inst)
		inst:do_task(0, function()
			c_give("tp_epic", 5)
			c_give("tp_treasure_map", 1)
			inst:Remove()
		end)
	end,
})

local rand_epic = ItemData("tp_rand_epic", {
	fn = function(inst)
		inst:do_task(0, function()
			c_give("tp_epic", math.random(4))
			inst:Remove()
		end)
	end
})

local phone = ItemData("tp_phone", {
	anim = {"tp_phone", "tp_phone", "idle", "idle_water"},
	img = "tp_phone#",
	fn = function(inst)
		inst:add_cmps({
			inspect = {},
		})
	end,
})

local potion = ItemData("tp_potion", {
	anim = {"tp_items", "tp_items", "tp_potion"},
	img = {"tp_items", "tp_potion"},
	fn = function(inst)
		inst:add_cmps({
			inspect = {},
		})
		inst:AddComponent("tppotion")
		inst:AddComponent("container")
	    inst.components.container:SetNumSlots(1.1)
	    inst.components.container.widgetslotpos = {Vector3(0,0,0)}
	    inst.components.container.widgetanimbank = "ui_bundle_2x2"
	    inst.components.container.widgetanimbuild = "ui_bundle_2x2"
	    inst.components.container.widgetpos = Vector3(200,0,0)
	    inst.components.container.side_align_tip = 100
	    inst.components.container.acceptsstacks = false
		inst.components.container.widgetbuttoninfo = {
			text = STRINGS.TP_STR.tp_sure,
			position = Vector3(0, -100, 0),
			fn = function(inst, doer)
				inst.components.container:Close()
				local item = inst.components.container.slots[1]
				print(item, item.prefab)
				if inst.components.tppotion:CanSet(item.prefab) then
					local potion = SpawnPrefab("tp_potion_active")
					potion.components.tppotion:SetItem(item)
					if doer.components.inventory then
						doer.components.inventory:GiveItem(potion)
					else
						potion.Transform:SetPosition(inst:GetPosition():Get())
					end
					potion.components.tppotion:SetImage()
					inst:Remove()
				end
			end,
			validfn = function(inst)
				return inst.components.container.slots[1]
			end,
		}
	end,
})
table.insert(many_items, potion)

local potion_active = ItemData("tp_potion_active", {
	anim = {"tp_items", "tp_items", "tp_potion"},
	img = {"tp_items", "tp_potion"},
	fn = function(inst)
		inst:add_cmps({
			food = {
				health=0, hunger=0, san=0, 
				fn=function(inst, eater)
					inst.components.tppotion:OnEat(eater)
				end,
			},
			inspect = {},
			invitem = {
				drop = function(inst)
					inst.components.tpfollowimage:Show()
				end,
				put = function(inst)
					inst.components.tpfollowimage:Hide()
				end,
			},
		})
		inst:AddComponent("tppotion")
		inst:AddComponent("tpfollowimage")
		inst.components.tpfollowimage.offset = Vector3(0, 0, 0)
		inst.components.tpfollowimage.scale = .3
	end
})
table.insert(many_items, potion_active)

local plantable = ItemData("tp_plantable", {
	anim = {"tp_items", "tp_items", "tp_plantable", "tp_plantable"},
	img = {"tp_items", "tp_plantable"},
	fn = function(inst)
		inst:add_cmps({
			inspect = {},
		})
		inst:AddComponent("tpplantable")
		inst:AddComponent("container")
	    inst.components.container:SetNumSlots(1.1)
	    inst.components.container.widgetslotpos = {Vector3(0,0,0)}
	    inst.components.container.widgetanimbank = "ui_bundle_2x2"
	    inst.components.container.widgetanimbuild = "ui_bundle_2x2"
	    inst.components.container.widgetpos = Vector3(200,0,0)
	    inst.components.container.side_align_tip = 100
	    inst.components.container.acceptsstacks = false
		inst.components.container.widgetbuttoninfo = {
			text = STRINGS.TP_STR.tp_sure,
			position = Vector3(0, -100, 0),
			fn = function(inst, doer)
				inst.components.container:Close()
				local item = inst.components.container.slots[1]
				if inst.components.tpplantable:CanSet(item.prefab) then
					local seed = SpawnPrefab("tp_plantable_seed")
					seed.components.tpplantable:SetItem(item)
					if doer.components.inventory then
						doer.components.inventory:GiveItem(seed)
					else
						seed.Transform:SetPosition(inst:GetPosition():Get())
					end
					seed.components.tpplantable:SetImage()
					inst:Remove()
				end
			end,
			validfn = function(inst)
				return inst.components.container.slots[1]
			end,
		}
	end
})
table.insert(many_items,plantable)

local plantable_seed = ItemData("tp_plantable_seed", {
	anim = {"tp_items", "tp_items", "tp_plantable", "tp_plantable"},
	img = {"tp_items", "tp_plantable"},
	fn = function(inst)
		inst:add_cmps({
			inspect = {},
			invitem = {
				drop = function(inst)
					inst.components.tpfollowimage:Show()
				end,
				put = function(inst)
					inst.components.tpfollowimage:Hide()
				end,
			}
		})
		inst:AddComponent("tpplantable")
		inst:AddComponent("tpfollowimage")
		inst.components.tpfollowimage.offset = Vector3(0, 0, 0)
		inst.components.tpfollowimage.scale = .3
	end
})
table.insert(many_items, plantable_seed)

local scroll = ItemData("tp_scroll", {
	anim = {"tp_items", "tp_items", "tp_scroll"},
	img = {"tp_items", "tp_scroll"},
	fn = function(inst)
		inst:AddTag("tp_scroll")
		inst:add_cmps({
			inspect = {},
		})
		inst:AddComponent("tpscroll")
		inst:AddComponent("container")




	    inst.components.container:SetNumSlots(1.1)
	    inst.components.container.widgetslotpos = {Vector3(0,0,0)}
	    inst.components.container.widgetanimbank = "ui_bundle_2x2"
	    inst.components.container.widgetanimbuild = "ui_bundle_2x2"
	    inst.components.container.widgetpos = Vector3(200,0,0)
	    inst.components.container.side_align_tip = 100
	    inst.components.container.acceptsstacks = false

		inst.components.container.widgetbuttoninfo = {
			text = STRINGS.TP_STR.tp_sure,
			position = Vector3(0, -100, 0),
			fn = function(inst, doer)

				inst.components.container:Close()
				local item = inst.components.container.slots[1]
				inst.components.tpscroll:SetScroll(item.prefab)
				inst.components.tpscroll:OnRead(doer)


			end,
			validfn = function(inst)

				return inst.components.container.slots[1]
			end,
		}





	end,
})
table.insert(many_items, scroll)

local TpTransPanel = require "screens/tp_trans_panel"
local scroll_pig_teleport = ItemData("scroll_pig_teleport", {
	anim = {"tp_items", "tp_items", "scroll_pig_teleport"},
	img = {"tp_items", "scroll_pig_teleport"},
	fn = function(inst)
		inst:add_cmps({
			stack = {max=20},
			book = {
				fn = function(inst, reader)
					TheFrontEnd:PushScreen(TpTransPanel())
					return true
				end, 
				act="map"
			},
		})
	end,
})
table.insert(many_items, scroll_pig_teleport)

local resource_transporter_remote = ItemData(
"tp_resource_transporter_controller", {
	anim = {"tp_items", "tp_items", "tp_resource_transporter_controller"},
	img = {"tp_items", "tp_resource_transporter_controller"},
	fn = function(inst)
		inst:add_cmps({
			inspect = {},
		})
		inst:AddComponent("tpinterable")
		inst:AddComponent("tpuse")
		inst.components.tpuse.use = function(inst, doer)
			local center = c_find("tp_resource_transporter")
			if center then
				center:transport()
			end
		end
	end,
})
table.insert(many_items, resource_transporter_remote)

local scroll_bearger = ItemData("tp_scroll_bearger", {
	anim = {"tp_scroll_boss", "tp_scroll_boss", "bearger"},
	img = {"tp_scroll_boss", "tp_scroll_bearger"},
	fn = function(inst)
		inst:add_cmps({
			inspect = {},
		})
		inst.boss_name = "bearger"
		inst:AddTag("tp_scroll")
		inst:AddComponent("tpuse")
		inst.components.tpuse.use = function(inst, doer)
			doer.components.sanity:DoDelta(-50)
			local pos = doer:around_land(4)
			if pos then
				if not doer:HasTag("play_boss_music") or math.random() < .1 then
					if inst.boss_name == "moose" 
					or inst.boss_name == "tigershark" then
						doer.SoundEmitter:PlaySound("tp_boss_scroll_bgm/music/bgm2", "tp_boss_scroll")
					else
						doer.SoundEmitter:PlaySound("tp_boss_scroll_bgm/music/bgm", "tp_boss_scroll")
					end
					doer:AddTag("play_boss_music")
				end
				WARGON.make_fx2("boss_spawn", pos)
				doer:do_task(.5*5, function()
					local boss_sp = WARGON.make_spawn(pos, "boss_follower_sp")
					boss_sp.boss_name = inst.boss_name
				end)
				local owner = inst.components.inventoryitem.owner
				local other_boss = inst:wg_find(9999, function(item, inst)
					return item.prefab == inst.boss_name
				end, {"tp_summon_boss"})
				if not other_boss and owner 
				and owner.prefab == "tp_spawn_book" then
					if owner.components.container:Has("tp_scroll", 3) then
						owner.components.container:ConsumeByName("tp_scroll", 3)
					end
				else
					inst:Remove()
				end
			end
		end
	end,
})
table.insert(many_items, scroll_bearger)

local scroll_boss_names = {
	"dragonfly", "moose", "twister", "ancient_hulk", "tigershark"
}
for k, v in pairs(scroll_boss_names) do
	local name = "tp_scroll_"..v
	local scroll = deepcopy(scroll_bearger)
	scroll:SetName(name)
	scroll:HookFn(function(inst)
		inst.AnimState:PlayAnimation(v)
		inst.components.inventoryitem:SetImage({"tp_scroll_boss", name})
		inst.boss_name = v
	end)
	table.insert(many_items, scroll)
end


local tophat_1 = ItemData("tp_tophat_1", {
	anim = {"tophat", "hat_top", "anim", "idle_water"},
	img = "tophat",
	fn = function(inst)
		inst.equip_fns = {}
		inst.unequip_fns = {}
		inst:add_cmps({
			inspect = {},
			equip = {
				slot = "head",
				equip = function(inst, owner)
					WARGON.EQUIP.hat_on(owner, "hat_top")
					if inst.components.fueled then
						inst.components.fueled:StartConsuming()
					end
					for k, v in pairs(inst.equip_fns) do
						v(inst, owner)
					end
				end,
				unequip = function(inst, owner)
					if inst.components.fueled then
						inst.components.fueled:StopConsuming()
					end
					WARGON.EQUIP.hat_off(owner)
					for k, v in pairs(inst.unequip_fns) do
						v(inst, owner)
					end
				end,
			},
			trade = {},
		})
		inst.components.equippable.dapperness = TUNING.DAPPERNESS_MED
		inst:AddComponent("fueled")
		inst.components.fueled.fueltype = "USAGE"
		inst.components.fueled:InitializeFuelLevel(TUNING.TOPHAT_PERISHTIME)
		inst.components.fueled:SetDepletedFn(function(inst)
			inst:Remove()
		end)
		inst:AddComponent("waterproofer")
		inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_SMALL)
	end,
})

local tophat_2 = deepcopy(tophat_1)
tophat_2:SetName("tp_tophat_2")
tophat_2:HookFn(function(inst)
	inst.components.fueled:InitializeFuelLevel(TUNING.TOPHAT_PERISHTIME+30*16)
end)

local tophat_3 = deepcopy(tophat_2)
tophat_3:SetName("tp_tophat_3")
tophat_3:HookFn(function(inst)


	inst.max_sanity = 30
	inst.components.equippable.max_sanity_mod = 30










end)

local tophat_4 = deepcopy(tophat_3)
tophat_4:SetName("tp_tophat_4")
tophat_4:HookFn(function(inst)
	inst.max_sanity = 50
	inst.components.equippable.max_sanity_mod = 50

end)

local tophat_5 = deepcopy(tophat_4)
tophat_5:SetName("tp_tophat_5")
tophat_5:HookFn(function(inst)
	table.insert(inst.equip_fns, function(inst, owner)
		owner:AddTagNum("tp_hat_witch", 1)
	end)
	table.insert(inst.unequip_fns, function(inst, owner)
		owner:AddTagNum("tp_hat_witch", -1)
	end)
end)




	
























































local flowerhat_1 = ItemData("tp_flowerhat_1", {
	anim = {"flowerhat", "hat_flower", "anim", "idle_water"},
	img = "flowerhat",
	fn = function(inst)
		inst.equip_fns = {}
		inst.unequip_fns = {}
		inst:add_cmps({
			inspect = {},
			equip = {
				slot = "head",
				equip = function(inst, owner)
					WARGON.EQUIP.hat_open(owner, "hat_flower")
					for k, v in pairs(inst.equip_fns) do
						v(inst, owner)
					end
				end,
				unequip = function(inst, owner)
					WARGON.EQUIP.hat_off(owner)
					for k, v in pairs(inst.unequip_fns) do
						v(inst, owner)
					end
				end,
			},
			trade = {},
		})
		inst.components.equippable.dapperness = TUNING.DAPPERNESS_TINY
		inst:AddTag("show_spoilage")
		inst:AddComponent("perishable")
		inst.components.perishable:SetPerishTime(TUNING.PERISH_FAST)
		inst.components.perishable:StartPerishing()
		inst.components.perishable:SetOnPerishFn(function(inst)
			inst:Remove()
		end)
		inst.opentop = true
	end,
})

local flowerhat_2 = deepcopy(flowerhat_1)
flowerhat_2:SetName("tp_flowerhat_2")
flowerhat_2:HookFn(function(inst)

	table.insert(inst.equip_fns, function(inst, owner)
		inst:ListenForEvent("picksomething", pick_flower, owner)
	end)
	table.insert(inst.unequip_fns, function(inst, owner)
		inst:RemoveEventCallback("picksomething", pick_flower, owner)
	end)
end)

local flowerhat_3 = deepcopy(flowerhat_2)
flowerhat_3:SetName("tp_flowerhat_3")
flowerhat_3:HookFn(function(inst)

	inst.components.equippable.walkspeedmult = .1
end)

local flowerhat_4 = deepcopy(flowerhat_3)
flowerhat_4:SetName("tp_flowerhat_4")
flowerhat_4:HookFn(function(inst)
	inst:AddComponent("tpinter")
	inst.fix_value = 30
	inst.components.tpinter:SetCanFn(function(inst, item, doer)
		return item.prefab == "petals"
		and inst.components.perishable:GetPercent() < 1
	end)
	inst.components.tpinter:SetFn(function(inst, item, doer)
		local item = item.components.stackable:Get()
		item:Remove()
		local dt = doer.components.tplevel.attr.fixup+inst.fix_value
		inst.components.perishable:DoDelta(dt)
	end)
end)

local function flowerhat_on_eat(inst, data)
	local hat = inst:get_equip_item("head")
	if hat and hat:HasTag("tp_hat_druid")
	and hat.components.perishable then
		hat.components.perishable:DoDelta(-10)
	end



end

local flowerhat_5 = deepcopy(flowerhat_4)
flowerhat_5:SetName("tp_flowerhat_5")
flowerhat_5:HookFn(function(inst)
	inst:AddTag("tp_hat_druid")
	table.insert(inst.equip_fns, function(inst, owner)
		owner:AddTag("tp_hat_druid")
		inst:ListenForEvent("oneat", flowerhat_on_eat, owner)
	end)
	table.insert(inst.unequip_fns, function(inst, owner)
		owner:RemoveTag("tp_hat_druid")
		inst:RemoveEventCallback("oneat", flowerhat_on_eat, owner)
	end)
end)




	




















































local strawhat_4 = ItemData("tp_strawhat_4", {
	anim = {"tp_strawhat_trap", "tp_strawhat_trap", "idle", "idle_water", },
	img = "strawhat",
	fn = function(inst)
		WARGON.CMP.add_cmps(inst, {
			inspect = {},
			trap = {},
			finite = {
				use=10, max=10, 
				fn=function(inst)
					inst:Remove()
				end
			},
		})
		WARGON.add_tags(inst, {
			"trap",
		})
		inst.components.trap.targettag = "canbetrapped"
		inst.components.trap:SetOnHarvestFn(function(inst)
			inst.components.finiteuses:Use()
		end)
		inst.components.trap.baitsortorder = 1
		inst:SetStateGraph("SGtrap")
		inst.sounds = {
			close = "dontstarve/common/trap_close",
			rustle = "dontstarve/common/trap_rustle",
		}
		inst.entity:AddMiniMapEntity()
		inst.MiniMapEntity:SetIcon("rabbittrap.png")
	end,
})

local strawhat_3 = ItemData("tp_strawhat_3", {
	anim = {"strawhat", "hat_straw", "anim", "idle_water"},
	img = "strawhat",
	fn = function(inst)
		inst:add_tags({
			"tp_open_beefalo_container",
		})
		inst.mounted_foleysound = "dontstarve/beefalo/saddle/regular_foley"
		WARGON.CMP.add_cmps(inst, {
			inspect = {},
			finite = {max=10, use=10, 
				fn=function(inst)
					inst:Remove()
				end
			},
			saddler = {},
		})
		inst.components.saddler:SetBonusDamage(1)
		inst.components.saddler:SetBonusSpeedMult(1)
		inst.components.saddler:SetSwaps("hat_straw", "swap_hat")
		inst.components.saddler:SetDiscardedCallback(function() end)
	end,
})

local function strawhat_score(inst, giver)
	local pos = inst:GetPosition()
	if pos.y <= 0.1 then

		inst.components.tphatball:Trigger(giver)
		if inst.tp_per_task then
			inst.tp_per_task:Cancel()
			inst.tp_per_task = nil
		end
	end
end

local function strawhat_throw(inst, thrower, pt)

	inst.Physics:SetFriction(.2)
	if inst.tp_per_task == nil 
	and not inst.components.tphatball.pet then

		inst.tp_per_task = WARGON.per_task(inst, .1, function() 
			strawhat_score(inst, thrower) 
		end)
	end
end

local strawhat_2 = ItemData("tp_strawhat_2", {
	anim = {"strawhat", "hat_straw", "anim", "idle_water"},
	img = "strawhat",
	fn = function(inst)
		WARGON_CMP_EX.add_cmps(inst, {
			inspect = {},
			weapon = {dmg=1},
			finite = {
				max=TUNING.SPEAR_USES, 
				use=TUNING.SPEAR_USES, 
				fn=function(inst)
					inst:Remove()
				end,
			},
			equip = {
				equip=function(inst, owner)
					WARGON_EQUIP_EX.object_on(owner, "tp_strawhat", "swap_object")
				end, 
				unequip=function(inst, owner)
					WARGON.EQUIP.object_off(owner)
				end,
			},
			throw = {
				throw=strawhat_throw,
			},
			tphatball = {},
			tpuse = {},
		})
		inst.components.tpuse.use = function(inst, doer)
			if inst.components.tphatball.pet then
				inst.components.tphatball:Release(doer)
				inst:Remove()
			end
		end
		inst.components.tpuse.can = function(inst)
			return inst.components.tphatball.pet ~= nil
		end
	end,
})




















local footballhat_1 = ItemData("tp_footballhat_1", {
	anim = {"footballhat", "hat_football", "anim", "idle_water"},
	img = "footballhat",
	fn = function(inst)
		inst.equip_fns = {}
		inst.unequip_fns = {}
		inst:add_cmps({
			inspect = {},
			equip = {
				slot = "head",
				equip = function(inst, owner)
					WARGON.EQUIP.hat_on(owner, "hat_football")
					for k, v in pairs(inst.equip_fns) do
						v(inst, owner)
					end
				end,
				unequip = function(inst, owner)
					WARGON.EQUIP.hat_off(owner)
					for k, v in pairs(inst.unequip_fns) do
						v(inst, owner)
					end
				end,
			},
			trade = {},
		})
		inst:AddComponent("armor")
		inst:AddComponent("waterproofer")
		inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_SMALL)
		inst.components.armor:InitCondition(TUNING.ARMOR_FOOTBALLHAT, TUNING.ARMOR_FOOTBALLHAT_ABSORPTION)
	end,
})

local footballhat_2 = deepcopy(footballhat_1)
footballhat_2:SetName("tp_footballhat_2")

local footballhat_3 = deepcopy(footballhat_2)
footballhat_3:SetName("tp_footballhat_3")
footballhat_3:HookFn(function(inst)


	inst.fix_value = 150
	inst:AddComponent("tpinter")
	inst.components.tpinter:SetCanFn(function(inst, item, doer)
		return item.prefab == "pigskin"
			and inst.components.armor:GetPercent() < 1
	end)
	inst.components.tpinter:SetFn(function(inst, item, doer)
		local item = item.components.stackable:Get()
		item:Remove()
		local dt = doer.components.tplevel.attr.fixup + inst.fix_value
		inst.components.armor:DoDelta(dt)
	end)
end)

local footballhat_4 = deepcopy(footballhat_3)
footballhat_4:SetName("tp_footballhat_4")
footballhat_4:HookFn(function(inst)
	inst.components.armor:InitCondition(TUNING.ARMOR_FOOTBALLHAT, .8)
end)

local function footballhat_attacked(owner, data)


	if math.random() < .3 then
		if owner.components.tpbuff then
			owner.components.tpbuff:AddBuff("tp_ballhat")
		end
	end
end

local footballhat_5 = deepcopy(footballhat_4)
footballhat_5:SetName("tp_footballhat_5")
footballhat_5:HookFn(function(inst)
	table.insert(inst.equip_fns, function(inst, owner)
		inst:ListenForEvent("attacked", footballhat_attacked, owner)
	end)
	table.insert(inst.unequip_fns, function(inst, owner)
		inst:RemoveEventCallback("attacked", footballhat_attacked, owner)
	end)
end)




	


local function armorwood_blocked(owner)
	owner.SoundEmitter:PlaySound("dontstarve/wilson/hit_armour") 
end








































local armorwood = require("prefabs/armor_wood")

local armorwood_2 = deepcopy(armorwood)
armorwood_2:SetName("tp_armorwood_2")
armorwood_2:HookFn(function(inst)
	inst.components.equippable.equip_fns = {}
	inst.components.equippable.unequip_fns = {}
	inst.components.inventoryitem:SetImage("armorwood")
end)

local armorwood_3 = deepcopy(armorwood_2)
armorwood_3:SetName("tp_armorwood_3")
armorwood_3:HookFn(function(inst)


	inst.fix_value = 100
	inst:AddComponent("tpinter")
	inst.components.tpinter:SetCanFn(function(inst, item, doer)
		return item.prefab == "boards"
			and inst.components.armor:GetPercent() < 1
	end)
	inst.components.tpinter:SetFn(function(inst, item, doer)
		local item = item.components.stackable:Get()
		item:Remove()
		local dt = doer.components.tplevel.attr.fixup + inst.fix_value
		inst.components.armor:DoDelta(dt)
	end)
end)

local armorwood_4 = deepcopy(armorwood_3)
armorwood_4:SetName("tp_armorwood_4")
armorwood_4:HookFn(function(inst)
	inst.components.armor:InitCondition(TUNING.ARMORWOOD, .8)
end)

local function oak_armor_spawn_nuter(inst, data)

	local pt = inst:GetPosition()
	if math.random() < .5 then
		for i = 1, math.random(2, 4) do
			local pos = WARGON.around_land(inst, math.random(3))
			if pos then
				if WARGON.on_water(inst, pos) then
					WARGON.make_fx(pos, "splash_water_drop")
				else
					local nuter = SpawnPrefab("birchnutdrake")
					if data.attacker and nuter.components.combat:CanTarget(data.attacker) then
						nuter.Transform:SetPosition(pos:Get())
						nuter.components.combat:SetTarget(data.attacker)

						nuter:AddTag("tp_no_drop_loot")
						WARGON.no_save(nuter)
					else
						nuter:Remove()
					end
				end
			end
		end
	end
end

local armorwood_5 = deepcopy(armorwood_4)
armorwood_5:SetName("tp_armorwood_5")
armorwood_5:HookFn(function(inst)
	table.insert(inst.components.equippable.equip_fns, function(inst, owner)
		owner:AddTag("tp_oak_armor")
		inst:ListenForEvent("attacked", oak_armor_spawn_nuter, owner)
	end)
	table.insert(inst.components.equippable.unequip_fns, function(inst, owner)
		owner:RemoveTag("tp_oak_armor")
		inst:RemoveEventCallback("attacked", oak_armor_spawn_nuter, owner)
	end)
end)

local armorwood_6 = deepcopy(armorwood_5)
armorwood_6:SetName("tp_armorwood_6")
armorwood_6:HookFn(function(inst)
	inst:add_cmps({
		equip = {
			slot = "hand",
			equip = function(inst, owner)
				inst:ListenForEvent("blocked", armorwood_blocked, owner)
				WARGON.EQUIP.object_on(owner, "armor_wood", "swap_body")
			end,
			unequip = function(inst, owner)
				inst:RemoveEventCallback("blocked", armorwood_blocked, owner)
				WARGON.EQUIP.object_off(owner)
			end,
		},
		weapon = {dmg=34*1.5},
	})
	inst:AddTag("slowattack")
end)

local cane = require("prefabs/cane")

local cane_a = deepcopy(cane)
cane_a:SetName("tp_cane_a")
cane_a:HookFn(function(inst)
	inst:AddTag("tp_auto_cane")
	inst.components.inventoryitem:SetImage("cane")
end)

local cane_b = deepcopy(cane_a)
cane_b:SetName("tp_cane_b")
cane_b:HookFn(function(inst)
	inst:RemoveTag("tp_auto_cane")
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(1)
	inst:AddTag("tp_move_no_target")
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_HUA"
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(1)
	end
end)

local cane_c = deepcopy(cane_a)
cane_c:SetName("tp_cane_c")
cane_c:HookFn(function(inst)
	inst:RemoveTag("tp_auto_cane")
	inst.components.equippable:AddEquipFn(function(inst, owner)
		owner:AddTag("tp_spear_road")
	end)
	inst.components.equippable:AddUnequipFn(function(inst, owner)
		owner:RemoveTag("tp_spear_road")
	end)
end)

local staff_fn = loadfile("prefabs/staff")
local staffs = {staff_fn()}
local icestaff = staffs[1]
local firestaff = staffs[2]

local icestaff_2 = deepcopy(icestaff)
icestaff_2:SetName("tp_icestaff_2")
icestaff_2:HookFn(function(inst)
	inst.components.inventoryitem:SetImage("icestaff")
end)

local icestaff_3 = deepcopy(icestaff_2)
icestaff_3:SetName("tp_icestaff_3")

local firestaff_2 = deepcopy(firestaff)
firestaff_2:SetName("tp_firestaff_2")
firestaff_2:HookFn(function(inst)
	inst.components.inventoryitem:SetImage("firestaff")
end)

local firestaff_3 = deepcopy(firestaff_2)
firestaff_3:SetName("tp_firestaff_3")

local function staff_trinity_equip(inst, owner)
	local bank, build = inst.components.tptrinity:GetBuild()
	WARGON.EQUIP.object_on(owner, bank, build)
end

local function staff_trinity_use_test(inst)
	return inst.components.equippable:IsEquipped()
end

local function staff_trinity_use_use(inst)
	inst.components.tptrinity:Change()
end

local function staff_trinity_spear(inst)
	WARGON.CMP.add_cmps(inst, {
		weapon = {dmg=34, fn="nil", fx='nil', range={nil,nil}},
	})

	WARGON.add_tags(inst, {"sharp"})
	WARGON.remove_tags(inst, {'rangedlighter', 'extinguisher', "tp_witch_staff"})
	inst:set_anim({"spear", "spear", "idle"})
	MakeInventoryFloatable(inst, "idle_water", "idle")
end

local function staff_trinity_ice_weapon_fn(inst, owner, target)
	WARGON.frozen_prefab(target, owner)
	if owner and owner.components.sanity then
		owner.components.sanity:DoDelta(-TUNING.SANITY_SUPERTINY)
	end
end

local function staff_trinity_ice(inst)
	WARGON.CMP.add_cmps(inst, {
		weapon = {dmg=0, fn=staff_trinity_ice_weapon_fn, fx='ice_projectile',
			range={8,10} },
	})
	WARGON.add_tags(inst, {'extinguisher', "tp_witch_staff"})
	WARGON.remove_tags(inst, {"sharp", 'rangedlighter'})
	inst:set_anim({"staffs", "staffs", "bluestaff"})
	MakeInventoryFloatable(inst, "bluestaff_water", "bluestaff")
end

local function staff_trinity_fire_weapon_fn(inst, owner, target)
	WARGON.fire_prefab(target, owner)
    if owner and owner.components.sanity then
        owner.components.sanity:DoDelta(-TUNING.SANITY_SUPERTINY)
    end
    owner.SoundEmitter:PlaySound("dontstarve/wilson/fireball_explo")
    if not owner:HasTag("tp_hat_witch") then
	    target:PushEvent("attacked", { attacker = owner, damage = 0 })
    end
end

local function staff_trinity_fire(inst)
	WARGON.CMP.add_cmps(inst, {
		weapon = {dmg=0, fn=staff_trinity_fire_weapon_fn, fx='fire_projectile',
			range={8,10} },	
	})
	WARGON.add_tags(inst, {'rangedlighter', "tp_witch_staff"})
	WARGON.remove_tags(inst, {"sharp", 'extinguisher'})
	inst:set_anim({"staffs", "staffs", "redstaff"})
	MakeInventoryFloatable(inst, "redstaff_water", "redstaff")
end

local trinity_staff = ItemData("tp_trinity_staff", {
	anim = {"spear", "spear", "idle", "idle_water"},
	img = "spear",
	fn = function(inst)
		WARGON.CMP.add_cmps(inst, {
			inspect = {},
			weapon = {dmg=34},
			equip = {equip=staff_trinity_equip, 
				unequip=function(inst, owner)
					WARGON.EQUIP.object_off(owner)
				end,
			},
			finite = {use=150, max=150, 
				fn=function(inst)
					inst:Remove()
				end
			},
			use = {str="切换", test=staff_trinity_use_test, use=staff_trinity_use_use},
		})
		inst:AddComponent("tptrinity")
		inst.components.tptrinity:SetBuild({
			{'swap_spear', 'swap_spear'},
			{'swap_staffs', 'bluestaff'},
			{'swap_staffs', 'redstaff'},
		})
		inst.components.tptrinity:SetImage({
			'spear',
			'icestaff',
			'firestaff',
		})
		inst.components.tptrinity:SetFn({
			staff_trinity_spear,
			staff_trinity_ice,
			staff_trinity_fire,
		})
	end,
})

local nightsword = require("prefabs/nightsword")

local nightsword_2 = deepcopy(nightsword)
nightsword_2:SetName("tp_nightsword_2")
nightsword_2:HookFn(function(inst)
	inst.components.inventoryitem:SetImage("nightsword")
	inst.components.equippable.dapperness = TUNING.CRAZINESS_SMALL
end)

local nightsword_3 = deepcopy(nightsword_2)
nightsword_3:SetName("tp_nightsword_3")
nightsword_3:HookFn(function(inst)
	inst.components.equippable.dapperness = -TUNING.DAPPERNESS_LARGE
end)

local nightsword_4 = deepcopy(nightsword_3)
nightsword_4:SetName("tp_nightsword_4")
nightsword_4:HookFn(function(inst)
	inst.components.equippable.dapperness = -TUNING.DAPPERNESS_MED_LARGE
end)

local nightsword_5 = deepcopy(nightsword_4)
nightsword_5:SetName("tp_nightsword_5")
nightsword_5:HookFn(function(inst)



	inst.components.equippable.dapperness = -TUNING.DAPPERNESS_MED
	inst.fix_value = 15
	inst:AddComponent("tpinter")
	inst.components.tpinter:SetCanFn(function(inst, item, doer)
		return item.prefab == "nightmarefuel"
			and inst.components.finiteuses:GetPercent() < 1
	end)
	inst.components.tpinter:SetFn(function(inst, item, doer)
		local item = item.components.stackable:Get()
		item:Remove()
		local dt = doer.components.tplevel.attr.fixup + inst.fix_value
		inst.components.finiteuses:DoDelta(dt)
	end)
end)

local function unreal_sword_spell(staff, target, pos)
	local owner = staff.components.inventoryitem.owner
	if target then
		local pt = owner:GetPosition()
		local pt2 = target:GetPosition()
		owner.Transform:SetPosition(pt2:Get())
		target.Transform:SetPosition(pt:Get())
	else
		owner.components.inventory:ConsumeByName("nightmarefuel", 1)

		WARGON.make_fx(pos, "statue_transition")
		WARGON.make_fx(pos, "statue_transition_2")
		WARGON.do_task(staff, .5, function()
			local shadow = WARGON.make_spawn(pos, "tp_unreal_wilson")
			if WARGON.on_water(shadow) then
				shadow:SpawnShadowBoat(pos)
			end
			shadow.components.follower:SetLeader(owner)
			owner.components.health:DoDelta(-TUNING.SHADOWWAXWELL_HEALTH_COST)
		    owner.components.sanity:RecalculatePenalty()
		    owner.SoundEmitter:PlaySound("dontstarve/maxwell/shadowmax_appear")
		end)
	end
end

local function unreal_sword_test(staff, caster, target, pos)
	if target and target:HasTag("tp_unreal_wilson") then


		return true
	end
	if caster.components.inventory:Has("nightmarefuel", 1) then
		return caster.components.sanity:GetMaxSanity() >= TUNING.SHADOWWAXWELL_SANITY_PENALTY
	end
end

local nightsword_6 = deepcopy(nightsword_5)
nightsword_6:SetName("tp_nightsword_6")
nightsword:HookFn(function(inst)
	inst.components.equippable.dapperness = -TUNING.DAPPERNESS_SMALL
	WARGON.CMP.add_cmps(inst, {
		caster = {spell=unreal_sword_spell, test=unreal_sword_test, 
			can={point=true, inv=false, target=true}},
	})
end)

local hambat = require("prefabs/hambat")

local hambat_2 = deepcopy(hambat)
hambat_2:SetName("tp_hambat_2")
hambat_2:HookFn(function(inst)
	inst:AddTag("tp_must_spoilsh")
	inst.components.inventoryitem:SetImage("hambat")
	inst:AddComponent("edible")
	inst.components.edible.foodtype = "MEAT"
    inst.components.edible.healthvalue = 6
    inst.components.edible.hungervalue = 50
    inst.components.edible.sanityvalue = 0
    inst.components.edible.CollectInventoryActions = function()
	end
end)

local hambat_3 = deepcopy(hambat)
hambat_3:SetName("tp_hambat_3")
hambat_3:HookFn(function(inst)
	inst:AddTag("tp_must_spoilsh")
	inst.components.inventoryitem:SetImage("hambat")
	inst.components.equippable:AddEquipFn(function(inst, owner)
		owner:add_dmg_rate(inst.prefab, .1)
	end)
	inst.components.equippable:AddUnequipFn(function(inst, owner)
		owner:rm_dmg_rate(inst.prefab)
	end)
end)

local hambat_4 = deepcopy(hambat_3)
hambat_4:SetName("tp_hambat_4")
hambat_4:HookFn(function(inst)
	inst:add_cmps({
		tool = {
			act = {chop=1, mine=1, dig=1, ham=1, hack=1, shear=1},
		},
	})
end)

local hambat_5 = deepcopy(hambat_3)
hambat_5:SetName("tp_hambat_5")
hambat_5:HookFn(function(inst)
	local onattack = inst.components.weapon.onattack
	inst.components.weapon.onattack = function(inst, owner, target)
		onattack(inst, owner, target)
		local fx = WARGON.make_fx2("many_small_meat", target)
		fx.rand = inst.components.perishable:GetPercent()
	end
end)

local hambat_6 = deepcopy(hambat_5)
hambat_6:SetName("tp_hambat_6")
hambat_6:HookFn(function(inst)
	inst:AddComponent("tpinter")
	inst.components.tpinter:SetFn(function(inst, item, doer)
		local item = item.components.stackable:Get()
		item:Remove()
		local cur = item.components.perishable:GetPercent()*100
		inst.components.perishable:DoDelta(cur)
	end)
	inst.components.tpinter:SetCanFn(function(inst, item, doer)
		return item:HasTag("tp_hambat_fuel")
	end)
end)

local amulet_fn = loadfile("prefabs/amulet")
local amulets = {amulet_fn()}
local yellowamulet = amulets[6]

local yellowamulet_2 = deepcopy(yellowamulet)
yellowamulet_2:SetName("tp_yellowamulet_2")
yellowamulet_2:HookFn(function(inst)
	inst.components.inventoryitem:SetImage("yellowamulet")
end)

local yellowamulet_3 = deepcopy(yellowamulet_2)
yellowamulet_3:SetName("tp_yellowamulet_3")

local function brave_amulet_on_hunger_delta(inst, data)
	local p = inst.components.hunger:GetPercent()
	WARGON.add_hunger_rate(inst, "tp_brave_amulet", 2*p)

		WARGON.add_dmg_rate(inst, "tp_brave_amulet", .4*p)


		if inst.components.tpbody then
			inst.components.tpbody:AddAbsorbModifier("tp_brave_amulet", .6*p)
		end

end

local yellowamulet_4 = deepcopy(yellowamulet_3)
yellowamulet_4:SetName("tp_yellowamulet_4")
yellowamulet_4:HookFn(function(inst)
	inst.components.equippable:AddEquipFn(function(inst, owner)
		inst:ListenForEvent("hungerdelta", brave_amulet_on_hunger_delta, owner)

	end)
	inst.components.equippable:AddUnequipFn(function(inst, owner)
		inst:RemoveEventCallback("hungerdelta", brave_amulet_on_hunger_delta, owner)


		owner:rm_dmg_rate("tp_brave_amulet")
		owner:rm_hunger_rate("tp_brave_amulet")
		if owner.components.tpbody then
			owner.components.tpbody:RemoveAbsorbModifier("tp_brave_amulet")
		end
	end)
end)


















local hat_fn = loadfile("prefabs/hats")
local hats = {hat_fn()}
local beefalohat = hats[3]
local gasmaskhat = nil
for k, v in pairs(hats) do
	if v.name == "gasmaskhat" then
		gasmaskhat = v
	end
end

local beefalohat_2 = deepcopy(beefalohat)
beefalohat_2:SetName("tp_beefalohat_2")
beefalohat_2:HookFn(function(inst)
	inst.components.inventoryitem:SetImage("beefalohat")
end)

local beefalohat_3 = deepcopy(beefalohat_2)
beefalohat_3:SetName("tp_beefalohat_3")
beefalohat_3:HookFn(function(inst)
	inst.skill_fn = function(item, player)
		item:Remove()
		c_give("horn")
	end
end)

local beefalohat_4 = deepcopy(beefalohat_3)
beefalohat_4:SetName("tp_beefalohat_4")
beefalohat_4:HookFn(function(inst)
	inst.skill_fn = function(item, player)
		if not player.sg:HasStateTag("busy")
		or player.sg:HasStateTag("doing") then
			local horn = SpawnPrefab("horn")
			horn.components.finiteuses:SetUses(1)
			local ba = BufferedAction(player, nil, ACTIONS.PLAY, horn)
			player:PushBufferedAction(ba)
			item.components.fueled:DoDelta(-800)
		end
	end
end)








































local beefalohat_5 = deepcopy(beefalohat_4)
beefalohat_5:SetName("tp_beefalohat_5")
beefalohat_5:HookFn(function(inst)
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_MED
end)

local gasmaskhat_2 = deepcopy(gasmaskhat)
gasmaskhat_2:SetName("tp_gasmaskhat_2")
gasmaskhat_2:HookFn(function(inst)
	inst.components.inventoryitem:SetImage("gasmaskhat")
	inst.components.equippable:AddEquipFn(function(inst, owner)
		owner:AddTag("tp_diver")
	end)
	inst.components.equippable:AddUnequipFn(function(inst, owner)
		owner:RemoveTag("tp_diver")
	end)
end)

local boomerang = require("prefabs/boomerang")

local boomerang_2 = deepcopy(boomerang)
boomerang_2:SetName("tp_boomerang_2")
boomerang_2:HookFn(function(inst)
	inst.components.inventoryitem:SetImage("boomerang")
	inst.components.equippable:AddEquipFn(function(inst, owner)
		owner:AddTag("tp_bat_scythe")
	end)
	inst.components.equippable:AddUnequipFn(function(inst, owner)
		owner:RemoveTag("tp_bat_scythe")
	end)
end)


local axe_fn = loadfile("prefabs/axe")
local axes = {axe_fn()}
for i = 2, 6 do
	local tool = nil
	if i == 6 then
		tool = deepcopy(axes[2])
	else
		tool = deepcopy(axes[1])
	end
	tool:SetName("tp_axe_"..i)
	tool:HookFn(function(inst)
		if i == 6 then
			inst.AnimState:SetBuild("goldenaxe")
			inst.AnimState:SetBank("goldenaxe")
			inst.components.inventoryitem:SetImage("goldenaxe")
		else	
			inst.components.inventoryitem:SetImage("axe")
		end
		inst.components.tool:SetAction(ACTIONS.CHOP, i)
		inst.components.finiteuses:SetMaxUses(110)
		inst.components.finiteuses:SetUses(110)
		inst.components.finiteuses:SetOnFinished(function(inst)
			if i<6 then
				local next = i+1
				c_give("tp_axe_"..next)
			end
			inst:Remove()
		end)
		if i>=4 then
			inst:AddComponent("tpinter")
			inst.components.tpinter:SetFn(function(inst, item, doer)
				local item = item.components.stackable:Get()
				item:Remove()
				inst.components.finiteuses:DoDelta(50)
			end)
			inst.components.tpinter:SetCanFn(function(inst, item, doer)
				if i>=6 and item.prefab == "goldnugget" then
					return true
				end
				return item.prefab == "flint"
			end)
		end
		if i == 6 then
			inst.components.equippable:AddEquipFn(function(inst, owner)
				owner:AddTag("tp_magic_tool_owner")
			end)
			inst.components.equippable:AddUnequipFn(function(inst, owner)
				owner:RemoveTag("tp_magic_tool_owner")
			end)
		end
	end)
	table.insert(many_items, tool)
end


local pickaxe_fn = loadfile("prefabs/pickaxe")
local pickaxes = {pickaxe_fn()}
for i = 2, 6 do
	local tool = nil
	if i == 6 then
		tool = deepcopy(pickaxes[2])
	else
		tool = deepcopy(pickaxes[1])
	end
	tool:SetName("tp_pickaxe_"..i)
	tool:HookFn(function(inst)
		if i == 6 then
			inst.AnimState:SetBuild("goldenpickaxe")
			inst.AnimState:SetBank("goldenpickaxe")
			inst.components.inventoryitem:SetImage("goldenpickaxe")
		else	
			inst.components.inventoryitem:SetImage("pickaxe")
		end
		inst.components.tool:SetAction(ACTIONS.MINE, i)
		inst.components.finiteuses:SetMaxUses(35)
		inst.components.finiteuses:SetUses(35)
		inst.components.finiteuses:SetOnFinished(function(inst)
			if i<6 then
				local next = i+1
				c_give("tp_pickaxe_"..next)
			end
			inst:Remove()
		end)
		if i>=4 then
			inst:AddComponent("tpinter")
			inst.components.tpinter:SetFn(function(inst, item, doer)
				local item = item.components.stackable:Get()
				item:Remove()
				inst.components.finiteuses:DoDelta(20)
			end)
			inst.components.tpinter:SetCanFn(function(inst, item, doer)
				if i>=6 and item.prefab == "goldnugget" then
					return true
				end
				return item.prefab == "flint"
			end)
		end
	end)
	table.insert(many_items, tool)
end


local shovel_fn = loadfile("prefabs/shovel")
local shovels = {shovel_fn()}
for i = 2, 6 do
	local tool = nil
	if i == 6 then
		tool = deepcopy(shovels[2])
	else
		tool = deepcopy(shovels[1])
	end
	tool:SetName("tp_shovel_"..i)
	tool:HookFn(function(inst)
		if i == 6 then
			inst.components.inventoryitem:SetImage("goldenshovel")
		else
			inst.components.inventoryitem:SetImage("shovel")
		end
		inst.components.tool:SetAction(ACTIONS.DIG, i)
		inst.components.finiteuses:SetMaxUses(30)
		inst.components.finiteuses:SetUses(30)
		inst.components.finiteuses:SetOnFinished(function(inst)
			if i<6 then
				local next = i+1
				c_give("tp_shovel_"..next)
			end
			inst:Remove()
		end)
		if i>=4 then
			inst:AddComponent("tpinter")
			inst.components.tpinter:SetFn(function(inst, item, doer)
				local item = item.components.stackable:Get()
				item:Remove()
				inst.components.finiteuses:DoDelta(10)
			end)
			inst.components.tpinter:SetCanFn(function(inst, item, doer)
				if i>=6 and item.prefab == "goldnugget" then
					return true
				end
				return item.prefab == "flint"
			end)
		end
	end)
	table.insert(many_items, tool)
end

local bugnet = require("prefabs/bugnet")

local bugnet_2 = deepcopy(bugnet)
bugnet_2:SetName("tp_bugnet_2")
bugnet_2:HookFn(function(inst)
	inst.components.inventoryitem:SetImage("bugnet")
	inst:ListenForEvent("percentusedchange", function(inst, data)
		if GetClock():IsNight() and not inst.fixed then
			inst.fixed = true
			local max = inst.components.finiteuses.total
			local use = inst.components.finiteuses.current
			local new = math.min(max, use+1)
			inst.components.finiteuses:SetUses(new)

			inst.fixed = nil
		end
	end)
end)

return 







alloy,
alloy_great,
alloy_red,
many_gem,
epic_red,
plant_army_book,
tele_book,
spawn_book,
engine,
dimensional,
small_pig_book,
gun_battery,
coin,
coin10,
coin100,
gift,
gift2,
gift3,
gift4,
gift5,
gift6,
gift7,
gift8,
many_epic,
rand_epic,
tophat_2,
tophat_3,
tophat_4,
tophat_5,





flowerhat_2,
flowerhat_3,
flowerhat_4,
flowerhat_5,





strawhat_2,
strawhat_3,
strawhat_4,


footballhat_2,
footballhat_3,
footballhat_4,
footballhat_5,

armorwood_2,
armorwood_3,
armorwood_4,
armorwood_5,
armorwood_6,
cane_a,
cane_b,
cane_c,
icestaff_2,
icestaff_3,
firestaff_2,
firestaff_3,
trinity_staff,
nightsword_2,
nightsword_3,
nightsword_4,
nightsword_5,
nightsword_6,
hambat_2,
hambat_3,
hambat_4,
hambat_5,
hambat_6,
yellowamulet_2,
yellowamulet_3,
yellowamulet_4,


beefalohat_2,
beefalohat_3,
beefalohat_4,
beefalohat_5,

gasmaskhat_2,
boomerang_2,
bugnet_2,

unpack(many_items)

