local TpLevel = require "screens/tp_level_panel"

local leifs = {}
local leif_phy = {"char"}




local function leif_trader_test(inst, item, giver)
	return item.prefab == "tp_gingko_leaf"
end

local function leif_trader_refuse(inst, giver, item)
end

local function leif_dance(inst)
    inst.AnimState:PlayAnimation("panic_pre", false)
    inst.AnimState:PushAnimation("panic_loop", false)
    inst.AnimState:PushAnimation("panic_post", false)
    inst.AnimState:PushAnimation("idle_loop", true)
end

local function leif_trader_accept(inst, giver, item)






        local gift = WARGON.is_dlc(2) and "pinecone" or WARGON.is_dlc(3) and "acron" or "jungletreeseed"
        local gift2 = WARGON.is_dlc(2) and "teatree_nut" or WARGON.is_dlc(3) and "coconut" or "teatree_nut"
        local spalings = {
            ["tp_war_tree_seed"] = 1,
            ["tp_defense_tree_seed"] = 1,
            ["tp_life_tree_seed"] = 1,
            ["tp_gingko"] = 30,
            [gift] = 5,
            [gift] = 5,
            [gift2] = 5,
            [gift2] = 5,
        }
        local loot = weighted_random_choice(spalings)
        inst.components.lootdropper:SpawnLootPrefab(loot)

end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()

	shadow:SetSize( 4, 1.5 )
    inst.Transform:SetFourFaced()
    MakeCharacterPhysics(inst, 1000, .5)















    inst:AddComponent("inspectable")










    return inst
end

local TpLevelPanel = require("screens/tp_level_panel")

local function cure(Sim)
    local inst = fn(Sim)
    WARGON.make_map(inst, "leif_sparse_head.tex")
    inst.AnimState:SetBank("leif")
    inst.AnimState:SetBuild("leif_lumpy_build")
    inst.AnimState:PlayAnimation("idle_loop", true)
    WARGON.CMP.add_cmps(inst, {
    	trader = {
            test=function(inst, item, giver)
                return item.prefab == "acorn" or item.prefab == "tp_gingko_leaf"
            end, 
            accept=function(inst, giver, item)
                if giver.components.poisonable
                and giver.components.poisonable:IsPoisoned() then
                    giver.components.poisonable:Cure()
                end
                leif_dance(inst)
            end,
        },
        loot = {},

	})
    return inst
end

local function seed(Sim)
    local inst = fn(Sim)
    WARGON.make_map(inst, "tp_leif_icon.tex")
    inst.AnimState:SetBank("leif")
    inst.AnimState:SetBuild("leif_build")
    inst.AnimState:PlayAnimation("idle_loop", true)
    WARGON.CMP.add_cmps(inst, {
    	trader = {
            test=leif_trader_test, 
            refuse=leif_trader_refuse,
            accept=function(inst, giver, item)
                inst.components.lootdropper:SpawnLootPrefab("tp_gingko_spaling")
                leif_dance(inst)
            end,
        },
        loot = {},

	})
    return inst
end

local function level(Sim)
    local inst = fn(Sim)
    WARGON.make_map(inst, "tp_tree_guard_icon.tex")
    inst.AnimState:SetBank("treeguard")
    inst.AnimState:SetBuild("treeguard_build")
    inst.AnimState:PlayAnimation("idle_loop", true)
    inst:AddComponent("tpuse")
    inst.components.tpuse.use = function(inst)
        TheFrontEnd:PushScreen(TpLevelPanel())
    end
    return inst
end

local TpSalePanel = require("screens/tp_sale_panel")

local function sale(Sim)
    local inst = fn(Sim)
    WARGON.make_map(inst, "tp_leif_sale_icon.tex")
    inst.AnimState:SetBank("tree_leaf_monster")
    inst.AnimState:SetBuild("tree_leaf_trunk_build")
    inst.AnimState:PlayAnimation("idle_loop_agro", true)
    inst.AnimState:OverrideSymbol("swap_leaves", "tree_leaf_poison_build", "swap_leaves")
    inst.AnimState:OverrideSymbol("legs", "tree_leaf_poison_build", "legs")
    inst.AnimState:OverrideSymbol("legs_mouseover", "tree_leaf_poison_build", "legs_mouseover")
    inst.AnimState:OverrideSymbol("eye", "tree_leaf_poison_build", "eye")
    inst.AnimState:OverrideSymbol("mouth", "tree_leaf_poison_build", "mouth")
    inst:AddComponent("tpuse")
    inst.components.tpuse.use = function(inst)
        TheFrontEnd:PushScreen(TpSalePanel())
    end
    return inst
end

return 
Prefab("common/tp_leif", cure, {}),
Prefab("common/tp_leif_seed", seed, {}),
Prefab("common/tp_leif_level", level, {}),
Prefab("common/tp_leif_sale", sale, {})