require("brains/moosebrain")
require "stategraphs/SGmoose"

local assets =
{




}

local prefabs =
{




}

local MOOSE_SCALE = 1.55


















local BASE_TAGS = {"structure"}
local SEE_STRUCTURE_DIST = 20

local TARGET_DIST = 10
local LOSE_TARGET_DIST = 30

local function LeaveWorld(inst)
    inst:Remove()
end

local function NearPlayerBase(inst)
    local pt = inst:GetPosition()
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, SEE_STRUCTURE_DIST, BASE_TAGS)
    if #ents >= 2 then
        inst.SeenBase = true
        return true
    end
end

local function RetargetFn(inst)
    if inst.sg:HasStateTag("busy") then return end

    local target = nil

    if not target and inst.components.entitytracker:GetEntity("egg") then
         target =  FindEntity(inst.components.entitytracker:GetEntity("egg"), TARGET_DIST, function(guy) 
            return inst.components.combat:CanTarget(guy)
               and not guy:HasTag("prey")
               and not guy:HasTag("smallcreature")
               and not guy:HasTag("mossling")
        end)
    end

    if not target then
        target =  FindEntity(inst, TARGET_DIST, function(guy) 
            return inst.components.combat:CanTarget(guy)
               and not guy:HasTag("prey")
               and not guy:HasTag("smallcreature")
               and not guy:HasTag("mossling")
        end)
    end

    return target
end

local function KeepTargetFn(inst, target)
    local landing = inst.components.knownlocations:GetLocation("landpoint")

    return inst.components.combat:CanTarget(target) and inst:GetDistanceSqToInst(target) <= LOSE_TARGET_DIST*LOSE_TARGET_DIST and
    (landing and target:GetPosition():DistSq(landing) <= LOSE_TARGET_DIST* LOSE_TARGET_DIST or true)

end

local function OnEntitySleep(inst)
    if inst.shouldGoAway then
        LeaveWorld(inst)
    end
end

local function OnSeasonChange(inst, data)
    inst.shouldGoAway = (GetSeasonManager():GetSeason() ~= SEASONS.SPRING or GetSeasonManager().incaves)
    if inst:IsAsleep() then
        OnEntitySleep(inst)
    end
end

local function OnAttacked(inst, data)
    inst.components.combat:SetTarget(data.attacker)
end

local function OnCollide(inst, other)

end

local function OnSave(inst, data)
    data.WantsToLayEgg = inst.WantsToLayEgg
    data.CanDisarm = inst.CanDisarm
    data.shouldGoAway = inst.shouldGoAway
end

local function OnLoad(inst, data)
    if data.WantsToLayEgg then 
        inst.WantsToLayEgg = data.WantsToLayEgg
    end
    if data.CanDisarm then 
        inst.CanDisarm = data.CanDisarm
    end
    inst.shouldGoAway = data.shouldGoAway or false
end

local function ontimerdone(inst, data)
    if data.name == "WantsToLayEgg" then
        inst.WantsToLayEgg = true
    end

    if data.name == "DisarmCooldown" then
        inst.CanDisarm = true
    end
end

local function action_button_picker(inst)
    return BufferedAction(inst, inst.components.tpvehicleowner.vehicle, ACTIONS.TP_DOWN_CAR)
end

local function left_click_picker(inst, target, pos)
    if target and target.components.tpvehicle
    and target.components.tpvehicle:CanDownCar() then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.TP_DOWN_CAR}, target, nil)
    end
    if target and ((target.components.health and target.components.combat 
    and inst.components.combat:CanTarget(target)) 
    or target.components.workable or target.components.hackable) then
        return inst.components.playeractionpicker:SortActionList({ACTIONS.TP_MAKE_WIND}, target, nil)
    end



end

local function right_click_picker(inst, target, pos)
    return {}
end

local function fn(Sim)
    local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()

    local s = MOOSE_SCALE

    trans:SetScale(s,s,s)

	shadow:SetSize(6, 2.75)

    MakeCharacterPhysics(inst, 5000, 1)


    inst.Physics:SetCollisionCallback(OnCollide)

    inst.Transform:SetFourFaced()

    anim:SetBank("goosemoose")
    anim:SetBuild("goosemoose_build")
    anim:PlayAnimation("idle", true)
    









    





    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(TUNING.MOOSE_HEALTH)
    inst.components.health.destroytime = 3
    


    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(TUNING.MOOSE_DAMAGE)


    inst.components.combat.hiteffectsymbol = "goosemoose_body"
    inst.components.combat:SetAttackPeriod(TUNING.MOOSE_ATTACK_PERIOD)


    inst.components.combat:SetHurtSound("dontstarve_DLC001/creatures/moose/hurt")

 


    


    inst:AddComponent("lootdropper")

    


    inst:AddComponent("inspectable")
    inst.components.inspectable:RecordViews()



































    inst.WantsToLayEgg = false
    inst.CanDisarm = false



    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed = TUNING.MOOSE_WALK_SPEED
    inst.components.locomotor.runspeed = TUNING.MOOSE_RUN_SPEED

    inst:SetStateGraph("SGtp_moose")



    inst:AddTag("scarytoprey")
    inst:AddTag("companion")
    inst:AddTag("tp_moose")

    inst:AddComponent("tpenergy")
    inst.components.tpenergy:SetMax(300)
    inst.components.tpenergy:SetRate(1)

    inst:AddComponent("tpvehicle")
    inst:AddComponent("tpvehiclecontroller")
    inst:AddComponent("tpvehicleactionpicker")
    inst.components.tpvehicle.ex_up_car = function(inst, doer)
        doer.components.playercontroller.actionbuttonoverride = action_button_picker
        doer.components.playeractionpicker.leftclickoverride = left_click_picker
        doer.components.playeractionpicker.rightclickoverride = right_click_picker
    end
    inst.components.tpvehicle.ex_down_car = function(inst, doer)
        doer.components.playercontroller.actionbuttonoverride = nil
        doer.components.playeractionpicker.leftclickoverride = nil
        doer.components.playeractionpicker.rightclickoverride = nil
    end

    return inst
end

return Prefab( "common/object/tp_moose", fn, assets, prefabs),
MakePlacer("common/tp_moose_placer", "goosemoose", "goosemoose_build", "idle",nil, nil, nil, MOOSE_SCALE)
