local function fn()
	local inst = WARGON.create_prefab({
		anim = {"wilson", "wx78", "idle_loop"},
		phy = {"char", 75, .5},
		faced = 4,	
		shadow = {1.3, .6},
	})
	inst:add_cmps({
		loco = {
			walk = 4,
			run = 6,
		},
		combat = {
			dmg = 10,
			re = {
				time = 3,
				fn = function(inst)
					return FindEntity(inst, 20, function(guy)
						return guy:HasTag("tp_pig_killer_target")
					end)
				end,
			},
			keep = function(inst, target)
				return target:HasTag("tp_pig_killer_target")
			end,
			symbol = "torso",
			hit = function(inst, target, damage)
				if target:HasTag("tp_pig_killer_target") then
					inst.components.health:DoDelta(damage or 30)



				end
			end,
		},
		health = {
			max = 500,
		},
		homeseeker = {},
	})
	inst:ListenForEvent("onhitother", function(inst, data)
		if data and data.target then
			if data.target:HasTag("tp_pig_killer_target") then
				if data.target.components.health then
					data.target.components.health:Kill()
				end
				inst.components.health:DoDelta(100)
			end
		end
	end)
	WARGON.EQUIP.object_on(inst, "swap_ham_bat", "swap_ham_bat")
	WARGON.EQUIP.hat_on(inst, "hat_football")
	inst:SetBrain(require "brains/tp_pig_killer_brain")
	inst:SetStateGraph("SGtp_pig_killer")

	return inst
end

return Prefab("common/tp_pig_killer", fn, {})