local papyrus = {"papyrus", "papyrus", "idle"}
local Anims = {
	papyrus = {"papyrus", "papyrus", "idle", },
}

local function onfinished(inst)
	inst:Remove()
end

local function on_use(inst)
	local item = inst.components.stackable and inst.components.stackable:Get() or inst
	item:Remove()
end

local function MakeScroll(name, anims, fn_name, img)
	local function fn()
		local inst = WARGON.make_prefab(anims, nil, "inv")
		WARGON_CMP_EX.add_cmps(inst, 
		{
			invitem = {atlas="images/inventoryimages/"..name..'.xml', 
				img=name},
			stack = {max=20},
			inspect = {},
			book = {fn = WARGON_SCROLL_FN[fn_name], act="map"},

		})
		inst:AddTag("tp_scroll")

	    return inst
	end
	return Prefab("common/inventory/"..name, fn, {})
end

return
MakeScroll("scroll_sleep", Anims.papyrus, "sleep", "scroll_sleep"),
MakeScroll("scroll_grow", Anims.papyrus, "grow", "scroll_grow"),
MakeScroll("scroll_lightning", Anims.papyrus, "lightning", "scroll_lightning"),
MakeScroll("scroll_bird", Anims.papyrus, "bird", "scroll_bird"),
MakeScroll("scroll_tentacle", Anims.papyrus, "tentacle", "papyrus"),
MakeScroll("scroll_volcano", Anims.papyrus, "volcano", "papyrus")