local assets = {

}

local waxwells = {"wilson", "waxwell", "idle_loop"}
local phys = {"char", 75, .5}
local shadows = {1.3, .6}

local function soul_student_combat_re(inst)
	return WARGON.find(inst, 16*1.33, function(guy)
        return inst.components.combat:CanTarget(guy)
           and guy:HasTag("player")
    end)
end

local function soul_student_combat_keep(inst, target)
	return inst.components.combat:CanTarget(target)

end

local function soul_student_on_attacked(inst, data)
	if data.attacker then
		inst.components.combat:SetTarget(data.attacker)




		if not inst.sg:HasStateTag("attack") then
			local target = inst:wg_find(100, nil, {"tp_soul_student_point"})
			if target and inst:IsNear(target, 5) then

				local pos = WARGON.around_land(target, 7)
				if pos then
					WARGON.make_fx(inst, "statue_transition")
					WARGON.make_fx(pos, "statue_transition_2")
					inst.Transform:SetPosition(pos:Get())
				end
			end
		end
	end
end

local function soul_student_on_attack(inst, data)




















end

local function soul_student_on_hit_other(inst, data)



end

local function soul_student_on_health_delta(inst, data)
	if inst.components.health:GetPercent() < .5 then
		inst:AddTag("tp_soul_student_warth")
	end
end

local function soul_student_weapon_drop(inst)
	inst:Remove()
end

local function soul_student_equip_weapon(inst)

end

local function close_door(inst)
	local door = inst:wg_find(100, nil, {"interior_door"})
	if door then
		door:AddTag("NOCLICK")
	end
end

local function open_door(inst)
	local door = inst:wg_find(100, nil, {"interior_door"})
	if door then
		door:RemoveTag("NOCLICK")
	end
end

local function fn()
	local inst = WARGON.make_prefab(waxwells, nil, phys, shadows, 4)

	WARGON.add_tags(inst, {
		"tp_sign_damage", "epic", "tp_only_player_attack", "noauradamage",
	})
	inst:AddTag("tp_room_boss")
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		health = {max=2500, fire=0,},
		loco = {walk=4, run=6},
		combat = {
			dmg=0, player=.5, per=2, 
			range = {10, 12},

			re={time=3, fn=soul_student_combat_re},
			keep=soul_student_combat_keep,
		},
		loot = {
			loot={


				"tp_boss_loot",
			}, 
		},
		inv = {},
	})










	WARGON.EQUIP.hat_on(inst, "hat_top", nil, true)
	WARGON.EQUIP.object_on(inst, "swap_staffs", "redstaff")
	WARGON.EQUIP.body_on(inst, "armor_sanity", "swap_body")
	WARGON.add_listen(inst, {
		attacked = soul_student_on_attacked,
		onhitother = soul_student_on_hit_other,
		healthdelta = soul_student_on_health_delta,
		doattack = soul_student_on_attack,
	})
	WARGON.do_task(inst, 0, function()
		soul_student_on_health_delta(inst)
		soul_student_equip_weapon(inst)
	end)
	inst.task = inst:per_task(1, function()
		local souls = inst:wg_finds(100, {"ghost"})
		if #souls < 4 then
			WARGON.make_spawn(inst, "ghost")
		end
	end)
	inst:SetBrain(require "brains/tp_fake_knight_brain")
	inst:SetStateGraph("SGtp_soul_student")
	inst:do_task(0, function()
		close_door(inst)
	end)
	inst:ListenForEvent("death", open_door)

	return inst
end

local function proj_remove(inst)
	inst:Remove()
end

local function proj_hit(inst, owner, target)
	local n = math.random(4)
	local pos = target:GetPosition()
	for i = 1, 4 do




		local fx = SpawnPrefab("tp_fx_charge_surround")
		if n == i then
			fx:AddTag("tp_fx_charge_surround_attack")
		end

		fx.Transform:SetPosition(pos:Get())
		fx.Transform:SetRotation(i*90)
		fx.master = owner
		fx.target = target
	end
    inst:Remove()
end

local function proj()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
    
    anim:SetBank("bishop_attack")
    anim:SetBuild("bishop_attack")
    anim:PlayAnimation("idle")
    
    inst:AddTag("projectile")
    inst.persists = false
    
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(20)

    inst.components.projectile:SetHitDist(2)
    inst.components.projectile:SetOnHitFn(proj_hit)
    inst.components.projectile:SetOnMissFn(proj_remove)
    inst.components.projectile.speed_z = 15
    
    return inst
end

return Prefab("common/tp_soul_student", fn, assets),
	Prefab("common/tp_soul_student_proj", proj, {})