local Anims = {
	spear_lance = {"tp_spear_lance", "tp_spear_lance", "idle", "idle_water"},
	spear_ice = {"tp_spear_ice", "tp_spear_ice", "idle", "idle_water"},
	spear_fire = {"tp_spear_fire", "tp_spear_fire", "idle", "idle_water"},
	spear_thunder = {"tp_spear_thunder", "tp_spear_thunder", "idle", "idle_water"},
	spear_gungnir = {"spear", "spear_forge_gungnir", "idle", "idle_water"},
	spear_poison = {"tp_spear_poison", "tp_spear_poison", "idle", "idle_water"},
	spear_shadow = {"tp_spear_shadow", "tp_spear_shadow", "idle", "idle_water"},
	spear_blood = {"tp_spear_blood", "tp_spear_blood", "idle", "idle_water"},
	spear_rose = {"spear", "spear_rose", "idle", "idle_water"},
	spear_wind = {'tp_swords', 'tp_swords', 'tp_forest_staff', 'tp_forest_staff_water'},
	spear_wrestle = {'spear_wathgrithr', "spear_wathgrithr_wrestle", "idle", "idle_water"},
	spear_lightning = {'tp_spear_lightning', 'tp_spear_lightning', 'idle', 'idle_water'},
	spear_speed = {'tp_spear_speed', 'tp_spear_speed', 'idle', 'idle_water'},
	spear_earth = {'tp_spear_earth', 'tp_spear_earth', 'idle', 'idle_water'},
	spear_shine = {'tp_spear_shine', 'tp_spear_shine', 'idle', 'idle_water'},
	spear_northern = {'spear', 'spear_northern', 'idle', 'idle_water'},
	spear_simple = {"spear", "spear_simple", "idle", "idle_water"},
	spear_bag = {"tp_spear_bag", "tp_spear_bag", "idle", "idle_water"},
	spear_beefalo = {"tp_spear_beefalo", "tp_spear_beefalo", "idle", "idle_water"},
	spear_combat = {"tp_spear_combat", "tp_spear_combat", "idle", "idle_water"},
	spear_diamond = {"tp_spear_diamond", "tp_spear_diamond", "idle", "idle_water"},
	spear_gold = {"tp_spear_gold", "tp_spear_gold", "idle", "idle_water"},
	spear_tornado = {"tp_spear_tornado", "tp_spear_tornado", "idle", "idle_water"},
	spear_conqueror = {"tp_spear_conqueror", "tp_spear_conqueror", "idle", "idle_water"},
	spear_hockey = {"spear", "spear_hockey", "idle", "idle_water"},
	spear_cooldown = {"tp_spear_cooldown", "tp_spear_cooldown", "idle", "idle_water"},
	spear_potion = {"tp_spear_potion", "tp_spear_potion", "idle", "idle_water"},
	starstaff_crystal = {"staffs", "starstaff_crystal", "yellowstaff", "yellowstaff_water"},
	icestaff_lance = {"staffs", "icestaff_lance", "bluestaff", "bluestaff_water"},
	firestaff_lance = {"staffs", "firestaff_lance", "redstaff", "redstaff_water"},
	icestaff_rose = {"staffs", "icestaff_rose", "bluestaff", "bluestaff_water"},
	firestaff_rose = {"staffs", "firestaff_rose", "redstaff", "redstaff_water"},
	spear_anubis = {"tp_spear_anubis", "tp_spear_anubis", "idle", "idle_water"},
	spear_heracles = {"tp_spear_heracles", "tp_spear_heracles", "idle", "idle_water"},
	spear_perseus = {"tp_spear_perseus", "tp_spear_perseus", "idle", "idle_water"},
	spear_hades = {"tp_spear_hades", "tp_spear_hades", "idle", "idle_water"},
	spear_zeus = {"tp_spear_zeus", "tp_spear_zeus", "idle", "idle_water"},
	spear_hermes = {"tp_spear_hermes", "tp_spear_hermes", "idle", "idle_water"},
	spear_gaea = {"tp_spear_gaea", "tp_spear_gaea", "idle", "idle_water"},
	spear_collect = {"tp_spear_collect", "tp_spear_collect", "idle", "idle_water"},
	spear_dream = {"tp_spear_dream", "tp_spear_dream", "idle", "idle_water"},
	spear_turret = {"tp_spear_turret", "tp_spear_turret", "idle", "idle_water"},
	spear_single = {"tp_spear_single", "tp_spear_single", "idle", "idle_water"},
	spear_ripper = {"tp_spear_ripper", "tp_spear_ripper", "idle", "idle_water"},
	spear_road = {"tp_spear_road", "tp_spear_road", "idle", "idle_water"},
	spear_shell = {"tp_spear_shell", "tp_spear_shell", "idle", "idle_water"},
	spear_leaf = {"tp_spear_leaf", "tp_spear_leaf", "idle", "idle_water"},
	spear_shark = {"tp_spear_shark", "tp_spear_shark", "idle", "idle_water"},
	spear_wave = {"tp_spear_wave", "tp_spear_wave", "idle", "idle_water"},
	spear_snake = {"tp_spear_snake", "tp_spear_snake", "idle", "idle_water"},
}

local function MakeItem(name, anims, item_fn, atlas, img)
	local function fn()
		local the_atlas, the_img
		the_atlas = atlas and "images/inventoryimages/"..atlas..".xml" 
		the_img = img or atlas
	 	local inst = WARGON.make_prefab(anims, anims[4], "inv", nil, nil, item_fn)
	 	WARGON_CMP_EX.add_cmps(inst, {
	 		invitem = {atlas=the_atlas, img=the_img},
	 	})
		inst:AddTag("tp_item")
		inst:AddComponent("tpinter")
		inst.components.tpinter:SetCanFn(function(inst, invitem, doer)
			return invitem:HasTag("tp_fix_powder") 
				and not inst:HasTag("tp_not_fix")
		end)








	    return inst
	end
	return Prefab("common/inventory/"..name, fn, {})
end


local function do_area_damage(inst, range, dmg, reason, fn)
	local owner = inst.components.inventoryitem.owner
	WARGON.area_dmg(inst, range, owner, dmg, reason, fn)
end

local function do_area(inst, range, fn)
	local owner = inst.components.inventoryitem.owner
	local ents = WARGON.finds(inst, range, nil, {"player", "wall", "FX", "NOCLICK", "INLIMBO"})
	for i, v in pairs(ents) do
		if not v.components.follower or v.components.follower.leader ~= owner then
			if v.components.combat and v.components.health
			and owner.components.combat:CanTarget(v) then
				fn(inst, v)
			end
		end
	end
end

local function mk_lv_dmg(inst, owner, target)


end

local function on_finish(inst)
	inst:Remove()
end

local function head_unequip(inst, owner)
	WARGON.EQUIP.hat_off(owner)
	if inst.components.fueled then
		inst.components.fueled:StopConsuming()
	end
end

local function hand_unequip(inst, owner)
	WARGON_EQUIP_EX.object_off(owner)
end


local function spear_lance_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "swap_spear_forge_lance", "swap_spear")
end

local function spear_throw(inst)
	inst:AddTag("projectile")
	inst.AnimState:PlayAnimation("throw")



end

local function spear_drop(inst)
	inst:RemoveTag("projectile")
	if inst.components.floatable then

		inst.components.floatable:SetAnimationFromPosition()
	end
end

local function spear_hit(inst, owner, target)
	WARGON.FX.impact_fx(inst, target)
	spear_drop(inst)
end

local function spear_catch(inst, owner)
	inst:RemoveTag("projectile")
	if owner.components.inventory then
		if owner.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) == nil then
			owner.components.inventory:Equip(inst)
		else
			owner.components.inventory:GiveItem(inst)
		end
	end
	if owner.components.tpbuff then
		owner.components.tpbuff:AddBuff("tp_pack_catcoon")
	end
end

local function spear_lance_catch(inst, owner)
	if owner.components.inventory
	and owner.components.inventory:IsFull() == false then
		spear_catch(inst, owner)
	else
		spear_drop(inst)
	end
end

local function set_spear_proj(inst)
	inst:AddComponent("tpproj")
	inst.components.tpproj:SetSpeed(25)
	inst.components.tpproj:SetOnThrownFn(spear_throw)
	inst.components.tpproj:SetOnHitFn(function(...)
		if inst.components.weapon.onattack then
			inst.components.weapon.onattack(...)
		end
		spear_hit(...)
	end)
	inst.components.tpproj:SetOnMissFn(spear_drop)
	inst.components.tpproj:SetLaunchOffset(Vector3(0, 0.2, 0))
	inst.components.tpproj.oncatch = spear_lance_catch
	inst:AddTag("tp_catcoon_spear")
end

local function set_spear_lunge(inst)
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_CI"
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		inst:StartThread(function()
			for i = 1, 3 do
				Sleep(0.1)
				do_area_damage(inst, 1.5, 34, inst.prefab)
				local fx = WARGON.make_fx(inst, "tp_fx_wilson_lunge")
				local owner = inst.components.inventoryitem.owner
				fx.AnimState:SetBuild(owner.components.sciencemorph:GetBuild())
				fx.Transform:SetRotation(owner.Transform:GetRotation())
				WARGON.EQUIP.object_on(fx, "swap_spear_forge_gungnir", "swap_spear_gungnir")
			end
		end)
	end
end

local function spear_lance_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34, },
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		equip = {equip=spear_lance_equip, unequip=hand_unequip},
	})
	inst:AddComponent("tpproj")
	inst.components.tpproj:SetSpeed(25)
	inst.components.tpproj:SetOnThrownFn(spear_throw)
	inst.components.tpproj:SetOnHitFn(spear_hit)
	inst.components.tpproj:SetOnMissFn(spear_drop)
	inst.components.tpproj:SetLaunchOffset(Vector3(0, 0.2, 0))
	inst.components.tpproj.oncatch = spear_lance_catch
	inst:AddTag("tp_catcoon_spear")
end

local function spear_ice_fx_add(inst)





end

local function spear_ice_fx_remove(inst)




end

local function spear_ice_inv_drop(inst)

end

local function spear_ice_inv_put(inst)

end

local function spear_ice_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_ice", "swap_object")


end

local function spear_ice_unequip(inst, owner)
	hand_unequip(inst, owner)


end

local function spear_ice_weapon_fn(inst, owner, target)

	if math.random() < .5 then
		WARGON.frozen_prefab(target, nil)
	end

end

local function spear_ice_proj_throw(inst)

	spear_throw(inst)




end

local function spear_ice_proj_drop(inst)

	spear_drop(inst)




end

local function spear_ice_proj_hit(inst, owner, target)
	WARGON.FX.impact_fx(inst, target)
	spear_ice_proj_drop(inst)
	spear_ice_weapon_fn(inst, owner, target)
end

local function spear_ice_proj_catch(inst, owner)
	if owner.components.inventory
	and owner.components.inventory:IsFull() == false then
		spear_catch(inst, owner)




	else
		spear_ice_proj_drop(inst)
	end
end

local function spear_ice_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34, fn=spear_ice_weapon_fn},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		equip = {equip=spear_ice_equip, unequip=spear_ice_unequip},
		inv = {drop=spear_ice_inv_drop, put=spear_ice_inv_put},
	})
	inst:AddComponent("tpproj")
	inst.components.tpproj:SetSpeed(25)
	inst.components.tpproj:SetOnThrownFn(spear_ice_proj_throw)
	inst.components.tpproj:SetOnHitFn(spear_ice_proj_hit)
	inst.components.tpproj:SetOnMissFn(spear_ice_proj_drop)
	inst.components.tpproj:SetLaunchOffset(Vector3(0, 0.2, 0))
	inst.components.tpproj.oncatch = spear_ice_proj_catch
	inst:AddTag("tp_catcoon_spear")
	inst:AddTag("tp_forge_weapon")
end

local function spear_fire_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_fire", "swap_object")

end

local function spear_fire_unequip(inst, owner)
	hand_unequip(inst, owner)

end

local function spear_fire_weapon_fn(inst, owner, target)

	WARGON.fire_prefab(target, nil)



end

local function spear_fire_throw(inst)

	spear_throw(inst)




end

local function spear_fire_drop(inst)

	spear_drop(inst)




end

local function spear_fire_hit(inst, owner, target)
	WARGON.FX.impact_fx(inst, target)
	spear_fire_drop(inst)
	spear_fire_weapon_fn(inst, owner, target)
end

local function spear_fire_catch(inst, owner)
	if owner.components.inventory
	and owner.components.inventory:IsFull() == false then
		spear_catch(inst, owner)




	else
		spear_fire_drop(inst)
	end
end

local function spear_fire_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34, fn=spear_fire_weapon_fn},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		equip = {equip=spear_fire_equip, unequip=spear_fire_unequip},
	})
	inst:AddComponent("tpproj")
	inst.components.tpproj:SetSpeed(25)
	inst.components.tpproj:SetOnThrownFn(spear_fire_throw)
	inst.components.tpproj:SetOnHitFn(spear_fire_hit)
	inst.components.tpproj:SetOnMissFn(spear_fire_drop)
	inst.components.tpproj:SetLaunchOffset(Vector3(0, 0.2, 0))
	inst.components.tpproj.oncatch = spear_fire_catch
	inst:AddTag("tp_catcoon_spear")
	inst:AddTag("tp_forge_weapon")
end

local function spear_thunder_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_thunder", "swap_object")
end


local function spear_thunder_weapon_fn(inst, owner, target)











 	local new_target = WARGON.find(target, 5, function(guy)
 		return WARGON.can_enemy(owner, guy)
		 	and guy ~= target
 	end)	
    if new_target then
        local proj = WARGON.make_spawn(target, "tp_charge_proj")
        proj.master = owner
        table.insert(proj.no_targets, target)
        proj.components.tpproj:Throw(owner, new_target, owner)
    end
end

local function spear_thunder_throw(inst)

	spear_throw(inst)



end

local function spear_thunder_drop(inst)

	spear_drop(inst)




end

local function spear_thunder_hit(inst, owner, target)
	WARGON.FX.impact_fx(inst, target)
	spear_thunder_weapon_fn(inst, owner, target)
	spear_thunder_drop(inst)
end

local function spear_thunder_catch(inst, owner)
	if owner.components.inventory
	and owner.components.inventory:IsFull() == false then
		spear_catch(inst, owner)
		if inst.fx then
			inst.fx:Remove()
			inst.fx = nil
		end
	else
		spear_thunder_drop(inst)
	end
end

local function spear_thunder_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34*.75, fn=spear_thunder_weapon_fn},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		equip = {equip=spear_thunder_equip, unequip=hand_unequip},
	})
	inst.components.weapon:SetElectric()
	inst:AddComponent("tpproj")
	inst.components.tpproj:SetSpeed(25)
	inst.components.tpproj:SetOnThrownFn(spear_thunder_throw)
	inst.components.tpproj:SetOnHitFn(spear_thunder_hit)
	inst.components.tpproj:SetOnMissFn(spear_thunder_drop)
	inst.components.tpproj:SetLaunchOffset(Vector3(0, 0.2, 0))
	inst.components.tpproj.oncatch = spear_thunder_catch
	inst:AddTag("tp_catcoon_spear")
end




























































local function spear_combat_weapon_fn(inst, owner, target)

	if owner.components.tpbuff then
		owner.components.tpbuff:AddBuff("tp_spear_combat")
	end
end

local function spear_combat_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_combat", "swap_object")
end

local function spear_combat_unequip(inst, owner)
	hand_unequip(inst, owner)
end

local function spear_combat_throw(inst)
	inst:AddTag("projectile")
	spear_throw(inst)
end

local function spear_combat_drop(inst)
	inst:RemoveTag("projectile")
	spear_drop(inst)
end

local function spear_combat_hit(inst, owner, target)
	WARGON.FX.impact_fx(inst, target)
	spear_combat_weapon_fn(inst, owner, target)
	spear_combat_drop(inst)
end

local function spear_combat_catch(inst, owner)
	if owner.components.inventory
	and owner.components.inventory:IsFull() == false then
		spear_catch(inst, owner)
	else
		spear_combat_drop(inst)
	end
end

local function spear_combat_fn(inst)
	inst:add_cmps({
		inspect = {},
		weapon = {dmg=34, fn=spear_combat_weapon_fn},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		equip = {equip=spear_combat_equip, unequip=spear_combat_unequip},
	})
	set_spear_proj(inst)

	inst:AddTag("tp_forge_weapon")
end


local function spear_gungnir_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "swap_spear_forge_gungnir", "swap_spear_gungnir")
end

local function spear_gungnir_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34, },
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		equip = {equip=spear_gungnir_equip, unequip=hand_unequip},
	})
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_CI"
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		inst:StartThread(function()
			for i = 1, 3 do
				Sleep(0.1)
				do_area_damage(inst, 1.5, 34, "tp_spear_gungnir")
				local fx = WARGON.make_fx(inst, "tp_fx_wilson_lunge")
				local owner = inst.components.inventoryitem.owner
				fx.AnimState:SetBuild(owner.components.sciencemorph:GetBuild())
				fx.Transform:SetRotation(owner.Transform:GetRotation())
				WARGON.EQUIP.object_on(fx, "swap_spear_forge_gungnir", "swap_spear_gungnir")
			end
		end)
	end
end

local function spear_poison_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_poison", "swap_object")
end

local function spear_poison_weapon_fn(inst, owner, target)

	WARGON.poison_prefab(target)
	WARGON.add_speed_rate(target, "tp_spear_poison", -.25, 20)



end

local function spear_poison_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34, fn=spear_poison_weapon_fn},
		finite = {max=300, use=300, fn=on_finish},
		equip = {equip=spear_poison_equip, unequip=hand_unequip},
	})
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_CI"
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		inst:StartThread(function()
			for i = 1, 3 do
				Sleep(0.1)
				local function area_poison(inst, target)
					WARGON.poison_prefab(target)
				end
				do_area(inst, 1.5, area_poison)
				do_area_damage(inst, 1.5, 34, "tp_spear_poison")
				local fx = WARGON.make_fx(inst, "tp_fx_poison_bubble")


			end
		end)
	end

	inst:AddTag("tp_forge_weapon")
end

local function spear_shadow_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_shadow", "swap_object")
end

local function spear_shadow_weapon_fn(inst, owner, target)

	if target:HasTag("shadowcreature") then
		if target.components.health and target.components.combat
		and owner.components.combat:CanTarget(target) then
			local dmg = 100
			if GetWorld():IsCave() then
				dmg = 300
			end
			target.components.combat:GetAttacked(owner, dmg, inst, inst.prefab)


		end





	end

end

local function spear_shadow_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=1, fn=spear_shadow_weapon_fn},
		finite = {max=300, use=300, fn=on_finish},
		equip = {equip=spear_shadow_equip, unequip=hand_unequip, effect={san=-TUNING.SANITYAURA_LARGE}},
	})
	inst.components.weapon.getdamagefn = function(inst)
		local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
		local dmg = 1
		if owner and owner.components.sanity then
			local p = owner.components.sanity:GetPercent()
			dmg = 1 + p * 100
		end
		return dmg
	end
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_CI"
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		inst:StartThread(function()
			for i = 1, 3 do
				Sleep(0.1)
				local function area_shadow(inst, target)
					local owner = inst.components.inventoryitem.owner
					owner.components.sanity:DoDelta(5)
				end
				do_area(inst, 1.5, area_shadow)
				do_area_damage(inst, 1.5, 34, "tp_spear_shadow", 
					function(inst, attacker, target)
						if target:HasTag("shadowcreature") then
							if target.components.health then
								target.components.health:Kill()
								if attacker.components.sanity then
									attacker.components.sanity:DoDelta(20)
								end
							end
						end
					end
				)
				local fx = WARGON.make_fx(inst, "statue_transition")
			end
		end)
	end

end

local function spear_blood_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_blood", "swap_object")


end

local function spear_blood_unequip(inst, owner)
	hand_unequip(inst, owner)


end

local function spear_blood_weapon_fn(inst, owner, target)


	if target:HasTag('epic') then
		owner.components.health:DoDelta(20, nil, "tp_health_equip")
	elseif target:HasTag("largecreature") then
		owner.components.health:DoDelta(15, nil, "tp_health_equip")
	else
		owner.components.health:DoDelta(10, nil, "tp_health_equip")
	end


end

local function spear_blood_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34, fn=spear_blood_weapon_fn},
		finite = {max=300, use=300, fn=on_finish},
		equip = {equip=spear_blood_equip, unequip=spear_blood_unequip},
	})
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_CI"
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		inst:StartThread(function()
			for i = 1, 3 do
				Sleep(0.1)
				local function area_blood(inst, target)
					local owner = inst.components.inventoryitem.owner
					owner.components.health:DoDelta(10, nil, "tp_health_equip")
				end
				do_area(inst, 1.5, area_blood)
				do_area_damage(inst, 1.5, 34, "tp_spear_blood")
				local fx = WARGON.make_fx(inst, "tp_blood_fx")

			end
		end)
	end

	inst:AddTag("tp_forge_weapon")
end

local function spear_gold_kill_reward(inst, data)
	if data.victim and not data.victim:HasTag("tp_not_reward")
	and not data.victim:HasTag("tp_not_reward_gold") then
		if data.victim:HasTag("epic") then
			c_give("oinc10", 5)
		elseif data.victim:HasTag("largecreature") then
			c_give("oinc10")
		elseif data.victim:HasTag("monster") then
			c_give("oinc")
		end
		data.victim:AddTag("tp_not_reward_gold")
	end
end

local function spear_gold_weapon_fn(inst, owner, target)

end

local function spear_gold_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_gold", "swap_object")
	owner:add_listener("killed", spear_gold_kill_reward)
end

local function spear_gold_unequip(inst, owner)
	hand_unequip(inst, owner)
	owner:rm_listener("killed", spear_gold_kill_reward)
end

local function spear_gold_fn(inst)
	inst:add_cmps({
		inspect = {},
		weapon = {dmg=34, fn=spear_gold_weapon_fn},
		finite = {max=300, use=300, fn=on_finish},
		equip = {equip=spear_gold_equip, unequip=spear_gold_unequip},
	})
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_CI"
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	set_spear_lunge(inst)
	inst:AddTag("tp_forge_weapon")
end


local function spear_wrestle_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "swap_spear_wathgrithr_wrestle", "swap_spear_wathgrithr")
end

local function spear_wrestle_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34, },
		finite = {max=150, use=150, fn=on_finish},
		equip = {equip=spear_wrestle_equip, unequip=hand_unequip},
	})
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_ZHUAN"
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		do_area_damage(inst, 3.5, 34, "tp_spear_wrestle")
	end
end

local function spear_lightning_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_lightning", "swap_object")
end

local function spear_lightning_weapon_fn(inst, owner, target)

	if math.random() < .33 then

        local pos = Vector3(target.Transform:GetWorldPosition())
        GetSeasonManager():DoLightningStrike(pos, false, target) 
	end
end

local function spear_lightning_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34, fn=spear_lightning_weapon_fn,},
		finite = {max=150, use=150, fn=on_finish},
		equip = {equip=spear_lightning_equip, unequip=hand_unequip},
	})
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_ZHUAN"
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		do_area_damage(inst, 3.5, 34, "tp_spear_lightning")
		local num_lightnings =  3
	    inst:StartThread(function()
	        for k = 0, num_lightnings do
	            Sleep(math.random( .3, .5))
	            local rad = math.random(3, 15)
	            local angle = k*((4*PI)/num_lightnings)
	            local pos = Vector3(inst.Transform:GetWorldPosition()) + Vector3(rad*math.cos(angle), 0, rad*math.sin(angle))
	            GetSeasonManager():DoLightningStrike(pos)
	        end
	    end)
	end
	inst:AddTag("tp_forge_weapon")
end

local function spear_speed_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, 'tp_spear_speed', 'swap_object')
end

local function spear_speed_weapon_fn(inst, owner, target)
	if owner and owner.components.tpbuff then
		owner.components.tpbuff:AddBuff("tp_spear_speed")
	end
end

local function spear_speed_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34, fn=spear_speed_weapon_fn},
		finite = {max=150, use=150, fn=on_finish},
		equip = {equip=spear_speed_equip, unequip=hand_unequip},
	})
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_ZHUAN"
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		do_area_damage(inst, 3.5, 34, "tp_spear_speed", 
			function(inst, attacker, target)
				if attacker and attacker.components.tpbuff then
					attacker.components.tpbuff:AddBuff("tp_spear_speed")
				end
			end)
	end
end

local function spear_earth_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, 'tp_spear_earth', 'swap_object')
end

local function spear_earth_weapon_fn(inst, owner, target)
	inst.components.tpgroundpounder:GroundPound()
end

local function spear_earth_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		combat = {dmg=17.5,},
		weapon = {dmg=34, fn=spear_earth_weapon_fn},
		finite = {max=150, use=150, fn=on_finish},
		equip = {equip=spear_earth_equip, unequip=hand_unequip},
	})
	inst:AddComponent("tpgroundpounder")
	inst.components.tpgroundpounder.destroyer = true
    inst.components.tpgroundpounder.damageRings = 1
    inst.components.tpgroundpounder.destructionRings = 1
    inst.components.tpgroundpounder.numRings = 1
    inst.components.tpgroundpounder.groundpoundfx = "small_ground_pound"
    inst.components.tpgroundpounder.groundpoundringfx = "small_ground_pound_ring"
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_ZHUAN"
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		do_area_damage(inst, 3.5, 34, "tp_spear_earth")
		inst.components.tpgroundpounder:GroundPound()
	end
end

local function spear_shine_turn_on(inst)
	if not inst.components.fueled:IsEmpty() then
		inst.components.fueled:StartConsuming()
		inst.Light:Enable(true)
	end
end

local function spear_shine_turn_off(inst)
	inst.components.fueled:StopConsuming()
	inst.Light:Enable(false)
end

local function spear_shine_perish(inst)
	spear_shine_turn_off(inst)
	inst:Remove()
end

local function spear_shine_unequip(inst, owner)
	hand_unequip(inst, owner)
	spear_shine_turn_off(inst)
end

local function spear_shine_add_fuel(inst)
	inst.components.fueled:DoDelta(60)
	spear_shine_turn_on(inst)
end

local function spear_shine_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, 'tp_spear_shine', 'swap_object')
	spear_shine_turn_on(inst)
end

local function spear_shine_weapon_fn(inst, owner, target)

	spear_shine_add_fuel(inst)
end

local function spear_shine_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=34, fn=spear_shine_weapon_fn},

		equip = {equip=spear_shine_equip, unequip=hand_unequip},
		invitem = {drop=spear_shine_turn_off},
	})
	
	local light = inst.entity:AddLight()
	light:SetFalloff(0.4)
	light:SetIntensity(.7)
	light:SetRadius(2.5)
	light:SetColour(180/255, 195/255, 150/255)
	light:Enable(false)

	inst:AddComponent("fueled")
	inst.components.fueled:InitializeFuelLevel(TUNING.MINERHAT_LIGHTTIME)
	inst.components.fueled:SetDepletedFn(spear_shine_perish)

	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_ZHUAN"
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		do_area_damage(inst, 3.5, 34, "tp_spear_shine", 
			function(inst, attacker, target)
				spear_shine_add_fuel(inst)
			end)

	end
	inst:AddTag("tp_forge_weapon")
end

local function spear_tornado_weapon_fn(inst, owner, target)
	if math.random() < .15 then
		WARGON.spawn_tornado(owner, target)
	end

end

local function spear_tornado_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_tornado", "swap_object")
end

local function spear_tornado_unequip(inst, owner)
	hand_unequip(inst, owner)
end

local function spear_tornado_fn(inst)
	inst:add_cmps({
		inspect = {},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		weapon = {dmg=34, fn=spear_tornado_weapon_fn},
		equip = {equip=spear_tornado_equip, unequip=spear_tornado_unequip},
	})
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_ZHUAN"
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		local owner = inst.components.inventoryitem.owner
		WARGON.spawn_tornado(owner)
	end
	inst:AddTag("tp_forge_weapon")
end

local function spear_shoot_weapon_fn(inst, owner, target)
end

local function spear_shoot_ball(inst, owner, target)















    if target then
	    local proj = WARGON.make_spawn(inst, "tp_spear_shoot_proj")
	    proj.components.tpproj:Throw(owner, target, owner)
    end
end

local function spear_shoot_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "swap_spear_hockey", "swap_spear")
end

local function spear_shoot_unequip(inst, owner)
	WARGON.EQUIP.object_off(owner)
end

local function spear_shoot_fn(inst)
	inst:add_cmps({
		inspect = {},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		weapon = {dmg=34, fn=spear_shoot_weapon_fn},
		equip = {equip=spear_shoot_equip, unequip=spear_shoot_unequip},
	})
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(2)
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_ZHUAN"
	inst:AddTag("tp_move_combat")
	inst.components.tpmove.onmove = function(inst, owner, target)
		inst.components.tprecharge:SetRechargeTime(2)



		if owner.components.hunger then
			owner.components.hunger:DoDelta(-5)
			spear_shoot_ball(inst, owner, target)
		end

	end
end


























local function spear_wind_equip(inst, owner)

	WARGON_EQUIP_EX.object_on(owner, "tp_forest_staff", "swap_object")
	if inst.fx == nil then
		local pt = owner:GetPosition()
		pt.x = pt.x + 5
		inst.fx = WARGON.make_fx(pt, "tp_fx_leaf_circle")
		inst.fx.master = owner
		inst.fx:start_task(inst.fx)
	end
	owner:AddTag("tp_spear_wind")
end

local function spear_wind_unequip(inst, owner)
	hand_unequip(inst, owner)
	if inst.fx then
		inst.fx:Remove()
		inst.fx = nil
	end
	owner:RemoveTag("tp_spear_wind")
end

local function spear_wind_weapon_fn(inst, owner, target)
	if inst.fx then
		inst.fx:stop_task(inst.fx)
		inst.fx:ForceFacePoint(target:GetPosition())
		inst.fx:start_task2(inst.fx)
	end
end

local function spear_wind_fn(inst)
	WARGON_CMP_EX.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=0, fn=spear_wind_weapon_fn, range={8,10}},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		equip = {equip=spear_wind_equip, unequip=spear_wind_unequip},
		water = {value=TUNING.WATERPROOFNESS_SMALL},
	})
	inst:AddTag("tp_not_fix")







end

local function spear_mix_weapon_fn(inst, owner, target, projectile)
end

local function spear_mix_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "swap_spear_northern", "swap_spear")
end

local function spear_mix_fn(inst)
	WARGON.CMP.add_cmps(inst, {
		inspect = {},
		weapon = {dmg=1, fn=spear_mix_weapon_fn},
		finite = {max=1, use=1, fn=on_finish},
		equip = {equip=spear_mix_equip, unequip=hand_unequip},
		tpmixweapon = {},
	})

end

local function spear_diamond_weapon_fn(inst, owner, target)

end

local function spear_diamond_broke(inst, data)
	if inst.components.health then
		inst:do_task(.1, function()
			inst.components.health:Kill()
		end)
	end
end

local function spear_diamond_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_diamond", "swap_object")
	owner:add_listener("armorbroke", spear_diamond_broke)
end

local function spear_diamond_unequip(inst, owner)
	hand_unequip(inst, owner)
	owner:rm_listener("armorbroke", spear_diamond_broke)
end

local function spear_diamond_fn(inst)
	inst:AddTag("tp_not_fix")
	inst:add_cmps({
		inspect = {},
		weapon = {dmg=34, fn=spear_diamond_weapon_fn},
		equip = {equip=spear_diamond_equip, unequip=spear_diamond_unequip},
		armor = {armor=1800, absorb=1},
	})
	inst:AddTag("tp_forge_weapon")
end
























local function spear_beefalo_weapon_fn(inst, owner, target)
	if target and target:HasTag("beefalo") then
		if target.components.health then
			target.components.health:DoDelta(-25)
		end
	end
end

local function spear_beefalo_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_beefalo", "swap_object")
end

local function spear_beefalo_unequip(inst, owner)
	hand_unequip(inst, owner)
end

local function spear_beefalo_fn(inst)
	inst:add_cmps({
		inspect = {},
		weapon = {dmg=34, fn=spear_beefalo_weapon_fn},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		equip = {equip=spear_beefalo_equip, unequip=spear_beefalo_unequip},
	})
end

local function spear_conqueror_weapon_fn(inst, owner, target)
	if owner.components.tpbuff
	and (target:HasTag("monster") or target:HasTag("epic")) then
		owner.components.tpbuff:AddBuff("tp_spear_conqueror")
	end
	if owner:HasTag("tp_spear_conqueror") then
		if owner.components.health then
			owner.components.health:DoDelta(5)
		end
		if owner.components.sanity then
			owner.components.sanity:DoDelta(5)
		end
		if target.components.health then
			target.components.health:DoDelta(-5)
		end
	end
end

local function spear_conqueror_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_conqueror", "swap_object")
end

local function spear_conqueror_unequip(inst, owner)
	hand_unequip(inst, owner)
end

local function spear_conqueror_fn(inst)
	inst:add_cmps({
		inspect = {},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		weapon = {dmg=34, fn=spear_conqueror_weapon_fn},
		equip = {equip=spear_conqueror_equip, unequip=spear_conqueror_unequip},
	})
end


local function spear_cooldown_weapon_fn(inst, owner, target)
	target:do_task(5, function()
		if target:is_alive() then
			target.components.health:DoDelta(inst.components.weapon.damage)
		end
	end)



end

local function spear_cooldown_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_cooldown", "swap_object")
end

local function spear_cooldown_unequip(inst, owner)
	hand_unequip(inst, owner)
end

local function spear_cooldown_fn(inst)
	inst:add_cmps({
		inspect = {},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		weapon = {dmg=68, fn=spear_cooldown_weapon_fn},
		equip = {equip=spear_cooldown_equip, unequip=spear_cooldown_unequip},
	})








end

local function spear_potion_weapon_fn(inst, owner, target)
	if owner.components.tpbuff then
		local potions = {
			"health_small",
			"sanity_small",
			"crazy",
			"shine",
			"dry",
			"smell",
			"warth",
			"iron",
		}
		if math.random() < .1 then
			local buff = "tp_potion_"..potions[math.random(#potions)]
			owner.components.tpbuff:AddBuff(buff)
		end
	end
end

local function spear_potion_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_potion", "swap_object")
end

local function spear_potion_unequip(inst, owner)
	hand_unequip(inst, owner)
end

local function spear_potion_fn(inst)
	inst:add_cmps({
		inspect = {},
		finite = {max=TUNING.SPEAR_USES, use=TUNING.SPEAR_USES, fn=on_finish},
		weapon = {dmg=34, fn=spear_potion_weapon_fn},
		equip = {equip=spear_potion_equip, unequip=spear_potion_unequip},
	})
end

























































































local function spear_heracles_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_heracles", "swap_object")
end

local function spear_heracles_unequip(inst, owner)
	hand_unequip(inst, owner)
end

local function spear_heracles_fn(inst)
	inst:add_cmps({
		inspect = {},
		finite = {max=300, use=300, fn=on_finish},
		weapon = {dmg=68, },
		equip = {equip=spear_heracles_equip, unequip=spear_heracles_unequip},
	})
	inst.components.weapon.getdamagefn = function(inst)
		local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
		local dmg = owner and owner.components.tplevel and owner.components.tplevel.attr.forge*2 or 0
		return inst.components.weapon.damage + dmg
	end
end

local function spear_perseus_weapon_fn(inst, owner, target)
	if owner.components.tpbuff then
		owner.components.tpbuff:AddBuff("tp_spear_perseus")
	end
end

local function spear_perseus_equip(inst, owner)
	WARGON.EQUIP.object_on(owner, "tp_spear_perseus", "swap_object")
end

local function spear_perseus_unequip(inst, owner)
	hand_unequip(inst, owner)
end

local function spear_perseus_fn(inst)
	inst:add_cmps({
		inspect = {},
		finite = {max=300, use=300, fn=on_finish},
		weapon = {dmg=51, fn=spear_perseus_weapon_fn},
		equip = {equip=spear_perseus_equip, unequip=spear_perseus_unequip},
	})
	inst:AddTag("tp_forge_weapon")
end































































local WeaponData = Class(Prefab, function(self, name, data)
	Prefab._ctor(self, name)
	self.data = data
	self.fn = function()
		local atlas, img = WARGON.resolve_img_path(data.img)
		img = string.sub(img, 1, -5)
	 	local inst = WARGON.make_prefab(data.anim, data.anim[4], "inv")
	 	inst:add_cmps({
	 		invitem = { atlas=atlas, img=img },
	 		inspect = {},
	 		weapon = {
	 			dmg = data.dmg,
	 			fn = data.weapon_fn,
	 			range = data.range,
	 		},
	 		equip = {
	 			equip = data.equip_fn,
	 			unequip = data.unequip_fn,
	 		},
	 	})
	 	if data.finite then
	 		inst:add_cmps({
	 			finite = {use=data.finite, max=data.finite, fn=on_finish},
 			})
	 	end
	 	if data.tpproj then
	 		set_spear_proj(inst)
	 	end
	 	if data.lunge then
	 		set_spear_lunge(inst)
	 	end
	 	if data.fn then
	 		data.fn(inst)
	 	end
	 	if data.forge then
	 		inst:AddTag("tp_forge_weapon")
	 	end
	 	if data.not_fix then
	 		inst:AddTag("tp_not_fix")
	 	end
		inst:AddTag("tp_item")
		inst:AddComponent("tpinter")
		inst.components.tpinter:SetCanFn(function(inst, invitem, doer)
			return invitem:HasTag("tp_fix_powder") 
				and not inst:HasTag("tp_not_fix")
		end)








	    return inst
	end
end)

function WeaponData:__tostring()
	return string.format("Weapon %s - %s", self.name, self.desc)
end

local spear_hades = WeaponData("tp_spear_hades", {
	anim = Anims.spear_hades,
	img = "tp_spear_hades#",





	forge = true,
	dmg = 51,
	finite = 300,
	weapon_fn = function(inst, owner, target)
		local hp, san = 10, 10
		if target:HasTag("epic") then
			hp, san = 20, 20
		elseif target:HasTag("largecreature") then
			hp, san = 15, 15
		end
		owner.components.health:DoDelta(hp)
		owner.components.sanity:DoDelta(san)
		if target:HasTag("shadowcreature") 
		or (target.components.health:GetPercent() < .2)
		and target:is_alive() then
			target.components.combat:GetAttacked(owner, 99999, inst)
			owner.components.health:DoDelta(30)
			owner.components.sanity:DoDelta(30)
		end
	end,
	equip_fn = function(inst, owner)

		WARGON.EQUIP.object_on(owner, "tp_spear_hades", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_zeus = WeaponData("tp_spear_zeus", {
	anim = Anims.spear_zeus,
	img = "tp_spear_zeus#",
	fn = function(inst)



		inst.components.weapon:SetElectric()
		inst.components.weapon.getdamagefn = function(inst)
			local owner = inst.components.equippable.owner
			if owner and owner.components.sanity
			and owner.components.sanity:IsCrazy() then
				return 0
			end
			return 42.5
		end










	end,
	dmg = 42.5,


	range = {2, 2},
	finite = 300,

	weapon_fn = function(inst, owner, target)
		WARGON.make_fx(target, "lightning")
		if owner.components.sanity then
			owner.components.sanity:DoDelta(-5)
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_zeus", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_hermes = WeaponData("tp_spear_hermes", {
	anim = Anims.spear_hermes,
	img = "tp_spear_hermes#",
	dmg = 34,
	finite = 300,
	forge = true,
	fn = function(inst)
		inst.components.equippable.walkspeedmult = .25


	end,
	weapon_fn = function(inst, owner, target)
		if math.random() < .15 then
			if target.components.lootdropper then
				target.components.lootdropper:DropSingleLoot()
			end
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_hermes", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_gaea = WeaponData("tp_spear_gaea", {
	anim = Anims.spear_gaea,
	img = "tp_spear_gaea#",
	dmg = 51,
	finite = 300,
	forge = true,
	weapon_fn = function(inst, owner, target)
		WARGON.make_fx(target, "groundpoundring_fx")
		local ents = target:wg_finds(12)
		for k, v in pairs(ents) do









			if WARGON.is_kind(v, target) then
				if WARGON.can_enemy(owner, v) then
					v.components.combat:GetAttacked(owner, 15, inst)
				end
			end
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_gaea", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_valkyrie = WeaponData("tp_spear_valkyrie", {
	anim = Anims.starstaff_crystal,
	img = "starstaff_crystal#",
	dmg = 51,
	finite = 300,
	forge = true,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "swap_starstaff_crystal", "swap_yellowstaff")
		if inst.task then
			inst.task:Remove()
		end
		inst.task = owner:per_task(1, function()
			local dmg = owner.components.combat:CalcDamage(inst, inst)
			local rate = dmg * .01 * .33



			if owner.components.health then
				owner.components.health:AddAbsorbModifier("tp_spear_valkyrie", rate)
			end
		end)
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
		if inst.task then
			inst.task:Cancel()
			inst.task = nil
		end

		owner.components.health:RemoveAbsorbModifier("tp_spear_valkyrie")
	end,
})

local spear_rose = WeaponData("tp_spear_rose", {
	anim = Anims.spear_rose,
	img = "spear_rose#",
	dmg = 34,
	finite = 150,
	fn = function(inst)
		inst:AddComponent("tprecharge")
		inst.components.tprecharge:SetRechargeTime(5)
	end,
	weapon_fn = function(inst, owner, target)

		if inst.components.tprecharge:IsRecharged() then
			inst.components.tprecharge:SetRechargeTime(5)


			local fx = WARGON.make_fx(target,"bramblefx")
			fx.AnimState:SetMultColour(.3, 1, .3, 1)
			local dmg = inst.components.weapon.damage
			do_area_damage(inst, 5, dmg, inst.prefab)
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "swap_spear_rose", "swap_spear")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_trap = WeaponData("tp_spear_trap", {
	anim = Anims.spear_simple,
	img = "spear_simple#",
	dmg = 34,
	finite = 150,
	weapon_fn = function(inst, owner, target)
		if math.random() < .1 then
			if not target:wg_find(1.5, nil, {"tp_trap_teeth"})
			and target:on_land() then

				local trap = WARGON.make_spawn(target, "trap_teeth")
				trap.AnimState:SetBuild("trap_teeth_tiger")
				trap.components.dsskins.skin = "trap_teeth_tiger"
				trap.components.mine:Reset()
			end
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "swap_spear_simple", "swap_spear")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})	

local spear_ice_thunder = WeaponData("tp_spear_ice_thunder", {
	anim = Anims.icestaff_lance,
	img = "icestaff_lance#",
	dmg = 51,
	finite = 300,
	forge = true,
	weapon_fn = function(inst, owner, target)
		WARGON.frozen_prefab(target, nil)
		local new_target = target:wg_find(5, function(guy)
			return WARGON.can_enemy(owner, guy)
				and guy ~= target
		end)
	    if new_target then
	        local proj = WARGON.make_spawn(target, "tp_ice_charge_proj")
	        proj.master = owner
	        table.insert(proj.no_targets, target)
	        proj.components.tpproj:Throw(owner, new_target, owner)
	    end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "swap_icestaff_lance", "swap_bluestaff")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_fire_thunder = WeaponData("tp_spear_fire_thunder", {
	anim = Anims.firestaff_lance,
	img = "firestaff_lance#",
	dmg = 51,
	finite = 300,
	forge = true,
	weapon_fn = function(inst, owner, target)
		WARGON.fire_prefab(target, nil)
		local new_target = target:wg_find(5, function(guy)
			return WARGON.can_enemy(owner, guy)
				and guy ~= target
		end)
	    if new_target then
	        local proj = WARGON.make_spawn(target, "tp_fire_charge_proj")
	        proj.master = owner
	        table.insert(proj.no_targets, target)
	        proj.components.tpproj:Throw(owner, new_target, owner)
	    end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "swap_firestaff_lance", "swap_redstaff")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_ice_rose = WeaponData("tp_spear_ice_rose", {
	anim = Anims.icestaff_rose,
	img = "icestaff_rose#",
	dmg = 51,
	finite = 300,
	forge = true,
	fn = function(inst)
		inst:AddComponent("tprecharge")
		inst.components.tprecharge:SetRechargeTime(3)
	end,
	weapon_fn = function(inst, owner, target)

		if inst.components.tprecharge:IsRecharged() then
			inst.components.tprecharge:SetRechargeTime(3)


			local fx = WARGON.make_fx(target,"bramblefx")
			fx.AnimState:SetMultColour(.3, .3, 1, 1)
			local dmg = inst.components.weapon.damage
			do_area_damage(inst, 5, dmg, inst.prefab, 
				function(inst, attacker, target)
					WARGON.frozen_prefab(target, nil, 2)
				end
			)
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "swap_icestaff_rose", "swap_bluestaff")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_fire_rose = WeaponData("tp_spear_fire_rose", {
	anim = Anims.firestaff_rose,
	img = "firestaff_rose#",
	dmg = 51,
	finite = 300,
	forge = true,
	fn = function(inst)
		inst:AddComponent("tprecharge")
		inst.components.tprecharge:SetRechargeTime(3)
	end,
	weapon_fn = function(inst, owner, target)

		if inst.components.tprecharge:IsRecharged() then
			inst.components.tprecharge:SetRechargeTime(3)


			local fx = WARGON.make_fx(target,"bramblefx")
			fx.AnimState:SetMultColour(1, .3, .3, 1)
			local dmg = inst.components.weapon.damage*1.5
			do_area_damage(inst, 5, dmg, inst.prefab, 
				function(inst, attacker, target)
					WARGON.fire_prefab(target, nil)
				end
			)
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "swap_firestaff_rose", "swap_redstaff")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_collect = WeaponData("tp_spear_collect", {
	anim = Anims.spear_collect,
	img = "tp_spear_collect#",
	dmg = 34,
	finite = 150,
	fn = function(inst)
		inst:add_cmps({
			caster = {
				spell = function(staff, target, pos)
					WARGON.make_fx(target, "collapse_small")
					if target and target:is_alive() then
						target:Remove()
						staff.components.tpcollecter:LevelUp()
					end
				end,
				test = function(staff, caster, target, pos)
					if target and target:HasTag("smallcreature") 
					and (target:HasTag("canbetrapped") 
					or target:HasTag("bird") )
					and target.components.combat
					and caster.components.combat:CanTarget(target) then
						return true
					end 
				end, 
				can={point=false, inv=true, target=true}
			},	
		})


		inst:AddComponent("tpcollecter")
		inst.components.weapon.getdamagefn = function(inst)
			local dmg = inst.components.weapon.damage
			return dmg + inst.components.tpcollecter.level*5
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_collect", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_bag = WeaponData("tp_spear_bag", {
	anim = Anims.spear_bag,
	img = "tp_spear_bag#",
	dmg = 34,
	finite = 150,
	fn = function(inst)
		inst:add_cmps({
			finite = {
				fn = function(inst)
					inst.components.container:DropEverything()
					inst:Remove()
				end,
			},
			cont = {typ="2x4"},
		})
		inst.components.container.itemtestfn = function(inst, item, slot)
			return inst ~= item
		end
		inst.components.container.CollectSceneActions = function()
		end
		inst.components.container.CollectInventoryActions = function()
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_bag", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
		inst.components.container:Close()
	end,
})

local spear_turret = WeaponData("tp_spear_turret", {
	anim = Anims.spear_turret,
	img = "tp_spear_turret#",
	dmg = 34,
	finite = 150,
	fn = function(inst)
		inst:add_cmps({
			caster = {
				spell = function(staff, target, pos)
					local owner = staff.components.equippable.owner
					if owner and owner.components.tpbuff then
						owner.components.tpbuff:AddBuff("tp_spear_turret")
					end
					WARGON.make_fx(pos, "collapse_small")
					local turret = WARGON.make_spawn(pos, "eyeturret")
					turret:no_save()
					turret:do_task(20, function()
						if turret:is_alive() then
							turret.components.health:Kill()
						end
					end)
					staff.components.tprecharge:SetRechargeTime(20)
				end,
				test = function(staff, caster, target, pos)
					if staff.components.tprecharge:IsRecharged()
					and WARGON.on_land(caster, pos)
					and not caster:HasTag("tp_spear_turret") then
						return true
					end
				end, 
				can={point=true, inv=false, target=false},
			},	
		})
		inst:AddComponent("tprecharge")
		inst.components.tprecharge:SetRechargeTime(20)	
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_turret", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_dream = WeaponData("tp_spear_dream", {
	anim = Anims.spear_dream,
	img = "tp_spear_dream#",
	dmg = 34,
	finite = 300,
	fn = function(inst)
		inst.components.weapon.getdamagefn = function(inst)
			local dmg = 34
			local heracles = inst.components.container:FindItem(function(item)
				return item.prefab == "tp_spear_heracles"
			end)
			local anubis = inst.components.container:FindItem(function(item)
				return item.prefab == "tp_spear_anubis_3"
			end)
			if anubis and anubis.components.tprecharge
			and anubis.components.tprecharge:IsRecharged() then
				dmg = dmg + anubis.level
			end
			if heracles then
				dmg = dmg * 2
			end
			return dmg
		end
		inst:add_cmps({
			finite = {
				fn = function(inst)
					inst.components.container:DropEverything()
					inst:Remove()
				end,
			},
			cont = {typ="cooker"},
		})
		inst.components.container.itemtestfn = function(inst, item, slot)
			return inst.components.tpspeardream:CanGetItem(item)
		end
		inst.components.container.CollectSceneActions = function()
		end
		inst.components.container.CollectInventoryActions = function()
		end
		inst.components.container.widgetbuttoninfo = {
			text = STRINGS.TP_STR.tp_spear_dream,
			position = Vector3(0, -165, 0),
			fn = function(inst)
				inst.components.tpspeardream:GetPower()
				inst.components.container:Close()
			end,
			validfn = function(inst)
				return true
			end,
		}
		inst:AddComponent("tpspeardream")
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_dream", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
		inst.components.tpspeardream:GetPower()
		inst.components.container:Close()
	end,
})

local spear_single = WeaponData("tp_spear_single", {
	anim = Anims.spear_single,
	img = "tp_spear_single#",
	finite = 150,
	dmg = 34,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_single", "swap_object")
		inst.key_down = nil
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
		inst.key_down = nil
	end,
	fn = function(inst)
		inst.handler = TheInput:AddKeyDownHandler(KEY_F, function()
			if inst.components.equippable 
			and inst.components.equippable:IsEquipped()
			and inst.components.equippable.owner
			and inst.key_down == nil then
				local owner = inst.components.equippable.owner
				if owner.components.tpbuff then
					owner.components.tpbuff:AddBuff("tp_spear_single")
				end
				inst.key_down = true
			end
		end)
		inst.handler2 = TheInput:AddKeyUpHandler(KEY_F, function()
			if inst.components.equippable 
			and inst.components.equippable:IsEquipped()
			and inst.components.equippable.owner then
				inst.key_down = nil
			end
		end)
		inst:ListenForEvent("onremove", function()
			inst.handler:Remove()
			inst.handler2:Remove()
		end)
	end,
})

local spear_ripper = WeaponData("tp_spear_ripper", {
	anim = Anims.spear_ripper,
	img = "tp_spear_ripper#",
	finite = 150,
	dmg = 34,
	weapon_fn = function(inst, owner, target)









		WARGON.absorb_ripped(target)
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_ripper", "swap_object")
	end,	
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_road = WeaponData("tp_spear_road", {
	anim = Anims.spear_road,
	img = "tp_spear_road#",
	finite = 150,
	dmg = 34,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_road", "swap_object")
		owner:AddTag("tp_spear_road")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
		owner:RemoveTag("tp_spear_road")
	end,
})

local spear_shell = WeaponData("tp_spear_shell", {
	anim = Anims.spear_shell,
	img = "tp_spear_shell#",
	finite = 150,
	dmg = 34,
	weapon_fn = function(inst, owner, target)
		if inst.task then
			inst.task:Cancel()
			inst.task = nil
		end
		if owner.components.tpbuff then
			owner.components.tpbuff:AddBuff("tp_spear_shell")
		end
		inst.components.equippable.poisonblocker = true
		inst.task = inst:do_task(5, function()
			inst.components.equippable.poisonblocker = false
		end)
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_shell", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_leaf = WeaponData("tp_spear_leaf", {
	anim = Anims.spear_leaf,
	img = "tp_spear_leaf#",
	finite = 150,
	dmg = 34,
	fn = function(inst)
		inst:add_cmps({
			finite = {
				fn = function(inst)
					inst.components.container:DropEverything()
					inst:Remove()
				end,
			},
			cont = {typ="1x4"},
		})
		inst.components.container.itemtestfn = function(inst, item, slot)
			return inst ~= item
		end
		inst.components.container.CollectSceneActions = function()
		end
		inst.components.container.CollectInventoryActions = function()
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_leaf", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
		inst.components.container:Close()
	end,
})

local spear_shark = WeaponData("tp_spear_shark", {
	anim = Anims.spear_shark,
	img = "tp_spear_shark#",
	finite = 150,
	dmg = 34,
	fn = function(inst)
		inst.components.weapon.getdamagefn = function(inst)
			local dmg = inst.components.weapon.damage
			if WARGON.on_water(inst) then
				return dmg + 20
			end
			return dmg
		end
	end,
	weapon_fn = function(inst, owner, target)
		if math.random() < .25 then
			local fx = WARGON.make_fx(inst, "tp_fx_water_flower_line")


			WARGON.face_target(fx, target)
			fx.owner = owner












		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_shark", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local function spear_wave_surf(inst, data)
	inst:add_speed_rate("tp_spear_wave", .25, 5)
	if inst.components.tpbuff then
		inst.components.tpbuff:AddBuff("tp_spear_wave", 5)
	end
end

local spear_wave = WeaponData("tp_spear_wave", {
	anim = Anims.spear_wave,
	img = "tp_spear_wave#",
	finite = 150,
	dmg = 34,
	equip_fn = function(inst, owner)
		inst:ListenForEvent("boostbywave", spear_wave_surf, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_wave", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		inst:RemoveEventCallback("boostbywave", spear_wave_surf, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_snake = WeaponData("tp_spear_snake", {
	anim = Anims.spear_snake,
	img = "tp_spear_snake#",
	finite = 150,
	dmg = 34,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_snake", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
	fn = function(inst)
		inst:AddComponent("tprecharge")
		inst.components.tprecharge:SetRechargeTime(5)
		inst:AddTag("tp_move_no_target")
		inst:AddComponent("tpmove")
		inst.components.tpmove.action = "TP_HUA"
		inst.components.tpmove.onmove = function(inst)
			inst.components.tprecharge:SetRechargeTime(5)












		end
	end,	
})

local spear_attr = WeaponData("tp_spear_attr", {
	anim = Anims.spear_attr,
	img = "tp_spear_attr#",
	finite = 150,
	dmg = 34,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_attr", "swap_object")
		owner.components.tpbody:AddMaxHealthModifier(inst.prefab, 30)
		owner.components.tpbody:SetMaxHealth()
		owner.components.tpbody:AddMaxSanityModifier(inst.prefab, 30)
		owner.components.tpbody:SetMaxSanity()
		owner.components.tpbody:AddMaxHungerModifier(inst.prefab, 30)
		owner.components.tpbody:SetMaxHunger()
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
		owner.components.tpbody:RemoveMaxHealthModifier(inst.prefab)
		owner.components.tpbody:SetMaxHealth()
		owner.components.tpbody:RemoveMaxSanityModifier(inst.prefab)
		owner.components.tpbody:SetMaxSanity()
		owner.components.tpbody:RemoveMaxHungerModifier(inst.prefab)
		owner.components.tpbody:SetMaxHunger()
	end,
})

local spear_anubis = WeaponData("tp_spear_anubis", {
	anim = Anims.spear_anubis,
	img = "tp_spear_anubis#",
	finite = 300,
	dmg = 10,
	weapon_fn = function(inst)
		if inst.components.tprecharge:IsRecharged() then
			inst.components.tprecharge:SetRechargeTime(inst.cooldown)
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_anubis", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
	fn = function(inst)
		inst.cooldown = 3
		inst:AddComponent("tprecharge")
		inst.components.tprecharge:SetRechargeTime(inst.cooldown)
		inst:AddTag("tp_spear_anubis")
		inst.level = 0
		inst:ListenForEvent("tp_owner_killed", function(inst, data)
			if data and data.victim 
			and not data.victim:HasTag("tp_not_reward")
			and not data.victim:HasTag("tp_not_reward_anubis") then
				if data.victim:HasTag("epic") then
					inst.level = inst.level + 4
				elseif data.victim:HasTag("monster") then
					inst.level = inst.level + 1
				end
				data.victim:AddTag("tp_not_reward_anubis")
			end
		end)
		inst.components.weapon.getdamagefn = function(inst)
			if inst.components.tprecharge:IsRecharged() then
				return inst.level + 10
			end
			return 10
		end
		inst.OnSave = function(inst, data)
			if data then
				data.level = inst.level
			end
		end
		inst.OnLoad = function(inst, data)
			if data then
				inst.level = data.level or 0
			end
		end
	end,	
})

local spear_anubis_2 = deepcopy(spear_anubis)
spear_anubis_2:SetName("tp_spear_anubis_2")
spear_anubis_2:HookFn(function(inst)
	inst.cooldown = 2
end)

local spear_anubis_3 = deepcopy(spear_anubis)
spear_anubis_3:SetName("tp_spear_anubis_3")
spear_anubis_3:HookFn(function(inst)
	inst.cooldown = 1
end)

local spear_shadow = WeaponData("tp_spear_shadow", {
	anim = Anims.spear_shadow,
	img = "tp_spear_shadow#",
	finite = 300,
	dmg = 34,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_shadow", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
	weapon_fn = function(inst, owner, target)
		if target:HasTag("shadowcreature") 
		and target.components.health and target.components.combat
		and owner.components.combat:CanTarget(target) then
			local dmg = inst.damage
			if GetWorld():IsCave() then
				dmg = dmg*inst.mult
			end
			target.components.combat:GetAttacked(owner, dmg, inst, inst.prefab)
		end
	end,
	fn = function(inst)
		inst.damage = 100
		inst.mult = 2
		inst:add_cmps({
			equip = { effect={san=-TUNING.SANITYAURA_LARGE} },
		})
		inst.components.weapon.getdamagefn = function(inst)
			local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
			local dmg = 1
			if owner and owner.components.sanity then
				local p = owner.components.sanity:GetPercent()
				dmg = 1 + p * 100
			end
			return dmg
		end
		inst:AddComponent("tpmove")
		inst.components.tpmove.action = "TP_CI"
		inst:AddComponent("tprecharge")
		inst.components.tprecharge:SetRechargeTime(10)
		inst.components.tpmove.onmove = function(inst)
			inst.components.tprecharge:SetRechargeTime(10)
			inst:StartThread(function()
				for i = 1, 3 do
					Sleep(0.1)
					local function area_shadow(inst, target)
						local owner = inst.components.inventoryitem.owner
						owner.components.sanity:DoDelta(5)
					end
					do_area(inst, 1.5, area_shadow)
					do_area_damage(inst, 1.5, 34, "tp_spear_shadow", 
						function(inst, attacker, target)
							if target:HasTag("shadowcreature") then
								if target.components.health and target.components.combat
								and attacker.components.combat:CanTarget(target) then
									target.components.combat:GetAttacked(owner, inst.damage, inst, inst.prefab)




								end
							end
						end
					)
					local fx = WARGON.make_fx(inst, "statue_transition")
				end
			end)
		end
	end,
})

local spear_shadow_2 = deepcopy(spear_shadow)
spear_shadow_2:SetName("tp_spear_shadow_2")
spear_shadow_2:HookFn(function(inst)
	inst.mult = 3
end)

local spear_shadow_3 = deepcopy(spear_shadow_2)
spear_shadow_3:SetName("tp_spear_shadow_3")
spear_shadow_3:HookFn(function(inst)
	inst.damage = 150
end)

return
MakeItem("tp_spear_lance", Anims.spear_lance, spear_lance_fn, "spear_forge_lance"),
MakeItem("tp_spear_ice", Anims.spear_ice, spear_ice_fn, "tp_spear_ice"),
MakeItem("tp_spear_fire", Anims.spear_fire, spear_fire_fn, "tp_spear_fire"),
MakeItem("tp_spear_thunder", Anims.spear_thunder, spear_thunder_fn, "tp_spear_thunder"),
MakeItem("tp_spear_gungnir", Anims.spear_gungnir, spear_gungnir_fn, "spear_forge_gungnir"),
MakeItem("tp_spear_poison", Anims.spear_poison, spear_poison_fn, "tp_spear_poison"),

MakeItem("tp_spear_blood", Anims.spear_blood, spear_blood_fn, "tp_spear_blood"),
MakeItem("tp_spear_wind", Anims.spear_wind, spear_wind_fn, "tp_swords", "tp_forest_staff"),
MakeItem("tp_spear_wrestle", Anims.spear_wrestle, spear_wrestle_fn, "spear_wathgrithr_wrestle"),
MakeItem("tp_spear_lightning", Anims.spear_lightning, spear_lightning_fn, "tp_spear_lightning"),
MakeItem("tp_spear_speed", Anims.spear_speed, spear_speed_fn, "tp_spear_speed"),
MakeItem("tp_spear_earth", Anims.spear_earth, spear_earth_fn, "tp_spear_earth"),
MakeItem("tp_spear_shine", Anims.spear_shine, spear_shine_fn, "tp_spear_shine"),
MakeItem("tp_spear_gold", Anims.spear_gold, spear_gold_fn, "tp_spear_gold"),
MakeItem("tp_spear_combat", Anims.spear_combat, spear_combat_fn, "tp_spear_combat"),
MakeItem("tp_spear_beefalo", Anims.spear_beefalo, spear_beefalo_fn, "tp_spear_beefalo"),

MakeItem("tp_spear_diamond", Anims.spear_diamond, spear_diamond_fn, "tp_spear_diamond"),

MakeItem("tp_spear_tornado", Anims.spear_tornado, spear_tornado_fn, "tp_spear_tornado"),
MakeItem("tp_spear_conqueror", Anims.spear_conqueror, spear_conqueror_fn, "tp_spear_conqueror"),
MakeItem("tp_spear_shoot", Anims.spear_hockey, spear_shoot_fn, "spear_hockey"),
MakeItem("tp_spear_cooldown", Anims.spear_cooldown, spear_cooldown_fn, "tp_spear_cooldown"),
MakeItem("tp_spear_potion", Anims.spear_potion, spear_potion_fn, "tp_spear_potion"),


MakeItem("tp_spear_heracles", Anims.spear_heracles, spear_heracles_fn, "tp_spear_heracles"),
MakeItem("tp_spear_perseus", Anims.spear_perseus, spear_perseus_fn, "tp_spear_perseus"),


spear_hades,
spear_zeus,
spear_hermes,
spear_gaea,
spear_valkyrie,
spear_rose,
spear_trap,
spear_ice_thunder,
spear_fire_thunder,
spear_ice_rose,
spear_fire_rose,
spear_collect,
spear_bag,
spear_turret,
spear_dream,
spear_ripper,
spear_single,
spear_road,
spear_shell,
spear_leaf,
spear_shark,
spear_wave,
spear_snake,

spear_anubis,
spear_anubis_2,
spear_anubis_3,
spear_shadow,
spear_shadow_2,
spear_shadow_3,

MakeItem("tp_spear_mix", Anims.spear_northern, spear_mix_fn, "spear_northern")
