local Anims = {
    spear = {"spear", "spear", "idle", "idle_water"},
	spear_lance = {"tp_spear_lance", "tp_spear_lance", "idle", "idle_water"},
	spear_ice = {"tp_spear_ice", "tp_spear_ice", "idle", "idle_water"},
	spear_fire = {"tp_spear_fire", "tp_spear_fire", "idle", "idle_water"},
	spear_thunder = {"tp_spear_thunder", "tp_spear_thunder", "idle", "idle_water"},
	spear_gungnir = {"spear", "spear_forge_gungnir", "idle", "idle_water"},
	spear_poison = {"tp_spear_poison", "tp_spear_poison", "idle", "idle_water"},
	spear_shadow = {"tp_spear_shadow", "tp_spear_shadow", "idle", "idle_water"},
	spear_blood = {"tp_spear_blood", "tp_spear_blood", "idle", "idle_water"},
	spear_rose = {"spear", "spear_rose", "idle", "idle_water"},
	spear_wind = {'tp_spear_wind', 'tp_spear_wind', 'idle', 'idle_water'},
	spear_wrestle = {'spear_wathgrithr', "spear_wathgrithr_wrestle", "idle", "idle_water"},
	spear_lightning = {'tp_spear_lightning', 'tp_spear_lightning', 'idle', 'idle_water'},
	spear_speed = {'tp_spear_speed', 'tp_spear_speed', 'idle', 'idle_water'},
	spear_earth = {'tp_spear_earth', 'tp_spear_earth', 'idle', 'idle_water'},
	spear_shine = {'tp_spear_shine', 'tp_spear_shine', 'idle', 'idle_water'},
	spear_northern = {'spear', 'spear_northern', 'idle', 'idle_water'},
	spear_simple = {"spear", "spear_simple", "idle", "idle_water"},
	spear_bag = {"tp_spear_bag", "tp_spear_bag", "idle", "idle_water"},
	spear_beefalo = {"tp_spear_beefalo", "tp_spear_beefalo", "idle", "idle_water"},
	spear_combat = {"tp_spear_combat", "tp_spear_combat", "idle", "idle_water"},
	spear_diamond = {"tp_spear_diamond", "tp_spear_diamond", "idle", "idle_water"},
	spear_gold = {"tp_spear_gold", "tp_spear_gold", "idle", "idle_water"},
	spear_tornado = {"tp_spear_tornado", "tp_spear_tornado", "idle", "idle_water"},
	spear_conqueror = {"tp_spear_conqueror", "tp_spear_conqueror", "idle", "idle_water"},
	spear_hockey = {"spear", "spear_hockey", "idle", "idle_water"},
	spear_cooldown = {"tp_spear_cooldown", "tp_spear_cooldown", "idle", "idle_water"},
	spear_potion = {"tp_spear_potion", "tp_spear_potion", "idle", "idle_water"},
	starstaff_crystal = {"staffs", "starstaff_crystal", "yellowstaff", "yellowstaff_water"},
	icestaff_lance = {"staffs", "icestaff_lance", "bluestaff", "bluestaff_water"},
	firestaff_lance = {"staffs", "firestaff_lance", "redstaff", "redstaff_water"},
	icestaff_rose = {"staffs", "icestaff_rose", "bluestaff", "bluestaff_water"},
	firestaff_rose = {"staffs", "firestaff_rose", "redstaff", "redstaff_water"},
	spear_anubis = {"tp_spear_anubis", "tp_spear_anubis", "idle", "idle_water"},
	spear_heracles = {"tp_spear_heracles", "tp_spear_heracles", "idle", "idle_water"},
	spear_perseus = {"tp_spear_perseus", "tp_spear_perseus", "idle", "idle_water"},
	spear_hades = {"tp_spear_hades", "tp_spear_hades", "idle", "idle_water"},
	spear_zeus = {"tp_spear_zeus", "tp_spear_zeus", "idle", "idle_water"},
	spear_hermes = {"tp_spear_hermes", "tp_spear_hermes", "idle", "idle_water"},
	spear_gaea = {"tp_spear_gaea", "tp_spear_gaea", "idle", "idle_water"},
	spear_collect = {"tp_spear_collect", "tp_spear_collect", "idle", "idle_water"},
	spear_dream = {"tp_spear_dream", "tp_spear_dream", "idle", "idle_water"},
	spear_turret = {"tp_spear_turret", "tp_spear_turret", "idle", "idle_water"},
	spear_single = {"tp_spear_single", "tp_spear_single", "idle", "idle_water"},
	spear_ripper = {"tp_spear_ripper", "tp_spear_ripper", "idle", "idle_water"},
	spear_road = {"tp_spear_road", "tp_spear_road", "idle", "idle_water"},
	spear_shell = {"tp_spear_shell", "tp_spear_shell", "idle", "idle_water"},
	spear_leaf = {"tp_spear_leaf", "tp_spear_leaf", "idle", "idle_water"},
	spear_shark = {"tp_spear_shark", "tp_spear_shark", "idle", "idle_water"},
	spear_wave = {"tp_spear_wave", "tp_spear_wave", "idle", "idle_water"},
	spear_snake = {"tp_spear_snake", "tp_spear_snake", "idle", "idle_water"},
}

local function do_area_damage(inst, range, dmg, reason, fn)
	local owner = inst.components.inventoryitem.owner
	WARGON.area_dmg(inst, range, owner, dmg, reason, fn)
end

local function do_area(inst, range, fn)
	local owner = inst.components.inventoryitem.owner
	local ents = WARGON.finds(inst, range, nil, {"player", "wall", "FX", "NOCLICK", "INLIMBO"})
	for i, v in pairs(ents) do
		if not v.components.follower or v.components.follower.leader ~= owner then
			if v.components.combat and v.components.health
			and owner.components.combat:CanTarget(v) then
				fn(inst, v)
			end
		end
	end
end

local function get_attacked(target, owner, dmg, inst)
	if target.components.health and target.components.combat
	and owner.components.combat:CanTarget(target) then
		target.components.combat:GetAttacked(owner, dmg, inst or nil, inst and inst.prefab or nil)
	end
end

local function spear_throw(inst)
	inst:AddTag("projectile")
	inst.AnimState:PlayAnimation("throw")
end

local function spear_drop(inst)
	inst:RemoveTag("projectile")
	if inst.components.floatable then
		inst.components.floatable:SetAnimationFromPosition()
	end
end

local function spear_hit(inst, owner, target)
	WARGON.FX.impact_fx(inst, target)
	spear_drop(inst)
end

local function spear_catch(inst, owner)
	inst:RemoveTag("projectile")
	if owner.components.inventory then
		if owner.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) == nil then
			owner.components.inventory:Equip(inst)
		else
			owner.components.inventory:GiveItem(inst)
		end
	end
	if owner.components.tpbuff then
		owner.components.tpbuff:AddBuff("tp_pack_catcoon")
	end
end

local function spear_lance_catch(inst, owner)
	if owner.components.inventory
	and owner.components.inventory:IsFull() == false then
		spear_catch(inst, owner)
	else
		spear_drop(inst)
	end
end

local function set_spear_proj(inst)
	inst:AddComponent("tpproj")
	inst.components.tpproj:SetSpeed(25)
	inst.components.tpproj:SetOnThrownFn(spear_throw)
	inst.components.tpproj:SetOnHitFn(function(...)
		if inst.components.weapon.onattack then
			inst.components.weapon.onattack(...)
		end
		spear_hit(...)
	end)
	inst.components.tpproj:SetOnMissFn(spear_drop)
	inst.components.tpproj:SetLaunchOffset(Vector3(0, 0.2, 0))
	inst.components.tpproj.oncatch = spear_lance_catch
	inst:AddTag("tp_catcoon_spear")
end

local function set_spear_lunge(inst)
	inst:AddComponent("tpmove")
	inst.components.tpmove.action = "TP_CI"
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(10)
	inst.components.tpmove.onmove = function(inst)
		inst.components.tprecharge:SetRechargeTime(10)
		inst:StartThread(function()
			for i = 1, 3 do
				Sleep(0.1)
				do_area_damage(inst, 1.5, 34, inst.prefab)
				local fx = WARGON.make_fx(inst, "tp_fx_wilson_lunge")
				local owner = inst.components.inventoryitem.owner
				fx.AnimState:SetBuild(owner.components.sciencemorph:GetBuild())
				fx.Transform:SetRotation(owner.Transform:GetRotation())
				WARGON.EQUIP.object_on(fx, "swap_spear_forge_gungnir", "swap_spear_gungnir")
			end
		end)
	end
end

local WeaponData = Class(Prefab, function(self, name, data)
	Prefab._ctor(self, name)
	self.data = data
	self.fn = function()
		local atlas, img = WARGON.resolve_img_path(data.img)
		img = string.sub(img, 1, -5)
	 	local inst = WARGON.make_prefab(data.anim, data.anim[4], "inv")
	 	inst:add_cmps({
	 		invitem = { atlas=atlas, img=img },
	 		inspect = {},
	 		weapon = {
	 			dmg = data.dmg,
	 			fn = data.weapon_fn,
	 			range = data.range,
	 		},
	 		equip = {
	 			equip = data.equip_fn,
	 			unequip = data.unequip_fn,
	 		},
	 	})
	 	if data.finite then
	 		inst:add_cmps({
	 			finite = {
                    use=data.finite, max=data.finite, 
                    fn=function(inst)
                        inst:Remove()
                    end
                },
 			})
	 	end
	 	if data.throw then
	 		set_spear_proj(inst)
	 	end
	 	if data.lunge then
	 		set_spear_lunge(inst)
	 	end
	 	if data.fn then
	 		data.fn(inst)
	 	end
	 	if data.forge then
	 		inst:AddTag("tp_forge_weapon")
	 	end
	 	if data.not_fix then
	 		inst:AddTag("tp_not_fix")
	 	end
		inst:AddTag("tp_item")
		inst:AddComponent("tpinter")
		inst.components.tpinter:SetCanFn(function(inst, invitem, doer)
			return invitem:HasTag("tp_fix_powder") 
				and not inst:HasTag("tp_not_fix")
		end)
	    return inst
	end
end)

function WeaponData:__tostring()
	return string.format("Weapon %s - %s", self.name, self.desc)
end














local spear_ice_2 = WeaponData("tp_spear_ice_2", {
	anim = Anims.spear_ice,
	img = "tp_spear_ice#",
	dmg = 34,
	finite = 150,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_ice", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
	weapon_fn = function(inst, owner, target)
		if math.random() < .75 then
			WARGON.frozen_prefab(target)
		end
	end,
	throw = true,
	forge = true,
})

local spear_ice_3 = deepcopy(spear_ice_2)
spear_ice_3:SetName("tp_spear_ice_3")
spear_ice_3:HookFn(function(inst)
	local fn = inst.components.weapon.onattack
	inst.components.weapon.onattack = function(inst, owner, target)
		WARGON.frozen_prefab(target)
	end
end)

local spear_2 = WeaponData("tp_spear_2", {
    anim = Anims.spear,
    img = "spear",
    dmg = 42.5,
    finite = 150,
    equip_fn = function(inst, owner)
        WARGON.EQUIP.object_on(owner, "swap_spear", "swap_spear")
    end,
    unequip_fn = function(inst, owner)
        WARGON.EQUIP.object_off(owner)
    end,
})

local spear_3 = deepcopy(spear_2)
spear_3:SetName("tp_spear_3")
spear_3:HookFn(function(inst)
	inst:AddComponent("tpinter")
	inst.components.tpinter:SetFn(function(inst, item, doer)
		if item.prefab == "flint" then
			local item = item.components.stackable:Get()
			item:Remove()
			inst.components.finiteuses:TpAddUses(50)
		end
	end)
	inst.components.tpinter:SetCanFn(function(inst, item, doer)
		return item.prefab == "flint" 
	end)
end)

local spear_4 = deepcopy(spear_3)
spear_4:SetName("tp_spear_4")
spear_4:HookFn(function(inst)
	inst.components.weapon:SetDamage(51)
	set_spear_proj(inst)
	inst.components.tpproj:SetOnThrownFn(function(inst)
		inst:AddTag("projectile")
	end)
end)

local spear_5 = deepcopy(spear_4)
spear_5:SetName("tp_spear_5")
spear_5:HookFn(function(inst)
	inst.components.weapon.onattack = function(inst, owner, target)
		if target:HasTag("chess") then
			get_attacked(target, owner, inst.components.weapon.damage)
		end
	end
	inst.components.equippable.walkspeedmult = .1
end)

local spear_6 = deepcopy(spear_5)
spear_6:SetName("tp_spear_6")
spear_6:HookFn(function(inst)
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_TINY
end)

local spear_a = deepcopy(spear_6)
spear_a:SetName("tp_spear_a")
spear_a:HookFn(function(inst)
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(60)
	inst.skill_fn = function(inst, player)
		inst.components.tprecharge:SetRechargeTime(60)
		if player.components.tpbuff then
			player.components.tpbuff:AddBuff("tp_spear_a")
		end
	end
end)

local spear_a_2 = deepcopy(spear_a)
spear_a_2:SetName("tp_spear_a_2")
spear_a_2:HookFn(function(inst)
	inst.skill_fn = function(inst, player)
		if player.components.tpbuff then
			inst.components.tprecharge:SetRechargeTime(60)
			player.components.tpbuff:AddBuff("tp_spear_a_2")
		end
	end
end)

local spear_a_3 = deepcopy(spear_a)
spear_a_3:SetName("tp_spear_a_3")
spear_a_3:HookFn(function(inst)
	inst.components.weapon.onattack = function(inst, owner, target)
		if (target:HasTag("monster") or target:HasTag("epic"))
		and owner:HasTag("tp_spear_a_3_buff") then
			get_attacked(target, owner, inst.components.weapon.damage)
		end
	end
	inst.skill_fn = function(inst, player)
		if player.components.tpbuff then
			inst.components.tprecharge:SetRechargeTime(60)
			player.components.tpbuff:AddBuff("tp_spear_a_3")
		end
	end
end)

local spear_b = deepcopy(spear_6)
spear_b:SetName("tp_spear_b")
spear_b:HookFn(function(inst)
	inst:AddComponent("tprecharge")
	inst.components.tprecharge:SetRechargeTime(6)
	inst.skill_fn = function(inst, player)
		inst.components.tprecharge:SetRechargeTime(6)
		inst.components.weapon:SetRange(8, 10)
		inst.components.weapon.onattack = function(inst, owner, target)

			WARGON.make_fx2("sign", target)
			inst.components.finiteuses:Use()
		end
		inst:do_task(20, function(inst)
			inst.components.weapon:SetRange()
			inst.components.weapon.onattack = nil
		end)
	end
end)

local spear_b_2 = deepcopy(spear_b)
spear_b_2:SetName("tp_spear_b_2")
spear_b_2:HookFn(function(inst)
	inst.skill_fn = function(inst, player)
		inst.components.tprecharge:SetRechargeTime(6)
		inst.components.weapon:SetRange(9, 11)
		inst.components.weapon.onattack = function(inst, owner, target)

			WARGON.make_fx2("sign", target)
			inst.components.finiteuses:Use()
		end
		inst:do_task(25, function(inst)
			inst.components.weapon:SetRange()
			inst.components.weapon.onattack = nil
		end)
	end
end)

local spear_b_3 = deepcopy(spear_b)
spear_b_3:SetName("tp_spear_b_3")
spear_b_3:HookFn(function(inst)
	inst.skill_fn = function(inst, player)
		inst.components.tprecharge:SetRechargeTime(6)
		inst.components.weapon:SetRange(10, 12)
		inst.components.weapon.onattack = function(inst, owner, target)

			WARGON.make_fx2("sign", target)
			inst.components.finiteuses:Use()
			local ents = target:wg_finds(6, nil, {"NOCLICK", "FX", "INLIMBO"})
			local cnt = 1
			for k, v in pairs(ents) do
				if WARGON.can_enemy(owner, v) then
					get_attacked(v, owner, inst.components.weapon.damage, inst)

					WARGON.make_fx2("sign", v)
					cnt = cnt + 1
					if cnt >= 5 then
						break
					end
				end
			end
		end
		inst:do_task(30, function(inst)
			inst.components.weapon:SetRange()
			inst.components.weapon.onattack = nil
		end)
	end
end)

local spear_fire_2 = WeaponData("tp_spear_fire_2", {
	anim = Anims.spear_fire,
	img = "tp_spear_fire#",
	dmg = 42.5,
	finite = 150,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_fire", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
	weapon_fn = function(inst, owner, target)
		if inst:HasTag("tp_spear_fire_burn") then
			WARGON.fire_prefab(target)
		end
	end,
	throw = true,
	forge = true,
})

local spear_fire_3 = deepcopy(spear_fire_2)
spear_fire_3:SetName("tp_spear_fire_3")
spear_fire_3:HookFn(function(inst)
	local fn = inst.components.weapon.onattack
	inst.components.weapon.onattack = function(inst, owner, target)
		fn(inst, owner, target)
		if target.components.burnable
		and target.components.burnable:IsBurning() then
			get_attacked(target, owner, 34, inst)
		end
	end
end)

local spear_zeus_2 = WeaponData("tp_spear_zeus_2", {
	anim = Anims.spear_zeus,
	img = "tp_spear_zeus#",
	dmg = 42.5,
	range = {5, 6},
	finite = 300,
	fn = function(inst)
		inst.sanity_cost = 5
		inst.components.weapon:SetElectric()
		inst.components.weapon.getdamagefn = function(inst)
			local owner = inst.components.equippable.owner
			if owner and owner.components.sanity
			and owner.components.sanity:IsCrazy() then
				return 0
			end
			return 42.5
		end
	end,	
	weapon_fn = function(inst, owner, target)
		WARGON.make_fx(target, "lightning")
		if owner.components.sanity then
			owner.components.sanity:DoDelta(-inst.sanity_cost)
		end
	end,
	equip_fn = function(inst, owner)
		WARGON.EQUIP.object_on(owner, "tp_spear_zeus", "swap_object")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
	end,
})

local spear_zeus_3 = deepcopy(spear_zeus_2)
spear_zeus_3:SetName("tp_spear_zeus_3")
spear_zeus_3:HookFn(function(inst)
	inst.sanity_cost = 3
	inst.components.weapon:SetRange(8, 10)
end)

local spear_wind_2 = WeaponData("tp_spear_wind_2", {
	anim = Anims.spear_wind,
	img = "tp_spear_wind#",
	dmg = 0,
	finite = 150,
	range = {8, 10},
	equip_fn = function(inst, owner)
		WARGON_EQUIP_EX.object_on(owner, "swap_spear_wind", "swap_object")
		if inst.fx == nil then
			local pt = owner:GetPosition()
			pt.x = pt.x + 5
			inst.fx = WARGON.make_fx(pt, "tp_fx_leaf_circle")
			inst.fx.damage = inst.fx_damage
			inst.fx.master = owner
			inst.fx:start_task(inst.fx)
		end
		owner:AddTag("tp_spear_wind")
	end,
	unequip_fn = function(inst, owner)
		WARGON.EQUIP.object_off(owner)
		if inst.fx then
			inst.fx:Remove()
			inst.fx = nil
		end
		owner:RemoveTag("tp_spear_wind")
	end,
	weapon_fn = function(inst, owner, target)
		if inst.fx then
			inst.fx:stop_task(inst.fx)
			inst.fx:ForceFacePoint(target:GetPosition())
			inst.fx:start_task2(inst.fx)
		end
	end,
	fn = function(inst)
		inst.fx_damage = 12.5
		inst:add_cmps({
			water = {value=TUNING.WATERPROOFNESS_SMALL},
		})
	end,
})

local spear_wind_3 = deepcopy(spear_wind_2)
spear_wind_3:SetName("tp_spear_wind_3")
spear_wind_3:HookFn(function(inst)
	inst.fx_damage = 15
	inst.fix_value = 50
	inst:AddComponent("tpinter")
	inst.components.tpinter:SetCanFn(function(inst, item, doer)
		return item.prefab == "tp_gingko_leaf"
			and inst.components.finiteuses:GetPercent() < 1
	end)
	inst.components.tpinter:SetFn(function(inst, item, doer)
		local item = item.components.stackable:Get()
		item:Remove()
		local dt = doer.components.tplevel.attr.fixup + inst.fix_value
		inst.components.finiteuses:DoDelta(dt)
	end)
end)

return 
spear_2,
spear_3,
spear_4,
spear_5,
spear_6,
spear_a,
spear_a_2,
spear_a_3,
spear_b,
spear_b_2,
spear_b_3,
spear_fire_2,
spear_fire_3,
spear_zeus_2,
spear_zeus_3,
spear_wind_2,
spear_wind_3,

spear_ice_2,
spear_ice_3