local assets =
{

}

local function KillFX(inst)
    if inst:GetTimeAlive() > 0 then
        inst.killed = true
    else
        inst:Remove()
    end
end

local function IsMovingStep(step)
    return step ~= 0 and step ~= 3
end

local function OnSnowflakeAnimOver(inst)
    if inst.snowflakeemitter:IsValid() then
        if IsMovingStep(inst.step) then
            if inst.snowflakeemitter.ismoving then
                inst:Show()
            else
                inst:Hide()
            end
        end
        inst.Transform:SetPosition(inst.snowflakeemitter.Transform:GetWorldPosition())
        inst.AnimState:PlayAnimation(inst.anim)
    else
        inst:Remove()
    end
end

local function CreateSnowflake(snowflakeemitter, variation, step)
    local inst = CreateEntity()
    inst:AddTag("FX")
    inst.entity:SetCanSleep(false)
    inst.persists = false

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    inst.AnimState:SetBank("tp_spore")
    inst.AnimState:SetBuild("tp_spore")

    inst.AnimState:SetFinalOffset(1)

    inst.snowflakeemitter = snowflakeemitter

    inst.anim = "land"
    inst.step = step
    inst:ListenForEvent("animover", OnSnowflakeAnimOver)
    OnSnowflakeAnimOver(inst)

    return inst
end

local function CheckMoving(inst)
    local parent = inst.entity:GetParent()
    if parent ~= nil then
        local newpos = parent:GetPosition()
        inst.ismoving = inst.prevpos ~= nil and inst.prevpos ~= newpos
        inst.prevpos = newpos
    else
        inst.ismoving = false
    end
end

local function snowfn()
    local inst = CreateEntity()

    inst.entity:AddTransform()


    inst:AddTag("FX")



        for i = 0, 5 do
            local delay = i * 86 / 6 * FRAMES






            inst:DoTaskInTime(delay + 67 * FRAMES, CreateSnowflake, 7, i)
        end
        inst.ismoving = false
        inst:DoPeriodicTask(0, CheckMoving)

    inst.persists = false

    return inst
end

local function OnGroundAnimOver(inst)
    inst:Remove()










end

local function groundfn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()


    inst:AddTag("FX")

    inst.AnimState:SetBank("tp_spore")
    inst.AnimState:SetBuild("tp_spore")

    inst.AnimState:PlayAnimation("cough_out")
    inst.AnimState:SetFinalOffset(1)







    inst.persists = false







    inst:ListenForEvent("animover", OnGroundAnimOver)
    inst.KillFX = KillFX

    return inst
end

return Prefab("tp_spirit_fx", snowfn, assets),
    Prefab("tp_spirit_fx_ground", groundfn, assets)
