local Image = require "widgets/image"
local Screen = require "widgets/screen"
local Button = require "widgets/button"
local Text = require "widgets/text"
local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local Menu = require "widgets/menu"
local ImageButton = require "widgets/imagebutton"

local TpMenu = require "widgets/tp_menu"
local TpBlackboard = require "widgets/tp_blackboard"
local TpIngdSign = require "widgets/tp_ingd_sign"

local TpItem = Class(ImageButton, function(self, atlas, normal)
	ImageButton._ctor(self, atlas, normal)






end)

function TpItem:OnGainFocus()
	TpItem._base.OnGainFocus(self)


	if self.gain_focus_fn then
		self.gain_focus_fn()
	end
end

function TpItem:OnLoseFocus()
	TpItem._base.OnLoseFocus(self)

	if self.lose_focus_fn then
		self.lose_focus_fn()
	end
end

local TpItemBoard = Class(TpBlackboard, function(self)
	TpBlackboard._ctor(self)
	self.back_ground:SetTexture(
		"images/hud.xml", "craftingsubmenu_fullhorizontal.tex"
	)
	self.back_ground:SetScale(2.1, 1.1, 0)
	self.page_up:SetPosition(-225, 0, 0)
	self.page_down:SetPosition(360, 0, 0)

	self.slots = {}
	self.items = {}
	local count = 1
	for i = 0, 6  do
		for j = 0, 4 do
			self.slots[count] = self:AddChild(Image(
				"images/hud.xml", "inv_slot.tex"
			))
			self.slots[count]:SetScale(.8)
			self.slots[count]:SetPosition(-140+70*i, 140-70*j)
			self.slots[count]:Hide()
			self.items[count] = self:AddChild(TpItem(
				"images/inventoryimages.xml", "ash.tex"
			))
			self.items[count]:SetScale(.8)
			self.items[count]:SetPosition(-140+70*i, 140-70*j)
			self.items[count]:Hide()
			self.items[count].gain_focus_fn = function()
				self.sign:Show()
				self.sign:SetPosition(-140+70*i, 140+140-70*j)
			end
			self.items[count].lose_focus_fn = function()
				self.sign:Hide()
			end
			count = count + 1
		end
	end

	self.sign = self:AddChild(TpIngdSign())

	self.sign:Hide()

	self.item_word = self:AddChild(Text(TITLEFONT, 30))
	self.item_word:Hide()


	self.toggle = false
end)

function TpItemBoard:TurnOn()
	if self.sign.shown then

		self.toggle = true
	else

		self.sign:Show()
		self.item_word:Show()
	end
end

function TpItemBoard:TurnOff()
	if self.toggle then

		self.toggle = false
	else

		self.sign:Hide()
		self.item_word:Hide()
	end
end

function TpItemBoard:TestItem()
	self.test_data = {}
	self.test_data[1] = -140
	self.test_data[2] = 140
	self.test_data[3] = 70
	self.test_data[4] = .8

	local function test_fn()
		local count = 1
		for i = 0, 6  do
			for j = 0, 4 do
				self.items[count]:SetScale(self.test_data[4])
				self.items[count]:SetPosition(
					self.test_data[1]+self.test_data[3]*i, 
					self.test_data[2]-self.test_data[3]*j
				)
				count = count + 1
			end
		end
	end
	local menuitems = {
		{
			text = "横轴起点",
			cb = function()
				if TheInput:IsKeyDown(KEY_CTRL) then
					self.test_data[1] = self.test_data[1] - 10
				else
					self.test_data[1] = self.test_data[1] + 10
				end
				test_fn()
			end
		},
		{
			text = "纵轴起点",
			cb = function()
				if TheInput:IsKeyDown(KEY_CTRL) then
					self.test_data[2] = self.test_data[2] - 10
				else
					self.test_data[2] = self.test_data[2] + 10
				end
				test_fn()
			end
		},
		{
			text = "间隔距离",
			cb = function()
				if TheInput:IsKeyDown(KEY_CTRL) then
					self.test_data[3] = self.test_data[3] - 10
				else
					self.test_data[3] = self.test_data[3] + 10
				end
				test_fn()
			end
		},
		{
			text = "格子大小",
			cb = function()
				if TheInput:IsKeyDown(KEY_CTRL) then
					self.test_data[4] = self.test_data[4] - .1
				else
					self.test_data[4] = self.test_data[4] + .1
				end
				test_fn()
			end
		},
		{
			text = "输出值",
			cb = function()
				print("TpItemBoard Output:")
				local strs = {
					"横轴起点",
					"纵轴起点",
					"间隔距离",
					"格子大小",
				}	
				for k, v in pairs(self.test_data) do
					print(strs[k].." "..v)
				end
			end
		}
	}
	self.test_menu = self:AddChild(
		Menu(menuitems, 50, false)
	)

	self.test_menu:SetPosition(350, -250+30, 0)
	self.test_menu:SetScale(.8)
end

local TpInfoBoard = Class(TpBlackboard, function(self)
	TpBlackboard._ctor(self)
	self.back_ground:SetTexture(
		"images/hud.xml", "inventory_bg.tex"
	)
	self.back_ground:SetScale(0.4, 0.6, 0)
	self.page_up:SetPosition(-260, 20, 0)
	self.page_up:SetScale(.6)
	self.page_up:Hide()
	self.page_down:SetPosition(260, 20, 0)
	self.page_down:SetScale(.6)
	self.page_down:Hide()
	self.text:SetRegionSize(450, 450, 0)
	self.text:SetPosition(0, 10, 0)
end)

function TpInfoBoard:TestItem()
	self.data = {}
	self.data[1] = 10
	self.data[2] = .6
	local menuitems = {
		{
			text = "TextPos",
			cb = function()
				if TheInput:IsKeyDown(KEY_CTRL) then
					self.data[1] = self.data[1] - 10
				else
					self.data[1] = self.data[1] + 10
				end
				self.text:SetPosition(0, self.data[1], 0)
			end
		},
		{
			text = "ArrowSize",
			cb = function()
				if TheInput:IsKeyDown(KEY_CTRL) then
					self.data[2] = self.data[2] - .1
				else
					self.data[2] = self.data[2] + .1
				end
				self.page_up:SetScale(self.data[2])
				self.page_down:SetScale(self.data[2])
			end
		},
		{
			text = "Output",
			cb = function()
				print("TpInfoBoard Output:")
				local strs = {
					"TextPos",
					"ArrowSize",
				}	
				for k, v in pairs(self.data) do
					print(strs[k].." "..v)
				end
			end
		}
	}
	self.test_menu = self:AddChild(
		Menu(menuitems, 50, false)
	)

	self.test_menu:SetPosition(350, -250+30, 0)
	self.test_menu:SetScale(.8)
end

local DATA = WARGON.DATA.composed_panel_data
local TpComposedPanel = Class(Screen, function(self)
	SetPause(true)
	self.data = DATA

	Screen._ctor(self, "TpComposedPanel")
	self.root = self:AddChild(Widget("ROOT"))
	self.root:SetVAnchor(ANCHOR_MIDDLE)
	self.root:SetHAnchor(ANCHOR_MIDDLE)
	self.root:SetPosition(0, 0, 0)
	self.root:SetScaleMode(SCALEMODE_PROPORTIONAL)
	self.bg = self.root:AddChild(
		Image("images/fepanels.xml", "panel_saveslots.tex")
	)
	self.bg:SetScale(2, 1, 1)

	self.exit = self.root:AddChild(ImageButton(
		"minimap/minimap_data.xml", "xspot.png"
	))
	self.exit:SetPosition(350, 300)
	self.exit:SetOnClick(function()
		TheFrontEnd:PopScreen(self)
		SetPause(false)
	end)

	self.label = self.root:AddChild(Image(
		"images/ui.xml", "update_banner.tex"
	))
	self.label:SetPosition(0, 300, 0)
	self.title = self.label:AddChild(Text(TITLEFONT, 40))
	self.title:SetString(self.data.title)
	self.title:SetPosition(0, 10, 0)

	self.info_board = self.root:AddChild(TpInfoBoard())
	self.info_board:SetPosition(50, 170, 0)



	self.item_board = self.root:AddChild(TpItemBoard())
	self.item_board:SetPosition(-20, -90, 0)



	self.menu = self.root:AddChild(TpMenu(), 8)
	self.menu:SetScale(.6)
	self.menu:SetPosition(-330, 0, 0)

	self:Init()
end)

function TpComposedPanel:Init()
	self:MenuPageTurn(0)
	self:ItemBoardPageTurn(0)
	self.menu.page_up:SetOnClick(function()
		self:MenuPageTurn(-1)
	end)
	self.menu.page_down:SetOnClick(function()
		self:MenuPageTurn(1)
	end)
	self.item_board.page_up:SetOnClick(function()
		self:ItemBoardPageTurn(-1)
	end)
	self.item_board.page_down:SetOnClick(function()
		self:ItemBoardPageTurn(1)
	end)
end

function TpComposedPanel:MenuPageTurn(dt)
	self.data:PageTurn(dt)
	self:SetMenu()
end

function TpComposedPanel:ItemBoardPageTurn(dt)
	self.data:GetItem():PageTurn(dt)
	self:SetItemBoard()
end

function TpComposedPanel:SetMenu()
	local shelfs = self.data:GetItems()

	for k, v in pairs(shelfs) do
		local button = self.menu.buttons[k]
		if button then
			button:SetText(v.title)
			button:SetOnClick(function()

				self.data:SetPoint(k)
				self:SetItemBoard()
			end)
			if not button.shown then
				button:Show()
			end
		end
	end
	for i = #shelfs+1, 8 do
		local button = self.menu.buttons[i]
		if button then
			button:Hide()
		end
	end

	if self.data.cur <= 1 then
		self.menu.page_up:Disable()
	else
		self.menu.page_up:Enable()
	end
	if self.data.cur >= self.data.max then
		self.menu.page_down:Disable()
	else
		self.menu.page_down:Enable()
	end
	self:SetItemBoard()
end

function TpComposedPanel:SetItemBoard()

	self.clicked = nil
	local item_shelf = self.data:GetItem():GetItems()

	for k, v in pairs(item_shelf) do
		local item = self.item_board.items[k]
		local slot = self.item_board.slots[k]
		if slot and item then

			item:SetTextures(WARGON.resolve_img_path(v.img))

			item:SetOnClick(function()
				self:SetString(v:GetString())
				self.clicked = true

				if WARGON.DEBUG.COMPOSED then
					if TheInput:IsKeyDown(KEY_CTRL) then
						WARGON.debug_composed(v.name)
					else
						c_give(v.name)
					end
				end
			end)
			item.gain_focus_fn = function()

				local pos = item:GetPosition()

				self.item_board.item_word:SetString(STRINGS.NAMES[string.upper(v.name)])
				self.item_board.item_word:SetPosition(pos)

				pos.y = pos.y + 150

				self.item_board.sign:SetPosition(pos)



				self.item_board.sign:SetIngds(v.ingds, v.materials)

				self.item_board:TurnOn()
				if not self.clicked then
					self:SetString(v:GetString())
				end
			end
			item.lose_focus_fn = function()





				self.item_board:TurnOff()
			end
			if not item.shown then
				item:Show()
			end
			if not slot.shown then
				slot:Show()
			end
		end
	end
	for i = #item_shelf+1, 35 do
		local item = self.item_board.items[i]
		local slot = self.item_board.slots[i]
		if item then
			item:Hide()
		end
		if slot then
			slot:Hide()
		end
	end
	local shelf = self.data:GetItem()
	if shelf.cur <= 1 then
		self.item_board.page_up:Disable()
	else
		self.item_board.page_up:Enable()
	end
	if shelf.cur >= shelf.max then
		self.item_board.page_down:Disable()
	else
		self.item_board.page_down:Enable()
	end
end

function TpComposedPanel:SetString(str)

	self.info_board:SetString(str)
end

return TpComposedPanel