require("stategraphs/commonstates")

local actionhandlers = 
{
}

local events =
{
    CommonHandlers.OnStep(),

    CommonHandlers.OnAttacked(),
    CommonHandlers.OnDeath(),

    EventHandler("newcombattarget", function(inst)
        inst.sg:GoToState("tp_tou")
    end)














}

local function attack_over(inst)




end

local function throw_over(inst)



end

local states=
{
    State{
        name = "death",
        tags = {"busy"},
        
        onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.components.lootdropper:DropLoot(Vector3(inst.Transform:GetWorldPosition()))            
            inst.components.locomotor:StopMoving()
            RemovePhysicsColliders(inst)            
            inst.AnimState:Hide("swap_arm_carry")
            inst.AnimState:PlayAnimation("death")
        end,
    },
	
	State{
        name = "idle",
        tags = {"idle", "canrotate"},
        
        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PushAnimation("idle_loop", true)
        end,
    },
    
    State{
        name = "tp_ci_start",
        tags = {"busy", "attack"},
        onenter = function(inst)
            inst.AnimState:AddOverrideBuild("player_lunge_wargon")
            inst.AnimState:PlayAnimation("lunge_pre")
            if inst.components.combat.target then
                local target = inst.components.combat.target
                inst:ForceFacePoint(target:GetPosition())
            end
        end,
        timeline =
        {
            TimeEvent(12 * FRAMES, function(inst)
                inst.sg:GoToState('tp_ci')
            end),
        },
    },

    State{
        name = "tp_ci",
        tags = {"doing", "busy", "canrotate", "attack"},
        onenter = function(inst)

            inst.components.combat:StartAttack()
            inst.components.locomotor:Stop()
            inst.SoundEmitter:PlaySound("dontstarve_DLC003/characters/wheeler/slide")

            inst.brain:Stop()
            inst.Physics:SetMotorVelOverride(20, 0, 0)





            inst.AnimState:PlayAnimation("lunge_pst")

        end,
        timeline =
        {
            TimeEvent(2*FRAMES, function(inst) 
                inst.components.combat:DoAttack() 
            end),
            TimeEvent(5*FRAMES, function(inst) 
                inst.components.combat:DoAttack() 
            end),
            TimeEvent(7* FRAMES, function(inst)
                inst.Physics:ClearMotorVelOverride()
                ChangeToCharacterPhysics(inst)


            end),
        },

        events =
        {
            EventHandler("animover", function(inst)
                inst.AnimState:ClearOverrideBuild("player_lunge_wargon")
                if inst.AnimState:AnimDone() then
                    inst.sg:GoToState("tp_tou")



                end
            end),
        },

        onexit = function(inst)
            inst.brain:Start()
            inst.Physics:ClearMotorVelOverride()


        end,
    },

    State{
        name = "tp_tou_start",
        tags = { "aoe", "doing", "busy", "nointerrupt", "nomorph", "attack"},

        onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("superjump_pre")

            RemovePhysicsColliders(inst)
        end,

        events =
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("tp_tou")
            end),
        },

        onexit = function(inst)

        end,
    },

    State{
        name = "tp_tou",
        tags = { "aoe", "doing", "busy", "nointerrupt", "nopredict", "nomorph"},

        onenter = function(inst, data)
            inst.components.health:SetInvincible(true)
            inst.AnimState:PlayAnimation("superjump")
            inst.sg:SetTimeout(1)
        end,

        ontimeout = function(inst)
            inst.sg:GoToState("tp_tou_pst")
        end,

        timeline =
        {
            TimeEvent(FRAMES, function(inst)
                inst.sg:AddStateTag("noattack")
                inst.components.health:SetInvincible(true)
                inst.DynamicShadow:Enable(false)
            end),
        },
    },

    State{
        name = "tp_tou_pst",
        tags = { "aoe", "doing", "busy", "noattack", "nopredict", "nomorph"},

        onenter = function(inst, data)
            inst.AnimState:PlayAnimation("superjump_land")
            if inst.components.combat.target then
                local target = inst.components.combat.target
                inst.Transform:SetPosition(target:GetPosition():Get())
            end
            inst.sg:SetTimeout(22 * FRAMES)
        end,

        timeline =
        {
            TimeEvent(3 * FRAMES, function(inst)
                inst.DynamicShadow:Enable(true)
            end),
            TimeEvent(4 * FRAMES, function(inst)
                inst.sg:RemoveStateTag("noattack")
                inst.components.health:SetInvincible(false)

                inst.components.tpgroundpounder:GroundPound()
                ChangeToCharacterPhysics(inst)
            end),

        },

        ontimeout = function(inst)


        end,

        events =
        {
            EventHandler("animover", function(inst)
                if inst.AnimState:AnimDone() then
                    inst.sg:GoToState("throw")



                end
            end),
        },

        onexit = function(inst)
            inst.AnimState:SetMultColour(1, 1, 1, 1)
            inst.DynamicShadow:Enable(true)
            inst.components.health:SetInvincible(false)
        end,
    },

    State{
        name = "throw",
        tags = {"busy", "attack"},
        onenter = function(inst)
            inst.components.locomotor:Stop()

            local target = inst.components.combat.target
            if target then
                WARGON.face_target(inst, target)
            end
            inst.AnimState:PlayAnimation("atk", false)
            inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
        end,
        timeline = {
            TimeEvent(8*FRAMES, function(inst)
                local target = inst.components.combat.target
                if target then

                    local proj = WARGON.make_spawn(inst, "tp_boomerang_proj")
                    proj.components.tpproj:Throw(inst, target)
                    WARGON.EQUIP.object_off(inst)




                end
            end)
        },
        events = {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")

            end)
        },
        onexit = function(inst)

        end,
    },

    State{
        name = "attack",
        tags = {"attack", "busy"},
        
        onenter = function(inst)
            






            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("atk")
            inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
        end,
        
        timeline=
        {
            TimeEvent(8*FRAMES, function(inst) 
            	inst.components.combat:DoAttack() 
            end),
            TimeEvent(12*FRAMES, function(inst) 
				inst.sg:RemoveStateTag("busy")
				inst.sg:RemoveStateTag("attack")
			end),
        },
        
        events=
        {
            EventHandler("animqueueover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    },
    
	State{
		name = "run_start",
		tags = {"moving", "running", "canrotate"},
	    
		onenter = function(inst) 
			inst.components.locomotor:RunForward()
			inst.AnimState:PlayAnimation("run_pre")
		end,
	    
		timeline = 
		{
		    TimeEvent(4*FRAMES, PlayFootstep ),
		    TimeEvent(5*FRAMES, PlayFootstep ),
		},

		events=
		{   
			EventHandler("animover", function(inst) 
                inst.sg:GoToState("run") 
            end ),        
		},
	},
    
	State{
		name = "run",
		tags = {"moving", "running", "canrotate"},
	    
		onenter = function(inst) 
			inst.components.locomotor:RunForward()
			inst.AnimState:PlayAnimation("run_loop")
		end,
		
		events=
		{   
			EventHandler("animover", function(inst) 
                inst.sg:GoToState("run") 
            end ),        
		},
	},
        
	State{
		name = "run_stop",
		tags = {"canrotate"},
	    
		onenter = function(inst) 
			inst.Physics:Stop()
			inst.AnimState:PlayAnimation("run_pst")
		end,
	    
		events=
		{   
			EventHandler("animover", function(inst) 
                inst.sg:GoToState("idle") 
            end ),        
		},
	},
	
    State{
        name = "hit",
        tags = {"busy"},
        
        onenter = function(inst)
            inst.SoundEmitter:PlaySound("dontstarve/wilson/hit") 
            inst.AnimState:PlayAnimation("hit")
            inst.Physics:Stop()            
        end,
        
        events=
        {
            EventHandler("animover", function(inst) 
                inst.sg:GoToState("idle") 
            end ),
        },        
    },    
}
    
return StateGraph("tp_combat_lord", states, events, "idle", actionhandlers)

