local Widget = require "widgets/widget"
local Text = require "widgets/text"
local Button = require "widgets/button"
local Image = require "widgets/image"
local ImageButton = require "widgets/imagebutton"
local UIAnim = require "widgets/uianim"
local TpBuffSlot = require "widgets/tp_buff_slot"

local TpBuffBar = Class(Widget, function(self, owner)
    Widget._ctor(self, "TpBuffBar")
    self.slots = {}
    self.owner = owner









end)

local uipos = {}
for i = 0, 1 do
    for j = 0, 8 do
        table.insert(uipos, Vector3(j*40, i*-40, 0))
    end
end
local MAX_SLOT = #uipos


function TpBuffBar:Add(buff, time)

    local slot = self:Search(buff.name)
    buff.time = time or buff.time
    if not slot then
        slot = self:AddChild(TpBuffSlot(buff))

        slot:Start()
        table.insert(self.slots, slot)
    else
        slot:SetTime(buff.time)
        slot:SetStack(buff.stack)
    end
    self:ReSort()
    return slot
end

function TpBuffBar:Delete(buff)
    local slot, idx = self:Search(buff)
    if slot then
        self:RemoveChild(slot)
        slot:Kill()
        table.remove(self.slots, idx)
        slot = nil
        self:ReSort()
    end
    return slot
end

function TpBuffBar:Search(buff)
    for k, v in pairs(self.slots) do

        if v.name == buff then
            return v, k
        end
    end
end

function TpBuffBar:ReSort()
    for k, v in pairs(self.slots) do
        if k > MAX_SLOT then
            v:Hide()
        else
            if not v.shown then
                v:Show()
            end
            v:SetPosition(uipos[k])
        end
    end
end













return TpBuffBar